#! /bin/sh
### BEGIN INIT INFO
# Provides:          lwserver
# Required-Start:    $syslog $local_fs $remote_fs
# Required-Stop:     $syslog $local_fs $remote_fs
# Should-Start:      dbus
# Should-Stop:       dbus
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Librework desktux server
# Description:       Librework provides desktop over the network
### END INIT INFO

PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DAEMON=/usr/bin/lwserver
NAME=lwserver
DESC="Librework server"

test -x $DAEMON || exit 0

# Parse configuration
if [ -f /etc/librework-server/librework-server.ini ]
then
	PORT=`cat /etc/librework-server/librework-server.ini | grep -w -i LibreworkServerPort | awk -F '=' '{print $2}'` 
fi

if [ -n "${PORT}" ]
then
	DAEMON_OPTS="-p ${PORT}"
fi

set -e

case "$1" in
  start)
	echo -n "Starting $DESC: "
	start-stop-daemon --start --background --quiet \
		--exec $DAEMON -- $DAEMON_OPTS
	echo "$NAME."
	;;
  stop)
	echo -n "Stopping $DESC: "
	start-stop-daemon --stop --quiet \
		--exec $DAEMON
	echo "$NAME."
	;;
  force-reload)
	# check whether $DAEMON is running. If so, restart
	start-stop-daemon --stop --test --quiet \
		--exec $DAEMON \
	&& $0 restart \
	|| exit 0
	;;
  restart)
	echo -n "Restarting $DESC: "
	start-stop-daemon --stop --quiet \
		--exec $DAEMON || true
	sleep 2
	start-stop-daemon --start --background --quiet \
		--exec $DAEMON -- $DAEMON_OPTS
	echo "$NAME."
	;;
  status)
	RUNNING=`ps -ef | grep -w "${NAME}" | grep -v "grep"`
	if [ -n "${RUNNING}" ]
	then
		echo "$NAME is running."
		exit 0
	else
		echo "$NAME not running."
		exit 1
        fi
	;;
  *)
	N=/etc/init.d/$NAME
	echo "Usage: $N {start|stop|restart|force-reload}" >&2
	exit 1
	;;
esac

exit 0
