#!/bin/bash

SERVER=$1
SUFFIX=$2
USERNAME=$3
PASSWORD=$4

function usage()
{
	echo "Usage: updatesamba.sh <server> <suffix> <username> [ <password> ]"
	echo "Example: updatesamba.sh localhost dc=librework,dc=local Administrator"
	echo "Another example: updatesamba.sh lserver:389 dc=librework,dc=local Administrator myS3cr3tPazz"
	exit 1
}

if [ -z "$2" ]
then
	usage
fi

if [ -n "$5" ]
then
	usage
fi

if [ -z ${PASSWORD} ]
then
	echo "Enter password for ${USERNAME}:"
	read PASSWORD
fi

FIRST=1
for i in progid.ldif proggroup.ldif servergroup.ldif lwuseraux.ldif updateUserClass.ldif applicationContainer.ldif serverContainer.ldif application.ldif lwserver.ldif add_app.ldif add_server.ldif
do
	echo "Importing ldif file $i..."

	RESULT=1
	while [ ${RESULT} != 0 ]
	do
		if [ "${FIRST}" == "1" ]
		then
			sed "s/__SUFFIX__/${SUFFIX}/g" $i | ldbmodify -v -H ldap://${SERVER} -U ${USERNAME}%${PASSWORD}
		else
			sed "s/__SUFFIX__/${SUFFIX}/g" $i | ldbmodify -v -H ldap://${SERVER} -U ${USERNAME}%${PASSWORD} 2>/dev/null
		fi

		RESULT=$?

		if [ "${RESULT}" != "0" ]
		then
			if [ "${FIRST}" == "1" ]
			then
				echo "Something failed"
				exit 1
			fi
		fi

		if [ "${RESULT}" != "0" ]
		then
			sleep 10
		fi

		FIRST=0
	done

	echo -e "done."
done
