#!/bin/bash

if [[ ! -n $1 ]]; then
        echo faltan parametros
        exit 255
fi

uid=$(id -u $1)
if [[ $? -eq 1 ]]; then
        exit 255
fi

tmpfile=$(mktemp)

quota $uid 2>&1> $tmpfile


cat $tmpfile | grep "blocks" 2>&1>/dev/null
result=$?
if [[ $result == 0 ]]; then
	blockUsed=$(cat $tmpfile | grep -v limit | grep -v quotas |  tr -s ' ' | cut -d ' ' -f3)
	blockLimit=$(cat $tmpfile | grep -v limit | grep -v quotas |  tr -s ' ' | cut -d ' ' -f5)
	files=$(cat $tmpfile | grep -v limit | grep -v quotas |  tr -s ' ' | cut -d ' ' -f6)
elif [[ $result == 1 ]]; then
        cat $tmpfile | grep "none" 2>&1>/dev/null
        result=$?
                if [[ $result == 0 ]]; then
		blockUsed=0
		blockLimit=0
		files=0
                fi
fi

echo "blocks_used:"$blockUsed
echo "blocks_limit:"$blockLimit
echo "files:"$files

rm $tmpfile

