#!/bin/bash

VNETWORK=$1
VMIP=$2

function usage()
{
        echo "Usage: $0 <vnetwork>> <VMIP>"
        echo "Example: $0 dmz 192.168.100.2"
        exit 1
}

if [ -n "${3}" ] || [ -z "${2}" ]
then
        usage
fi

sed -i "/#__DMZ CONFIGURATION__/a ACCEPT      \$FW           ${VNETWORK}                               tcp     http,https,8080\\
DNAT            net             ${VNETWORK}:${VMIP}       tcp     3389\\
SSH(ACCEPT)     \$FW             ${VNETWORK}" /etc/shorewall/rules


/etc/init.d/shorewall restart
