#!/bin/bash

OSBITS=$1


function usage()
{ 
	echo "Usage: $0 <procesor architecture 32/64> "
      	echo "Example: $0 64"
	exit 1
}

if [ -n "${2}" ] || [ -z "${1}" ]
then
        usage
fi




echo "
deb http://ftp.debian.org/debian wheezy main contrib non-free
deb http://ftp.debian.org/debian/ wheezy-updates main contrib non-free
deb http://security.debian.org/ wheezy/updates main contrib non-free
deb http://ftp.tuxum.com/tuxum2012R1 wheezy main
" > /etc/apt/sources.list


apt-get update


case ${OSBITS} in
	"32") apt-get install linux-image-686-pae xcp-xapi xen-hypervisor-4.1-i386 bash-completion parted firmware-linux-nonfree;;
	"64") apt-get install linux-image-amd64 xcp-xapi bash-completion parted firmware-linux-nonfree;;
	*) echo "select 32 or 64 bits processor"
	   exit 1;;
esac


echo "bridge" > /etc/xcp/network.conf

sed -i "s/TOOLSTACK=.*/TOOLSTACK=xapi/" /etc/default/xen

#Avoid XenD conflict by disabling:

sed -i -e 's/xend_start$/#xend_start/' -e 's/xend_stop$/#xend_stop/' /etc/init.d/xen

#Add some lines to /etc/default/grub:

echo "
GRUB_CMDLINE_XEN_DEFAULT="dom0_mem=1024M,max:1024M"
GRUB_DISABLE_OS_PROBER=true
" >>/etc/default/grub

#to start dom0 with 1024 MB of RAM and disable OS prober to prevent virtual machines on logical volumes from appearing in the boot menu

#Enable bash completion:

echo "
if ! shopt -oq posix; then
  if [ -f /usr/share/bash-completion/bash_completion ]; then
    . /usr/share/bash-completion/bash_completion
  elif [ -f /etc/bash_completion ]; then
    . /etc/bash_completion
  fi
fi
" >>/etc/bash.bashrc

#Put xen grub image first:

dpkg-divert --divert /etc/grub.d/08_linux_xen --rename /etc/grub.d/20_linux_xen

update-grub2

init 6

