#ifndef APPBUTTON_H
#define APPBUTTON_H

#include <QPushButton>
#include <QPaintEvent>
#include <QString>
#include <QStringList>
#include <QIcon>
#include <QPixmap>
#include <QColor>
#include <QRgb>
#include <QPainter>
#include <QFont>
#include <QWidget>
#include <QSize>
#include <QGraphicsScene>
#include <QGraphicsColorizeEffect>
#include <QGraphicsPixmapItem>
#include <QCursor>

#include "constants.h"
#include "appinstance.h"

class AppButton : public QPushButton
{
	Q_OBJECT

	public:
		AppButton ( AppInstance * app, QWidget * parent = 0 );
		AppButton ( QIcon icon, QString name, QWidget * widget, QWidget * parent = 0 );

		static QSize buttonSize();

		AppInstance * getAppInstance() { return app; };

	signals:
		void appButtonClicked(AppInstance * button);
		void appButtonClicked(QWidget * widget);

	private slots:
		void buttonClicked();

    private:
        void enterEvent(QEvent * event);
        void leaveEvent(QEvent * event);
        void mousePressEvent(QMouseEvent * event);
        void mouseReleaseEvent(QMouseEvent * event);
		void paintEvent ( QPaintEvent * e);
        void forceRepaint();

		AppInstance * app;
		QString text;
		QIcon icon;
		QWidget * widget;
        QWidget * parent;
        int substract;
        bool highlight;
};

#endif
