#ifndef APPSERVER_H
#define APPSERVER_H

#include <QtNetwork/QTcpServer>
#include <QtNetwork/QTcpSocket>
#include <QHostAddress>

#include "threadbutton.h"
#include "settings.h"

class AppServer : public QTcpServer
{
	Q_OBJECT

	public:
		AppServer(ThreadButton * button, QHostAddress remoteAddress);
		~AppServer();

		bool listen();

	public slots:
		void closeApp();
		void killApp();
		void disconnectSession();

	private slots:
		void readData();

	signals:
		void running();
		void closeTab();
		void renameTab(QString);

	private:
		void incomingConnection ( int socketDescriptor );
		QTcpSocket * socket;
		QHostAddress remoteAddress;
};

#endif
