#include "closebutton.h"

CloseButton::CloseButton ( const QIcon & icon, QWidget * parent ) : QPushButton( QIcon(), "", parent )
{
	this->icon = icon;
	setIconSize(QSize(CLOSEBUTTON_SIZE, CLOSEBUTTON_SIZE));
        setFixedSize(QSize(CLOSEBUTTON_SIZE, CLOSEBUTTON_SIZE));
	init();
}

void CloseButton::init()
{
	connect(this, SIGNAL(clicked()), this, SLOT(buttonClicked()));
}

void CloseButton::buttonClicked()
{
	emit closeButtonClicked(this);
}

void CloseButton::paintEvent ( QPaintEvent * e)
{
	QPushButton::paintEvent( e );

        QPainter p(this);

	if ( ! icon.isNull() )
	{
		int pressedMargin = 0;

		if ( isDown() )
		{
			pressedMargin = BUTTON_PRESSED_MARGIN;
		}

		QPoint upLeft( pressedMargin, pressedMargin);
		QPoint downRight( CLOSEBUTTON_SIZE - pressedMargin, CLOSEBUTTON_SIZE - pressedMargin );
		QRect rectangle (upLeft, downRight);
		p.drawPixmap( rectangle, icon.pixmap(CLOSEBUTTON_SIZE - 2 * pressedMargin, CLOSEBUTTON_SIZE - 2 * pressedMargin) );
	}
}

