#ifndef CLOSEBUTTON_H
#define CLOSEBUTTON_H

#include <QPushButton>
#include <QString>
#include <QStringList>
#include <QIcon>
#include <QWidget>
#include <QPainter>

#include "constants.h"

class CloseButton : public QPushButton
{
	Q_OBJECT

	public:
		CloseButton ( const QIcon & icon, QWidget * parent = 0 );

		void setIcon(QIcon icon) { this->icon = icon; QPushButton::setIcon(icon); };

		QIcon getIcon() { return icon; };
	signals:
		void closeButtonClicked(CloseButton * button);

	private slots:
		void buttonClicked();
		void paintEvent(QPaintEvent * e);

	private:
		void init();

		QIcon icon;
};

#endif
