#ifndef CLOUDINTERFACE_H
#define CLOUDINTERFACE_H

#include <QObject>

#define SUCCESS 0
#define UNKNOWN_ERROR 1

class FileInfo
{
public:
    QString fileName;
    long fileSize;
    bool isDir;
};

class CloudInterface : public QObject
{
    Q_OBJECT
public:
    explicit CloudInterface(QObject *parent = 0);
    virtual int init(QString user, QString password, QString ) = 0;
    virtual QList<FileInfo> readDir(QString path) = 0;
    virtual int downloadFile(QString fileName) = 0;
    virtual int uploadFile(QString fileName) = 0;
    virtual int moveFile(QString sourceFileName, QString targetFileName) = 0;
    virtual int removeFile(QString fileName) = 0;

signals:

public slots:
};

#endif // CLOUDINTERFACE_H
