QT += core widgets network

linux: equals(QT_MAJOR_VERSION, 5)
{
	linux: greaterThan(QT_MINOR_VERSION, 5): QT += webenginewidgets
	linux: lessThan(QT_MINOR_VERSION, 6): QT += webkitwidgets
}

linux: QT += x11extras
win32: QT += winextras

DEFINES += UNICODE

linux: TEMPLATE        = lib
win32: TEMPLATE        = app
win64: TEMPLATE        = app

LANGUAGE        = C++

linux: LIBS += -lX11 -lcups -lldap
win64: LIBS += -lpsapi -ladvapi32 -lwtsapi32 -lmpr -lnetapi32 -luser32 -lshell32
win32: LIBS += -lpsapi -ladvapi32 -lwtsapi32 -lmpr -lnetapi32 -luser32 -lshell32

include(../qmake.variables)

HEADERS += constants.h menu.h appbutton.h sessionmanager.h \
    initscreen.h \
    cloudinterface.h \
    sharedesktopconfig.h
HEADERS += filesystemwidget.h remoteclientmanager.h
HEADERS += threadbutton.h closebutton.h toolbutton.h
HEADERS += settings.h
HEADERS += application.h mimeconfig.h
HEADERS += configure.h configurationdialog.h
HEADERS += pixmaplabel.h pixmapframe.h
HEADERS += fileiconprovider.h tabbar.h threadwidget.h
HEADERS += threadmanager.h appserver.h storageservice.h
HEADERS += appinstance.h userconfig.h
HEADERS += desktuxinterface.h lwclient.h desktop.h
linux {
	HEADERS += cupsmanager.h ldapinfo.h
	HEADERS += decorator.h x11info.h manager.h
}
win32 {
	HEADERS += winmanager.h wininfo.h
}

SOURCES += menu.cpp appbutton.cpp sessionmanager.cpp \
    initscreen.cpp \
    cloudinterface.cpp \
    sharedesktopconfig.cpp
SOURCES += filesystemwidget.cpp remoteclientmanager.cpp
SOURCES += threadbutton.cpp closebutton.cpp toolbutton.cpp
SOURCES += settings.cpp
SOURCES += application.cpp mimeconfig.cpp
SOURCES += configure.cpp
SOURCES += pixmaplabel.cpp pixmapframe.cpp
SOURCES += fileiconprovider.cpp tabbar.cpp threadwidget.cpp
SOURCES += threadmanager.cpp appserver.cpp storageservice.cpp
SOURCES += appinstance.cpp userconfig.cpp
SOURCES += desktuxinterface.cpp lwclient.cpp desktop.cpp
linux {
	SOURCES += ldapinfo.cpp cupsmanager.cpp
	SOURCES += decorator.cpp x11info.cpp manager.cpp
}
win32 {
        SOURCES += main.cpp winmanager.cpp wininfo.cpp
}

TARGET		= desktux
target.path	= $$LIB_DIR
INSTALLS        += target

linux: exists( "/usr/bin/colorgcc" ) {
	QMAKE_CXX = colorgcc
}

RESOURCES += \
    resources.qrc

FORMS += \
    filesystemwidget.ui \
    initscreen.ui
