#include "configure.h"
#include "x11info.h"

Configure::Configure(QWidget * parent, QString color) : Menu(parent, color)
{
}

Configure::~Configure()
{
	delete mimeConfig;
	delete userConfig;
    //delete shareDesktopConfig;
}

void Configure::addApplications()
{
	prepareCells();

	mimeConfig = new MimeConfig(this);
	addConfigurationApplication(mimeConfig);
	mimeConfig->hide();

	userConfig = new UserConfig(this);
	addConfigurationApplication(userConfig);
	userConfig->hide();

    /*shareDesktopConfig = new ShareDesktopConfig(this);
    addConfigurationApplication(shareDesktopConfig);
    shareDesktopConfig->hide();*/
}

void Configure::addConfigurationApplication(ConfigurationDialog * configAppName)
{
	AppButton * pixmap = new AppButton(configAppName->icon(), configAppName->name(), configAppName->widget(), this);
	pixmap->setFlat(true);
	connect(pixmap, SIGNAL(appButtonClicked(QWidget *)), this, SLOT(launchConfigurationApplication(QWidget  *)));
	locateApplication(pixmap);
}

void Configure::launchConfigurationApplication(QWidget * widget)
{
	emit selectWidget( widget, true );
}
