#ifndef CONFIGURE_H
#define CONFIGURE_H

#include <QPalette>
#include <QBoxLayout>
#include <QGroupBox>
#include <QGridLayout>
#include <QListWidget>
#include <QPixmap>
#include <QLabel>
#include <QStringList>

#include "constants.h"
#include "settings.h"
#include "appbutton.h"
#include "mimeconfig.h"
#include "userconfig.h"
#include "sharedesktopconfig.h"
#include "menu.h"

class Configure : public Menu
{
	Q_OBJECT

	public:
        Configure(QWidget *parent, QString color);
		~Configure();

		void addApplications();

	private slots:
		void launchConfigurationApplication(QWidget * widget);

	private:
		void addConfigurationApplication(ConfigurationDialog * configAppName);

		MimeConfig * mimeConfig;
		UserConfig * userConfig;
//        ShareDesktopConfig * shareDesktopConfig;
};

#endif
