#ifdef Q_OS_LINUX
#define CONFIG_FILE "/etc/desktux/desktux.ini"
#define SHAREDIR "/usr/share/desktux/"
#define CHROOT "schroot"
#define CHROOTMOUNT Settings::getValue("ChrootMount") + "/mnt." + Settings::getUserName()
#define XRDP_DIS "/usr/bin/xrdp-dis"
#endif

#ifdef Q_OS_WIN
#define PROGRAMFILES qgetenv("PROGRAMW6432")
#define CONFIG_FILE PROGRAMFILES + "\\Librework Desktop\\desktux.ini"
#define SHAREDIR PROGRAMFILES + "\\Librework Desktop\\"
#endif

#define VERSION 2.2

#define WINMANAGER_TIMER 300
#define NETWORK_START_WAIT_TIME 10000

#define BASICFSMODE

#define TOKEN_FILE Settings::homePath() + QDir::separator() + ".librework.ini"

#define ICONDIR ":/icons/"
#define ICON_DIR_32 ICONDIR "32x32"
#define ICON_DIR_48 ICONDIR "48x48"
#define ICON_DIR_64 ICONDIR "64x64"
#define ICON_DIR_OTHER ICONDIR "other"
#define ICON_DIR_APPS ICONDIR "applications"
#define ICON_DIR_GROUPS ICONDIR "groups"
#define ICON_DIR_ANIM ICONDIR "animations"
#define ICON_DIR_WM ICONDIR "wm/"
#define WALLPAPERS_DIR SHAREDIR "wallpapers"
#define MIME_DIR ":/mime"
#define I18N_DIR SHAREDIR "i18n"
#define APPLICATIONS_FILE MIME_DIR + QString(QDir::separator()) + "applications"
#define GROUPS_FILE MIME_DIR + QString(QDir::separator()) + "groups"
#define EXTENSIONS_FILE MIME_DIR + QString(QDir::separator()) + "extensions"
#define MIMETYPES_FILE MIME_DIR + QString(QDir::separator()) + "types"
#define DESKTUX_SERVER_PORT 4445

#define GOOGLEDRIVE_HOME "Google Drive"
#define DROPBOX_HOME "Dropbox"
#define GOOGLEPRINT_CONF ".cloudprint.conf"
#define GOOGLEPRINT_MANAGER "/usr/lib/cloudprint-cups/manageaccounts.py"
#define SEARCH_DIR "search"
#define DOWNLOADS_DIR "Downloads"
#define SHARED_DIR "/shared"

#define RDP_CLIENT "xfreerdp"
//#define RDP_CLIENT "rdesktop"

#define TIMER_RIGHT_CLICK 1250
#define TIMEOUT 15 // in seconds
#define LOADINGTIMEOUT 20 // in seconds

#define MAXLINKDEPTH 10

// Window Manager Behaviour
#define FULLSCREEN 0
#define STANDARD 1

// Colors
#define BORDERCOLOR "a6aabd"
#define BACKGROUNDCOLOR "e6eaed"
#define HEXBACKGROUNDCOLOR 0xe6eaed
//#define HEXHIGHLIGHTCOLOR 0xd8e6f1
#define HEXHIGHLIGHTCOLOR 0xe6eaed
#define HEXNORMALCOLOR 0xc2bbb8

#define CLOSEBUTTON_SIZE 16
#define TOOLBUTTON_SIZE 48
#define ICON_SIZE 64
#define MENU_ICON_SIZE 32
#define TAB_BUTTON_HEIGHT 42
#define TAB_BUTTON_WIDTH 48
#define THREAD_WIDGET_WIDTH 250
#define BUTTON_PRESSED_MARGIN 2
#define FONT_SIZE 13
#define SEPARATION 6
#define MARGIN 5

#define MENUBUTTON 0
#define CURRENTTHREADBUTTON 1
#define THREADBUTTON 2
#define EXITBUTTON 3

// FileManager
#define DBUS_TIMEOUT 5
#define PLACE_HOME 0
#define PLACE_SHARED 1
#define PLACE_SEARCHS 2

// ToolButton
#define TOOLBUTTON_MARGIN 5
