#include "cupsmanager.h"

#include <cups/cups.h>

QStringList CupsManager::getPrinters(QString userName)
{
	QStringList ret;
	cups_dest_t *dests;
	int numDests = cupsGetDests( &dests );

	qDebug("Number of printers: %d", numDests);

	for (int i = 0; i < numDests; i++)
	{
		QString dest = dests[i].name;
		if ( ! userName.isEmpty() )
		{
			if ( dest.startsWith( userName + "_" ) )
			{
				ret += dest;
			}
		} else {
			ret += dest;
		}
	}

	cupsFreeDests ( numDests, dests );

	return ret;
}
