#ifndef DECORATOR_H
#define DECORATOR_H

#include <QWidget>
#include <QList>
#include <QPalette>
#include <QPainter>
#include <QPixmap>
#include <QBitmap>
#include <QGraphicsOpacityEffect>

#include "constants.h"

#define DECWIDTH 6
#define DECHEIGHT 6

class Decorator : public QWidget
{
	Q_OBJECT

	public:
		Decorator ( QPoint pos, QSize wsize, long window, QWidget * parent = 0, int section = Qt::TopSection );

		void setWindow(long window);
		long getWindow();

		static bool hasDecorator(long window);

	public slots:
		static void closeDecorator( long window );

	protected slots:
		void paintEvent(QPaintEvent *event);

	signals:
		void closing( long window );

	private:
		long window;
		int section;
		QSize wsize;
};

static QList<Decorator*> decorators;
static QList<long> windows;

#endif // DECORATOR_H
