#include "desktuxinterface.h"

#include <QApplication>
#include <QStyle>
#include <QStyleFactory>
#include <QTranslator>
#include <QProcess>

#include "desktop.h"
#include "settings.h"

int runDesktux()
{
    int argc = 0;
    char **argv = 0;
    QApplication qApplication(argc, argv);

	QStyle *style = QStyleFactory::create("plastique");

	if(style)
	{
		qDebug("Oxygen loaded!"); /// @note You can leave this out if you want!
		QApplication::setStyle(style);
	}

	Settings * settings = new Settings();
	Settings::setExtensions();

#ifdef Q_OS_LINUX
	QString program("setxkbmap");
	QStringList arguments;
	arguments += "-layout";
	//arguments += settings->getValue("KeyboardLayout");
	arguments += "es";

	QProcess::execute( program, arguments );
#endif

	QTranslator* translator = new QTranslator();

	//if (translator->load("desktux_" + settings->getValue("Language"), I18N_DIR))
	//if (translator->load("desktux_es", I18N_DIR))
	if (translator->load("desktux_es"))
	{
		qApplication.installTranslator(translator);
	}

	delete settings;

    Desktop * desktop = new Desktop();
    Q_UNUSED(desktop);

	return qApplication.exec();
}
