#include "fileiconprovider.h"

FileIconProvider::FileIconProvider() : QFileIconProvider()
{
}

QIcon FileIconProvider::icon ( IconType iconType) const
{
    switch( iconType )
    {
        case QFileIconProvider::Folder:
            return QIcon( ICON_DIR_64 + QString(QDir::separator()) + "folder.png" );
        break;
        default:
            return QIcon( ICON_DIR_64 + QString(QDir::separator()) + "openwith.png" );
    }
}
QIcon FileIconProvider::icon ( const QFileInfo & info ) const
{
	if ( info.isDir() )
	{
        return QIcon( ICON_DIR_64 + QString(QDir::separator()) + "folder.png" );
	}

	QIcon icon = Application::getIcon( info );

	if (icon.isNull())
    {
        return QIcon( ICON_DIR_64 + QString(QDir::separator()) + "openwith.png" );
        //return QFileIconProvider::icon(info);
    } else {
		return Application::getIcon( info );
    }
}
