#include "ldapinfo.h"

/* Discarding LDAP

LdapInfo::LdapInfo(QString suffix, QString ldapServer, int port)
{
	ldapUrl = "ldap://" + ldapServer + ":" + QString::number(port);
	this->suffix = "," + suffix;
}

bool LdapInfo::authenticate(QString authDn, QString password)
{
	qDebug( "Connecting as %s with password %s...", (authDn + suffix).toUtf8().data(), password.toUtf8().data() );
 
	// Open LDAP Connection
	if( ! ldap_initialize( &ldap, ldapUrl.toUtf8().data() ) == LDAP_SUCCESS )
	{
		return false;
	}
 
	berval cred;

	if ( password.length() > 0 )
	{
		cred.bv_val = new char[password.length() + 1];
		strcpy( cred.bv_val, password.toUtf8().data());
	} else {
		cred.bv_val = 0;
	}
	cred.bv_len = password.length();

	QString auth = authDn + suffix;

	// User authentication (bind)
	bool res = ( ldap_sasl_bind_s( ldap, auth.toUtf8().data(), NULL, &cred, NULL, NULL, NULL) == LDAP_SUCCESS );

	if ( password.length() > 0 )
	{
		delete[] cred.bv_val;
	}

	if ( ! res )
	{
		qDebug( "Error: bad authentication" );
		return false;
	} else {
		qDebug( "Successful authentication" );
		return true;
	}
}

bool LdapInfo::setValue(QString baseDn, QString attribute, QString value)
{
	return false;
}

QStringList LdapInfo::getValues(QString baseDn, QString filter, QString attribute)
{
	QStringList ret;

	LDAPMessage * res = NULL;

	char * attrs = new char[attribute.length() + 1];
	strcpy( attrs, attribute.toUtf8().data());

	qDebug("Base: %s, Filter: %s, Attributes: %s", (baseDn + suffix).toUtf8().data(), filter.toUtf8().data(), attrs);

	int search = ldap_search_ext_s( ldap, (baseDn + suffix).toUtf8().data(), LDAP_SCOPE_SUBTREE, filter.toUtf8().data(), & attrs, 0, NULL, NULL, NULL, 1,  &res );

	if ( ! search == LDAP_SUCCESS )
	{
		char * error;
		error = ldap_err2string( search );
		qDebug("Error in ldap_result: %s", error);
	} else {
		for ( LDAPMessage * entry = ldap_first_entry(ldap, res); entry != NULL; entry = ldap_next_entry(ldap, entry) )
		{
			qDebug("attrs: %s", attrs);
			berval ** vals = ldap_get_values_len( ldap, entry, attrs);
			if ( vals != NULL )
			{
				for (int vi = 0; vals[vi]; vi++)
				{ 
					struct berval *val = vals[vi];
					if ( val != NULL )
					{
						ret += val->bv_val;
					}
				}
				ldap_value_free_len( vals );
			} else {
				qDebug("No results");
			}
		}
	}

	delete[] attrs;

	if (res != NULL)
	{
		ldap_msgfree(res);
	}
	return ret;
}

void LdapInfo::close()
{
	if (ldap != NULL)
	{
		ldap_unbind_ext( ldap, NULL, NULL );
	}
}
*/
