#ifndef LWCLIENT_H
#define LWCLIENT_H

#include <QTcpSocket>
#include <QObject>
#include <QString>
#include <QByteArray>
#include <QMutex>

#include "settings.h"

class LWClient : public QObject
{
	Q_OBJECT

	public:
		LWClient();
		~LWClient();

		bool connect();
		bool authenticate(QString username, QString password);
		bool isConnected() { return _isConnected; };
		QString sendMessage(QString message);
		QByteArray sendMessageByteArray(QString message);
		bool waitForConnected(int timeout = 30000) {return tcpSocket->waitForConnected(timeout);};

		static LWClient * instance();
		static void setInstance( LWClient * instance );

	private:
		QTcpSocket * tcpSocket;
		bool _isConnected;
		QMutex mutex;
};

#endif
