#ifndef MENU_H
#define MENU_H

#include <QPalette>
#include <QBoxLayout>
#include <QGroupBox>
#include <QGridLayout>
#include <QListWidget>
#include <QPixmap>
#include <QLabel>
#include <QStringList>

#include "constants.h"
#include "settings.h"
#include "appbutton.h"
#include "appinstance.h"
#include "application.h"
#include "pixmapframe.h"
#include "lwclient.h"

/*
#ifdef Q_OS_LINUX
#include "x11info.h"
#endif
*/

/* #include "ldapinfo.h" */

class Menu : public PixmapFrame
{
	Q_OBJECT

	public:
		Menu(QWidget * parent, QString color);

		long getWindowId();
		void addApplications(QStringList validApplications, LWClient * lwClient = 0);
		void resize ( QSize newSize );

	public slots:
		void launchApplicationSlot(AppInstance * app) { emit launchApplication(app); };
		void setLogo();

	signals:
		void launchApplication(AppInstance * app);
		void selectWidget(QWidget * widget, bool force = false);

	protected:
		/* void addApplication(LdapInfo * ldap, QString appName); */
		void addApplication(LWClient * lwClient, QString appName);
		
		void prepareCells();
		void locateApplication(QWidget * widget);
		PixmapFrame * principalWidget;
		int rows, columns;
		QGridLayout * layout;
};

#endif
