#ifdef OLDCODE

#ifndef CONTAINER_H
#define CONTAINER_H

#include <QLabel>
#include <QMovie>
#include <QTimer>
#include <QWidget>

#include "tabwidget.h"
#include "appinstance.h"

class Container : public QObject
{
	Q_OBJECT

	public:
        Container ( long window, TabWidget * parent = 0 );
		~Container();

		void resize();
		bool mustBeResized();
		void setToBeResized( QSize newSize);

		void setProcess(QProcess * process);
		QProcess * getProcess();

		void setWindow(long window);
		long getWindow();

		void setServerPort(quint16 port);
		quint16 getServerPort();

		void setAppInstance( AppInstance * app );
		AppInstance * getAppInstance();

		QString getName();
        TabWidget * getTabWidget() { return tabWidget; };

	public slots:
		void closing();
		void loading();
		void closeTab(int exitCode, QProcess::ExitStatus exitStatus);
		void closeTab();
		void renameTab(QString name);
		void loaded();
		void showLoading();
		void hideLoading();

	signals:
		void closeApp();
		void killApp();
		void disconnectSession();
		void nameChanged(long);
		void running();
		void loadedFinished();

	private:
		long window;
		TabWidget * tabWidget;
		quint16 port;
		QString name;
		AppInstance * app;
		QProcess * process;
		bool resizing;
		bool finished;
		bool toBeResized;
		QSize newSize;
		bool loadedContainer;
		bool loadingWidgetCreated;
		QLabel * loadingWidget;
		QMovie * loadingMovie;
};

#endif
#endif
