#include "dirwidgetmenu.h"

DirWidgetMenu::DirWidgetMenu(QWidget * parent) : QMenu(parent)
{
	remove = new QAction(QIcon(ICON_DIR_32 + QString(QDir::separator()) + "remove.png"), tr("&Remove"), parent);
	remove->setStatusTip(tr("Remove"));

	rename = new QAction(QIcon(ICON_DIR_32 + QString(QDir::separator()) + "rename.png"), tr("R&ename"), parent);
	rename->setStatusTip(tr("Rename"));

	openWith = new QMenu(tr("&Open with..."), parent);
	openWith->setIcon(QIcon(ICON_DIR_32 + QString(QDir::separator()) + "openwith.png"));
	openWith->setStatusTip(tr("Open this file with an specific application"));


	cut = new QAction(QIcon(ICON_DIR_32 + QString(QDir::separator()) + "cut.png"), tr("&Cut"), parent);
	cut->setStatusTip(tr("Cut"));

	copy = new QAction(QIcon(ICON_DIR_32 + QString(QDir::separator()) + "copy.png"), tr("Cop&y"), parent);
	copy->setStatusTip(tr("Copy"));

	paste = new QAction(QIcon(ICON_DIR_32 + QString(QDir::separator()) + "paste.png"), tr("&Paste"), parent);
	paste->setStatusTip(tr("Paste"));

	newFolder = new QAction(QIcon(ICON_DIR_32 + QString(QDir::separator()) + "folder-new.png"), tr("&New Folder"), parent);
	newFolder->setStatusTip(tr("Create a new folder"));

	properties = new QAction(QIcon(ICON_DIR_32 + QString(QDir::separator()) + "properties.png"), tr("Proper&ties"), parent);
	properties->setStatusTip(tr("Properties"));

	location = new QAction(QIcon(ICON_DIR_32 + QString(QDir::separator()) + "location.png"), tr("Open containing fo&lder"), parent);
	location->setStatusTip(tr("Open containing folder"));
}

void DirWidgetMenu::setDirMenu(bool multiple)
{
	clear();
	addAction(remove);
	connect(remove, SIGNAL(triggered()), this, SIGNAL(removeTriggered()));

	if ( ! multiple )
	{
		addAction(rename);
		connect(rename, SIGNAL(triggered()), this, SIGNAL(renameTriggered()));
	}

	addSeparator();
	addAction(cut);
	connect(cut, SIGNAL(triggered()), this, SIGNAL(cutTriggered()));
	addAction(copy);
	connect(copy, SIGNAL(triggered()), this, SIGNAL(copyTriggered()));
	addAction(paste);
	connect(paste, SIGNAL(triggered()), this, SIGNAL(pasteTriggered()));

	addSeparator();
	addAction(paste);
	connect(paste, SIGNAL(triggered()), this, SIGNAL(pasteTriggered()));
	addAction(newFolder);
	connect(newFolder, SIGNAL(triggered()), this, SIGNAL(newFolderTriggered()));

	if ( ! multiple )
	{
		addSeparator();
		addAction(properties);
		connect(properties, SIGNAL(triggered()), this, SIGNAL(propertiesTriggered()));
	}
}

void DirWidgetMenu::setFileMenu(bool multiple)
{
	clear();

	if ( ! multiple )
	{
		openWith->clear();
		addMenu(openWith);
		connect(openWith, SIGNAL(aboutToShow()), this, SIGNAL(openWithTriggered()));
		addSeparator();
	}

	addAction(remove);
	connect(remove, SIGNAL(triggered()), this, SIGNAL(removeTriggered()));

	if ( ! multiple )
	{
		addAction(rename);
		connect(rename, SIGNAL(triggered()), this, SIGNAL(renameTriggered()));
	}

	addSeparator();
	addAction(cut);
	connect(cut, SIGNAL(triggered()), this, SIGNAL(cutTriggered()));
	addAction(copy);
	connect(copy, SIGNAL(triggered()), this, SIGNAL(copyTriggered()));
	addAction(paste);
	connect(paste, SIGNAL(triggered()), this, SIGNAL(pasteTriggered()));

	addSeparator();
	addAction(paste);
	connect(paste, SIGNAL(triggered()), this, SIGNAL(pasteTriggered()));
	addAction(newFolder);
	connect(newFolder, SIGNAL(triggered()), this, SIGNAL(newFolderTriggered()));

	if ( ! multiple )
	{
		addSeparator();
		addAction(properties);
		connect(properties, SIGNAL(triggered()), this, SIGNAL(propertiesTriggered()));
	}
}

void DirWidgetMenu::setLinkMenu(bool multiple)
{
	setFileMenu( multiple );

	if ( ! multiple )
	{
		addSeparator();
		addAction(location);
		connect(location, SIGNAL(triggered()), this, SIGNAL(locationTriggered()));
	}
}

void DirWidgetMenu::setOtherMenu()
{
	clear();
	addAction(paste);
	connect(paste, SIGNAL(triggered()), this, SIGNAL(pasteTriggered()));
	addAction(newFolder);
	connect(newFolder, SIGNAL(triggered()), this, SIGNAL(newFolderTriggered()));
}
