#ifndef DIRWIDGETMENU_H
#define DIRWIDGETMENU_H

#include <QMenu>
#include <QAction>
#include <QWidget>
#include <QDir>

#include "constants.h"

class DirWidgetMenu : public QMenu
{
	Q_OBJECT

	public:
		DirWidgetMenu(QWidget * parent);

		void setDirMenu(bool multiple = false);
		void setFileMenu(bool multiple = false);
		void setLinkMenu(bool multiple = false);
		void setOtherMenu();
		QMenu * getOpenWithMenu() { return openWith; };
		QAction * pasteAction() { return paste; };

	signals:
		void removeTriggered();
		void renameTriggered();
		void openWithTriggered();
		void cutTriggered();
		void copyTriggered();
		void pasteTriggered();
		void newFolderTriggered();
		void propertiesTriggered();
		void locationTriggered();

	private:
		QAction * remove;
		QAction * rename;
		QMenu * openWith;
		QAction * cut;
		QAction * copy;
		QAction * paste;
		QAction * newFolder;
		QAction * properties;
		QAction * location;
};

#endif
