#ifndef DROPBOXCONFIG_H
#define DROPBOXCONFIG_H

#include <QDialog>
#include <QWidget>
#include <QGridLayout>
#include <QPushButton>
#include <QGroupBox>
#include <QVBoxLayout>
#include <QProcess>
#include <QList>
#include <QTreeView>
#include <QInputDialog>
#include <QMessageBox>
#include <QLineEdit>
#include <QDir>

#include "configurationdialog.h"
#include "toolbutton.h"
#include "application.h"
#include "constants.h"
#include "dropboxservice.h"
#include "dropboxmanager.h"

class DropboxConfig : public QDialog, public ConfigurationDialog
{
	Q_OBJECT

	public:
		DropboxConfig(Menu * menu, DropboxService * dropboxService);

		void init();
		QIcon icon() { return QIcon(ICON_DIR_APPS + QString(QDir::separator()) + "dropbox.png"); };
		QString name() { return tr("Dropbox"); };
		QDialog * widget() { return this; };

	public slots:
		void accept();
		void reject();

	private slots:
		void itemChanged( const QModelIndex & );
		void addSlot();
		void removeSlot();
		void refreshSlot();

	private:
		QGridLayout * layout;
		bool dontclose;

		QTreeView * drives;
		DropboxManager * model;
		DropboxService * dropboxService;
		ToolButton * backButton;
		ToolButton * refresh;
		ToolButton * add;
		ToolButton * remove;
		QProcess * process;
};

#endif
