#ifndef DROPBOXMANAGER_H
#define DROPBOXMANAGER_H

#include <QProcess>
#include <QString>
#include <QWidget>
#include <QStringList>
#include <QStandardItemModel>

class QUrl;

#include "constants.h"
#include "settings.h"
#include "dropboxservice.h"

class DropboxManager : public QStandardItemModel
{
	Q_OBJECT

	public:
		DropboxManager( DropboxService * dropboxService, QObject * parent = 0 );
		~DropboxManager();

		void update();

		QStringList getAccounts();
		void removeAccount( QString account );

		QUrl addAccount( QString account );
		void finishAddAccount( QString key );

	signals:
		void isAvailable( bool );

	private:
		QProcess * process;
		DropboxService * dropboxService;
};

#endif
