#ifndef FILEDIALOG_H
#define FILEDIALOG_H

#include <QDialog>
#include <QVBoxLayout>
#include <QHBoxLayout>
#include <QLabel>
#include <QProcess>
#include <QMovie>
#include <QIcon>

#include "toolbutton.h"
#include "constants.h"
#include "dirwidget.h"

class FileDialog : public QDialog
{
	Q_OBJECT

	public:
		FileDialog(QWidget * parent = 0);
		~FileDialog();

		void doCopy(QString source, QString target);
		void doMove(QString source, QString target);
		void doRemove(QString filePath);
		void doMoveToTrash(QString filePath);

	private slots:
		void actionFinished(int status);

	signals:
		void finished();

	private:
		void doCopy(QMovie * movie, QString source, QString target, bool move);

		QVBoxLayout * layout;
		QLabel * animationLabel;

		QProcess * process;
		QString program;
		QStringList arguments;
		QWidget * parent;
};

#endif
