#ifndef FILEPROPERTIES_H
#define FILEPROPERTIES_H

#include <QDialog>
#include <QFileInfo>
#include <QGridLayout>
#include <QIcon>
#include <QLabel>
#include <QDateTime>
#include <QDir>

#include "application.h"
#include "constants.h"
#include "toolbutton.h"

class FileProperties : public QDialog
{
	Q_OBJECT

	public:
		FileProperties(QFileInfo file, QIcon mimeIcon, QWidget * parent);

	private:
		QGridLayout * layout;
		
		QLabel * icon;
		QLabel * fileName;
		QLabel * mimeType;
		QLabel * fullPath;
		QLabel * size;
		QLabel * modified;
		QLabel * accessed;
		ToolButton * closeButton;
};

#endif
