#ifndef GOOGLEDRIVECONFIG_H
#define GOOGLEDRIVECONFIG_H

#include <QDialog>
#include <QWidget>
#include <QGridLayout>
#include <QPushButton>
#include <QGroupBox>
#include <QVBoxLayout>
#include <QProcess>
#include <QList>
#include <QTreeView>
#include <QInputDialog>
#include <QMessageBox>
#include <QLineEdit>
#include <QDir>

#include "configurationdialog.h"
#include "toolbutton.h"
#include "application.h"
#include "constants.h"
#include "googledriveservice.h"
#include "googledrivemanager.h"

class GoogleDriveConfig : public QDialog, public ConfigurationDialog
{
	Q_OBJECT

	public:
		GoogleDriveConfig(Menu * menu, GoogleDriveService * googleDriveService);

		void init();
		QIcon icon() { return QIcon(ICON_DIR_APPS + QString(QDir::separator()) + "google-drive.png"); };
		QString name() { return tr("Google Drive"); };
		QDialog * widget() { return this; };

	public slots:
		void accept();
		void reject();

	private slots:
		void itemChanged( const QModelIndex & );
		void addSlot();
		void removeSlot();
		void refreshSlot();

	private:
		QGridLayout * layout;
		bool dontclose;

		QTreeView * drives;
		GoogleDriveManager * model;
		GoogleDriveService * googleDriveService;
		ToolButton * backButton;
		ToolButton * refresh;
		ToolButton * add;
		ToolButton * remove;
		QProcess * process;
};

#endif
