#ifndef GOOGLEDRIVEMANAGER_H
#define GOOGLEDRIVEMANAGER_H

#include <QProcess>
#include <QString>
#include <QWidget>
#include <QStringList>
#include <QStandardItemModel>

class QUrl;

#include "constants.h"
#include "settings.h"
#include "googledriveservice.h"

class GoogleDriveManager : public QStandardItemModel
{
	Q_OBJECT

	public:
		GoogleDriveManager( GoogleDriveService * googleDriveService, QObject * parent = 0 );
		~GoogleDriveManager();

		void update();

		QStringList getAccounts();
		void removeAccount( QString account );

		QUrl addAccount( QString account );
		void finishAddAccount( QString key );

	signals:
		void isAvailable( bool );

	private:
		QProcess * process;
		GoogleDriveService * googleDriveService;
};

#endif
