#ifndef GOOGLEPRINTCONFIG_H
#define GOOGLEPRINTCONFIG_H

#include <QDialog>
#include <QWidget>
#include <QGridLayout>
#include <QPushButton>
#include <QGroupBox>
#include <QVBoxLayout>
#include <QProcess>
#include <QList>
#include <QStandardItemModel>
#include <QModelIndex>
#include <QTreeView>
#include <QInputDialog>
#include <QDir>

#include "googleprintmanager.h"
#include "configurationdialog.h"
#include "toolbutton.h"
#include "application.h"
#include "constants.h"

class QEvent;

class GooglePrintConfig : public QDialog, public ConfigurationDialog
{
	Q_OBJECT

	public:
		GooglePrintConfig(Menu * menu);
		~GooglePrintConfig();

		void init();
		QIcon icon() { return QIcon(ICON_DIR_APPS + QString(QDir::separator()) + "google-print.png"); };
		QString name() { return tr("Google Print"); };
		QDialog * widget() { return this; };


	public slots:
		void accept();
		void reject();

	private slots:
		void itemChanged( const QModelIndex & );
		void refreshSlot();
		void addSlot();
		void removeSlot();
		void connectSlot();
		void enterEvent ( QEvent * );

	private:
		QGridLayout * layout;
		bool dontclose;
		bool firstTime;
		QTreeView * printers;
		GooglePrintManager * model;
		ToolButton * refresh;
		ToolButton * add;
		ToolButton * remove;
		ToolButton * conn;

		ToolButton * backButton;
		QProcess * process;
};

#endif
