#ifndef GOOGLEPRINTMANAGER_H
#define GOOGLEPRINTMANAGER_H

#include <QProcess>
#include <QString>
#include <QWidget>
#include <QStringList>
#include <QStandardItemModel>
#include <QTcpSocket>

class QUrl;

#include "constants.h"
#include "settings.h"
#include "cupsmanager.h"

class GooglePrintManager : public QStandardItemModel
{
	Q_OBJECT

	public:
		GooglePrintManager( QObject * parent = 0 );
		~GooglePrintManager();

		void update();
		bool isConnected( QString printer );

		QStringList getAccounts();
		QStringList getPrinters( QString account );
		void removeAccount( QString account );
		void connectPrinter( QString account, QString printer );
		void disconnectPrinter( QString account, QString printer );
		void prunePrinters();

		QUrl addAccount( QString account );
		void finishAddAccount( QString key );

		QStringList getCommandOutput( QString command, QStringList arguments );
		QString namedPrinter(QString printer);

	private:
		QProcess * process;
		QTcpSocket * tcpSocket;
};

#endif
