#include "search.h"

#include <QDir>

Search::Search(QString exp, QStringList dirs) : QThread()
{
	this->exp = exp;
	this->dirs = dirs;
}

QFileInfoList Search::foundFiles()
{
	return files;
}

void Search::run()
{
	this->files = recursiveSearch(exp, dirs);

	emit searchDone();

	terminate();

	exec();
}

QList<QFileInfo> Search::recursiveSearch(QString exp, QStringList dirs)
{
	QList<QFileInfo> res;

	int dirsCount = dirs.count();

	for (int d=0; d<dirsCount; d++)
	{
		QDir searchDir(dirs[d]);
		QFileInfoList entryList = searchDir.entryInfoList(QDir::AllDirs | QDir::Files | QDir::NoDotAndDotDot | QDir::NoSymLinks);

		int count = entryList.count();
		for (int i=0; i<count; i++)
		{
			if (entryList[i].isDir() && !entryList[i].isSymLink())
			{
				res += recursiveSearch(exp, QStringList(entryList[i].absoluteFilePath()));
			}
			if (entryList[i].fileName().contains(exp, Qt::CaseInsensitive))
			{
				res += entryList[i];
			}
		}
	}

	return res;
}
