#include "pixmapframe.h"

PixmapFrame::PixmapFrame(QWidget * parent, QPixmap pixmap) : QFrame( parent )
{
	opacity = 1.0;
	this->pixmap = pixmap;
	x = 0;
	y = 0;
}

void PixmapFrame::setOpacity(qreal opacity)
{
	this->opacity = opacity;
	repaint();
}

void PixmapFrame::setPixmap(QPixmap pixmap, bool centered, bool expanded )
{
	this->pixmap = pixmap;
	this->centered = centered;
	this->expanded = expanded;
	resize();
}

void PixmapFrame::resize()
{
	if (expanded)
	{
		x = 0;
		y = 0;

		if ( (double)pixmap.width() / (double)width() > (double)pixmap.height() / (double)height() )
		{
			this->pixmap = pixmap.scaledToWidth(width(), Qt::SmoothTransformation);
		} else {
			this->pixmap = pixmap.scaledToHeight(height(), Qt::SmoothTransformation);
		}
	} else {
		this->pixmap = pixmap;
		if (centered)
		{
			x = (width() - pixmap.width() ) / 2;
			y = (height() - pixmap.height() ) / 2;
		} else {
			x = 0;
			y = 0;
		}
	}
	repaint();
}

void PixmapFrame::paintEvent ( QPaintEvent * )
{
	QPainter painter(this);
	painter.setOpacity(opacity);
	painter.drawPixmap(x, y, pixmap);
}
