#ifndef STORAGESERVICE_H
#define STORAGESERVICE_H

#include <QObject>
#include <QString>
#include <QStringList>
#include <QProcess>

class StorageService : public QObject
{
	Q_OBJECT

	public:
		virtual void start() = 0;
		virtual void stop() = 0;
		virtual bool status() = 0;
		virtual void update() = 0;
		virtual void unconfigure() = 0;
		virtual void unconfigure(QString account) = 0;
                virtual QStringList getAccounts() = 0;
                virtual int launchCommand(QStringList subcommands) = 0;

		QStringList getCommandOutput(QString command, QStringList arguments);

	signals:
		void isAvailable( bool );
		void isUpdating( bool );
};

#endif
