#ifndef THREADMANAGER_H
#define THREADMANAGER_H

#include <QApplication>
#include <QLabel>
#include <QTimer>
#include <QProcess>
#include <QDesktopWidget>
#include <QWidget>
#include <QPushButton>
#include <QGridLayout>
#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QList>
#include <qmath.h>
#include <QThread>

#include "threadbutton.h"
#include "threadwidget.h"
#include "constants.h"
#include "tabbar.h"

/*
#ifdef Q_OS_LINUX
#include "x11info.h"
#endif
*/

class ThreadManager : public QWidget
{
	Q_OBJECT

	public:
		ThreadManager( TabBar * tabBar, int numberOfMenus, QWidget * parent );

		void init();

	public slots:
		void update(int);

	private slots:
		void closeAllThreads();
		void killAllThreads();
		void disconnect();
		void exit();
		void setSelected( ThreadButton * button );

	signals:
		void finished();
	private:
		QWidget * emptyThread();

		QGridLayout * grid;
		QList<ThreadButton*> * threads;
		TabBar * tabBar;
		QPushButton * sleepButton;
		QPushButton * closeAllButton;
		QPushButton * killAllButton;
		QPushButton * returnButton;
		int rows;
		int numberOfMenus;
};

#endif
