#ifndef TOOLBUTTON_H
#define TOOLBUTTON_H

#include <QPushButton>
#include <QString>
#include <QStringList>
#include <QIcon>
#include <QPixmap>
#include <QPainter>
#include <QFont>
#include <QWidget>
#include <QSize>

#include "constants.h"

class ToolButton : public QPushButton
{
	Q_OBJECT

	public:
		ToolButton ( const QIcon & icon, const QString & text, QWidget * parent = 0 );

		void setText(QString name) { this->name = name; };
		void setIcon(QIcon icon) { this->icon = icon; };
		void setWidget(QWidget * widget) { this->widget = widget; };
		void addPixmap( const QPixmap & pixmap, QIcon::Mode mode = QIcon::Active, QIcon::State state = QIcon::On );

		static QSize buttonSize();

		QString getText() { return name; };
		QIcon getIcon() { return icon; };

	signals:
		void clicked(QWidget *);

	private slots:
		void emitClicked();

	private:
		void init();
		void paintEvent ( QPaintEvent * e);
		void enterEvent ( QEvent * event );
		void leaveEvent ( QEvent * event );

		QString name;
		QIcon icon;
		QWidget * widget;
};

#endif
