#ifndef USERCONFIG_H
#define USERCONFIG_H

#include <QObject>

#ifdef Q_OS_WIN
#include <Windows.h>
#include <lm.h>
#endif

#include <QDialog>
#include <QWidget>
#include <QGridLayout>
#include <QLineEdit>
#include <QGroupBox>
#include <QVBoxLayout>
#include <QDir>

#include "configurationdialog.h"
#include "toolbutton.h"
#include "appinstance.h"

class UserConfig : public QDialog, public ConfigurationDialog
{
	Q_OBJECT

	public:
		UserConfig(Menu * menu);

		void init();
		QIcon icon() { return QIcon(ICON_DIR_APPS + QString(QDir::separator()) + "userconfig.png"); };
		QString name() { return tr("User\nConfiguration"); };
		QDialog * widget() { return this; };


	public slots:
		void accept();
		void reject();

	private:
		QGridLayout * layout;
		bool dontclose;

		ToolButton * backButton;
		QLineEdit * username;
		QLineEdit * password;
		QLineEdit * newPassword;
		QLineEdit * repeatPassword;
		ToolButton * acceptButton;
		ToolButton * cancelButton;
};

#endif
