#ifndef WININFO_H
#define WININFO_H

#include <windows.h>
#include <Psapi.h>
#include <lm.h>
#include <WtsApi32.h>

#include <QWidget>
#include <QHash>
#include <QHashIterator>
#include <QDesktopWidget>
#include <QList>
#include <QProcess>
#include <QTimer>
#include <QString>
#include <QWindow>
#include <QGuiApplication>
#include <QApplication>
#include <QIcon>
#include <QtWinExtras/QtWin>
//#include <qpa/qplatformnativeinterface.h>

#include "constants.h"
#include "settings.h"

struct handleData
{
    QProcess * process;
    bool showVisible;
    QList<HWND> windows;
    HWND first;
};

/*
struct _STORAGE_DEVICE_NUMBER
{
  DEVICE_TYPE  DeviceType;
  ULONG  DeviceNumber;
  ULONG  PartitionNumber;
};
*/

BOOL CALLBACK EnumWindowsProc(HWND hWnd, LPARAM lparam);
//void CALLBACK FollowWindowsProc(HWINEVENTHOOK hook, DWORD event, HWND hWnd, long idObject, long idChild, DWORD dwEventThread, DWORD dwmsEventTime);

class WinInfo
{
    public:
        static void followProc(DWORD processId);
        static QList<HWND> getWindows(QProcess * process);
        static QList<HWND> getVisibleWindows();
        static QString getWindowTitle(HWND hWnd);
        static unsigned long getWindowPid(HWND hWnd);
        static QString getWindowExecName(HWND hWnd);
        static HWND getParent(HWND hWnd);
		static bool hasNoParent(HWND hWnd);
        static void setWindowsInfo( QList<HWND> * windowsList, QList<long> * styles, QList<long> * exStyles, QList<QString> * titles);
        static void debugWindowInfo( HWND hWnd );

        static int isWindowStyle(HWND hWnd, long style);
        static int isWindowExStyle(HWND hWnd, long style);

        static bool isDlgFrame(HWND hWnd);
        static bool isChild(HWND hWnd);
        static bool isPopupWindow(HWND hWnd);
        static bool isPopup(HWND hWnd);
        static bool hasSysmenu(HWND hWnd);
        static bool isOverlapped(HWND hWnd);
        static bool isOverlappedWindow(HWND hWnd);
        static bool isVisible(HWND hWnd);
        static bool isAppWindow(HWND hWnd);
        static bool isToolWindow(HWND hWnd);

        static void selectWindow(HWND hWnd, bool fullScreen = false);
        static void closeWinWindow(HWND hWnd);
        static void killWinWindow(HWND hWnd);
        static void attachWindow(QWidget * container, HWND hWnd);
        static void hideTaskBar();
        static void showTaskBar();
        static void setWallPaper(LPWSTR image);
        static QIcon getWindowIcon(HWND hwnd);
        static QIcon getAppIcon(QString command);

        static HWND fromId(long long id);

		static QStringList getUsedLogicalDrives();
        static QString getAvailableLogicalDrive();
        static void removeRemoteDrive(QString drive);
		static QString appendRemoteDrive(QString name , QString _drive = QString::null);
		static void setRemoteDrives(QStringList *names, QStringList *drives, QList<bool> * remove, QHash<QString,QString> assignedDrives);
		static void setSharedFoldersDrives(QStringList *names, QStringList *drives, QList<bool> * remove, QHash<QString,QString> assignedDrives);
		static void setHomeDrive(QStringList * names, QStringList * drives, QList<bool> *remove);
};

#endif // WININFO_H
