# Windows CMD script for generating icons

set SRC=src\default
set SIZES=(32 48 64)
set XCF2PNG="%PROGRAMFILES(X86)%\xcftools\xcf2png"
set CONVERT="%PROGRAMFILES%\ImageMagick-6.9.2-Q16\convert"
set TARGET=..\common

if "%1" == "clean" (
	rmdir /S /Q %TARGET%\icons
	rmdir /S /Q %TARGET%\mime
	del /Q %SRC%\actions\*.png %SRC%\devices\*.png  %SRC%\places\*.png
	exit /B 0
)

mkdir %TARGET%\mime
xcopy ..\mime\* %TARGET%\mime\

mkdir %TARGET%\icons
mkdir %TARGET%\icons\applications
mkdir %TARGET%\icons\groups
mkdir %TARGET%\icons\other
mkdir %TARGET%\icons\animations

xcopy animations\* %TARGET%\icons\animations\
xcopy other\* %TARGET%\icons\other\

for %%i in %SIZES% do (
	mkdir %TARGET%\icons\%%ix%%i
)

for %%i in (%SRC%\actions\*.xcf %SRC%\devices\*.xcf %SRC%\places\*.xcf) do (
	call :XCF2PNG %%i
	for %%k in %SIZES% do (
		call :CONVERT %%i %%k 
	)
)

for %%i in (src\default\apps\*.xcf) do (
	call :XCF2PNGDEST %%i  %TARGET%\icons\applications
)

for %%i in (src\default\categories\*.xcf) do (
	call :XCF2PNGDEST %%i  %TARGET%\icons\groups
)

goto :eof

:XCF2PNG
	set PNG=%~dp1%~n1.png
	set XCF=%1
	%XCF2PNG% -o %PNG% %XCF%
	goto :eof

:XCF2PNGDEST
	set PNG=%~n1.png
	set XCF=%1
	set DEST=%2
	%XCF2PNG% -o %DEST%\%PNG% %XCF%
	goto :eof

:CONVERT
	set PNG=%~dp1%~n1.png
	set DEST=%~n1.png
	set SIZ=%2
	%CONVERT% -resize %SIZ%x%SIZ% %PNG% %TARGET%\icons\%SIZ%x%SIZ%\%DEST%
	goto :eof