#! /usr/bin/env python2.7

import cups, os, json, sys
from auth import Auth
from oauth2client import multistore_file
from printer import Printer

def usage():
	print("Usage: manageaccounts.py <config_file> <command> [ <account_name> ]")
	print("Commands:")
	print("list")
	print("add <account_name>")
	print("remove <account_name>")
	print("printers <account_name>")
	sys.exit(1)

try:
	configFile = sys.argv[1]
	command = sys.argv[2]
except:
	usage()

scope = 'https://www.googleapis.com/auth/cloudprint'

if command != "list":
	try:
		accountName = sys.argv[3]
	except:
		usage()

Auth.config = configFile

if os.path.exists(Auth.config):
	try:
		content_file = open(Auth.config, 'r')
		content = content_file.read()
		data = json.loads(content)
	except:
		# remove old config file
		print("Deleting old configuration file: " + Auth.config)
		os.remove(Auth.config)

requestors, storage = Auth.SetupAuth()

if command == "list":
	for requestor in requestors:
		print requestor.getAccount()
	sys.exit(0)

if command == "add":
	Auth.AddAccount(storage, accountName)
	sys.exit(0)

if command == "remove":
	storage = multistore_file.get_credential_storage(configFile, Auth.clientid, accountName, scope)
	storage.delete()
	sys.exit(0)

if command == "printers":
	for requestor in requestors:
		if requestor.getAccount() == accountName:
			printer = Printer(requestor)
			printers = printer.getPrinters()

	try:
		for foundprinter in printers:
			print( foundprinter['name'].encode('ascii', 'replace') )
	except:
		sys.exit(0)
	sys.exit(0)
