param([string]$librework_group,[string]$profiles_server)
#Main variables:
$gpo_name="librework"

#Extract zip function:
function unzip($file, $destination)
{
    $shell = new-object -com shell.application
    $zip = $shell.NameSpace($file)
    foreach($item in $zip.items())
    {
        $shell.Namespace($destination).copyhere($item)
    }
}

#Get-ScriptDirectory function:
function Get-ScriptDirectory
{
    $Invocation = (Get-Variable MyInvocation -Scope 1).Value
    Split-Path $Invocation.MyCommand.Path
}

#Code:
$ScriptDir = Get-ScriptDirectory
$Zipfile = "$ScriptDir" + "\" + "librework-gpo.zip"
$GpoFolder = "$ScriptDir" + "\" + "librework-gpo"

New-Item -ItemType directory -Path "$GpoFolder"
unzip -file "$ZipFile" -destination "$GpoFolder"

$GpoId = $GpoFolder + "\*-*-*-*-*"
$GpoIdFile = (Get-Item $GpoId).FullName
$DeployFile = "$GpoIdFile" + "\DomainSysvol\GPO\User\Documents & Settings\fdeploy1.ini"
$TmpFile = "$env:temp" + "\temp.ini"

get-content "$DeployFile" | %{$_ -replace "__PROFILES_SERVER__","$profiles_server"} > "$TmpFile"
Copy-Item "$TmpFile" "$DeployFile" -Force
Remove-Item "$TmpFile"

import-module grouppolicy

remove-gpo -name $gpo_name
new-gpo -name $gpo_name

$dc1=$env:userdomain
$dc2=($env:userdnsdomain).split(".")[1]

new-gplink -name $gpo_name -target "dc=$dc1,dc=$dc2" -enforced yes

import-gpo -backupgponame librework -targetname $gpo_name -path $GpoFolder

remove-item $GpoFolder -force -recurse

set-gppermissions -name $gpo_name -permissionlevel gpoapply -targetname $librework_group -targettype group
set-gppermissions -name $gpo_name -permissionlevel gpoapply -targetname "Domain Computers" -targettype group
set-gppermissions -name $gpo_name -permissionLevel None -targetname "Authenticated Users" -targettype group

$gpo = Get-GPO -Name $gpo_name
$gpo_dc1 = $gpo.domainname.split(".")[0]
$gpo_dc2 = $gpo.domainname.split(".")[1]
$adgpo = [ADSI]"LDAP://CN=`{$($gpo.Id.guid)`},CN=Policies,CN=System,DC=$gpo_dc1,DC=$gpo_dc2"

$rule = New-Object System.DirectoryServices.ActiveDirectoryAccessRule(
		[System.Security.Principal.NTAccount]"$env:userdomain\$env:username",
		"ExtendedRight",
		"Deny",
		[Guid]"edacfd8f-ffb3-11d1-b41d-00a0c968f939"
	)

$acl = $adgpo.ObjectSecurity
$acl.AddAccessRule($rule)
$adgpo.CommitChanges()