; Script generated by the Inno Setup Script Wizard.
; SEE THE DOCUMENTATION FOR DETAILS ON CREATING INNO SETUP SCRIPT FILES!

[Setup]
; NOTE: The value of AppId uniquely identifies this application.
; Do not use the same AppId value in installers for other applications.
; (To generate a new GUID, click Tools | Generate GUID inside the IDE.)
;SignTool=byparam $qC:\Program Files\Microsoft SDKs\Windows\v7.1\Bin\signtool.exe$q sign /f $qc:\librework\client\windeploy\Comodo.pfx$q /t http://timestamp.comodoca.com/authenticode /p librework14 $f
;SignedUninstaller=yes
ArchitecturesInstallIn64BitMode=x64
AppId={{E4903C3B-3C5A-42D0-A84D-F911C1B789E6}
AppName=Librework Desktop
AppVersion=2.2
;AppVerName=LibreWork Desktop 1.2
AppPublisher=LibreWork
AppPublisherURL=http://www.librework.com/
AppSupportURL=http://www.librework.com/
AppUpdatesURL=http://www.librework.com/
DefaultDirName={pf}\LibreWork Desktop
DisableDirPage=yes
DefaultGroupName=Librework Desktop
DisableProgramGroupPage=yes
OutputBaseFilename=librework-desktop-setup
SetupIconFile=librework.ico
Compression=lzma
SolidCompression=yes

;[Registry]
;Root: HKLM; Subkey: "Software\Microsoft\Windows NT\CurrentVersion\Winlogon"; ValueType: String; ValueName: "Shell"; ValueData: "{app}\desktux.exe"

[Languages]
Name: "english"; MessagesFile: "compiler:Default.isl"
Name: "spanish"; MessagesFile: "compiler:Languages\Spanish.isl"

[Tasks]
Name: "desktopicon"; Description: "{cm:CreateDesktopIcon}"; GroupDescription: "{cm:AdditionalIcons}"; Flags: unchecked

[Files]
Source: "desktux.exe"; DestDir: "{app}"; Flags: ignoreversion
Source: "reginstall.bat"; DestDir: "{app}"; Flags: ignoreversion
Source: "reguninstall.bat"; DestDir: "{app}"; Flags: ignoreversion
Source: "librework-gpo-requisites.ps1"; DestDir: "{app}"; Flags: ignoreversion
Source: "librework-gpo-uninstall.ps1"; DestDir: "{app}"; Flags: ignoreversion
Source: "librework-gpo.ps1"; DestDir: "{app}"; Flags: ignoreversion
Source: "librework-gpo.zip"; DestDir: "{app}"; Flags: ignoreversion
Source: "desktux_es.qm"; DestDir: "{app}"; Flags: ignoreversion
;Source: "desktux.ini"; DestDir: "{app}"; Flags: ignoreversion
Source: "librework.png"; DestDir: "{app}"; Flags: ignoreversion
Source: "librework.ico"; DestDir: "{app}"; Flags: ignoreversion
;Source: "icudt53.dll"; DestDir: "{app}"; Flags: ignoreversion
;Source: "icuin53.dll"; DestDir: "{app}"; Flags: ignoreversion
;Source: "icuuc53.dll"; DestDir: "{app}"; Flags: ignoreversion
;Source: "msvcp100.dll"; DestDir: "{app}"; Flags: ignoreversion
;Source: "msvcr100.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "concrt140.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "msvcp140.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "vccorlib140.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "vcruntime140.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "platforms\qwindows.dll"; DestDir: "{app}\platforms\"; Flags: ignoreversion
Source: "Qt5Core.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "Qt5Gui.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "Qt5Widgets.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "Qt5Network.dll"; DestDir: "{app}"; Flags: ignoreversion
;Source: "Qt5DBus.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "Qt5Svg.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "imageformats\*.dll"; DestDir: "{app}\imageformats\"; Flags: ignoreversion
;Source: "Qt5WinExtras.dll"; DestDir: "{app}"; Flags: ignoreversion
; NOTE: Don't use "Flags: ignoreversion" on any shared system files

[Icons]
Name: "{group}\LibreWork Desktop"; Filename: "{app}\desktux.exe"
Name: "{group}\{cm:UninstallProgram,LibreWork Desktop}"; Filename: "{uninstallexe}"
Name: "{commondesktop}\LibreWork Desktop"; Filename: "{app}\desktux.exe"; Tasks: desktopicon

[Run]
Filename: "{app}\reginstall.bat"; Parameters: {code:GetParams}; Flags: waituntilterminated
Filename: "{app}\desktux.exe"; Description: "{cm:LaunchProgram,LibreWork Desktop}"; Flags: nowait postinstall skipifsilent

[UninstallRun]
Filename: "{app}\reguninstall.bat"; Flags: waituntilterminated

[Code]
var
  LibreworkServerLineEdit: TNewEdit;
  LibreworkServerPortLineEdit: TNewEdit;
  FullScreenCheckBox: TNewCheckBox;
  HomePathLineEdit: TNewEdit;
  ProfilesServerLineEdit: TNewEdit;
  CustomPage: TWizardPage;  

function GetParams(Value: string):string;
begin
  Result := ProfilesServerLineEdit.Text;
end;
 
function CheckForm(Page: TWizardPage):Boolean;
begin
  if (LibreworkServerLineEdit.Text = '') then
  begin
    MsgBox('Librework principal server address must not be empty', mbError, MB_OK);
    Result := false
    exit
  end;
  if (LibreworkServerPortLineEdit.Text = '') then
  begin
    MsgBox('Librework principal server port must not be empty', mbError, MB_OK);
    Result := false
    exit
  end;
  if (HomePathLineEdit.Text = '') then
  begin
    MsgBox('Server home path must not be empty', mbError, MB_OK);
    Result := false
    exit
  end;
  if (ProfilesServerLineEdit.Text = '') then
  begin
    MsgBox('Home/Profiles server must not be empty', mbError, MB_OK);
    Result := false
    exit
  end;
  Result := true;
end;

procedure CurPageChanged(CurPageID: Integer);
var
  ResultCode : Integer;
begin
  if CurPageID = wpInstalling then
  begin
    CreateDir( ExpandConstant('{pf}') + '\Librework Desktop' ); 
    if (FileExists( ExpandConstant('{pf}') + '\Librework Desktop\reguninstall.bat' ) ) then
    begin
      Exec( ExpandConstant('{pf}') + '\Librework Desktop\reguninstall.bat', '', ExpandConstant('{pf}') + '\Librework Desktop', SW_SHOW,  ewWaitUntilTerminated, ResultCode );
    end;
    SetIniString('Server', 'LibreworkServerAddress', LibreworkServerLineEdit.Text, ExpandConstant('{pf}') + '\Librework Desktop\desktux.ini');
    SetIniString('Server', 'LibreworkServerPort', LibreworkServerPortLineEdit.Text, ExpandConstant('{pf}') + '\Librework Desktop\desktux.ini');
    SetIniString('Server', 'HomePath', HomePathLineEdit.Text, ExpandConstant('{pf}') + '\Librework Desktop\desktux.ini');
    SetIniString('Server', 'ProfilesServer', ProfilesServerLineEdit.Text, ExpandConstant('{pf}') + '\Librework Desktop\desktux.ini');
    if (FullScreenCheckBox.Checked = true) then
    begin
      SetIniString('Desktop', 'WindowManagerBehaviour', 'fullscreen', ExpandConstant('{pf}') + '\Librework Desktop\desktux.ini');
    end
    else
    begin
      SetIniString('Desktop', 'WindowManagerBehaviour', 'standard', ExpandConstant('{pf}') + '\Librework Desktop\desktux.ini');
    end;   
  end;
end;

procedure InitializeWizard;
var
  AddressLabel: TLabel;
  PortLabel: TLabel;
  HomePathLabel: TLabel;
  ProfilesServerLabel: TLabel;
  CheckLabel: TLabel;
  separator: Cardinal;
begin
  separator := 5;
  CustomPage := CreateCustomPage(wpSelectDir, 'Server Configuration', 'Select configuration options for this server');

  AddressLabel := TLabel.Create(WizardForm);
  AddressLabel.Parent := CustomPage.Surface;
  AddressLabel.Left := 0;
  AddressLabel.Top := 0;
  AddressLabel.Caption := 'Select Librework principal server address:';

  LibreworkServerLineEdit := TNewEdit.Create(WizardForm);
  LibreworkServerLineEdit.Parent := CustomPage.Surface;
  LibreworkServerLineEdit.Left := AddressLabel.width + separator;
  LibreworkServerLineEdit.Top := 0;  
  LibreworkServerLineEdit.Text := GetIniString('Server', 'LibreworkServerAddress', '127.0.0.1', ExpandConstant('{pf}') + '\Librework Desktop\desktux.ini');
  LibreworkServerLineEdit.Width := 150;

  PortLabel := TLabel.Create(WizardForm);
  PortLabel.Parent := CustomPage.Surface;
  PortLabel.Left := 0;
  PortLabel.Top := LibreworkServerLineEdit.Top + LibreworkServerLineEdit.Height + separator;
  PortLabel.Caption := 'Select Librework principal server port:';

  LibreworkServerPortLineEdit := TNewEdit.Create(WizardForm);
  LibreworkServerPortLineEdit.Parent := CustomPage.Surface;
  LibreworkServerPortLineEdit.Left := PortLabel.width + separator;
  LibreworkServerPortLineEdit.Top := LibreworkServerLineEdit.Top + LibreworkServerLineEdit.Height + separator;  
  LibreworkServerPortLineEdit.Text := GetIniString('Server', 'LibreworkServerPort', '4445', ExpandConstant('{pf}') + '\Librework Desktop\desktux.ini');
  LibreworkServerPortLineEdit.Width := 120;

  HomePathLabel := TLabel.Create(WizardForm);
  HomePathLabel.Parent := CustomPage.Surface;
  HomePathLabel.Left := 0;
  HomePathLabel.Top := LibreworkServerPortLineEdit.Top + LibreworkServerPortLineEdit.Height + separator;
  HomePathLabel.Caption := 'Select server home path:';

  HomePathLineEdit := TNewEdit.Create(WizardForm);
  HomePathLineEdit.Parent := CustomPage.Surface;
  HomePathLineEdit.Left := HomePathLabel.width + separator;
  HomePathLineEdit.Top := LibreworkServerPortLineEdit.Top + LibreworkServerPortLineEdit.Height + separator;  
  HomePathLineEdit.Text := GetIniString('Server', 'HomePath', 'C:\Users', ExpandConstant('{pf}') + '\Librework Desktop\desktux.ini');
  HomePathLineEdit.Width := 200;

  ProfilesServerLabel := TLabel.Create(WizardForm);
  ProfilesServerLabel.Parent := CustomPage.Surface;
  ProfilesServerLabel.Left := 0;
  ProfilesServerLabel.Top := HomePathLineEdit.Top + HomePathLineEdit.Height + separator;
  ProfilesServerLabel.Caption := 'Select home/profiles server name:';

  ProfilesServerLineEdit := TNewEdit.Create(WizardForm);
  ProfilesServerLineEdit.Parent := CustomPage.Surface;
  ProfilesServerLineEdit.Left := ProfilesServerLabel.width + separator;
  ProfilesServerLineEdit.Top := HomePathLineEdit.Top + HomePathLineEdit.Height + separator;  
  ProfilesServerLineEdit.Text := GetIniString('Server', 'ProfilesServer', 'domainserver', ExpandConstant('{pf}') + '\Librework Desktop\desktux.ini');
  ProfilesServerLineEdit.Width := 200;

  CheckLabel := TLabel.Create(WizardForm);
  CheckLabel.Parent := CustomPage.Surface;
  CheckLabel.Left := 0;
  CheckLabel.Top := ProfilesServerLineEdit.Top + ProfilesServerLineEdit.Height + 2 * separator;
  CheckLabel.Caption := 'Window manager behaviour:';

  FullScreenCheckBox := TNewCheckBox.Create(WizardForm);
  FullScreenCheckBox.Parent := CustomPage.Surface;
  FullScreenCheckBox.Left := 0;
  FullScreenCheckBox.Top := CheckLabel.Top + CheckLabel.Height + separator;
  FullScreenCheckBox.Caption := 'All windows full screen';
  FullScreenCheckBox.Width := 300;
  FullScreenCheckBox.Checked := ( GetIniString('Desktop', 'WindowManagerBehaviour', 'standard', ExpandConstant('{pf}') + '\Librework Desktop\desktux.ini') = 'fullscreen' );

  CustomPage.OnNextButtonClick := @CheckForm;
end;
