import time
import threading

class Cache(object):
	def __init__(self, ttl = 60):
		self.ttl = ttl
		self.cache = {}
		self.mutex=threading.RLock()

	def get( self, path ):
		with self.mutex:
			if not path in self.cache:
				return None

			timestamp,data = self.cache[ path ]

			minTime = time.time() - self.ttl
			if timestamp > minTime:
				return data
			else:
				del self.cache[ path ]
			return None

	def set( self, path, data ):
		with self.mutex:
			self.cache[path] = time.time(),data

	def remove( self, path ):
		with self.mutex:
			if path in self.cache:
				del self.cache[ path ]
