#!/usr/bin/env python

import hashlib
import os
import stat
import fsstat
import time

class FileSystem():
	def __init__( self ):
		pass
	def init( self, credentialsFile ):
		raise NotImplementedError
	def authorize( self, type, credentialsFile ):
		raise NotImplementedError
	def umount( self ):
		raise NotImplementedError
	def exists( self, fileName ):
		raise NotImplementedError
	def downloadFile( self, fileName, localFile ):
		raise NotImplementedError
	def uploadFile( self, fileName, localFile ):
		raise NotImplementedError
	def createDir( self, dirName ):
		raise NotImplementedError
	def remove( self, path ):
		raise NotImplementedError
	def getStat( self, path ):
		raise NotImplementedError
	def getDirContents( self, dirName ):
		raise NotImplementedError
	def statFs (self):
		raise NotImplementedError
	def retrieveId( self, path ):
		raise NotImplementedError
	def rename( self, oldPath, newPath ):
		raise NotImplementedError

	# Useful common functions
	def getFileName( self, path ):
		pathList = path.split('/')
		fileName = pathList[-1]
		return fileName

	def retrieveNameHash( self, path ):
		m = hashlib.md5()
		m.update( path )
		_hash = m.hexdigest()
		return _hash
