package com.librework.console;


import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.SessionScoped;
import javax.transaction.Transaction;

import org.apache.log4j.BasicConfigurator;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.AnnotationConfiguration;
import org.springframework.beans.factory.xml.XmlBeanDefinitionReader;
import org.springframework.context.support.GenericApplicationContext;
import org.springframework.core.io.ClassPathResource;
import org.springframework.dao.DataAccessException;

import com.librework.console.bean.HolaBean;
import com.librework.console.daoLDAP.IGroupLDAPDao;
import com.librework.console.daoLDAP.IUserGroupLDAPDao;
import com.librework.console.daoLDAP.IUserLDAPDao;
import com.librework.console.general.Constant;
import com.librework.console.model.GroupUser;
import com.librework.console.model.User;
import com.librework.console.model.UserGroup;
import com.librework.console.model.UserGroupPK;
import com.librework.console.modelLDAP.GroupUserLDAP;
import com.librework.console.modelLDAP.UserGroupLDAP;
import com.librework.console.modelLDAP.UserLDAP;
import com.librework.console.service.IGroupUserService;
import com.librework.console.service.IUserService;
import com.librework.console.service.ServiceUtilsLDAP;
import com.librework.console.utils.AppUtils;
import com.librework.console.utils.HibernateUtil;



@ManagedBean (name="miControlador")
@SessionScoped

public class MiControlador implements Serializable {
	
	
	private static final long serialVersionUID = 1L;
	
	private String nombre;
	private String saludo;
	
	protected UserLDAP userLdap;
	
	@ManagedProperty(value="#{UserService}")
	private IUserService userService;
	
	@ManagedProperty(value="#{GroupUserService}")
	private IGroupUserService groupUserService;
	

	public IGroupUserService getGroupUserService() {
		return groupUserService;
	}

	public void setGroupUserService(IGroupUserService groupUserService) {
		this.groupUserService = groupUserService;
	}

	public IUserService getUserService() {
		return userService;
	}

	public void setUserService(IUserService userService) {
		this.userService = userService;
	}

	@ManagedProperty(value = "#{holaBean}")
	private HolaBean holaBean;
	
	
	public void saluda() {
		GenericApplicationContext appContext = AppUtils.getContext();
		appContext.refresh();
		AppUtils.setApplicationContext(appContext);
		IUserLDAPDao userLdapDao = ServiceUtilsLDAP.getUserLDAPService();

		System.out.println("Valor nombre: " + nombre);
		System.out.println("Valor holaBean: " + holaBean);
		System.out.println("Valor userLdapDao: " + userLdapDao);
		//grupos
		IGroupLDAPDao groupLdapDao = ServiceUtilsLDAP.getGroupLDAPService();
		GroupUserLDAP groupLDAP = new GroupUserLDAP();
		groupLDAP.setCn("LIBREWORK");
		groupLDAP.setName("LIBREWORK");
		groupLDAP.setDescription("LIBREWORK");
		groupLdapDao.createGroup(groupLDAP);
		System.out.println("Groupo Creado");
		groupLDAP.setDescription("ACCESO A LIBREWORK");
		groupLdapDao.updateGroup(groupLDAP);
		System.out.println("Grupo modificado");
		groupLDAP = groupLdapDao.getGroupCn(groupLDAP.getCn());
		System.out.println(groupLDAP.getCn() + "," + groupLDAP.getName() + "," + groupLDAP.getDescription() +
				"," + groupLDAP.getDescription());
		List<GroupUserLDAP> resultG = groupLdapDao.getAllGroups();
		for (int i=0; i< resultG.size(); i++){
			String cn = (String) resultG.get(i).getCn();
			String name = (String) resultG.get(i).getName();
			String description = resultG.get(i).getDescription();
			String distinguishedName = resultG.get(i).getDistinguishedName();
			System.out.println(distinguishedName + "," + cn + "," + name + "," + description);
		}
		boolean blnRespuestaG = groupLdapDao.deleteGroup(groupLDAP);
	    resultG = groupLdapDao.getAllGroups();
	    for (int i=0; i< resultG.size(); i++){
			String cn = (String) resultG.get(i).getCn();
			String name = (String) resultG.get(i).getName();
			String description = resultG.get(i).getDescription();
			String distinguishedName = resultG.get(i).getDistinguishedName();
			System.out.println(distinguishedName + "," + cn + "," + name + "," + description);
		}
	    
		//Usuarios
		UserLDAP user = new UserLDAP();
		user.setCn("pnieto11");
		user.setSAMAccountName("pnieto11");
		user.setName("pnieto9");
		user.setDescription("Pedro Nieto 9");
		user.setDisplayName("Pedro Nieto 9");
		user.setRegisteredAddress("Pradillo");
		user.setMail("pnieto@dinsa.es");
		user.setUnicodePwd("Password123");
		
		userLdapDao.createUser(user);
		System.out.println("Usuario creado");
		userLdapDao.setPasswordUser(user);
		System.out.println("Password modificada");
		
		UserLDAP user2 = new UserLDAP();
		user2 = userLdapDao.getUserCn(user.getCn());
		System.out.println(user2.getCn() + "," + user2.getName() + "," + user2.getDescription() +
							"," + user2.getDisplayName() + "," + user2.getUnicodePwd()  + "," + user2.getUserAccountControl());
		user2.setDisplayName("Display modificado");
		boolean blnRespuesta = userLdapDao.updateUser(user2);
		user2 = userLdapDao.getUserCn(user2.getCn());
		System.out.println(blnRespuesta + "," + user2.getCn() + "," + user2.getName() + "," + user2.getDescription() +
				"," + user2.getDisplayName() + "," + user2.getUnicodePwd()  + "," + user2.getUserAccountControl());
		//Usuarios grupos
	    IUserGroupLDAPDao userGroupLdapDao = ServiceUtilsLDAP.getUserGroupLDAPService();
		UserGroupLDAP userGroupLDAP = new UserGroupLDAP();
		userGroupLDAP.setCnUser(user2.getCn());
		userGroupLDAP.setDnUser(user2.getDistinguishedName());
		userGroupLDAP.setCnGroup("Administrators");
		userGroupLDAP.setDnGroup("CN=Administrators,CN=Builtin,DC=librework,DC=local");
		userGroupLdapDao.createUserGroup(userGroupLDAP);
		System.out.println("Groupo Creado");
		List resultUG = userGroupLdapDao.getUserGroupByGroup("Administrators");
		for (int i=0; i< resultUG.size(); i++){
			UserGroupLDAP resulUsers = (UserGroupLDAP) resultUG.get(i);
			String[] users = resulUsers.getGroupsUser();
			for (int g=0; g < users.length; g++) {
				System.out.println(users[g]);
			}
			
			//String cn = (String) resultUG.get(i).getCnUser();
			//String name = (String) resultUG.get(i).getCnGroup();
			//System.out.println(cn + "," + name);
		}
		resultUG = userGroupLdapDao.getUserGroupByUser(user2.getCn());
		for (int i=0; i< resultUG.size(); i++){
			UserGroupLDAP resulGroups = (UserGroupLDAP) resultUG.get(i);
			String[] groups = resulGroups.getUsersGroup();
			for (int g=0; g < groups.length; g++) {
				System.out.println(groups[g]);
			}
		}
		
		boolean blnRespuestaUG = userGroupLdapDao.removeUserGroup(userGroupLDAP);
		
		List<UserLDAP> result = userLdapDao.getAllUsers();
		for (int i=0; i< result.size(); i++){
			String cn = (String) result.get(i).getCn();
			String name = (String) result.get(i).getName();
			String description = result.get(i).getDescription();
			String displayName = result.get(i).getDisplayName();
			String userPassword = result.get(i).getUnicodePwd();
			String userAccountControl = result.get(i).getUserAccountControl();
			String distinguishedName = result.get(i).getDistinguishedName();
			System.out.println(distinguishedName + "," + cn + "," + name + "," + description + "," + displayName + "," + userPassword  + "," + userAccountControl);
		}
		blnRespuesta = userLdapDao.deleteUser(user2);
		
	    result = userLdapDao.getAllUsers();
		
		for (int i=0; i< result.size(); i++){
			String cn = (String) result.get(i).getCn();
			String name = (String) result.get(i).getName();
			String description = result.get(i).getDescription();
			String displayName = result.get(i).getDisplayName();
			String userPassword = result.get(i).getUnicodePwd();
			String userAccountControl = result.get(i).getUserAccountControl();
			System.out.println(cn + "," + name + "," + description + "," + displayName + "," + userPassword  + "," + userAccountControl);
		}
		
		User userBD = new User();
		userBD.setUse_id("pnieto10");
		userBD.setUse_password("pnieto");
		userBD.setUse_direction("pradillo");
		userBD.setUse_name("pnieto");
		userBD.setUse_surname1("pnieto");
		userBD.setUse_surname2("pnieto");
		userBD.setUse_email("pnieot");
		userBD.setUse_phone("pnieo");
		Date dt = new Date();
		SimpleDateFormat sdf = new SimpleDateFormat(Constant.MASK_DATE_WEB);
		System.out.println(sdf.format(dt));
		userBD.setUse_datmod(dt);
		userBD.setUse_usemod("pnieto");
		try {
			getUserService().createUser(userBD);
			List<User> userList = getUserService().getAllUser();
			for (int i=0; i< userList.size(); i++){
				String cn = (String) userList.get(i).getUse_id();
				String name = (String) userList.get(i).getUse_name();
				String description = userList.get(i).getUse_surname1();
				String displayName = userList.get(i).getUse_surname2();
				String userPassword = userList.get(i).getUse_password();
				String userAccountControl = userList.get(i).getUse_direction();
				System.out.println(cn + "," + name + "," + description + "," + displayName + "," + userPassword  + "," + userAccountControl);
			}
			userBD.setUse_password("prueba");
			getUserService().updateUser(userBD);
			
			userList = getUserService().getAllUser();
			for (int i=0; i< userList.size(); i++){
				String cn = (String) userList.get(i).getUse_id();
				String name = (String) userList.get(i).getUse_name();
				String description = userList.get(i).getUse_surname1();
				String displayName = userList.get(i).getUse_surname2();
				String userPassword = userList.get(i).getUse_password();
				String userAccountControl = userList.get(i).getUse_direction();
				System.out.println(cn + "," + name + "," + description + "," + displayName + "," + userPassword  + "," + userAccountControl);
			}
			
			User user3 = getUserService().getUserId("Administrator");
			System.out.println(user3.getUse_direction());
			
			getUserService().deleteUser(userBD);
			
		} catch (DataAccessException e) {
			System.out.println(e.toString());
		}
		
		GroupUser groupBD = new GroupUser();
		
		groupBD.setGus_cn("PRUEBA");
		groupBD.setGus_name("prueba");
		groupBD.setGus_description("prueba");
		groupBD.setGus_datmod(dt);
		groupBD.setGus_usemod("PNIETO");
		getGroupUserService().createGroupUser(groupBD);
		List<GroupUser> groupList = getGroupUserService().getAllGroupUser();
		for (int i=0; i< groupList.size(); i++){
			long idG = groupList.get(i).getGus_id();
			String cnG = (String) groupList.get(i).getGus_cn();
			String nameG = groupList.get(i).getGus_name();
			String descriptionG = (String) groupList.get(i).getGus_description();
			System.out.println(idG + "," + cnG + "," + nameG + "," + descriptionG);
		}
		groupBD.setGus_description("Esto es una prueba");
		getGroupUserService().updateGroupUser(groupBD);
		
		groupList = getGroupUserService().getAllGroupUser();
		for (int i=0; i< groupList.size(); i++){
			long idG = groupList.get(i).getGus_id();
			String cnG = (String) groupList.get(i).getGus_cn();
			String nameG = groupList.get(i).getGus_name();
			String descriptionG = (String) groupList.get(i).getGus_description();
			System.out.println(idG + "," + cnG + "," + nameG + "," + descriptionG);
		}
		User user4 = getUserService().getUserId("Administrator");
		UserGroup userGroup = new UserGroup();
		@SuppressWarnings("deprecation")
		AnnotationConfiguration config=new AnnotationConfiguration();
		config.addAnnotatedClass(User.class);
		config.addAnnotatedClass(GroupUser.class);
		config.addAnnotatedClass(UserGroup.class);
		SessionFactory sessionFactory = config.configure().buildSessionFactory();
		Session session = sessionFactory.openSession();
		org.hibernate.Transaction tx=session.beginTransaction();
		UserGroupPK userGroupPK = new UserGroupPK(user4, groupBD);
		userGroup.setUserGroupPK(userGroupPK);
		userGroup.setFk_ugr_gus_id(groupBD.getGus_id());
		userGroup.setFk_ugr_use_id(user4.getUse_id());
		userGroup.setUgr_datmod(new Date());
		userGroup.setUgr_usemod("pnieto");
		
		user4.getUserGroups().add(userGroup);
		user4.getUserGroups().remove(userGroup);
		
		session.saveOrUpdate(user4);
		tx.commit();
		session.close();
		
		User user5 = getUserService().getUserId("pnieto");
		GroupUser groupUser5 = getGroupUserService().getGroupUserId(16);
		List<UserGroup> userGroups = getUserService().getAllGroupUser(user5);
		for (int i=0; i < userGroups.size(); i++) {
			GroupUser groupUser2 = userGroups.get(i).getUserGroupPK().getGroup();
			System.out.println(groupUser2.getGus_id() + ", " + groupUser2.getGus_cn());
		}
		blnRespuesta = getUserService().addGroupUser(user5, groupUser5);
		userGroups = getUserService().getAllGroupUser(user5);
		for (int i=0; i < userGroups.size(); i++) {
			GroupUser groupUser2 = userGroups.get(i).getUserGroupPK().getGroup();
			System.out.println(groupUser2.getGus_id() + ", " + groupUser2.getGus_cn());
		}
		blnRespuesta = getUserService().removeGroupUser(user5, groupUser5);
		userGroups = getUserService().getAllGroupUser(user5);
		for (int i=0; i < userGroups.size(); i++) {
			GroupUser groupUser2 = userGroups.get(i).getUserGroupPK().getGroup();
			System.out.println(groupUser2.getGus_id() + ", " + groupUser2.getGus_cn());
		}

		getGroupUserService().deleteGroupUser(groupBD);
		groupBD = getGroupUserService().getGroupUserCn("PRUEBA");
		System.out.println(groupBD.getGus_description());
		blnRespuesta = userLdapDao.authenticate("Administrator", "Dinsa.2014");
		System.out.println(blnRespuesta);
		if (! nombre.equals("")) {
			saludo =  "Hola " + nombre;
		} else {
			saludo = "Hola t";
		}
	}

	public HolaBean getHolaBean() {
		return holaBean;
	}
	
	public void setHolaBean(HolaBean holaBean){
		this.holaBean = holaBean;
	}
	
	public String getSaludo() {
		return saludo;
	}

	public void setSaludo(String saludo) {
		this.saludo = saludo;
	}
	
	public String getNombre() {
		return nombre;
	}
	
	public void setNombre(String nombre) {
		this.nombre = nombre;
	}

	
	
}
