package com.librework.console.dao.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Restrictions;

import com.librework.console.dao.IEventsDao;
import com.librework.console.model.Applications;
import com.librework.console.model.Events;
import com.librework.console.model.Server;
import com.librework.console.model.User;
import com.librework.console.utils.HibernateUtil;

public class EventsDaoImpl implements IEventsDao, Serializable {

	private static final long serialVersionUID = 1L;
	
	private SessionFactory sessionFactory;
	
	public SessionFactory getSessionFactory() {
		return sessionFactory;
	}

	public void setSessionFactory(SessionFactory sessionFactory) {
		this.sessionFactory = sessionFactory;
	}

	@Override
	public List<Events> getAllEvents(int lintpulsa) {
		// TODO Auto-generated method stub
		List<Events> list = new ArrayList<Events>();
		Session session = null;
		Transaction tx = null;
		
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
				.createCriteria(Events.class);
			criteria.setMaxResults(50 * lintpulsa);
			criteria.addOrder(Order.desc("eve_id"));
			List<Events> lista = criteria.list();
			if (!lista.isEmpty()) {
				list = lista;
			}
			tx.commit();
		} catch (Exception e) {
			tx.rollback();
			System.out.println("getAllEvents:" + e.toString());
		} 
		return list;
	}

	@Override
	public List<Events> getUserEvents(User user, int lintpulsa) {
		// TODO Auto-generated method stub
		List<Events> list = new ArrayList<Events>();
		Session session = null;
		Transaction tx = null;
		
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
					.createCriteria(Events.class);
			criteria.setMaxResults(50 * lintpulsa);
			criteria.addOrder(Order.desc("eve_id"));
			if (user != null) {
					criteria.add(Restrictions.eq("eve_adic_data_1", user.getUse_id()));
				
					List<Events> lista = criteria.list();
					if(lista.isEmpty()){
						lista = null;
					}
					list = lista;
			}
			
			tx.commit();
		} catch (Exception e) {
			tx.rollback();
			System.out.println("getAllEvents:" + e.toString());
		} 
		return list;
	}
	

	@Override
	public List<Events> getApplicationEvents(Applications app, int lintpulsa) {
		// TODO Auto-generated method stub
		List<Events> list = new ArrayList<Events>();
		Session session = null;
		Transaction tx = null;
		
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
				.createCriteria(Events.class);
			criteria.setMaxResults(50 * lintpulsa);
			criteria.addOrder(Order.desc("eve_id"));
			if (app != null) {
					criteria.add(Restrictions.eq("eve_adic_data_2", String.valueOf(app.getApp_id())));
				
					List<Events> lista = criteria.list();
					if(!lista.isEmpty()){
						list = lista;
				}
			}
			tx.commit();
		} catch (Exception e) {
			tx.rollback();
			System.out.println("getAllEvents:" + e.toString());
		} 
		return list;
	}

	@Override
	public List<Events> getServerEvents(Server server, int lintpulsa) {
		// TODO Auto-generated method stub
		List<Events> list = new ArrayList<Events>();
		Session session = null;
		Transaction tx = null;
		
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
				.createCriteria(Events.class);
			criteria.setMaxResults(50 * lintpulsa);
			criteria.addOrder(Order.desc("eve_id"));
			if (server != null) {
					criteria.add(Restrictions.eq("eve_adic_data_3", server.getSer_id()));
				
					List<Events> lista = criteria.list();
					if(!lista.isEmpty()){
						list = lista;
				}
			}
			tx.commit();
		} catch (Exception e) {
			tx.rollback();
			System.out.println("getAllEvents:" + e.toString());
		} 
		return list;
	}

}
