package com.librework.console.dao.impl;

import java.io.Serializable;
import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.criterion.Order;

import com.librework.console.dao.INotificationDao;
import com.librework.console.model.Events;
import com.librework.console.model.GroupUserApp;
import com.librework.console.model.Notification;
import com.librework.console.utils.HibernateUtil;

public class NotificationDaoImpl implements INotificationDao, Serializable {

	private static final long serialVersionUID = 1L;
	
	private SessionFactory sessionFactory;
	
	public SessionFactory getSessionFactory() {
		return sessionFactory;
	}

	public void setSessionFactory(SessionFactory sessionFactory) {
		this.sessionFactory = sessionFactory;
	}
	@Override
	public List<Notification> getAllNotification(int lintPulsa) {
		// TODO Auto-generated method stub
		List<Notification> list = null;
		Session session = null;
		Transaction tx = null;
		
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
					.createCriteria(Notification.class);
			criteria.setMaxResults(50 * lintPulsa);
			criteria.addOrder(Order.desc("not_id"));
			list = criteria.list();
			if (list.isEmpty()) {
				list = null;
			}
			tx.commit();
		} catch (Exception e) {
			tx.rollback();
			System.out.println("Notification:" + e.toString());
		} 
		return list;
	}

}
