package com.librework.console.dao.impl;

import java.io.Serializable;
import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.criterion.Restrictions;

import com.librework.console.dao.IServerHDDDao;
import com.librework.console.model.GroupServer;
import com.librework.console.model.Server;
import com.librework.console.model.ServerHDD;
import com.librework.console.utils.HibernateUtil;

public class ServerHDDDaoImpl implements IServerHDDDao, Serializable {

	private static final long serialVersionUID = 1L;
	
	private SessionFactory sessionFactory;
	
	public SessionFactory getSessionFactory() {
		return sessionFactory;
	}

	public void setSessionFactory(SessionFactory sessionFactory) {
		this.sessionFactory = sessionFactory;
	}

	@Override
	public boolean createServerHDD(ServerHDD serverHDD) {
		// TODO Auto-generated method stub
		boolean blnRespuesta = false;
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().openSession();
			tx = session.beginTransaction();
			session.save(serverHDD);
			tx.commit();
			blnRespuesta = true;
		} catch (Exception e) {
			if (session != null) {
				tx.rollback();
			}
			blnRespuesta = false;
			System.out.println("CREATE SERVER - " + e.toString());
		}
		return blnRespuesta;
	}

	@Override
	public List<ServerHDD> getAllServerHDD() {
		// TODO Auto-generated method stub
		Criteria criteria = HibernateUtil.getSessionFactory().getCurrentSession()
				.createCriteria(Server.class);
		List<ServerHDD> lista = criteria.list();
		if (! lista.isEmpty()) {
			return lista;
		}
		return null;
	}

	@Override
	public List<ServerHDD> getServerHDDId(long serverHDDId) {
		// TODO Auto-generated method stub
		Criteria criteria = HibernateUtil.getSessionFactory().getCurrentSession()
				.createCriteria(ServerHDD.class);
		if (serverHDDId != 0) {
			
			criteria.add(Restrictions.eq("shd_id", serverHDDId));
		
			List<ServerHDD> lista = criteria.list();
			if(!lista.isEmpty()){
				
				return lista;
				
			}
		}
		return null;
	}

	@Override
	public List<ServerHDD> getServerHDDServer(String serverHDDServer) {
		// TODO Auto-generated method stub
		Criteria criteria = HibernateUtil.getSessionFactory().getCurrentSession()
				.createCriteria(ServerHDD.class);
		if (serverHDDServer != null) {
			if (!serverHDDServer.equals("")) {
				criteria.add(Restrictions.eq("shd_ser_id", serverHDDServer));
				List<ServerHDD> lista = criteria.list();
				if (! lista.isEmpty()) {
					return lista;
				}
			}
		}
		return null;
	}

	@Override
	public List<ServerHDD> getServerHDDDescription(String serverDescription) {
		// TODO Auto-generated method stub
		Criteria criteria = HibernateUtil.getSessionFactory().getCurrentSession()
				.createCriteria(ServerHDD.class);
		if (serverDescription != null) {
			if (!serverDescription.equals("")) {
				criteria.add(Restrictions.like("shd_ser_id", serverDescription + "%"));
				List<ServerHDD> lista = criteria.list();
				if (! lista.isEmpty()) {
					return lista;
				}
			}
		}
		return null;
	}

	@Override
	public boolean updateServerHDD(ServerHDD serverHDD) {
		// TODO Auto-generated method stub
		boolean blnRespuesta = false;
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().openSession();
			tx = session.beginTransaction();
			session.update(serverHDD);
			tx.commit();
			blnRespuesta = true;
		} catch (Exception e) {
			if (session != null) {
				tx.rollback();
			}
			blnRespuesta = false;
			System.out.println("UPDATE SERVER - " + e.toString());
		}
		return blnRespuesta;
	}

	@Override
	public boolean deleteServerHDD(ServerHDD serverHDD) {
		// TODO Auto-generated method stub
		boolean blnRespuesta = false;
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().openSession();
			tx = session.beginTransaction();
			session.delete(serverHDD);
			tx.commit();
			blnRespuesta = true;
		} catch (Exception e) {
			if (session != null) {
				tx.rollback();
			}
			blnRespuesta = false;
			System.out.println("UPDATE SERVER - " + e.toString());
		}
		return blnRespuesta;
	}

	@Override
	public Server getServer(ServerHDD serverHDD) {
		// TODO Auto-generated method stub
		return null;
	}
}
