package com.librework.console.dao.impl;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import java.util.concurrent.TimeUnit;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;

import com.librework.console.dao.IServerHistDao;
import com.librework.console.model.Server;
import com.librework.console.model.ServerHist;
import com.librework.console.utils.HibernateUtil;

public class ServerHistDaoImpl implements IServerHistDao, Serializable {

	private static final long serialVersionUID = 1L;
	
	private SessionFactory sessionFactory;
	
	public SessionFactory getSessionFactory() {
		return sessionFactory;
	}

	public void setSessionFactory(SessionFactory sessionFactory) {
		this.sessionFactory = sessionFactory;
	}

	@Override
	public List<ServerHist> getServerHistToday(Server server) {
		// TODO Auto-generated method stub
		Date dteNow = new Date(TimeUnit.DAYS.toMillis(1));
		Date dteFilter = new Date(dteNow.getTime() - TimeUnit.DAYS.toMillis(1));
		Criteria criteria = HibernateUtil.getSessionFactory().getCurrentSession()
				.createCriteria(ServerHist.class);
		criteria.add(Restrictions.lt("seh_ser_datmod", dteFilter));
		List<ServerHist> lista = criteria.list();
		if (! lista.isEmpty()) {
			return lista;
		}
		return null;
	}

	@Override
	public List<ServerHist> getServerHistWeek(Server server) {
		// TODO Auto-generated method stub
		Date dteNow = new Date();
		Date dteFilter = new Date(dteNow.getTime() - TimeUnit.DAYS.toMillis(7));
		
		Criteria criteria = HibernateUtil.getSessionFactory().getCurrentSession()
				.createCriteria(ServerHist.class);
		criteria.add(Restrictions.lt("seh_ser_datmod", dteFilter));
		List<ServerHist> lista = criteria.list();
		if (! lista.isEmpty()) {
			return lista;
		}
		return null;
	}

	@Override
	public List<ServerHist> getServerHistMonth(Server server) {
		// TODO Auto-generated method stub
		Date dteNow = new Date(TimeUnit.DAYS.toMillis(30));
		Date dteFilter = new Date(dteNow.getTime() - TimeUnit.DAYS.toMillis(1));
		Criteria criteria = HibernateUtil.getSessionFactory().getCurrentSession()
				.createCriteria(ServerHist.class);
		criteria.add(Restrictions.lt("seh_ser_datmod", dteFilter));
		List<ServerHist> lista = criteria.list();
		if (! lista.isEmpty()) {
			return lista;
		}
		return null;
	}

	@Override
	public List<ServerHist> getServerHistAll(Server server) {
		// TODO Auto-generated method stub
		Criteria criteria = HibernateUtil.getSessionFactory().getCurrentSession()
				.createCriteria(ServerHist.class);
		List<ServerHist> lista = criteria.list();
		if (! lista.isEmpty()) {
			return lista;
		}
		return null;
	}
}
