package com.librework.console.dao.impl;

import java.io.Serializable;
import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.criterion.Restrictions;

import com.librework.console.dao.ISystemOperatingDao;
import com.librework.console.model.Applications;
import com.librework.console.model.Server;
import com.librework.console.model.ServerHDD;
import com.librework.console.model.SystemOperating;
import com.librework.console.model.User;
import com.librework.console.model.UserGroup;
import com.librework.console.utils.HibernateUtil;

public class SystemOperatingDaoImpl implements ISystemOperatingDao, Serializable {

	private static final long serialVersionUID = 1L;
	
	private SessionFactory sessionFactory;
	
	public SessionFactory getSessionFactory() {
		return sessionFactory;
	}

	public void setSessionFactory(SessionFactory sessionFactory) {
		this.sessionFactory = sessionFactory;
	}

	@Override
	public boolean createSystemOperating(SystemOperating systemOperating) {
		// TODO Auto-generated method stub
		boolean blnRespuesta = false;
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().openSession();
			tx = session.beginTransaction();
			session.save(systemOperating);
			tx.commit();
			blnRespuesta = true;
		} catch (Exception e) {
			if (session != null) {
				tx.rollback();
			}
			blnRespuesta = false;
			System.out.println("CREATE SERVER - " + e.toString());
		} 
		return blnRespuesta;
	}

	@Override
	public List<SystemOperating> getAllSystemOperating() {
		// TODO Auto-generated method stub
		List<SystemOperating> list = null;
		Session session = null;
		Transaction tx = null;
		
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
				.createCriteria(SystemOperating.class);
			List<SystemOperating> lista = criteria.list();
			if (! lista.isEmpty()) {
				list = lista;
			}
			tx.commit();
		} catch (Exception e) {
			tx.rollback();
			System.out.println("SystemOperating:" + e.toString());
		} 
		return list;
	}

	@Override
	public SystemOperating getSystemOperatingId(long systemOperatingId) {
		// TODO Auto-generated method stub
		SystemOperating syo = null;
		Session session = null;
		Transaction tx = null;
		
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
				.createCriteria(SystemOperating.class);
		if (systemOperatingId != 0) {
			
			criteria.add(Restrictions.eq("syo_id", systemOperatingId));
		
			List<SystemOperating> lista = criteria.list();
			if(!lista.isEmpty()){
				
				syo = lista.get(0);
				
			}
		}
		tx.commit();
		} catch (Exception e) {
			tx.rollback();
			System.out.println("SystemOperating:" + e.toString());
		} 
		return syo;
	}

	@Override
	public List<SystemOperating> getSystemOperatingDescription(
			String systemOperatingDescription) {
		// TODO Auto-generated method stub
		List<SystemOperating> list = null;
		Session session = null;
		Transaction tx = null;
		
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
				.createCriteria(SystemOperating.class);
			if (systemOperatingDescription != null) {
				if (!systemOperatingDescription.equals("")) {
					criteria.add(Restrictions.like("syo_description", systemOperatingDescription + "%"));
					List<SystemOperating> lista = criteria.list();
					if (! lista.isEmpty()) {
						list = lista;
					}
				}
			}
			tx.commit();
		} catch (Exception e) {
			tx.rollback();
			System.out.println("SystemOperating:" + e.toString());
		} 
		return list;
	}

	@Override
	public boolean updateSystemOperating(SystemOperating systemOperating) {
		// TODO Auto-generated method stub
		boolean blnRespuesta = false;
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().openSession();
			tx = session.beginTransaction();
			session.update(systemOperating);
			tx.commit();
			blnRespuesta = true;
		} catch (Exception e) {
			if (session != null) {
				tx.rollback();
			}
			blnRespuesta = false;
			System.out.println("UPDATE SERVER - " + e.toString());
		}
		return blnRespuesta;
	}

	@Override
	public boolean deleteSystemOperating(SystemOperating systemOperating) {
		// TODO Auto-generated method stub
		boolean blnRespuesta = false;
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().openSession();
			tx = session.beginTransaction();
			session.delete(systemOperating);
			tx.commit();
			blnRespuesta = true;
		} catch (Exception e) {
			if (session != null) {
				tx.rollback();
			}
			blnRespuesta = false;
			System.out.println("UPDATE SERVER - " + e.toString());
		}
		return blnRespuesta;
	}

	@Override
	public List<Server> getAllServer(SystemOperating systemOperating) {
		// TODO Auto-generated method stub
		List<Server> list = null;
		Session session = null;
		Transaction tx = null;
		
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
				.createCriteria(SystemOperating.class);
			if (systemOperating.getSyo_id() != 0) {
				
					criteria.add(Restrictions.eq("syo_id", systemOperating.getSyo_id()));
				
					List<SystemOperating> listaSystem = criteria.list();
					if(!listaSystem.isEmpty()){
						List<Server> lista = listaSystem.get(0).getServers();
						list = lista;
					}
				
			}
			tx.commit();
		} catch (Exception e) {
			tx.rollback();
			System.out.println("SystemOperating:" + e.toString());
		} 
		return list;
	}

	@Override
	public List<Applications> getAllApplications(SystemOperating systemOperating) {
		// TODO Auto-generated method stub
		List<Applications> list = null;
		Session session = null;
		Transaction tx = null;
		
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
				.createCriteria(SystemOperating.class);
			if (systemOperating.getSyo_id() != 0) {
				
					criteria.add(Restrictions.eq("syo_id", systemOperating.getSyo_id()));
				
					List<SystemOperating> listaSystem = criteria.list();
					if(!listaSystem.isEmpty()){
						List<Applications> lista = listaSystem.get(0).getApplications();
						list = lista;
					}
				
			}
			tx.commit();
		} catch (Exception e) {
			tx.rollback();
			System.out.println("SystemOperating:" + e.toString());
		} 
		return list;
	}

}
