package com.librework.console.dao.impl;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import java.util.concurrent.TimeUnit;

import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;

import com.librework.console.dao.IUserAppHistDao;
import com.librework.console.model.Applications;
import com.librework.console.model.Server;
import com.librework.console.model.ServerHist;
import com.librework.console.model.User;
import com.librework.console.model.UserAppHist;
import com.librework.console.utils.HibernateUtil;

public class UserAppHistDaoImpl implements IUserAppHistDao, Serializable {

	private static final long serialVersionUID = 1L;
	
	private SessionFactory sessionFactory;
	
	public SessionFactory getSessionFactory() {
		return sessionFactory;
	}

	public void setSessionFactory(SessionFactory sessionFactory) {
		this.sessionFactory = sessionFactory;
	}

	@Override
	public List<UserAppHist> getUserAppHistToday(User user, Applications app,
			Server server) {
		// TODO Auto-generated method stub
		Date dteNow = new Date(TimeUnit.DAYS.toMillis(1));
		Date dteFilter = new Date(dteNow.getTime() - TimeUnit.DAYS.toMillis(1));
		Criteria criteria = HibernateUtil.getSessionFactory().getCurrentSession()
				.createCriteria(UserAppHist.class);
		criteria.add(Restrictions.lt("uah_uap_datmod", dteFilter));
		List<UserAppHist> lista = criteria.list();
		if (! lista.isEmpty()) {
			return lista;
		}
		return null;
	}

	@Override
	public List<UserAppHist> getUserAppHistWeek(User user, Applications app,
			Server server) {
		// TODO Auto-generated method stub
		Date dteNow = new Date(TimeUnit.DAYS.toMillis(7));
		Date dteFilter = new Date(dteNow.getTime() - TimeUnit.DAYS.toMillis(1));
		Criteria criteria = HibernateUtil.getSessionFactory().getCurrentSession()
				.createCriteria(UserAppHist.class);
		criteria.add(Restrictions.lt("uah_uap_datmod", dteFilter));
		List<UserAppHist> lista = criteria.list();
		if (! lista.isEmpty()) {
			return lista;
		}
		return null;
	}

	@Override
	public List<UserAppHist> getUserAppHistMonth(User user, Applications app,
			Server server) {
		// TODO Auto-generated method stub
		Date dteNow = new Date(TimeUnit.DAYS.toMillis(30));
		Date dteFilter = new Date(dteNow.getTime() - TimeUnit.DAYS.toMillis(1));
		Criteria criteria = HibernateUtil.getSessionFactory().getCurrentSession()
				.createCriteria(UserAppHist.class);
		criteria.add(Restrictions.lt("uah_uap_datmod", dteFilter));
		List<UserAppHist> lista = criteria.list();
		if (! lista.isEmpty()) {
			return lista;
		}
		return null;
	}

	@Override
	public List<UserAppHist> getUserAppHistAll(User user, Applications app,
			Server server) {
		// TODO Auto-generated method stub
		Criteria criteria = HibernateUtil.getSessionFactory().getCurrentSession()
				.createCriteria(UserAppHist.class);
		List<UserAppHist> lista = criteria.list();
		if (! lista.isEmpty()) {
			return lista;
		}
		return null;
	}
	
	
}
