package com.librework.console.dao.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.hibernate.Criteria;
import org.hibernate.FetchMode;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.criterion.CriteriaSpecification;
import org.hibernate.criterion.Restrictions;
import com.librework.console.dao.IUserDao;
import com.librework.console.model.Applications;
import com.librework.console.model.GroupUser;
import com.librework.console.model.Site;
import com.librework.console.model.User;
import com.librework.console.model.UserApp;
import com.librework.console.model.UserAppPK;
import com.librework.console.model.UserGroup;
import com.librework.console.model.UserGroupPK;
import com.librework.console.model.UserSite;
import com.librework.console.model.UserSitePK;
import com.librework.console.utils.HibernateUtil;

public class UserDaoImpl implements IUserDao, Serializable {

	private static final long serialVersionUID = 1L;
	
	private SessionFactory sessionFactory;
	
	public SessionFactory getSessionFactory() {
		return sessionFactory;
	}

	public void setSessionFactory(SessionFactory sessionFactory) {
		this.sessionFactory = sessionFactory;
	}


	@Override
	public boolean createUser(User user) {
		boolean blnRespuesta = false;
		Session session = null;
		Transaction tx = null;
		try {
			
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			session.save(user);
			tx.commit();
			blnRespuesta = true;
		} catch (Exception e) {
			tx.rollback();
			blnRespuesta = false;
		}
		return blnRespuesta;
	}

	@Override
	public User getUserId(String userId) {
		User user = null;
		Session session = null;
		Transaction tx = null;
		
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
					.createCriteria(User.class);
			if (userId != null) {
				if (! userId.equals("")) {
					criteria.add(Restrictions.eq("use_id", userId));
				
					List<User> lista = criteria.list();
					if(!lista.isEmpty()){
						user = lista.get(0);
					}
				}
			}
			tx.commit();
		} catch (Exception e) {
			tx.rollback();
			System.out.println("GETUSERBYID:" + e.toString());
		} 
		return user;
	}
	
	@Override
	public List<User> getUserName(String userName) {
		// TODO Auto-generated method stub
		List<User> list = new ArrayList<User>();
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
					.createCriteria(User.class);
			if (userName != null) {
				if (! userName.equals("")) {
					criteria.add(Restrictions.like("use_id", userName + "%"));
				
					List<User> lista = criteria.list();
					if(!lista.isEmpty()){
						list = lista;
					}
				}
			}
			tx.commit();
			return list;
		} catch (Exception e) {
			System.out.println("GETUSERNAME:" + e.toString());
			tx.rollback();
		}
		
		return null;
	}

	@Override
	public List<User> getUserSurname1(String userSurname1) {
		// TODO Auto-generated method stub
		List<User> list = new ArrayList<User>();
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
					.createCriteria(User.class);
			if (userSurname1 != null) {
				if (! userSurname1.equals("")) {
					criteria.add(Restrictions.like("use_id", userSurname1 + "%"));
				
					List<User> lista = criteria.list();
					if(!lista.isEmpty()){
						list = lista;
					}
				}
			}
			tx.commit();
			return list;
		} catch (Exception e) {
			tx.rollback();
			System.out.println("GETUSERSURNAME1:" + e.toString());
			
		}
		return null;
		
	}

	@Override
	public List<User> getUserEmail(String userEmail) {
		// TODO Auto-generated method stub
		List<User> list = new ArrayList<User>();
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
				.createCriteria(User.class);
			if (userEmail != null) {
				if (! userEmail.equals("")) {
					criteria.add(Restrictions.like("use_id", userEmail + "%"));
				
					List<User> lista = criteria.list();
					if(!lista.isEmpty()){
						list = lista;
					}
				}
			}
			tx.commit();
			return list;
		} catch (Exception e) {
			tx.rollback();
			System.out.println("getUserEmail:" + e.toString());
			
		}
		return null;
	}

	@Override
	public List<User> getAllUser() {
		// TODO Auto-generated method stub
		List<User> list = new ArrayList<User>();
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
				.createCriteria(User.class);
			List<User> lista = criteria.list();
			if (!lista.isEmpty()) {
				list = lista;
			}
			tx.commit();
			return list;
		} catch (Exception e) {
			tx.rollback();
			System.out.println("getAllUser:" + e.toString());
			
		}
		return null;
	}
	
	@Override
	public List<User> getActiveUser() {
		// TODO Auto-generated method stub
		List<User> list = null;
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
					.createCriteria(User.class);
			criteria.add(Restrictions.isNull("use_end_last_connection"));
			List<User> lista = criteria.list();
			if (!lista.isEmpty()) {
				list = lista;
			}
			tx.commit();
			return list;
		} catch (Exception e) {
			tx.rollback();
			System.out.println("getActiveUser:" + e.toString());
			
		}
		return null;
	}

	@Override
	public List<User> getDeactivateUser() {
		// TODO Auto-generated method stub
		List<User> list = null;
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
				.createCriteria(User.class);
			criteria.add(Restrictions.isNotNull("use_end_last_connection"));
			List<User> lista = criteria.list();
			if (!lista.isEmpty()) {
				list = lista;
			}
			tx.commit();
			return list;
		} catch (Exception e) {
			tx.rollback();
			System.out.println("getDeactivateUser:" + e.toString());
			
		}
		return null;
	}

	@Override
	public boolean updateUser(User user) {
		// TODO Auto-generated method stub
		boolean blnRespuesta = false;
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			session.update(user);
			tx.commit();
			blnRespuesta = true;
		} catch (Exception e) {
			tx.rollback();
			blnRespuesta = false;
		}
		
		return blnRespuesta;
		
	}

	@Override
	public boolean deleteUser(User user) {
		// TODO Auto-generated method stub
		boolean blnRespuesta = false;
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			session.delete(user);
			tx.commit();
			blnRespuesta = true;
		} catch (Exception e) {
			tx.rollback();
			blnRespuesta = false;
		}
		
		return blnRespuesta;
	}

	@Override
	public boolean authenticateUser(String userId, String password) {
		// TODO Auto-generated method stub
		boolean blnRespuesta = false;
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
				.createCriteria(User.class);
			if (userId != null) {
				if (! userId.equals("")) {
					criteria.add(Restrictions.eq("use_id", userId));
				
					List<User> lista = criteria.list();
					if(lista.isEmpty()){
						blnRespuesta = false;
					}
					else {
						User user = lista.get(0);
						String bdPassword = "";
						bdPassword = user.getUse_password();
						if (password.equals(bdPassword)) {
							blnRespuesta = true;
						}
						else {
							blnRespuesta = false;
						}
					}
				}
			}
			tx.commit();
		} catch (Exception e) {
			tx.rollback();
			blnRespuesta = false;
		}
		
		return blnRespuesta;
	}

	@Override
	public List<UserGroup> getAllGroupUser(User user) {
		// TODO Auto-generated method stub
		List<UserGroup> lista = null;
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
					.createCriteria(User.class);
			if (user.getUse_id() != null) {
				if (! user.getUse_id().equals("")) {
					criteria.add(Restrictions.eq("use_id", user.getUse_id()));
					List<User> listaUser = criteria.list();
					if(!listaUser.isEmpty()){
						 lista = listaUser.get(0).getUserGroups();
					}
				}
			}
			tx.commit();
		} catch (Exception e) {
			tx.rollback();
			System.out.println("GetAllUserGroup");
		}
		return lista;
		
	}

	@Override
	public boolean addGroupUser(User user, GroupUser groupUser) {
		// TODO Auto-generated method stub
		boolean blnRespuesta = false;
		Session session=null;  
        Transaction tx=null;
		try {
			UserGroupPK userGroupPK = new UserGroupPK(user, groupUser);
		    UserGroup userGroup = new UserGroup();
		    userGroup.setUserGroupPK(userGroupPK);
		    userGroup.setFk_ugr_gus_id(groupUser.getGus_id());
		    userGroup.setFk_ugr_use_id(user.getUse_id());
		    userGroup.setUgr_datmod(new Date());
		    userGroup.setUgr_usemod(user.getUse_id());
		    user.getUserGroups().add(userGroup);
		    session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			session.save(userGroup);
			tx.commit();
			blnRespuesta = true;
		} catch (Exception e) {
			if (session != null) {
				tx.rollback();
			}
			blnRespuesta = false;
			System.out.println(e.toString());
		}
		
		return blnRespuesta;
	}

	@Override
	public boolean removeGroupUser(User user, GroupUser groupUser) {
		// TODO Auto-generated method stub
		boolean blnRespuesta = false;
		Session session=null;  
        Transaction tx=null;
		try {
			UserGroup userGroup = new UserGroup();
			UserGroupPK userGroupPK = new UserGroupPK(user, groupUser);
			userGroup.setUserGroupPK(userGroupPK);
			userGroup.setFk_ugr_gus_id(groupUser.getGus_id());
			userGroup.setFk_ugr_use_id(user.getUse_id());
			userGroup.setUgr_datmod(new Date());
			userGroup.setUgr_usemod(user.getUse_id());
			
			user.getUserGroups().remove(userGroup);
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			session.delete(userGroup);
			tx.commit();
			blnRespuesta = true;
		} catch (Exception e) {
			if (session != null) {
				tx.rollback();
			}
			blnRespuesta = false;
			System.out.println(e.toString());
		} 
		
		return blnRespuesta;
	}

	@Override
	public GroupUser getGroupUser(User user, GroupUser groupUser) {
		// TODO Auto-generated method stub
		GroupUser groupUserSalida = null;
		GroupUser returnUserSalida = null;
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
				.createCriteria(User.class);
		if (user.getUse_id() != null) {
			if (! user.getUse_id().equals("")) {
				criteria.add(Restrictions.eq("use_id", user.getUse_id()));
			
				List<User> listaUser = criteria.list();
				if(!listaUser.isEmpty()){
					List<UserGroup> lista = listaUser.get(0).getUserGroups();
					for (int i=0; i<lista.size(); i++) {
						groupUserSalida = lista.get(i).getUserGroupPK().getGroup();
						if (groupUser.getGus_id() == groupUserSalida.getGus_id()) {
							returnUserSalida = groupUserSalida;
						}
					}
				}
			}
		}
		tx.commit();
		} catch (Exception e) {
			tx.rollback();
			System.out.println("getGroupUser");
		}
		
		return returnUserSalida;
	}

	
	@Override
	public List<UserApp> getAllUserApp(User user) {
		// TODO Auto-generated method stub
		List<UserApp> list = null;
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
				.createCriteria(User.class);
			if (user.getUse_id() != null) {
				if (! user.getUse_id().equals("")) {
					criteria.add(Restrictions.eq("use_id", user.getUse_id()));
				
					List<User> listaUser = criteria.list();
					if(!listaUser.isEmpty()){
						List<UserApp> lista = listaUser.get(0).getUserApps();
						list = lista;
					}
				}
			}
			tx.commit();
		} catch (Exception e) {
			tx.rollback();
			System.out.println("getAllUserApp");
		}
		return list;
		
	}


	@Override
	public List<UserApp> getUserAppActive(User user) {
		List<UserApp> lstSalida = new ArrayList<UserApp>();
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
				.createCriteria(User.class);
			if (user.getUse_id() != null) {
				if (! user.getUse_id().equals("")) {
					criteria.add(Restrictions.eq("use_id", user.getUse_id()));
					
					List<User> listaUser = criteria.list();
					if (! listaUser.isEmpty()) {
						List<UserApp> lista = listaUser.get(0).getUserApps();
						if (! lista.isEmpty()) {
							for (int i = 0; i < lista.size(); i++) {
								if (lista.get(i).getUap_end_date_process() == null) {
									lstSalida.add(lista.get(i));
								}
							}
						}
					}
				}
			}
			tx.commit();
		} catch (Exception e) {
			tx.rollback();
			System.out.println("getUserAppActive");
		}
		return lstSalida;
		
	}
	
	
	@Override
	public boolean addUserApp(User user, Applications applications) {
		// TODO Auto-generated method stub
		boolean blnRespuesta = false;
		Session session=null;  
        Transaction tx=null;
		try {
			UserAppPK userAppPK = new UserAppPK(user, applications);
		    UserApp userApp = new UserApp();
		    userApp.setUserAppPK(userAppPK);
		    userApp.setFk_uap_app_id(applications.getApp_id());
		    userApp.setFk_uap_use_id(user.getUse_id());
		    userApp.setUap_start_date_process(new Date());
		    userApp.setUap_end_date_process(new Date());
		    userApp.setUap_datmod(new Date());
		    userApp.setUap_usemod(user.getUse_id());
		    user.getUserApps().add(userApp);
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			session.save(userApp);
			tx.commit();
			blnRespuesta = true;
		} catch (Exception e) {
			if (session != null) {
				tx.rollback();
			}
			blnRespuesta = false;
			System.out.println(e.toString());
		} 
		
		return blnRespuesta;
	}

	@Override
	public boolean removeUserApp(User user, Applications applications) {
		// TODO Auto-generated method stub
		boolean blnRespuesta = false;
		Session session=null;  
        Transaction tx=null;
		try {
			UserAppPK userAppPK = new UserAppPK(user, applications);
		    UserApp userApp = new UserApp();
		    userApp.setUserAppPK(userAppPK);
		    userApp.setFk_uap_app_id(applications.getApp_id());
		    userApp.setFk_uap_use_id(user.getUse_id());
		    userApp.setUap_datmod(new Date());
		    userApp.setUap_usemod(user.getUse_id());
		    user.getUserApps().remove(userApp);
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			session.delete(userApp);
			tx.commit();
			blnRespuesta = true;
		} catch (Exception e) {
			if (session != null) {
				tx.rollback();
			}
			blnRespuesta = false;
			System.out.println(e.toString());
		} 
		
		return blnRespuesta;
	}

	@Override
	public Applications getApplications(User user, Applications applications) {
		// TODO Auto-generated method stub
		Applications applicationsSalida = null;
		Applications returnSalida = null;
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
				.createCriteria(User.class);
			if (user.getUse_id() != null) {
				if (! user.getUse_id().equals("")) {
					criteria.add(Restrictions.eq("use_id", user.getUse_id()));
				
					List<User> listaUser = criteria.list();
					if(!listaUser.isEmpty()){
						List<UserApp> lista = listaUser.get(0).getUserApps();
						for (int i=0; i<lista.size(); i++) {
							applicationsSalida = lista.get(i).getUserAppPK().getApplications();
							if (applications.getApp_id() == applicationsSalida.getApp_id()) {
								returnSalida = applicationsSalida;
							}
						}
					}
				}
			}
			tx.commit();
		} catch (Exception e) {
			tx.rollback();
			System.out.println("getApplications" + e.toString());
		}
		return returnSalida;
	}

	@Override
	public List<UserSite> getAllUserSite(User user) {
		// TODO Auto-generated method stub
		List<UserSite> list = null;
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
				.createCriteria(User.class);
			if (user.getUse_id() != null) {
				if (! user.getUse_id().equals("")) {
					criteria.add(Restrictions.eq("use_id", user.getUse_id()));
				
					List<User> listaUser = criteria.list();
					if(!listaUser.isEmpty()){
						List<UserSite> lista = listaUser.get(0).getUserSites();
						list = lista;
					}
				}
			}
			tx.commit();
		} catch (Exception e) {
			tx.rollback();
			System.out.println("getAllUserSite" + e.toString());
		}
		return list;
	}

	@Override
	public boolean addUserSite(User user, Site site) {
		// TODO Auto-generated method stub
		boolean blnRespuesta = false;
		Session session=null;  
        Transaction tx=null;
		try {
			UserSitePK userSitePK = new UserSitePK(user, site);
		    UserSite userSite = new UserSite();
		    userSite.setUserSitePK(userSitePK);
		    userSite.setFk_usi_sit_id(site.getSit_id());
		    userSite.setFk_usi_use_id(user.getUse_id());
		    userSite.setUsi_datmod(new Date());
		    userSite.setUsi_usemod(user.getUse_id());
		    user.getUserSites().add(userSite);
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			session.save(userSite);
			tx.commit();
			blnRespuesta = true;
		} catch (Exception e) {
			if (session != null) {
				tx.rollback();
			}
			blnRespuesta = false;
			System.out.println(e.toString());
		} 
		return blnRespuesta;
	}

	@Override
	public boolean removeUserSite(User user, Site site) {
		// TODO Auto-generated method stub
		boolean blnRespuesta = false;
		Session session=null;  
        Transaction tx=null;
		try {
			UserSitePK userSitePK = new UserSitePK(user, site);
		    UserSite userSite = new UserSite();
		    userSite.setUserSitePK(userSitePK);
		    userSite.setFk_usi_sit_id(site.getSit_id());
		    userSite.setFk_usi_use_id(user.getUse_id());
		    userSite.setUsi_datmod(new Date());
		    userSite.setUsi_usemod(user.getUse_id());
		    user.getUserSites().remove(userSite);
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			session.delete(userSite);
			tx.commit();
			blnRespuesta = true;
		} catch (Exception e) {
			if (session != null) {
				tx.rollback();
			}
			blnRespuesta = false;
			System.out.println(e.toString());
		}
		return blnRespuesta;
	}

	@Override
	public Site getSite(User user, Site site) {
		// TODO Auto-generated method stub
		Site siteSalida = null;
		Site returnSalida = null;
		Session session = null;
		Transaction tx = null;
		try {
			session = HibernateUtil.getSessionFactory().getCurrentSession();
			tx = session.beginTransaction();
			Criteria criteria = session
				.createCriteria(User.class);
			if (user.getUse_id() != null) {
				if (! user.getUse_id().equals("")) {
					criteria.add(Restrictions.eq("use_id", user.getUse_id()));
				
					List<User> listaUser = criteria.list();
					if(!listaUser.isEmpty()){
						List<UserSite> lista = listaUser.get(0).getUserSites();
						for (int i=0; i<lista.size(); i++) {
							siteSalida = lista.get(i).getUserSitePK().getSite();
							if (site.getSit_id() == siteSalida.getSit_id()) {
								returnSalida = siteSalida;
							}
						}
					}
				}
			}
			tx.commit();
		} catch (Exception e) {
			tx.rollback();
			System.out.println("getSite" + e.toString());
		}
		return returnSalida;
	}

	
	
}
