package com.librework.console.general;



import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletContextEvent;
import javax.servlet.ServletContextListener;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;


import com.librework.console.utils.HibernateUtil;


public class HibernateFilter implements Filter {

	static
    {
        try
        {
            //Aqui creamos una session de la fabrica de session usando
            //el archivo de configuracion hibernate.cfg.xml
        	HibernateUtil.buildSessionFactory();
        }
        catch (Throwable ex)
        {
            
            System.err.println("Initial SessionFactory creation failed." + ex);
            throw new ExceptionInInitializerError(ex);
        }
    }
	 //Aqui en donde deberia crear una session de la fabrica de sessiones por que es el metodo init y este metodo se hizo para
	   //inicializar valores o solicitar recursos, pero eso ya lo hice arriba.
	    public void init(FilterConfig filterConfig) throws ServletException
	    {         
	    }
	    //Este metodo se debe declarar por que viene especificado en la interfaz y es donde se deberia asignar una session
	    //a un thread local, pero eso ya viene especificado en el archivo de configuracion hibernate.cfg.xml
	    //<property name="hibernate.current_session_context_class">thread</property>
	    public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException
	    {
	    	try {
				HibernateUtil.openSessionAndBindToThread();
				//System.out.println("OPEN SESSION");
				chain.doFilter(request, response);
			} finally {
				HibernateUtil.closeSessionAndUnbindFromThread();
				//System.out.println("CLOSE SESSION");
			}
	    	
	    }
	    //Para obtener una session
	   
	    //El metodo destroy se manda a llamar automaticamente al terminar el request, de esta manera
	   //aseguramos no dejar la session abierta
	    public void destroy()
	    {
	        
	        	HibernateUtil.closeSessionFactory();
				//System.out.println("CLOSE SESSION");
	       
	    }

	

	
	
	

}
