package com.librework.console.general;

import java.io.IOException;
import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.librework.console.managed.impl.LogonManagedImpl;

/**
 * Servlet Filter implementation class LogonFilter
 */

public class LogonFilter implements Filter {

    /**
     * Default constructor. 
     */
    public LogonFilter() {
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see Filter#destroy()
	 */
	public void destroy() {
		// TODO Auto-generated method stub
	}

	/**
	 * @see Filter#doFilter(ServletRequest, ServletResponse, FilterChain)
	 */
	public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) throws IOException, ServletException {
		// TODO Auto-generated method stub
		// place your code here
		HttpServletRequest req = (HttpServletRequest) request;
		  HttpServletResponse res = (HttpServletResponse) response;
		   
		  LogonManagedImpl logonBean = (LogonManagedImpl) req.getSession().getAttribute("logon");
		  
		  
		  String urlStr = req.getRequestURL().toString().toLowerCase();
		  boolean notSecured = notSecure(urlStr);
		  //System.out.println(urlStr + " - notSecure=[" + notSecured + "]");
		  
		  
		  if (notSecure(urlStr)) {
		    chain.doFilter(request, response);
		    return;
		  }
		  
		  
		  if (logonBean == null || !logonBean.isLoggedIn()) {
		    res.sendRedirect(req.getContextPath() + "/logon.jsf");
		    return;
		  }
		 
		 
		// pass the request along the filter chain
		chain.doFilter(request, response);
	}

	/**
	 * @see Filter#init(FilterConfig)
	 */
	public void init(FilterConfig fConfig) throws ServletException {
		// TODO Auto-generated method stub
	}

	private boolean notSecure(String urlStr) {

		
		  if (urlStr.endsWith("logon.jsf") || urlStr.endsWith("css/librework.css") || urlStr.endsWith(".png"))
		    return true;
		  if (urlStr.indexOf("/javax.faces.resource/") != -1)
		    return true;
		  return false;
		}
}
