package com.librework.console.managed.impl;

import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.ViewScoped;
import javax.faces.context.FacesContext;
import javax.servlet.http.HttpSession;

import org.primefaces.context.RequestContext;
import org.primefaces.event.DragDropEvent;
import org.primefaces.event.FileUploadEvent;
import org.primefaces.model.UploadedFile;
import org.springframework.beans.factory.BeanFactory;
import org.springframework.beans.factory.xml.XmlBeanFactory;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.Resource;

import com.librework.console.daoLDAP.IAppGroupLDAPDao;
import com.librework.console.daoLDAP.IAppServerLDAPDao;
import com.librework.console.daoLDAP.IApplicationLDAPDao;
import com.librework.console.daoLDAP.IServerGroupLDAPDao;
import com.librework.console.daoLDAP.IUserAppLDAPDao;
import com.librework.console.daoLDAP.IUserLDAPDao;
import com.librework.console.general.Constant;
import com.librework.console.managed.IAppManaged;
import com.librework.console.model.AppGroup;
import com.librework.console.model.AppServer;
import com.librework.console.model.Applications;
import com.librework.console.model.Events;
import com.librework.console.model.GroupApp;
import com.librework.console.model.GroupServer;
import com.librework.console.model.Server;
import com.librework.console.model.SystemOperating;
import com.librework.console.model.User;
import com.librework.console.model.UserApp;
import com.librework.console.modelLDAP.AppGroupLDAP;
import com.librework.console.modelLDAP.AppServerLDAP;
import com.librework.console.modelLDAP.ApplicationLDAP;
import com.librework.console.modelLDAP.ServerGroupLDAP;
import com.librework.console.modelLDAP.UserAppLDAP;
import com.librework.console.modelLDAP.UserLDAP;
import com.librework.console.modelWEB.AppWEB;
import com.librework.console.modelWEB.EventsWEB;
import com.librework.console.modelWEB.ServerWEB;
import com.librework.console.modelWEB.UserAppWEB;
import com.librework.console.service.IApplicationsService;
import com.librework.console.service.IEventsService;
import com.librework.console.service.IGroupAppService;
import com.librework.console.service.IServerService;
import com.librework.console.service.ISystemOperatingService;
import com.librework.console.service.IUserService;
import com.librework.console.utils.FacesUtils;
import com.librework.console.utils.LanguageUtils;
import com.librework.console.utils.PropertiesUtils;

@ManagedBean(name="appBean")
@ViewScoped
public class AppManagedImpl implements IAppManaged, Serializable {

	private static final long serialVersionUID = 1L;

	@ManagedProperty(value="#{logon}")
	private LogonManagedImpl logon;
	
	@ManagedProperty(value="#{ApplicationsService}")
	private IApplicationsService appService;
	
	@ManagedProperty(value="#{GroupAppService}")
	private IGroupAppService groupAppService;
	
	@ManagedProperty(value="#{EventsService}")
	private IEventsService eventsService;
	
	@ManagedProperty(value="#{UserService}")
	private IUserService userService;
	
	@ManagedProperty(value="#{ServerService}")
	private IServerService serverService;
	
	
	@ManagedProperty(value="#{SystemOperatingService}")
	private ISystemOperatingService syoService;
	
	private List<AppWEB> tableApp;
	private List<AppWEB> filteredtableApp;
	private AppWEB selectedApp;
	private Applications selectedApplication;
	private List<SystemOperating> tableSyo;
	
	//Detail Application
	//Events applications
	private List<EventsWEB> tableAllEvents;
	private int intPulsa;
	
	//Group applications
	private List<GroupApp> tableGroupAppAct;
	private List<GroupApp> filteredtableGroupAppAct;
	private GroupApp selectedGroupAppAct;
	private List<GroupApp> tableGroupAppDis;
	private List<GroupApp> filteredtableGroupAppDis;
	private GroupApp selectedGroupAppDis;
	
	//Server applciations
	private List<ServerWEB> tableServerAct;
	private List<ServerWEB> filteredtableServerAct;
	private ServerWEB selectedServerAct;
	private List<ServerWEB> tableServerDis;
	private List<ServerWEB> filteredtableServerDis;
	private ServerWEB selectedServerDis;
	
	//Users applications
	private List<User> tableUserAct;
	private List<User> filteredtableUserAct;
	private User selectedUserAct;
	private List<User> tableUserDis;
	private List<User> filteredtableUserDis;
	private User selectedUserDis;
	
	
	//UsersApp active
	private List<UserAppWEB> tableUserAppAct;
	private List<UserAppWEB> filteredtableUserAppAct;
	private UserAppWEB selectedUserAppAct;
	
	//App data
	private long app_id;
	private String app_name;
	private String app_display_name;
	private String app_description;
	private String app_path_exe;
	private SystemOperating syo;
	private long syo_id;
	private UploadedFile icon; 
	private byte[] app_icon;
	private boolean appCreated;
	private String app_detId;
	
	//General
	private FacesUtils faces;
	
	public AppManagedImpl() {
		tableApp = new ArrayList<AppWEB>();
		filteredtableApp = new ArrayList<AppWEB>();
		selectedApp = new AppWEB();
		tableSyo = new ArrayList<SystemOperating>();
		tableAllEvents = new ArrayList<EventsWEB>();
		intPulsa = 1;
		tableGroupAppAct = new ArrayList<GroupApp>();
		filteredtableGroupAppAct = new ArrayList<GroupApp>();
		selectedGroupAppAct = new GroupApp();
		tableGroupAppDis = new ArrayList<GroupApp>();
		filteredtableGroupAppDis = new ArrayList<GroupApp>();
		selectedGroupAppDis = new GroupApp();
		tableServerAct = new ArrayList<ServerWEB>();
		filteredtableServerAct = new ArrayList<ServerWEB>();
		selectedServerAct = new ServerWEB();
		tableServerDis = new ArrayList<ServerWEB>();
		filteredtableServerDis = new ArrayList<ServerWEB>();
		selectedServerDis = new ServerWEB();
		tableUserAct = new ArrayList<User>();
		filteredtableUserAct = new ArrayList<User>();
		selectedUserAct = new User();
		tableUserDis = new ArrayList<User>();
		filteredtableUserDis = new ArrayList<User>();
		selectedUserDis = new User();
		tableUserAppAct = new ArrayList<UserAppWEB>();
		filteredtableUserAppAct = new ArrayList<UserAppWEB>();
		selectedUserAppAct = new UserAppWEB();
		app_id = 0;
		app_name = "";
		app_display_name = "";
		app_description = "";
		app_path_exe = "";
		syo = new SystemOperating();
		app_icon = null;
		appCreated = false;
		app_detId = "";
		icon = null;
		faces = new FacesUtils();
	}
	
	@PostConstruct
	public void init() {
		try {
			getApp();
			getAllSyo();
			intPulsa = 1;
			HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);   
			app_detId = String.valueOf(session.getAttribute("app_detId"));
			session.removeAttribute("use_detId");
			session.removeAttribute("ser_detId");
			if (app_detId != null) {
				if (! app_detId.equals("null")) {
					Applications appTemp = getAppService().getApplicationsId(Long.parseLong(app_detId));
					AppWEB appWeb = new AppWEB();
					appWeb.setApp_id(appTemp.getApp_id());
					appWeb.setApp_name(appTemp.getApp_name());
					appWeb.setApp_description(appTemp.getApp_description());
					appWeb.setApp_display_name(appTemp.getApp_display_name());
					appWeb.setApp_path_exe(appTemp.getApp_path_exe());
					appWeb.setApp_syo(appTemp.getFk_app_syo_id().getSyo_description());
					appWeb.setApp_usemod(appTemp.getApp_usemod());
					appWeb.setApp_datmod(appTemp.getApp_datmod());
					selectedApp = appWeb;
					selectedApplication = appTemp;
					getAllAppEvents();
					getTableGroup();
					getTableServer();
					getTableUser();
					getActiveUserApp();
				}
			}
		} catch (Exception e) {
			System.out.println("APPBEAN:" + e.toString());
		}
	}
	
	@Override 
	public void getAllSyo() {
		tableSyo = getSyoService().getAllSystemOperating();
	}
	
	@Override
	public void getApp() {
		// TODO Auto-generated method stub
		//RequestContext context = RequestContext.getCurrentInstance();
		//GenericApplicationContext appContext = AppUtils.getContext();
		//appContext.refresh();
		//AppUtils.setApplicationContext(appContext);
		List<Applications> listApp = getAppService().getAllApplications();
		if (listApp != null) {
			if (!listApp.isEmpty()) {
				tableApp = new ArrayList<AppWEB>();
				for (int i = 0; i < listApp.size(); i++) {
					AppWEB appWEB = new AppWEB();
					appWEB.setApp_id(listApp.get(i).getApp_id());
					appWEB.setApp_name(listApp.get(i).getApp_name());
					appWEB.setApp_description(listApp.get(i).getApp_description());
					appWEB.setApp_display_name(listApp.get(i).getApp_display_name());
					appWEB.setApp_path_exe(listApp.get(i).getApp_path_exe());
					appWEB.setApp_syo(listApp.get(i).getFk_app_syo_id().getSyo_description());
					appWEB.setApp_usemod(listApp.get(i).getApp_usemod());
					appWEB.setApp_datmod(listApp.get(i).getApp_datmod());
					//if (listApp.get(i).getApp_icon() != null) {
					//	InputStream input = new ByteArrayInputStream(listApp.get(i).getApp_icon());
					//	DefaultStreamedContent imagen = new DefaultStreamedContent(input, "image/jpg");
					//	appWEB.setApp_icon(imagen);
					//}
					tableApp.add(appWEB);
				}
			}
		}
	}

	@Override
	public void createApp() {
		// TODO Auto-generated method stub
		if (lfCheckData()) {
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			Applications app = new Applications();
			if (icon != null) {
				app_icon = icon.getContents();
			}
			app.setApp_name(app_name);
			app.setApp_display_name(app_description);
			app.setApp_description(app_description);
			app.setApp_path_exe(app_path_exe);
			app.setFk_app_syo_id(syo);
			app.setApp_icon(app_icon);
			app.setApp_datmod(new Date());
			app.setApp_usemod(logon.getUserId());
			getAppService().createApplications(app);
			//Reply to LDAP SAMBA
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IApplicationLDAPDao appLdapDao = (IApplicationLDAPDao)factorySAMBA.getBean(Constant.BEAN_APPDAO);
				ApplicationLDAP appLDAP = appLdapDao.getApplicationCn(app.getApp_name());
				if (appLDAP == null) {
					appLDAP = new ApplicationLDAP();
					appLDAP.setCn(app.getApp_name());
					appLDAP.setName(app.getApp_name());
					appLDAP.setDisplayName(app.getApp_display_name());
					appLDAP.setDescription(app.getApp_description());
					appLDAP.setScriptPath(app.getApp_path_exe());
					appLDAP.setIcon(app.getApp_name() + Constant.CONS_ICO);
					appLDAP.setOperatingSystem(app.getFk_app_syo_id().getSyo_description());
					appLDAP.setProgGroup(Constant.STRING_SINESPECIFICAR);
					appLdapDao.createApplication(appLDAP);
				} else {
					appLDAP = new ApplicationLDAP();
					appLDAP.setCn(app.getApp_name());
					appLDAP.setName(app.getApp_name());
					appLDAP.setDisplayName(app.getApp_display_name());
					appLDAP.setDescription(app.getApp_description());
					appLDAP.setScriptPath(app.getApp_path_exe());
					appLDAP.setIcon(app.getApp_name() + Constant.CONS_ICO);
					appLDAP.setOperatingSystem(app.getFk_app_syo_id().getSyo_description());
					appLDAP.setProgGroup(Constant.STRING_SINESPECIFICAR);
					appLdapDao.updateApplication(appLDAP);
				}
			}
			//Set the newApp in appDet session variable for go to detail
			appCreated = true;
			//Set session variable for show app detail
			HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);
			session.setAttribute("app_detId", app.getApp_id());
			RequestContext.getCurrentInstance().execute(Constant.WEB_CLOSE_MSG_NEWAPP);
			RequestContext context = RequestContext.getCurrentInstance();
			String strRespuesta = Constant.WEB_PAGE_DETAPP + Constant.WEB_FACES_REDIRECT;
			context.addCallbackParam(Constant.ARGS_CORRECT, appCreated);
			context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
		} else {
			RequestContext context = RequestContext.getCurrentInstance();
			String strRespuesta = Constant.WEB_PAGE_DETAPP + Constant.WEB_FACES_REDIRECT;
			context.addCallbackParam(Constant.ARGS_CORRECT, appCreated);
			context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
		}
	}

	@Override
	public void gotoDetUse() {
		HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);  
		session.setAttribute("use_detId", selectedUserAppAct.getUse_id());  
		RequestContext context = RequestContext.getCurrentInstance();
		String strRespuesta = Constant.WEB_PAGE_DETUSER + Constant.WEB_FACES_REDIRECT;
		context.addCallbackParam(Constant.ARGS_CORRECT, true);
		context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
	}
	
	@Override
	public void gotoDetSer() {
		HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);  
		session.setAttribute("ser_detId", selectedUserAppAct.getSer_id());  
		RequestContext context = RequestContext.getCurrentInstance();
		String strRespuesta = Constant.WEB_PAGE_DETSERVER + Constant.WEB_FACES_REDIRECT;
		context.addCallbackParam(Constant.ARGS_CORRECT, true);
		context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
	}
	
	@Override
	public void dialogNewApp() {
		// TODO Auto-generated method stub
		app_id = 0;
		app_name = "";
		app_display_name = "";
		app_description = "";
		app_path_exe = "";
		app_icon = null;
		syo = new SystemOperating();
		RequestContext.getCurrentInstance().execute(Constant.WEB_MSG_NEWAPP);
	}
	
	@Override
	public void handleIcon(FileUploadEvent event)  {
		//System.out.println("prueba file");
		app_icon = event.getFile().getContents();
	}
	
	private boolean lfCheckData() {
		FacesMessage msg = null;
		LanguageUtils lang = new LanguageUtils();
		boolean blnCorrect = true;
		
		if (getApp_name().equals("")) {
			msg = new FacesMessage(FacesMessage.SEVERITY_INFO,lang.getMessage("gen_name"),
					lang.getMessage("gen_requiered"));
			FacesContext.getCurrentInstance().addMessage(null, msg);
			blnCorrect = false;
		}
		
		if (getApp_description().equals("")) {
			msg = new FacesMessage(FacesMessage.SEVERITY_INFO,lang.getMessage("gen_description"),
					lang.getMessage("gen_requiered"));
			FacesContext.getCurrentInstance().addMessage(null, msg);
			blnCorrect = false;
		}
		
		if (getApp_path_exe().equals("")) {
			msg = new FacesMessage(FacesMessage.SEVERITY_INFO,lang.getMessage("gen_path_exe"),
					lang.getMessage("gen_requiered"));
			FacesContext.getCurrentInstance().addMessage(null, msg);
			blnCorrect = false;
		}
		
		if (getSyo().getSyo_description().equals("")) {
			msg = new FacesMessage(FacesMessage.SEVERITY_INFO,lang.getMessage("gen_syo"),
					lang.getMessage("gen_requiered"));
			FacesContext.getCurrentInstance().addMessage(null, msg);
			blnCorrect = false;
		}
		return blnCorrect;
	}
	
	@Override
	public void getAllAppEvents() {
		// TODO Auto-generated method stub
		//RequestContext context = RequestContext.getCurrentInstance();
		//GenericApplicationContext appContext = AppUtils.getContext();
		//appContext.refresh();
		//AppUtils.setApplicationContext(appContext);
		//System.out.println("getAllEvents");
		SimpleDateFormat sdf = new SimpleDateFormat(Constant.MASK_DATE_WEB);
		Date datTemporal = null;
		String strtypeEvent = null;
		String strtextEvent = null;
		String striconEvent = null;
		LanguageUtils lang = new LanguageUtils();
		//Applications app = getAppService().getApplicationsId(selectedApp.getApp_id());
		List<Events> listEvents = getEventsService().getApplicationEvents(selectedApplication, intPulsa);
		if (listEvents != null) {
			tableAllEvents = new ArrayList<EventsWEB>();
			for (int i=0; i < listEvents.size(); i++) {
				EventsWEB eventsWEB = new EventsWEB();
				datTemporal = listEvents.get(i).getEve_datetime();
				eventsWEB.setDateTime(sdf.format(datTemporal));
				switch(listEvents.get(i).getTypeEvent().getTev_id()) {
				case Constant.EVE_START_SESSION:
					striconEvent = Constant.EVE_ICON_USER_EVENT;
					strtypeEvent = lang.getMessage(Constant.EVE_TXT_STAR_SESSION);
					strtextEvent = lang.getMessage(Constant.I18N_EVE_TXT_USER) + " " +
							       listEvents.get(i).getEve_adic_data_1() + " " +
							       lang.getMessage(Constant.I18N_EVE_TXT_STARTED_SESSION);
					break;
				case Constant.EVE_END_SESSION:
					striconEvent = Constant.EVE_ICON_USER_EVENT;
					strtypeEvent = lang.getMessage(Constant.EVE_TXT_END_SESSION);
					strtextEvent = lang.getMessage(Constant.I18N_EVE_TXT_USER) + " " +
							       listEvents.get(i).getEve_adic_data_1() + " " +
							       lang.getMessage(Constant.I18N_EVE_TXT_ENDED_SESSION);
					break;
				case Constant.EVE_STAR_APPLICATION:
					striconEvent = Constant.EVE_ICON_APP_EVENT;
					strtypeEvent = lang.getMessage(Constant.EVE_TXT_STAR_APPLICATION);
					strtextEvent = lang.getMessage(Constant.I18N_EVE_TXT_USER) + " " +
							       listEvents.get(i).getEve_adic_data_1() + " " +
							       lang.getMessage(Constant.I18N_EVE_TXT_STARTED_APPLICATION) + " " +
							       listEvents.get(i).getEve_adic_data_2() + " " +
							       lang.getMessage(Constant.I18N_EVE_TXT_SERVER) + " " +
							       listEvents.get(i).getEve_adic_data_3();
					break;
				case Constant.EVE_END_APPLICATION:
					striconEvent = Constant.EVE_ICON_APP_EVENT;
					strtypeEvent = lang.getMessage(Constant.EVE_TXT_END_APPLICATION);
					strtextEvent = lang.getMessage(Constant.I18N_EVE_TXT_USER) + " " +
						       listEvents.get(i).getEve_adic_data_1() + " " +
						       lang.getMessage(Constant.I18N_EVE_TXT_ENDED_APPLICATION) + " " +
						       listEvents.get(i).getEve_adic_data_2() + " " +
						       lang.getMessage(Constant.I18N_EVE_TXT_SERVER) + " " +
						       listEvents.get(i).getEve_adic_data_3();
					break;
				}
				eventsWEB.setIconEvent(striconEvent);
				eventsWEB.setTypeEvent(strtypeEvent);
				eventsWEB.setTextEvent(strtextEvent);
				User user = getUserService().getUserId(listEvents.get(i).getEve_adic_data_1());
				eventsWEB.setUserName(user.getUse_name() + user.getUse_surname1());
				tableAllEvents.add(eventsWEB);
			}
		}
	}
	
	@Override
	public void getMoreAppEvents() {
		// TODO Auto-generated method stub
		setIntPulsa(this.intPulsa + 1);
		//System.out.println(this.intPulsa);
		getAllAppEvents();
	}
	
	@Override
	public void getTableGroup() {
		List<GroupApp> lstTemp = new ArrayList<GroupApp>();
		List<GroupApp> lstTempGroupApp = new ArrayList<GroupApp>();
		if (selectedApp.getApp_id() != 0) {
			lstTempGroupApp = getGroupAppService().getAllGroupApp();
			List<AppGroup> appGroups = getAppService().getAllGroupApp(selectedApplication);
			if (appGroups != null) {
				for (int i=0; i < appGroups.size(); i++) {
					lstTemp.add(appGroups.get(i).getAppGroupPK().getGroup());
					lstTempGroupApp.remove(appGroups.get(i).getAppGroupPK().getGroup());
				}
				setTableGroupAppAct(lstTemp);
				setTableGroupAppDis(lstTempGroupApp);
			}
			setTableGroupAppAct(lstTemp);
			setTableGroupAppDis(lstTempGroupApp);
		}
	}
	
	@Override
	public void getTableServer() {
		float fCalculo;
		int iPorcentaje;
		List<Server> lstTemp = new ArrayList<Server>();
		List<Server> lstTempServer = new ArrayList<Server>();
		if (selectedApp.getApp_id() != 0) {
			lstTempServer = getServerService().getAllServer();
			List<AppServer> appServer = getAppService().getAllAppServer(selectedApplication);
			if (appServer != null) {
				for (int i=0; i < appServer.size(); i++) {
					lstTemp.add(appServer.get(i).getAppServerPK().getServer());
					lstTempServer.remove(appServer.get(i).getAppServerPK().getServer());
				}
			}
		}
		//GenericApplicationContext appContext = AppUtils.getContext();
		//appContext.refresh();
		//AppUtils.setApplicationContext(appContext);
		List<ServerWEB> lstTempWEB = new ArrayList<ServerWEB>();
		List<ServerWEB> lstTempServerWEB = new ArrayList<ServerWEB>();
		if (lstTemp != null) {
			if (!lstTemp.isEmpty()) {
				for (int i = 0; i < lstTemp.size(); i++) {
					ServerWEB serverWeb = new ServerWEB();
					serverWeb.setSer_id(lstTemp.get(i).getSer_id());
					serverWeb.setSer_host(lstTemp.get(i).getSer_host());
					serverWeb.setSer_syo(lstTemp.get(i).getFk_ser_syo_id().getSyo_description());
					serverWeb.setSer_memtot(Float.toString(lstTemp.get(i).getSer_mentot()));
					serverWeb.setSer_memuse(Float.toString(lstTemp.get(i).getSer_menuse()));
					fCalculo = lstTemp.get(i).getSer_menuse() * 100 / lstTemp.get(i).getSer_mentot();
					iPorcentaje = Math.round(fCalculo);
					serverWeb.setSer_pormemory(Integer.toString(iPorcentaje));
					iPorcentaje = Math.round(lstTemp.get(i).getSer_cpuuse());
					serverWeb.setSer_cpuuse(Integer.toString(iPorcentaje));
					serverWeb.setSer_porcpu(Integer.toString(iPorcentaje));
					iPorcentaje = Math.round(lstTemp.get(i).getSer_reduse());
					serverWeb.setSer_reduse(Integer.toString(iPorcentaje));
					serverWeb.setSer_porred(Integer.toString(iPorcentaje));
					lstTempWEB.add(serverWeb);
				}
			}
		}
		if (lstTempServer != null) {
			if (!lstTempServer.isEmpty()) {
				for (int i = 0; i < lstTempServer.size(); i++) {
					ServerWEB serverWeb = new ServerWEB();
					serverWeb.setSer_id(lstTempServer.get(i).getSer_id());
					serverWeb.setSer_host(lstTempServer.get(i).getSer_host());
					serverWeb.setSer_syo(lstTempServer.get(i).getFk_ser_syo_id().getSyo_description());
					serverWeb.setSer_memtot(Float.toString(lstTempServer.get(i).getSer_mentot()));
					serverWeb.setSer_memuse(Float.toString(lstTempServer.get(i).getSer_menuse()));
					fCalculo = lstTempServer.get(i).getSer_menuse() * 100 / lstTempServer.get(i).getSer_mentot();
					iPorcentaje = Math.round(fCalculo);
					serverWeb.setSer_pormemory(Integer.toString(iPorcentaje));
					iPorcentaje = Math.round(lstTempServer.get(i).getSer_cpuuse());
					serverWeb.setSer_cpuuse(Integer.toString(iPorcentaje));
					serverWeb.setSer_porcpu(Integer.toString(iPorcentaje));
					iPorcentaje = Math.round(lstTempServer.get(i).getSer_reduse());
					serverWeb.setSer_reduse(Integer.toString(iPorcentaje));
					serverWeb.setSer_porred(Integer.toString(iPorcentaje));
					lstTempServerWEB.add(serverWeb);
				}
			}
		}
		setTableServerAct(lstTempWEB);
		setTableServerDis(lstTempServerWEB);
		
	}
	
	@Override
	public void getTableUser() {
		List<User> lstTemp = new ArrayList<User>();
		List<User> lstTempUser = new ArrayList<User>();
		if (selectedApp.getApp_id() != 0) {
			lstTempUser = getUserService().getAllUser();
			List<UserApp> appUser = getAppService().getAllAppUser(selectedApplication);
			if (appUser != null) {
				for (int i=0; i < appUser.size(); i++) {
					lstTemp.add(appUser.get(i).getUserAppPK().getUser());
					lstTempUser.remove(appUser.get(i).getUserAppPK().getUser());
				}
				setTableUserAct(lstTemp);
				setTableUserDis(lstTempUser);
			}
			setTableUserAct(lstTemp);
			setTableUserDis(lstTempUser);
		}
	}
	
	@Override
	public void getActiveUserApp() {
		List<UserApp> lstUserApp = new ArrayList<UserApp>();
		List<UserAppWEB> lstUserAppWeb = new ArrayList<UserAppWEB>();
		try {
			lstUserApp = getAppService().getActiveAppUser(selectedApplication);
			if (lstUserApp != null) {
				for (int i = 0; i < lstUserApp.size(); i++) {
					UserAppWEB userAppWeb = new UserAppWEB();
					User user = getUserService().getUserId(lstUserApp.get(i).getFk_uap_use_id());
					Applications app = getAppService().getApplicationsId(lstUserApp.get(i).getFk_uap_app_id());
					Server server = getServerService().getServerId(lstUserApp.get(i).getFk_uap_ser_id().getSer_id());
					userAppWeb.setUse_id(user.getUse_id());
					userAppWeb.setUse_name(user.getUse_name() + " " + user.getUse_surname1());
					userAppWeb.setApp_id(app.getApp_id());
					userAppWeb.setApp_description(app.getApp_description());
					userAppWeb.setSer_id(server.getSer_id());
					userAppWeb.setSer_host(server.getSer_host());
					userAppWeb.setSer_description(server.getSer_description());
					userAppWeb.setUap_start_date_process(lstUserApp.get(i).getUap_start_date_process());
					userAppWeb.setUap_end_date_process(lstUserApp.get(i).getUap_end_date_process());
					userAppWeb.setUap_id_process(lstUserApp.get(i).getUap_id_process());
					userAppWeb.setUap_cpuuse(lstUserApp.get(i).getUap_cpuuse());
					userAppWeb.setUap_memuse(lstUserApp.get(i).getUap_memuse());
					lstUserAppWeb.add(userAppWeb);
				}
			}
			setTableUserAppAct(lstUserAppWeb);
			
		} catch (Exception e) {
			System.err.println("GETACTIVEUSER");
			e.printStackTrace();
		}
	}
	
	@Override
	public void dialogUpApp() {
		// TODO Auto-generated method stub
		RequestContext.getCurrentInstance().execute(Constant.WEB_MSG_UPAPP);
	}
	
	@Override
	public void updateApp() {
		FacesMessage msg = null;
		LanguageUtils lang = new LanguageUtils();
		app_name = selectedApplication.getApp_name();
		app_description = selectedApplication.getApp_description();
		app_path_exe = selectedApplication.getApp_path_exe();
		syo = selectedApplication.getFk_app_syo_id();
		if (lfCheckData()) {
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			Applications app = new Applications();
			if (icon != null) {
				app_icon = icon.getContents();
			}
			app.setApp_id(selectedApplication.getApp_id());
			app.setApp_name(selectedApplication.getApp_name());
			app.setApp_display_name(selectedApplication.getApp_description());
			app.setApp_description(selectedApplication.getApp_description());
			app.setApp_path_exe(selectedApplication.getApp_path_exe());
			app.setFk_app_syo_id(syo);
			app.setApp_icon(app_icon);
			app.setApp_datmod(new Date());
			app.setApp_usemod(logon.getUserId());
			getAppService().updateApplications(app);
			//Reply to LDAP SAMBA
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IApplicationLDAPDao appLdapDao = (IApplicationLDAPDao)factorySAMBA.getBean(Constant.BEAN_APPDAO);
				ApplicationLDAP appLDAP = appLdapDao.getApplicationCn(app.getApp_name());
				if (appLDAP == null) {
					appLDAP = new ApplicationLDAP();
					appLDAP.setCn(app.getApp_name());
					appLDAP.setName(app.getApp_name());
					appLDAP.setDisplayName(app.getApp_display_name());
					appLDAP.setDescription(app.getApp_description());
					appLDAP.setScriptPath(app.getApp_path_exe());
					appLDAP.setIcon(app.getApp_name() + Constant.CONS_ICO);
					appLDAP.setOperatingSystem(app.getFk_app_syo_id().getSyo_description());
					appLDAP.setProgGroup(Constant.STRING_SINESPECIFICAR);
					appLdapDao.createApplication(appLDAP);
				} else {
					appLDAP.setCn(app.getApp_name());
					appLDAP.setName(app.getApp_name());
					appLDAP.setDisplayName(app.getApp_display_name());
					appLDAP.setDescription(app.getApp_description());
					appLDAP.setScriptPath(app.getApp_path_exe());
					appLDAP.setIcon(app.getApp_name() + Constant.CONS_ICO);
					appLDAP.setOperatingSystem(app.getFk_app_syo_id().getSyo_description());
					appLdapDao.updateApplication(appLDAP);
				}
			}
			//Set the newApp in appDet session variable for go to detail
			appCreated = true;
			//Set session variable for show app detail
			HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);
			session.setAttribute("app_detId", app.getApp_id());
			RequestContext.getCurrentInstance().execute(Constant.WEB_CLOSE_MSG_UPAPP);
			RequestContext context = RequestContext.getCurrentInstance();
			String strRespuesta = Constant.WEB_PAGE_DETAPP + Constant.WEB_FACES_REDIRECT;
			context.addCallbackParam(Constant.ARGS_CORRECT, appCreated);
			context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
			msg = new FacesMessage(FacesMessage.SEVERITY_INFO, lang.getMessage("gen_correct"),
					lang.getMessage("gen_save_ok"));
			FacesContext.getCurrentInstance().addMessage(null, msg);
		} else {
			RequestContext context = RequestContext.getCurrentInstance();
			String strRespuesta = Constant.WEB_PAGE_DETAPP + Constant.WEB_FACES_REDIRECT;
			context.addCallbackParam(Constant.ARGS_CORRECT, appCreated);
			context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
			msg = new FacesMessage(FacesMessage.SEVERITY_FATAL, lang.getMessage("gen_error"),
					lang.getMessage("gen_save_ko"));
			FacesContext.getCurrentInstance().addMessage(null, msg);
		}
	}
	
	@Override
	public void deleteApp() {
		LanguageUtils lang = new LanguageUtils();
		PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
		getAppService().deleteApplications(selectedApplication);
		//Reply to LDAP SAMBA
		if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)){
			Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
			BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
			IApplicationLDAPDao appLdapDao = (IApplicationLDAPDao)factorySAMBA.getBean(Constant.BEAN_APPDAO);
			ApplicationLDAP appLDAP = appLdapDao.getApplicationCn(selectedApplication.getApp_name());
			appLdapDao.deleteApplciation(appLDAP);
		}
		//Set the newUser in useDet session varible for detail
		appCreated = false;
		//Srt session variable for show user detail
		HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);
		session.removeAttribute("app_detId");
		RequestContext context = RequestContext.getCurrentInstance();
		String strRespuesta = Constant.WEB_PAGE_HOMEAPP + Constant.WEB_FACES_REDIRECT;
		context.addCallbackParam(Constant.ARGS_CORRECT, true);
		context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
		faces.sendMessage("gen_correct",
				"gen_remove_ok", Constant.MSG_INFORMATION);
	}
	
	@Override
	public void removeAppServer() {
		try {
			Server server = getServerService().getServerId(selectedServerAct.getSer_id());
			boolean blnResult = getAppService().removeAppServer(selectedApplication, server);
			//Reply to SAMBA
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				boolean blnExisServerApp = false;
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IAppServerLDAPDao appServerLdapDao = (IAppServerLDAPDao)factorySAMBA.getBean(Constant.BEAN_APPSERVERDAO);
				List resultAS = appServerLdapDao.getAppServer(selectedApplication.getApp_name());
				for (int i = 0; i < resultAS.size(); i++) {
					AppServerLDAP resultServer = (AppServerLDAP) resultAS.get(i);
					String[] servers = resultServer.getServersApp();
					if (servers != null) {
						for (int a = 0; a < servers.length; a++) {
							if (servers[a].equals(server.getSer_host())) {
								blnExisServerApp = true;
							}
						}
					}
				}
				if (blnExisServerApp) {
					AppServerLDAP newAppServer = new AppServerLDAP();
					newAppServer.setCnApplication(selectedApplication.getApp_name());
					newAppServer.setCnServer(server.getSer_host());
					appServerLdapDao.removeAppServer(newAppServer);
				}
			}
			//End reply SAMBA
			if (blnResult) {
				tableServerAct.remove(selectedServerAct);
				tableServerDis.add(selectedServerAct);
				faces.sendMessage(Constant.TXT_GEN_CORRECT, Constant.TXT_GEN_REMOVE_OK,
						Constant.MSG_INFORMATION);
			} else {
				faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_REMOVE_KO,
						Constant.MSG_CRITICAL);
			}
			
		} catch (Exception e) {
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_REMOVE_KO,
					Constant.MSG_CRITICAL);
			e.printStackTrace();
		}
	}
	
	@Override
	public void addAppServer() {
	
		try {
			
			Server server = getServerService().getServerId(selectedServerDis.getSer_id());
			boolean blnResult = getAppService().addAppServer(selectedApplication, server, logon.getUserId());
			//Reply to SAMBA
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				boolean blnExisServerApp = false;
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IAppServerLDAPDao appServerLdapDao = (IAppServerLDAPDao)factorySAMBA.getBean(Constant.BEAN_APPSERVERDAO);
				List resultAS = appServerLdapDao.getAppServer(selectedApplication.getApp_name());
				for (int i = 0; i < resultAS.size(); i++) {
					AppServerLDAP resultServer = (AppServerLDAP) resultAS.get(i);
					String[] servers = resultServer.getServersApp();
					if (servers != null) {
						for (int a = 0; a < servers.length; a++) {
							if (servers[a].equals(server.getSer_host())) {
								blnExisServerApp = true;
							}
						}
					}
				}
				if (!blnExisServerApp) {
					AppServerLDAP newAppServer = new AppServerLDAP();
					newAppServer.setCnApplication(selectedApplication.getApp_name());
					newAppServer.setCnServer(server.getSer_host());
					appServerLdapDao.createAppServer(newAppServer);
				}
			}
			//End reply SAMBA
			if (blnResult) {
				tableServerAct.add(selectedServerDis);
				tableServerDis.remove(selectedServerDis);
				faces.sendMessage(Constant.TXT_GEN_CORRECT, Constant.TXT_GEN_SAVE_OK,
						Constant.MSG_INFORMATION);
			} else {
				faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_OK,
						Constant.MSG_CRITICAL);
			}
			
		} catch (Exception e) {
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_OK,
					Constant.MSG_CRITICAL);
			e.printStackTrace();
		}
	}
	
	@Override
	public void onServerDrop(DragDropEvent ddEvent) {
		try {
			ServerWEB serverWeb = ((ServerWEB) ddEvent.getData());
			Server server = getServerService().getServerId(serverWeb.getSer_id());
			boolean blnResult = getAppService().addAppServer(selectedApplication, server, logon.getUserId());
			//Reply to SAMBA
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				boolean blnExisServerApp = false;
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IAppServerLDAPDao appServerLdapDao = (IAppServerLDAPDao)factorySAMBA.getBean(Constant.BEAN_APPSERVERDAO);
				List resultAS = appServerLdapDao.getAppServer(selectedApplication.getApp_name());
				for (int i = 0; i < resultAS.size(); i++) {
					AppServerLDAP resultServer = (AppServerLDAP) resultAS.get(i);
					String[] servers = resultServer.getServersApp();
					if (servers != null) {
						for (int a = 0; a < servers.length; a++) {
							if (servers[a].equals(server.getSer_host())) {
								blnExisServerApp = true;
							}
						}
					}
				}
				if (!blnExisServerApp) {
					AppServerLDAP newAppServer = new AppServerLDAP();
					newAppServer.setCnApplication(selectedApplication.getApp_name());
					newAppServer.setCnServer(server.getSer_host());
					appServerLdapDao.createAppServer(newAppServer);
				}
			}
			//End reply SAMBA
			if (blnResult) {
				tableServerAct.add(serverWeb);
				tableServerDis.remove(serverWeb);
				faces.sendMessage(Constant.TXT_GEN_CORRECT, Constant.TXT_GEN_SAVE_OK,
						Constant.MSG_INFORMATION);
			} else {
				faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_OK,
						Constant.MSG_CRITICAL);
			}
			
		} catch (Exception e) {
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_OK,
					Constant.MSG_CRITICAL);
			e.printStackTrace();
		}
	}
	
	@Override
	public void removeAppUser() {
		
		try {
			boolean blnResult = getAppService().removeUserApp(selectedApplication, selectedUserAct);
			//Reply to SAMBA
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				boolean blnExisUserApp = false;
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IUserAppLDAPDao userAppLdapDao = (IUserAppLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERAPPDAO);
				List resultUG = userAppLdapDao.getApplicationsUser(selectedUserAct.getUse_id());
				for (int i = 0; i < resultUG.size(); i++) {
					UserAppLDAP resultApp = (UserAppLDAP) resultUG.get(i);
					String[] apps = resultApp.getApplicationsUser();
					if (apps != null) {
						for (int g = 0; g < apps.length; g++) {
							if (apps[g].equals(selectedApplication.getApp_name())) {
								blnExisUserApp = true;
							}
						}
					}
				}
				if (blnExisUserApp) {
					UserLDAP userLdap = new UserLDAP();
					IUserLDAPDao userLdapDao = (IUserLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERDAO);
					userLdap = userLdapDao.getUserCn(selectedUserAct.getUse_id());
					ApplicationLDAP appLdap = new ApplicationLDAP();
					IApplicationLDAPDao appLdapDao = (IApplicationLDAPDao)factorySAMBA.getBean(Constant.BEAN_APPDAO);
					appLdap = appLdapDao.getApplicationCn(selectedApplication.getApp_name());
					UserAppLDAP newUserAppLdap = new UserAppLDAP();
					newUserAppLdap.setCnApplication(appLdap.getCn());
					newUserAppLdap.setDnApplication(appLdap.getDistinguishedName());
					newUserAppLdap.setCnUser(userLdap.getCn());
					newUserAppLdap.setDnUser(userLdap.getDistinguishedName());
					userAppLdapDao.deleteUserApp(newUserAppLdap);
				}
			}
			//End reply SAMBA
			if (blnResult) {
				tableUserAct.remove(selectedUserAct);
				tableUserDis.add(selectedUserAct);
				faces.sendMessage(Constant.TXT_GEN_CORRECT, Constant.TXT_GEN_REMOVE_OK,
						Constant.MSG_INFORMATION);
			} else {
				faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_REMOVE_KO,
						Constant.MSG_CRITICAL);
			}
			 
		} catch (Exception e) {
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_REMOVE_KO,
					Constant.MSG_CRITICAL);
			e.printStackTrace();
		}
	}
	
	@Override
	public void addAppUser() {
		try {
			//Process db insert the new group user
			boolean blnResult = getAppService().addUserApp(selectedApplication, selectedUserDis, logon.getUserId());
			//Reply to SAMBA
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				boolean blnExisUserApp = false;
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IUserAppLDAPDao userAppLdapDao = (IUserAppLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERAPPDAO);
				List resultUG = userAppLdapDao.getApplicationsUser(selectedUserDis.getUse_id());
				for (int i = 0; i < resultUG.size(); i++) {
					UserAppLDAP resultApp = (UserAppLDAP) resultUG.get(i);
					String[] apps = resultApp.getApplicationsUser();
					if (apps != null) {
						for (int g = 0; g < apps.length; g++) {
							if (apps[g].equals(selectedApplication.getApp_name())) {
								blnExisUserApp = true;
							}
						}
					}
				}
				if (!blnExisUserApp) {
					UserLDAP userLdap = new UserLDAP();
					IUserLDAPDao userLdapDao = (IUserLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERDAO);
					userLdap = userLdapDao.getUserCn(selectedUserDis.getUse_id());
					ApplicationLDAP appLdap = new ApplicationLDAP();
					IApplicationLDAPDao appLdapDao = (IApplicationLDAPDao)factorySAMBA.getBean(Constant.BEAN_APPDAO);
					appLdap = appLdapDao.getApplicationCn(selectedApplication.getApp_name());
					UserAppLDAP newUserAppLdap = new UserAppLDAP();
					newUserAppLdap.setCnApplication(appLdap.getCn());
					newUserAppLdap.setDnApplication(appLdap.getDistinguishedName());
					newUserAppLdap.setCnUser(userLdap.getCn());
					newUserAppLdap.setDnUser(userLdap.getDistinguishedName());
					userAppLdapDao.createUserApp(newUserAppLdap);
				}
			}
			//End reply SAMBA
			if (blnResult) {
				tableUserAct.add(selectedUserDis);
				tableUserDis.remove(selectedUserDis);
				faces.sendMessage(Constant.TXT_GEN_CORRECT, Constant.TXT_GEN_SAVE_OK,
						Constant.MSG_INFORMATION);
			} else {
				faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_KO,
						Constant.MSG_CRITICAL);
			}
			
		} catch (Exception e) {
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_KO,
					Constant.MSG_CRITICAL);
			e.printStackTrace();
		}
	}
	
	@Override
	public void onUserDrop(DragDropEvent ddEvent) {
		try {
			User user = ((User) ddEvent.getData());
			boolean blnResult = getAppService().addUserApp(selectedApplication, user, logon.getUserId());
			//Reply to SAMBA
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				boolean blnExisUserApp = false;
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IUserAppLDAPDao userAppLdapDao = (IUserAppLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERAPPDAO);
				List resultUG = userAppLdapDao.getApplicationsUser(user.getUse_id());
				for (int i = 0; i < resultUG.size(); i++) {
					UserAppLDAP resultApp = (UserAppLDAP) resultUG.get(i);
					String[] apps = resultApp.getApplicationsUser();
					if (apps != null) {
						for (int g = 0; g < apps.length; g++) {
							if (apps[g].equals(selectedApplication.getApp_name())) {
								blnExisUserApp = true;
							}
						}
					}
				}
				if (!blnExisUserApp) {
					UserLDAP userLdap = new UserLDAP();
					IUserLDAPDao userLdapDao = (IUserLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERDAO);
					userLdap = userLdapDao.getUserCn(user.getUse_id());
					ApplicationLDAP appLdap = new ApplicationLDAP();
					IApplicationLDAPDao appLdapDao = (IApplicationLDAPDao)factorySAMBA.getBean(Constant.BEAN_APPDAO);
					appLdap = appLdapDao.getApplicationCn(selectedApplication.getApp_name());
					UserAppLDAP newUserAppLdap = new UserAppLDAP();
					newUserAppLdap.setCnApplication(appLdap.getCn());
					newUserAppLdap.setDnApplication(appLdap.getDistinguishedName());
					newUserAppLdap.setCnUser(userLdap.getCn());
					newUserAppLdap.setDnUser(userLdap.getDistinguishedName());
					userAppLdapDao.createUserApp(newUserAppLdap);
				}
			}
			//End reply SAMBA
			if (blnResult) {
				tableUserAct.add(user);
				tableUserDis.remove(user);
				faces.sendMessage(Constant.TXT_GEN_CORRECT, Constant.TXT_GEN_SAVE_OK,
						Constant.MSG_INFORMATION);
			} else {
				faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_KO,
						Constant.MSG_CRITICAL);
			}
			
		} catch (Exception e) {
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_KO,
					Constant.MSG_CRITICAL);
			e.printStackTrace();
		}
	}
	
	@Override
	public void removeAppGroup() {
		try {
			boolean blnResult = getAppService().removeGroupApp(selectedApplication, selectedGroupAppAct);
			//Reply to LDAP SAMBA
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				boolean blnExisAppGroup = false;
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IAppGroupLDAPDao appGroupLdapDao = (IAppGroupLDAPDao)factorySAMBA.getBean(Constant.BEAN_APPGROUPDAO);
				List resultAG = appGroupLdapDao.getGroupsApp(selectedApplication.getApp_name());
				for (int i = 0; i < resultAG.size(); i++) {
					AppGroupLDAP resultGroups = (AppGroupLDAP) resultAG.get(i);
					String[] groups = resultGroups.getGroupsApp();
					if (groups != null) {
						for (int g = 0; g < groups.length; g++) {
							if (groups[g].equals(selectedGroupAppAct.getGap_description())) {
								blnExisAppGroup = true;
							}
						}
					}
				}
				if (blnExisAppGroup) {
					AppGroupLDAP newAppGroupLdap = new AppGroupLDAP();
					newAppGroupLdap.setCnGroup(selectedGroupAppAct.getGap_description());
					newAppGroupLdap.setCnApplication(selectedApplication.getApp_name());
					appGroupLdapDao.removeAppGroup(newAppGroupLdap);
				}
			}
			//End reply SAMBA
			if (blnResult) {
				tableGroupAppAct.remove(selectedGroupAppAct);
				tableGroupAppDis.add(selectedGroupAppAct);
				faces.sendMessage(Constant.TXT_GEN_CORRECT, Constant.TXT_GEN_REMOVE_OK,
						Constant.MSG_INFORMATION);
			} else {
				faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_REMOVE_KO,
						Constant.MSG_CRITICAL);
			}
			
		} catch (Exception e) {
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_REMOVE_KO,
					Constant.MSG_CRITICAL);
			e.printStackTrace();
		}
	}
	
	@Override
	public void addAppGroup() {
		try {
			boolean blnResult = getAppService().addGroupApp(selectedApplication, selectedGroupAppDis, logon.getUserId());
			//Reply to LDAP SAMBA
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				boolean blnExisAppGroup = false;
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IAppGroupLDAPDao appGroupLdapDao = (IAppGroupLDAPDao)factorySAMBA.getBean(Constant.BEAN_APPGROUPDAO);
				List resultAG = appGroupLdapDao.getGroupsApp(selectedApplication.getApp_name());
				for (int i = 0; i < resultAG.size(); i++) {
					AppGroupLDAP resultGroups = (AppGroupLDAP) resultAG.get(i);
					String[] groups = resultGroups.getGroupsApp();
					if (groups != null) {
						for (int g = 0; g < groups.length; g++) {
							if (groups[g].equals(selectedGroupAppDis.getGap_description())) {
								blnExisAppGroup = true;
							}
						}
					}
				}
				if (! blnExisAppGroup) {
					AppGroupLDAP newAppGroupLdap = new AppGroupLDAP();
					newAppGroupLdap.setCnGroup(selectedGroupAppDis.getGap_description());
					newAppGroupLdap.setCnApplication(selectedApplication.getApp_name());
					appGroupLdapDao.createAppGroup(newAppGroupLdap);
				}
			}
			//End reply SAMBA
			if (blnResult) {
				tableGroupAppAct.add(selectedGroupAppDis);
				tableGroupAppDis.remove(selectedGroupAppDis);
				faces.sendMessage(Constant.TXT_GEN_CORRECT, Constant.TXT_GEN_SAVE_OK,
						Constant.MSG_INFORMATION);
			} else {
				faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_KO,
						Constant.MSG_CRITICAL);
			}
			
		} catch (Exception e) {
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_KO,
					Constant.MSG_CRITICAL);
			e.printStackTrace();
		}
	}
	
	@Override
	public void onAppDrop(DragDropEvent ddEvent) {
		try {
			GroupApp groupApp = ((GroupApp) ddEvent.getData());
			boolean blnResult = getAppService().addGroupApp(selectedApplication, groupApp, logon.getUserId());
			//Reply to LDAP SAMBA
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				boolean blnExisAppGroup = false;
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IAppGroupLDAPDao appGroupLdapDao = (IAppGroupLDAPDao)factorySAMBA.getBean(Constant.BEAN_APPGROUPDAO);
				List resultAG = appGroupLdapDao.getGroupsApp(selectedApplication.getApp_name());
				for (int i = 0; i < resultAG.size(); i++) {
					AppGroupLDAP resultGroups = (AppGroupLDAP) resultAG.get(i);
					String[] groups = resultGroups.getGroupsApp();
					if (groups != null) {
						for (int g = 0; g < groups.length; g++) {
							if (groups[g].equals(groupApp.getGap_description())) {
								blnExisAppGroup = true;
							}
						}
					}
				}
				if (! blnExisAppGroup) {
					AppGroupLDAP newAppGroupLdap = new AppGroupLDAP();
					newAppGroupLdap.setCnGroup(groupApp.getGap_description());
					newAppGroupLdap.setCnApplication(selectedApplication.getApp_name());
					appGroupLdapDao.createAppGroup(newAppGroupLdap);
				}
			}
			//End reply SAMBA
			if (blnResult) {
				tableGroupAppAct.add(groupApp);
				tableGroupAppDis.remove(groupApp);
				faces.sendMessage(Constant.TXT_GEN_CORRECT, Constant.TXT_GEN_SAVE_OK,
						Constant.MSG_INFORMATION);
			} else {
				faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_KO,
						Constant.MSG_CRITICAL);
			}
			
		} catch (Exception e) {
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_KO,
					Constant.MSG_CRITICAL);
			e.printStackTrace();
		}
	}
	
	
	
	
	
	
	
	
	
	/** Getter and setter **/
	/**
	 * @return the appService
	 */
	public IApplicationsService getAppService() {
		return appService;
	}

	/**
	 * @param appService the appService to set
	 */
	public void setAppService(IApplicationsService appService) {
		this.appService = appService;
	}

	/**
	 * @return the tableApp
	 */
	public List<AppWEB> getTableApp() {
		return tableApp;
	}

	/**
	 * @param tableApp the tableApp to set
	 */
	public void setTableApp(List<AppWEB> tableApp) {
		this.tableApp = tableApp;
	}

	/**
	 * @return the filteredtableApp
	 */
	public List<AppWEB> getFilteredtableApp() {
		return filteredtableApp;
	}

	/**
	 * @param filteredtableApp the filteredtableApp to set
	 */
	public void setFilteredtableApp(List<AppWEB> filteredtableApp) {
		this.filteredtableApp = filteredtableApp;
	}

	/**
	 * @return the selectedApp
	 */
	public AppWEB getSelectedApp() {
		return selectedApp;
	}

	/**
	 * @param selectedApp the selectedApp to set
	 */
	public void setSelectedApp(AppWEB selectedApp) {
		this.selectedApp = selectedApp;
		//Set session variable for show app detail
		HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);
		session.setAttribute("app_detId", selectedApp.getApp_id());
	}

	/**
	 * @return the app_id
	 */
	public long getApp_id() {
		return app_id;
	}

	/**
	 * @param app_id the app_id to set
	 */
	public void setApp_id(long app_id) {
		this.app_id = app_id;
	}

	/**
	 * @return the app_name
	 */
	public String getApp_name() {
		return app_name;
	}

	/**
	 * @param app_name the app_name to set
	 */
	public void setApp_name(String app_name) {
		this.app_name = app_name;
	}

	/**
	 * @return the app_display_name
	 */
	public String getApp_display_name() {
		return app_display_name;
	}

	/**
	 * @param app_display_name the app_display_name to set
	 */
	public void setApp_display_name(String app_display_name) {
		this.app_display_name = app_display_name;
	}

	/**
	 * @return the app_description
	 */
	public String getApp_description() {
		return app_description;
	}

	/**
	 * @param app_description the app_description to set
	 */
	public void setApp_description(String app_description) {
		this.app_description = app_description;
	}

	/**
	 * @return the app_path_exe
	 */
	public String getApp_path_exe() {
		return app_path_exe;
	}

	/**
	 * @param app_path_exe the app_path_exe to set
	 */
	public void setApp_path_exe(String app_path_exe) {
		this.app_path_exe = app_path_exe;
	}

	/**
	 * @return the app_syo_id
	 */
	public SystemOperating getSyo() {
		return syo;
	}

	/**
	 * @param app_syo_id the app_syo_id to set
	 */
	public void setSyo(SystemOperating syo) {
		this.syo = syo;
	}

	/**
	 * @return the app_icon
	 */
	public byte[] getApp_icon() {
		return app_icon;
	}

	/**
	 * @param app_icon the app_icon to set
	 */
	public void setApp_icon(byte[] app_icon) {
		this.app_icon = app_icon;
	}

	/**
	 * @return the appCreated
	 */
	public boolean isAppCreated() {
		return appCreated;
	}

	/**
	 * @param appCreated the appCreated to set
	 */
	public void setAppCreated(boolean appCreated) {
		this.appCreated = appCreated;
	}

	/**
	 * @return the app_detId
	 */
	public String getApp_detId() {
		return app_detId;
	}

	/**
	 * @param app_detId the app_detId to set
	 */
	public void setApp_detId(String app_detId) {
		this.app_detId = app_detId;
	}

	/**
	 * @return the syoService
	 */
	public ISystemOperatingService getSyoService() {
		return syoService;
	}

	/**
	 * @param syoService the syoService to set
	 */
	public void setSyoService(ISystemOperatingService syoService) {
		this.syoService = syoService;
	}

	/**
	 * @return the tableSyo
	 */
	public List<SystemOperating> getTableSyo() {
		return tableSyo;
	}

	/**
	 * @param tableSyo the tableSyo to set
	 */
	public void setTableSyo(List<SystemOperating> tableSyo) {
		this.tableSyo = tableSyo;
	}

	/**
	 * @return the syo_id
	 */
	public long getSyo_id() {
		return syo_id;
	}

	/**
	 * @param syo_id the syo_id to set
	 */
	public void setSyo_id(long syo_id) {
		this.syo_id = syo_id;
		setSyo(getSyoService().getSystemOperatingId(syo_id));
	}

	/**
	 * @return the icon
	 */
	public UploadedFile getIcon() {
		return icon;
	}

	/**
	 * @param icon the icon to set
	 */
	public void setIcon(UploadedFile icon) {
		this.icon = icon;
	}

	/**
	 * @return the logon
	 */
	public LogonManagedImpl getLogon() {
		return logon;
	}

	/**
	 * @param logon the logon to set
	 */
	public void setLogon(LogonManagedImpl logon) {
		this.logon = logon;
	}

	/**
	 * @return the groupAppService
	 */
	public IGroupAppService getGroupAppService() {
		return groupAppService;
	}

	/**
	 * @param groupAppService the groupAppService to set
	 */
	public void setGroupAppService(IGroupAppService groupAppService) {
		this.groupAppService = groupAppService;
	}

	/**
	 * @return the eventsService
	 */
	public IEventsService getEventsService() {
		return eventsService;
	}

	/**
	 * @param eventsService the eventsService to set
	 */
	public void setEventsService(IEventsService eventsService) {
		this.eventsService = eventsService;
	}

	/**
	 * @return the userService
	 */
	public IUserService getUserService() {
		return userService;
	}

	/**
	 * @param userService the userService to set
	 */
	public void setUserService(IUserService userService) {
		this.userService = userService;
	}

	/**
	 * @return the serverService
	 */
	public IServerService getServerService() {
		return serverService;
	}

	/**
	 * @param serverService the serverService to set
	 */
	public void setServerService(IServerService serverService) {
		this.serverService = serverService;
	}

	/**
	 * @return the tableAllEvents
	 */
	public List<EventsWEB> getTableAllEvents() {
		return tableAllEvents;
	}

	/**
	 * @param tableAllEvents the tableAllEvents to set
	 */
	public void setTableAllEvents(List<EventsWEB> tableAllEvents) {
		this.tableAllEvents = tableAllEvents;
	}

	/**
	 * @return the intPulsa
	 */
	public int getIntPulsa() {
		return intPulsa;
	}

	/**
	 * @param intPulsa the intPulsa to set
	 */
	public void setIntPulsa(int intPulsa) {
		this.intPulsa = intPulsa;
	}

	/**
	 * @return the tableGroupAppAct
	 */
	public List<GroupApp> getTableGroupAppAct() {
		return tableGroupAppAct;
	}

	/**
	 * @param tableGroupAppAct the tableGroupAppAct to set
	 */
	public void setTableGroupAppAct(List<GroupApp> tableGroupAppAct) {
		this.tableGroupAppAct = tableGroupAppAct;
	}

	/**
	 * @return the filteredtableGroupAppAct
	 */
	public List<GroupApp> getFilteredtableGroupAppAct() {
		return filteredtableGroupAppAct;
	}

	/**
	 * @param filteredtableGroupAppAct the filteredtableGroupAppAct to set
	 */
	public void setFilteredtableGroupAppAct(List<GroupApp> filteredtableGroupAppAct) {
		this.filteredtableGroupAppAct = filteredtableGroupAppAct;
	}

	/**
	 * @return the selectedGroupAppAct
	 */
	public GroupApp getSelectedGroupAppAct() {
		return selectedGroupAppAct;
	}

	/**
	 * @param selectedGroupAppAct the selectedGroupAppAct to set
	 */
	public void setSelectedGroupAppAct(GroupApp selectedGroupAppAct) {
		this.selectedGroupAppAct = selectedGroupAppAct;
	}

	/**
	 * @return the tableGroupAppDis
	 */
	public List<GroupApp> getTableGroupAppDis() {
		return tableGroupAppDis;
	}

	/**
	 * @param tableGroupAppDis the tableGroupAppDis to set
	 */
	public void setTableGroupAppDis(List<GroupApp> tableGroupAppDis) {
		this.tableGroupAppDis = tableGroupAppDis;
	}

	/**
	 * @return the filteredtableGroupAppDis
	 */
	public List<GroupApp> getFilteredtableGroupAppDis() {
		return filteredtableGroupAppDis;
	}

	/**
	 * @param filteredtableGroupAppDis the filteredtableGroupAppDis to set
	 */
	public void setFilteredtableGroupAppDis(List<GroupApp> filteredtableGroupAppDis) {
		this.filteredtableGroupAppDis = filteredtableGroupAppDis;
	}

	/**
	 * @return the selectedGroupAppDis
	 */
	public GroupApp getSelectedGroupAppDis() {
		return selectedGroupAppDis;
	}

	/**
	 * @param selectedGroupAppDis the selectedGroupAppDis to set
	 */
	public void setSelectedGroupAppDis(GroupApp selectedGroupAppDis) {
		this.selectedGroupAppDis = selectedGroupAppDis;
	}

	/**
	 * @return the tableServerAct
	 */
	public List<ServerWEB> getTableServerAct() {
		return tableServerAct;
	}

	/**
	 * @param tableServerAct the tableServerAct to set
	 */
	public void setTableServerAct(List<ServerWEB> tableServerAct) {
		this.tableServerAct = tableServerAct;
	}

	/**
	 * @return the filteredtableServerAct
	 */
	public List<ServerWEB> getFilteredtableServerAct() {
		return filteredtableServerAct;
	}

	/**
	 * @param filteredtableServerAct the filteredtableServerAct to set
	 */
	public void setFilteredtableServerAct(List<ServerWEB> filteredtableServerAct) {
		this.filteredtableServerAct = filteredtableServerAct;
	}

	/**
	 * @return the selectedServerAct
	 */
	public ServerWEB getSelectedServerAct() {
		return selectedServerAct;
	}

	/**
	 * @param selectedServerAct the selectedServerAct to set
	 */
	public void setSelectedServerAct(ServerWEB selectedServerAct) {
		this.selectedServerAct = selectedServerAct;
	}

	/**
	 * @return the tableServerDis
	 */
	public List<ServerWEB> getTableServerDis() {
		return tableServerDis;
	}

	/**
	 * @param tableServerDis the tableServerDis to set
	 */
	public void setTableServerDis(List<ServerWEB> tableServerDis) {
		this.tableServerDis = tableServerDis;
	}

	/**
	 * @return the filteredtableServerDis
	 */
	public List<ServerWEB> getFilteredtableServerDis() {
		return filteredtableServerDis;
	}

	/**
	 * @param filteredtableServerDis the filteredtableServerDis to set
	 */
	public void setFilteredtableServerDis(List<ServerWEB> filteredtableServerDis) {
		this.filteredtableServerDis = filteredtableServerDis;
	}

	/**
	 * @return the selectedServerDis
	 */
	public ServerWEB getSelectedServerDis() {
		return selectedServerDis;
	}

	/**
	 * @param selectedServerDis the selectedServerDis to set
	 */
	public void setSelectedServerDis(ServerWEB selectedServerDis) {
		this.selectedServerDis = selectedServerDis;
	}

	/**
	 * @return the tableUserAct
	 */
	public List<User> getTableUserAct() {
		return tableUserAct;
	}

	/**
	 * @param tableUserAct the tableUserAct to set
	 */
	public void setTableUserAct(List<User> tableUserAct) {
		this.tableUserAct = tableUserAct;
	}

	/**
	 * @return the filteredtableUserAct
	 */
	public List<User> getFilteredtableUserAct() {
		return filteredtableUserAct;
	}

	/**
	 * @param filteredtableUserAct the filteredtableUserAct to set
	 */
	public void setFilteredtableUserAct(List<User> filteredtableUserAct) {
		this.filteredtableUserAct = filteredtableUserAct;
	}

	/**
	 * @return the selectedUserAct
	 */
	public User getSelectedUserAct() {
		return selectedUserAct;
	}

	/**
	 * @param selectedUserAct the selectedUserAct to set
	 */
	public void setSelectedUserAct(User selectedUserAct) {
		this.selectedUserAct = selectedUserAct;
	}

	/**
	 * @return the tableUserDis
	 */
	public List<User> getTableUserDis() {
		return tableUserDis;
	}

	/**
	 * @param tableUserDis the tableUserDis to set
	 */
	public void setTableUserDis(List<User> tableUserDis) {
		this.tableUserDis = tableUserDis;
	}

	/**
	 * @return the filteredtableUserDis
	 */
	public List<User> getFilteredtableUserDis() {
		return filteredtableUserDis;
	}

	/**
	 * @param filteredtableUserDis the filteredtableUserDis to set
	 */
	public void setFilteredtableUserDis(List<User> filteredtableUserDis) {
		this.filteredtableUserDis = filteredtableUserDis;
	}

	/**
	 * @return the selectedUserDis
	 */
	public User getSelectedUserDis() {
		return selectedUserDis;
	}

	/**
	 * @param selectedUserDis the selectedUserDis to set
	 */
	public void setSelectedUserDis(User selectedUserDis) {
		this.selectedUserDis = selectedUserDis;
	}

	/**
	 * @return the tableUserAppAct
	 */
	public List<UserAppWEB> getTableUserAppAct() {
		return tableUserAppAct;
	}

	/**
	 * @param tableUserAppAct the tableUserAppAct to set
	 */
	public void setTableUserAppAct(List<UserAppWEB> tableUserAppAct) {
		this.tableUserAppAct = tableUserAppAct;
	}

	/**
	 * @return the filteredtableUserAppAct
	 */
	public List<UserAppWEB> getFilteredtableUserAppAct() {
		return filteredtableUserAppAct;
	}

	/**
	 * @param filteredtableUserAppAct the filteredtableUserAppAct to set
	 */
	public void setFilteredtableUserAppAct(List<UserAppWEB> filteredtableUserAppAct) {
		this.filteredtableUserAppAct = filteredtableUserAppAct;
	}

	/**
	 * @return the selectedUserAppAct
	 */
	public UserAppWEB getSelectedUserAppAct() {
		return selectedUserAppAct;
	}

	/**
	 * @param selectedUserAppAct the selectedUserAppAct to set
	 */
	public void setSelectedUserAppAct(UserAppWEB selectedUserAppAct) {
		this.selectedUserAppAct = selectedUserAppAct;
	}

	/**
	 * @return the selectedApplication
	 */
	public Applications getSelectedApplication() {
		return selectedApplication;
	}

	/**
	 * @param selectedApplication the selectedApplication to set
	 */
	public void setSelectedApplication(Applications selectedApplication) {
		this.selectedApplication = selectedApplication;
	}

	
}
