package com.librework.console.managed.impl;

import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.ViewScoped;


import com.librework.console.general.Constant;
import com.librework.console.managed.IEventsManaged;
import com.librework.console.model.Events;
import com.librework.console.model.User;
import com.librework.console.modelWEB.EventsWEB;
import com.librework.console.service.IEventsService;
import com.librework.console.service.IUserService;
import com.librework.console.utils.LanguageUtils;

@ManagedBean(name="eventsBean")
@ViewScoped
public class EventsManagedImpl implements IEventsManaged, Serializable {

	private static final long serialVersionUID = 1L;

	@ManagedProperty(value="#{EventsService}")
	private IEventsService eventsService;
	
	@ManagedProperty(value="#{UserService}")
	private IUserService userService;
	
	
	private List<EventsWEB> tableAllEvents;
	private int intPulsa;
	
	public EventsManagedImpl () {
		tableAllEvents = new ArrayList<EventsWEB>();
		intPulsa = 0;
	}
	
	@PostConstruct
	public void init() {
		try {
			setIntPulsa(1);
			getAllEvents();
		} catch (Exception e) {
			System.out.println(e.toString());
		}
	}
	@Override
	public void getAllEvents() {
		// TODO Auto-generated method stub
		//RequestContext context = RequestContext.getCurrentInstance();
		//GenericApplicationContext appContext = AppUtils.getContext();
		//appContext.refresh();
		//AppUtils.setApplicationContext(appContext);
		//System.out.println("getAllEvents");
		SimpleDateFormat sdf = new SimpleDateFormat(Constant.MASK_DATE_WEB);
		Date datTemporal = null;
		String strtypeEvent = null;
		String strtextEvent = null;
		String striconEvent = null;
		LanguageUtils lang = new LanguageUtils();
		List<Events> listEvents = getEventsService().getAllEvents(intPulsa);
		if (listEvents != null) {
			tableAllEvents = new ArrayList<EventsWEB>();
			for (int i=0; i < listEvents.size(); i++) {
				EventsWEB eventsWEB = new EventsWEB();
				datTemporal = listEvents.get(i).getEve_datetime();
				eventsWEB.setDateTime(sdf.format(datTemporal));
				switch(listEvents.get(i).getTypeEvent().getTev_id()) {
				case Constant.EVE_START_SESSION:
					striconEvent = Constant.EVE_ICON_USER_EVENT;
					strtypeEvent = lang.getMessage(Constant.EVE_TXT_STAR_SESSION);
					strtextEvent = lang.getMessage(Constant.I18N_EVE_TXT_USER) + " " +
							       listEvents.get(i).getEve_adic_data_1() + " " +
							       lang.getMessage(Constant.I18N_EVE_TXT_STARTED_SESSION);
					break;
				case Constant.EVE_END_SESSION:
					striconEvent = Constant.EVE_ICON_USER_EVENT;
					strtypeEvent = lang.getMessage(Constant.EVE_TXT_END_SESSION);
					strtextEvent = lang.getMessage(Constant.I18N_EVE_TXT_USER) + " " +
							       listEvents.get(i).getEve_adic_data_1() + " " +
							       lang.getMessage(Constant.I18N_EVE_TXT_ENDED_SESSION);
					break;
				case Constant.EVE_STAR_APPLICATION:
					striconEvent = Constant.EVE_ICON_APP_EVENT;
					strtypeEvent = lang.getMessage(Constant.EVE_TXT_STAR_APPLICATION);
					strtextEvent = lang.getMessage(Constant.I18N_EVE_TXT_USER) + " " +
							       listEvents.get(i).getEve_adic_data_1() + " " +
							       lang.getMessage(Constant.I18N_EVE_TXT_STARTED_APPLICATION) + " " +
							       listEvents.get(i).getEve_adic_data_2() + " " +
							       lang.getMessage(Constant.I18N_EVE_TXT_SERVER) + " " +
							       listEvents.get(i).getEve_adic_data_3();
					break;
				case Constant.EVE_END_APPLICATION:
					striconEvent = Constant.EVE_ICON_APP_EVENT;
					strtypeEvent = lang.getMessage(Constant.EVE_TXT_END_APPLICATION);
					strtextEvent = lang.getMessage(Constant.I18N_EVE_TXT_USER) + " " +
						       listEvents.get(i).getEve_adic_data_1() + " " +
						       lang.getMessage(Constant.I18N_EVE_TXT_ENDED_APPLICATION) + " " +
						       listEvents.get(i).getEve_adic_data_2() + " " +
						       lang.getMessage(Constant.I18N_EVE_TXT_SERVER) + " " +
						       listEvents.get(i).getEve_adic_data_3();
					break;
				}
				eventsWEB.setIconEvent(striconEvent);
				eventsWEB.setTypeEvent(strtypeEvent);
				eventsWEB.setTextEvent(strtextEvent);
				User user = getUserService().getUserId(listEvents.get(i).getEve_adic_data_1());
				eventsWEB.setUserName(user.getUse_name() + user.getUse_surname1());
				tableAllEvents.add(eventsWEB);
			}
		}
	}

	@Override
	public void getMoreEvents() {
		// TODO Auto-generated method stub
		setIntPulsa(this.intPulsa + 1);
		//System.out.println(this.intPulsa);
		getAllEvents();
	}
	
	
	
	
	
	
	
	/**
	 * @return the tableAllEvents
	 */
	public List<EventsWEB> getTableAllEvents() {
		return tableAllEvents;
	}

	/**
	 * @param tableAllEvents the tableAllEvents to set
	 */
	public void setTableAllEvents(List<EventsWEB> tableAllEvents) {
		this.tableAllEvents = tableAllEvents;
	}

	/**
	 * @return the eventsService
	 */
	public IEventsService getEventsService() {
		return eventsService;
	}

	/**
	 * @param eventsService the eventsService to set
	 */
	public void setEventsService(IEventsService eventsService) {
		this.eventsService = eventsService;
	}
	/**
	 * @return the userService
	 */
	public IUserService getUserService() {
		return userService;
	}
	/**
	 * @param userService the userService to set
	 */
	public void setUserService(IUserService userService) {
		this.userService = userService;
	}
	/**
	 * @return the intPulsa
	 */
	public int getIntPulsa() {
		return intPulsa;
	}
	/**
	 * @param intPulsa the intPulsa to set
	 */
	public void setIntPulsa(int intPulsa) {
		this.intPulsa = intPulsa;
	}
	
	
	

	
}
