package com.librework.console.managed.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.ViewScoped;
import javax.faces.context.FacesContext;

import org.primefaces.context.RequestContext;


import com.librework.console.general.Constant;
import com.librework.console.managed.IGroupAppManaged;
import com.librework.console.model.AppGroup;
import com.librework.console.model.Applications;
import com.librework.console.model.GroupApp;
import com.librework.console.service.IApplicationsService;
import com.librework.console.service.IGroupAppService;
import com.librework.console.utils.LanguageUtils;
import com.librework.console.utils.PropertiesUtils;


@ManagedBean(name="groupAppBean")
@ViewScoped
public class GroupAppManagedImpl implements IGroupAppManaged, Serializable {

	private static final long serialVersionUID = 1L;

	@ManagedProperty(value="#{GroupAppService}")
	private IGroupAppService groupAppService;
	
	@ManagedProperty(value="#{ApplicationsService}")
	private IApplicationsService appService;
	
	@ManagedProperty(value="#{logon}")
	private LogonManagedImpl logon;
	
	private List<GroupApp> tableGroupApp;
	private List<GroupApp> filteredtableGroupApp;
	private GroupApp selectedGroupApp;
	
	private long gap_id;
	private String gap_description;
	private boolean groupCreated;
	private List<Applications> tableAppGroup;
	private List<Applications> filteredtableAppGroup;
	
	public GroupAppManagedImpl() {
		tableGroupApp = new ArrayList<GroupApp>();
		filteredtableGroupApp = new ArrayList<GroupApp>();
		selectedGroupApp = new GroupApp();
		gap_id = 0;
		gap_description = "";
		groupCreated = false;
		tableAppGroup = new ArrayList<Applications>();
		filteredtableAppGroup = new ArrayList<Applications>();
	}
	
	@PostConstruct
	public void init() {
		try {
			getGroupApp();
		} catch (Exception e) {
			System.out.println("ERROR GROUPAPP:" + e.toString());
		}
	}
	@Override
	public void getGroupApp() {
		// TODO Auto-generated method stub
		//GenericApplicationContext appContext = AppUtils.getContext();
		//appContext.refresh();
		List<GroupApp> listGroupApp = getGroupAppService().getAllGroupApp();
		if (!listGroupApp.isEmpty()) {
			setTableGroupApp(listGroupApp);
		}
		
	}

	@Override
	public void createGroupApp() {
		// TODO Auto-generated method stub
		FacesMessage msg = null;
		LanguageUtils lang = new LanguageUtils();
		try {
			if (lfCheckData()) {
				PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
				GroupApp groupApp = new GroupApp();
				groupApp.setGap_description(gap_description);
				groupApp.setGap_datmod(new Date());
				groupApp.setGap_usemod(logon.getUserId());
				getGroupAppService().createGroupApp(groupApp);
				groupCreated = true;
				getGroupApp();
				msg = new FacesMessage(FacesMessage.SEVERITY_INFO, lang.getMessage("gen_correct"),
						lang.getMessage("gen_save_ok"));
				FacesContext.getCurrentInstance().addMessage(null, msg);
				RequestContext.getCurrentInstance().execute(Constant.WEB_CLOSE_MSG_NEWGROUPAPP);
			} 
		} catch (Exception e) {
			msg = new FacesMessage(FacesMessage.SEVERITY_FATAL, lang.getMessage("gen_error"),
					lang.getMessage("gen_save_ko"));
			FacesContext.getCurrentInstance().addMessage(null, msg);
		}
		
	}
	
	@Override
	public void dialogNewGroupApp() {
		// TODO Auto-generated method stub
		gap_id = 0;
		gap_description = "";
		groupCreated = false;
		PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
		RequestContext.getCurrentInstance().execute(Constant.WEB_MSG_NEWGROUPAPP);
	}
	
	@Override
	public void getAppGroup() {
		// TODO Auto-generated method stub
		List<Applications> lstTemp = new ArrayList<Applications>();
		if (selectedGroupApp.getGap_id() != 0) {
			List<AppGroup> appGroups = getGroupAppService().getAllApplications(selectedGroupApp);
			if (appGroups != null) {
				for (int i=0; i < appGroups.size(); i++) {
					lstTemp.add(appGroups.get(i).getAppGroupPK().getApp());
					
				}
				setTableAppGroup(lstTemp);
			}
			setTableAppGroup(lstTemp);
		} 
		
	}

	private boolean lfCheckData() {
		boolean blnCorrect = true;
		FacesMessage msg = null;
		LanguageUtils lang = new LanguageUtils();
		if (getGap_description().equals("")) {
			msg = new FacesMessage(FacesMessage.SEVERITY_INFO, lang.getMessage("gen_description"),
					lang.getMessage("gen_requiered"));
		}
		return blnCorrect;
	}
	
	
	
	
	
	
	
	/** Getter and setter **/
	/**
	 * @return the groupAppService
	 */
	public IGroupAppService getGroupAppService() {
		return groupAppService;
	}

	/**
	 * @param groupAppService the groupAppService to set
	 */
	public void setGroupAppService(IGroupAppService groupAppService) {
		this.groupAppService = groupAppService;
	}

	/**
	 * @return the tableGroupApp
	 */
	public List<GroupApp> getTableGroupApp() {
		return tableGroupApp;
	}

	/**
	 * @param tableGroupApp the tableGroupApp to set
	 */
	public void setTableGroupApp(List<GroupApp> tableGroupApp) {
		this.tableGroupApp = tableGroupApp;
	}

	/**
	 * @return the filteredtableGroupApp
	 */
	public List<GroupApp> getFilteredtableGroupApp() {
		return filteredtableGroupApp;
	}

	/**
	 * @param filteredtableGroupApp the filteredtableGroupApp to set
	 */
	public void setFilteredtableGroupApp(List<GroupApp> filteredtableGroupApp) {
		this.filteredtableGroupApp = filteredtableGroupApp;
	}

	/**
	 * @return the selectedGroupApp
	 */
	public GroupApp getSelectedGroupApp() {
		return selectedGroupApp;
	}

	/**
	 * @param selectedGroupApp the selectedGroupApp to set
	 */
	public void setSelectedGroupApp(GroupApp selectedGroupApp) {
		this.selectedGroupApp = selectedGroupApp;
		getAppGroup();
	}

	/**
	 * @return the gap_id
	 */
	public long getGap_id() {
		return gap_id;
	}

	/**
	 * @param gap_id the gap_id to set
	 */
	public void setGap_id(long gap_id) {
		this.gap_id = gap_id;
	}

	/**
	 * @return the gap_description
	 */
	public String getGap_description() {
		return gap_description;
	}

	/**
	 * @param gap_description the gap_description to set
	 */
	public void setGap_description(String gap_description) {
		this.gap_description = gap_description;
	}

	/**
	 * @return the groupCreated
	 */
	public boolean isGroupCreated() {
		return groupCreated;
	}

	/**
	 * @param groupCreated the groupCreated to set
	 */
	public void setGroupCreated(boolean groupCreated) {
		this.groupCreated = groupCreated;
	}

	/**
	 * @return the tableAppGroup
	 */
	public List<Applications> getTableAppGroup() {
		return tableAppGroup;
	}

	/**
	 * @param tableAppGroup the tableAppGroup to set
	 */
	public void setTableAppGroup(List<Applications> tableAppGroup) {
		this.tableAppGroup = tableAppGroup;
	}

	/**
	 * @return the filteredtableAppGroup
	 */
	public List<Applications> getFilteredtableAppGroup() {
		return filteredtableAppGroup;
	}

	/**
	 * @param filteredtableAppGroup the filteredtableAppGroup to set
	 */
	public void setFilteredtableAppGroup(List<Applications> filteredtableAppGroup) {
		this.filteredtableAppGroup = filteredtableAppGroup;
	}

	/**
	 * @return the appService
	 */
	public IApplicationsService getAppService() {
		return appService;
	}

	/**
	 * @param appService the appService to set
	 */
	public void setAppService(IApplicationsService appService) {
		this.appService = appService;
	}

	/**
	 * @return the logon
	 */
	public LogonManagedImpl getLogon() {
		return logon;
	}

	/**
	 * @param logon the logon to set
	 */
	public void setLogon(LogonManagedImpl logon) {
		this.logon = logon;
	}
	
	
}
