package com.librework.console.managed.impl;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.ViewScoped;
import javax.faces.context.FacesContext;

import org.primefaces.context.RequestContext;
import org.springframework.beans.factory.BeanFactory;
import org.springframework.beans.factory.xml.XmlBeanFactory;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.Resource;


import com.librework.console.daoLDAP.IGroupLDAPDao;
import com.librework.console.general.Constant;
import com.librework.console.managed.IGroupUserManaged;
import com.librework.console.model.AppGroup;
import com.librework.console.model.Applications;
import com.librework.console.model.GroupUser;
import com.librework.console.model.GroupUserApp;
import com.librework.console.model.User;
import com.librework.console.model.UserGroup;
import com.librework.console.modelLDAP.GroupUserLDAP;
import com.librework.console.service.IGroupUserService;
import com.librework.console.service.IUserService;
import com.librework.console.utils.LanguageUtils;
import com.librework.console.utils.PropertiesUtils;


@ManagedBean(name="groupUserBean")
@ViewScoped
public class GroupUserManagedImpl implements IGroupUserManaged, Serializable {

	private static final long serialVersionUID = 1L;
	
	@ManagedProperty(value="#{GroupUserService}")
	private IGroupUserService groupUserService;
	
	@ManagedProperty(value="#{UserService}")
	private IUserService userService;
	
	@ManagedProperty(value="#{logon}")
	private LogonManagedImpl logon;
	
	private List<GroupUser> tableGroupUser;
	private List<GroupUser> filteredtableGroupUser;
	private GroupUser selectedGroupUser;
	//Datos grupo
	private String gus_id;
	private String gus_cn;
	private String gus_name;
	private String gus_description;
	private boolean groupCreated;
	//Usuarios del grupo
	private List<User> tableUserGroup;
	private List<User> filteredtableUserGroup;
	//Applicaciones del grupo 
	private List<Applications> tableAppGroup;
	private List<Applications> filteredtableAppGroup;
	
	
	public GroupUserManagedImpl () {
		tableGroupUser = new ArrayList<GroupUser>();
		filteredtableGroupUser = new ArrayList<GroupUser>();
		selectedGroupUser = new GroupUser();
		tableUserGroup = new ArrayList<User>();
		tableAppGroup = new ArrayList<Applications>();
		filteredtableUserGroup = new ArrayList<User>();
		filteredtableAppGroup = new ArrayList<Applications>();
		gus_id = "";
		gus_cn = "";
		gus_name = "";
		gus_description = "";
		groupCreated = false;
	}
	
	@PostConstruct
	public void init() {
		try {
			getGroupUser();
		} catch (Exception e) {
			System.out.println(e.toString());
		}
	}

	@Override
	public void getGroupUser() {
		// TODO Auto-generated method stub
		//GenericApplicationContext appContext = AppUtils.getContext();
		//appContext.refresh();
		List<GroupUser> listGroupUser = getGroupUserService().getAllGroupUser();
		if (!listGroupUser.isEmpty()) {
			setTableGroupUser(listGroupUser);
		}
	}
	
	@Override
	public void dialogNewGroupUser() {
		gus_id = "";
		gus_cn = "";
		gus_name = "";
		gus_description = "";
		groupCreated = false;
		PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
		RequestContext.getCurrentInstance().execute(Constant.WEB_MSG_NEWGROUPUSER);
				
	}
	
	@Override
	public void createGroupUser() {
		FacesMessage msg = null;
		LanguageUtils lang = new LanguageUtils();
		try {
			if (lfCheckData()) {
				PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
				GroupUser groupUser = new GroupUser();
				groupUser.setGus_cn(gus_cn);
				groupUser.setGus_name(gus_name);
				groupUser.setGus_description(gus_description);
				groupUser.setGus_datmod(new Date());
				groupUser.setGus_usemod(logon.getUserId());
				getGroupUserService().createGroupUser(groupUser);
				//Reply to LDAP SAMBA
				if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
					Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
					BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
					IGroupLDAPDao groupUserLDAP = (IGroupLDAPDao)factorySAMBA.getBean(Constant.BEAN_GROUPDAO);
					GroupUserLDAP groupLDAP = groupUserLDAP.getGroupCn(groupUser.getGus_cn());
					if (groupLDAP == null) {
						groupLDAP = new GroupUserLDAP();
						groupLDAP.setCn(groupUser.getGus_cn());
						groupLDAP.setName(groupUser.getGus_name());
						groupLDAP.setDescription(groupUser.getGus_description());
						groupUserLDAP.createGroup(groupLDAP);
					}
				}
				groupCreated = true;
				getGroupUser();
				msg = new FacesMessage(FacesMessage.SEVERITY_INFO,lang.getMessage("gen_correct"),
						lang.getMessage("gen_save_ok"));
				FacesContext.getCurrentInstance().addMessage(null, msg);
				RequestContext.getCurrentInstance().execute(Constant.WEB_CLOSE_MSG_NEWGROUPUSER);
			} 
		} catch (Exception e) {
			msg = new FacesMessage(FacesMessage.SEVERITY_FATAL, lang.getMessage("gen_error"),
					lang.getMessage("gen_save_ko"));
			FacesContext.getCurrentInstance().addMessage(null, msg);
		}
		
	}
	
	private boolean lfCheckData() {
		boolean blnCorrect = true;
		FacesMessage msg = null;
		LanguageUtils lang = new LanguageUtils();
		if (getGus_cn().equals("")) {
			msg = new FacesMessage(FacesMessage.SEVERITY_INFO,lang.getMessage("gen_id"),
					lang.getMessage("gen_requiered"));
			FacesContext.getCurrentInstance().addMessage(null, msg);
			blnCorrect = false;
		}
		if (getGus_name().equals("")) {
			msg = new FacesMessage(FacesMessage.SEVERITY_INFO,lang.getMessage("gen_name"),
					lang.getMessage("gen_requiered"));
			FacesContext.getCurrentInstance().addMessage(null, msg);
			blnCorrect = false;
		}
		if (getGus_description().equals("")) {
			msg = new FacesMessage(FacesMessage.SEVERITY_INFO,lang.getMessage("gen_description"),
					lang.getMessage("gen_requiered"));
			FacesContext.getCurrentInstance().addMessage(null, msg);
			blnCorrect = false;
		}
		if (! getGus_cn().equals("")) {
			GroupUser groupUser = getGroupUserService().getGroupUserCn(getGus_cn());
			if (groupUser != null) {
				msg = new FacesMessage(FacesMessage.SEVERITY_WARN,lang.getMessage("gen_error"),
						lang.getMessage("gus_group_exis"));
				FacesContext.getCurrentInstance().addMessage(null, msg);
				blnCorrect = false;
			}
		}
		return blnCorrect;
	}
	
	@Override
	public void getUserGroup() {
		List<User> lstTemp = new ArrayList<User>();
		if (selectedGroupUser.getGus_cn() != null) {
			List<UserGroup> userGroups = getGroupUserService().getAllUser(selectedGroupUser);
			
			if (userGroups != null) {
				for (int i=0; i < userGroups.size(); i++) {
					lstTemp.add(userGroups.get(i).getUserGroupPK().getUser());
				}
				setTableUserGroup(lstTemp);
			}
			setTableUserGroup(lstTemp);
		}
	}
	
	@Override
	public void getAppGroup() {
		List<Applications> lstTemp = new ArrayList<Applications>();
		if (selectedGroupUser.getGus_cn() != null) {
			List<GroupUserApp> appGroups = getGroupUserService().getAllApplications(selectedGroupUser);
			
			if (appGroups != null) {
				for (int i=0; i < appGroups.size(); i++) {
					lstTemp.add(appGroups.get(i).getGroupUserAppPK().getApplications());
				}
			}
			setTableAppGroup(lstTemp);
		}
	}
	
	
	
	
	//** Getters and setters **//
	/**
	 * @return the groupUserService
	 */
	public IGroupUserService getGroupUserService() {
		return groupUserService;
	}



	/**
	 * @param groupUserService the groupUserService to set
	 */
	public void setGroupUserService(IGroupUserService groupUserService) {
		this.groupUserService = groupUserService;
	}



	/**
	 * @return the tableGroupUser
	 */
	public List<GroupUser> getTableGroupUser() {
		return tableGroupUser;
	}



	/**
	 * @param tableGroupUser the tableGroupUser to set
	 */
	public void setTableGroupUser(List<GroupUser> tableGroupUser) {
		this.tableGroupUser = tableGroupUser;
	}



	/**
	 * @return the filteredtableGroupUser
	 */
	public List<GroupUser> getFilteredtableGroupUser() {
		return filteredtableGroupUser;
	}



	/**
	 * @param filteredtableGroupUser the filteredtableGroupUser to set
	 */
	public void setFilteredtableGroupUser(List<GroupUser> filteredtableGroupUser) {
		this.filteredtableGroupUser = filteredtableGroupUser;
	}



	/**
	 * @return the selectedGroupUser
	 */
	public GroupUser getSelectedGroupUser() {
		return selectedGroupUser;
	}



	/**
	 * @param selectedGroupUser the selectedGroupUser to set
	 */
	public void setSelectedGroupUser(GroupUser selectedGroupUser) {
		this.selectedGroupUser = selectedGroupUser;
		getUserGroup();
		getAppGroup();
	}

	/**
	 * @return the gus_id
	 */
	public String getGus_id() {
		return gus_id;
	}

	/**
	 * @param gus_id the gus_id to set
	 */
	public void setGus_id(String gus_id) {
		this.gus_id = gus_id;
	}

	/**
	 * @return the gus_cn
	 */
	public String getGus_cn() {
		return gus_cn;
	}

	/**
	 * @param gus_cn the gus_cn to set
	 */
	public void setGus_cn(String gus_cn) {
		this.gus_cn = gus_cn;
	}

	/**
	 * @return the gus_name
	 */
	public String getGus_name() {
		return gus_name;
	}

	/**
	 * @param gus_name the gus_name to set
	 */
	public void setGus_name(String gus_name) {
		this.gus_name = gus_name;
	}

	/**
	 * @return the gus_description
	 */
	public String getGus_description() {
		return gus_description;
	}

	/**
	 * @param gus_description the gus_description to set
	 */
	public void setGus_description(String gus_description) {
		this.gus_description = gus_description;
	}

	/**
	 * @return the groupCreated
	 */
	public boolean isGroupCreated() {
		return groupCreated;
	}

	/**
	 * @param groupCreated the groupCreated to set
	 */
	public void setGroupCreated(boolean groupCreated) {
		this.groupCreated = groupCreated;
	}

	/**
	 * @return the logon
	 */
	public LogonManagedImpl getLogon() {
		return logon;
	}

	/**
	 * @param logon the logon to set
	 */
	public void setLogon(LogonManagedImpl logon) {
		this.logon = logon;
	}
	
	/**
	 * @return the userService
	 */
	public IUserService getUserService() {
		return userService;
	}

	/**
	 * @param userService the userService to set
	 */
	public void setUserService(IUserService userService) {
		this.userService = userService;
	}

	/**
	 * @return the tableUserGroup
	 */
	public List<User> getTableUserGroup() {
		return tableUserGroup;
	}

	/**
	 * @param tableUserGroup the tableUserGroup to set
	 */
	public void setTableUserGroup(List<User> tableUserGroup) {
		this.tableUserGroup = tableUserGroup;
	}

	/**
	 * @return the tableAppGroup
	 */
	public List<Applications> getTableAppGroup() {
		return tableAppGroup;
	}

	/**
	 * @param tableAppGroup the tableAppGroup to set
	 */
	public void setTableAppGroup(List<Applications> tableAppGroup) {
		this.tableAppGroup = tableAppGroup;
	}

	/**
	 * @return the filteredtableUserGroup
	 */
	public List<User> getFilteredtableUserGroup() {
		return filteredtableUserGroup;
	}

	/**
	 * @param filteredtableUserGroup the filteredtableUserGroup to set
	 */
	public void setFilteredtableUserGroup(List<User> filteredtableUserGroup) {
		this.filteredtableUserGroup = filteredtableUserGroup;
	}

	/**
	 * @return the filteredtableAppGroup
	 */
	public List<Applications> getFilteredtableAppGroup() {
		return filteredtableAppGroup;
	}

	/**
	 * @param filteredtableAppGroup the filteredtableAppGroup to set
	 */
	public void setFilteredtableAppGroup(List<Applications> filteredtableAppGroup) {
		this.filteredtableAppGroup = filteredtableAppGroup;
	}

	
	
}
