package com.librework.console.managed.impl;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.RequestScoped;
import javax.faces.context.FacesContext;
import javax.faces.event.PhaseId;

import org.primefaces.model.DefaultStreamedContent;
import org.primefaces.model.StreamedContent;

import com.librework.console.general.Constant;
import com.librework.console.model.Applications;
import com.librework.console.service.IApplicationsService;

@ManagedBean(name="imageBean")
@RequestScoped
public class ImageManagedImpl {

	@ManagedProperty(value="#{ApplicationsService}")
	private IApplicationsService appService;
	
	StreamedContent icoApp;

	/**
	 * @return the appService
	 */
	public IApplicationsService getAppService() {
		return appService;
	}

	/**
	 * @param appService the appService to set
	 */
	public void setAppService(IApplicationsService appService) {
		this.appService = appService;
	}

	/**
	 * @return the icoApp
	 */
	public StreamedContent getIcoApp() {
		FacesContext context = FacesContext.getCurrentInstance();
		String path = context.getExternalContext().getRealPath(Constant.WEB_PATH_RESOURCES);
		String fileName = path + File.separator + Constant.WEB_IMA_NOIMAGE;
		try {
			
		
		if (context.getCurrentPhaseId() == PhaseId.RENDER_RESPONSE) {
            // So, we're rendering the HTML. Return a stub StreamedContent so that it will generate right URL.
        	InputStream inputStream = new FileInputStream(fileName);
        	return new DefaultStreamedContent(inputStream, Constant.WEB_TYPE_IMAGE);
        }
        	else {
            // So, browser is requesting the image. Return a real StreamedContent with the image bytes.
	        String appId = context.getExternalContext().getRequestParameterMap().get("icon_id");
	        //System.out.println(appId);
	        if (appId == null) {
	        	InputStream inputStream = new FileInputStream(fileName);
	        	return new DefaultStreamedContent(inputStream, Constant.WEB_TYPE_IMAGE);
	        } else {
	            Applications app = getAppService().getApplicationsId(Long.valueOf(appId));
	            if (app.getApp_icon() == null) {
	            	
	            	InputStream inputStream = new FileInputStream(fileName);
		        	return new DefaultStreamedContent(inputStream, Constant.WEB_TYPE_IMAGE);
	            } else {
	            	return new DefaultStreamedContent(new ByteArrayInputStream(app.getApp_icon()), Constant.WEB_TYPE_IMAGE);
	            }
	        }
        }
		} catch (Exception e) {
			System.out.println(e.toString());
			return null;
		}
	}

	/**
	 * @param icoApp the icoApp to set
	 */
	public void setIcoApp(StreamedContent icoApp) {
		this.icoApp = icoApp;
	}
	
	
}
