package com.librework.console.managed.impl;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.SessionScoped;
import javax.faces.context.FacesContext;
import javax.servlet.http.HttpSession;

import org.primefaces.context.RequestContext;
import org.springframework.beans.factory.BeanFactory;
import org.springframework.beans.factory.xml.XmlBeanFactory;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.Resource;

import com.librework.console.bean.ILogonBean;
import com.librework.console.daoLDAP.IGroupLDAPDao;
import com.librework.console.daoLDAP.IUserGroupLDAPDao;
import com.librework.console.daoLDAP.IUserLDAPDao;
import com.librework.console.general.Constant;
import com.librework.console.managed.ILogonManaged;
import com.librework.console.model.GroupUser;
import com.librework.console.model.User;
import com.librework.console.model.UserGroup;
import com.librework.console.modelLDAP.GroupUserLDAP;
import com.librework.console.modelLDAP.UserGroupLDAP;
import com.librework.console.modelLDAP.UserLDAP;
import com.librework.console.service.IGroupUserService;
import com.librework.console.service.IUserService;
import com.librework.console.utils.LanguageUtils;
import com.librework.console.utils.PropertiesUtils;

@ManagedBean(name="logon")
@SessionScoped
public class LogonManagedImpl implements ILogonManaged, Serializable {

	private static final long serialVersionUID = 1L;
	
	private String userId;
	private String password;
	private String username;
	private boolean loggedIn;
	
	
	@ManagedProperty(value = "#{logonBean}")
	private ILogonBean logonBean;
	
	@ManagedProperty(value="#{UserService}")
	private IUserService userService;
	
	@ManagedProperty(value="#{GroupUserService}")
	private IGroupUserService groupUserService;
	
	public LogonManagedImpl() {
		userId = "";
		password = "";
		username="";
		loggedIn=false;
	}
	
	@Override
	@PostConstruct
	public void initialize() {
		// TODO Auto-generated method stub
		//System.out.println("PostConstruct LoginBean. Valor password " + password);
	}

	@Override
	public void doLogin() {
		// TODO Auto-generated method stub
		IUserLDAPDao userLdapDao = null;
		User user = null;
		GroupUserLDAP groupUserLDAP = null;
		GroupUser groupUser = null;
		Resource resource = null;
		BeanFactory factory = null;
		Boolean exisGroup = false;
		Boolean log = false;
		Boolean group = false;
		String strRespuesta = "";
		RequestContext context = RequestContext.getCurrentInstance();
		FacesMessage msg = null;
		LanguageUtils lang = new LanguageUtils();
		try {
			
			System.out.println(userId + ":" + password);
			System.out.println("PRUEBA");
			//Comprobamos si el habilitado LDAP SAMBA or client LDAP
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_AUTHENTICATION).equals(Constant.CONS_LOCAL)) {
				//Forma antigua de conectar a LDAP
				//GenericApplicationContext appContext = AppUtils.getContext();
				//appContext.refresh();
				//AppUtils.setApplicationContext(appContext);
				//Forma nueva de conectar a LDAP para poder usar cliente y samba
				resource = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				factory = new XmlBeanFactory(resource);
				userLdapDao = (IUserLDAPDao)factory.getBean(Constant.BEAN_USERDAO);
				log = userLdapDao.authenticate(userId, password);
			} else if (props.getProperty(Constant.LOAD_AUTHENTICATION).equals(Constant.CONS_CLIENT)) {
				resource = new ClassPathResource(Constant.CONFIG_FILE_LDAP_CLIENT);
				factory = new XmlBeanFactory(resource);
				userLdapDao = (IUserLDAPDao)factory.getBean(Constant.BEAN_USERDAO);
				log = userLdapDao.authenticate(userId, password);
			} else {
				log = getUserService().authenticateUser(userId, password);
			}
			if (log) {
				//Get groups of the user
				//Si es autentificacin por LDAP comprobamos que es del grupo de administradores
				//y replicamos datos en mySql si no existe se crea y si existe se modifica
				if (props.getProperty(Constant.LOAD_AUTHENTICATION).equals(Constant.CONS_LOCAL) ||
						props.getProperty(Constant.LOAD_AUTHENTICATION).equals(Constant.CONS_CLIENT)) {
					//Get groups of the user
					IUserGroupLDAPDao userGroupLdapDao = (IUserGroupLDAPDao)factory.getBean(Constant.BEAN_USERGROUPDAO);
					List resultUG = userGroupLdapDao.getUserGroupByUser(userId);
					for (int i=0; i< resultUG.size(); i++){
						UserGroupLDAP resulGroups = (UserGroupLDAP) resultUG.get(i);
						String[] groups = resulGroups.getUsersGroup();
						if (groups != null) {
							for (int g=0; g < groups.length; g++) {
								//System.out.println(groups[g]);
								if (groups[g].indexOf(Constant.CONS_ADMIN) > -1 && !group) {
									//If user is administrator get all data of the group user
									group = true;
									IGroupLDAPDao groupUserLdapDao = (IGroupLDAPDao)factory.getBean(Constant.BEAN_GROUPDAO);
									groupUserLDAP = groupUserLdapDao.getGroupDistinguishedName(groups[g]);
								}
							}
						}
					}
					// If is Administrator
					if (group) {
						//Get all data of user
						UserLDAP userLDAP = userLdapDao.getUserCn(userId);
						//If the user exists in LDAP check there in BD
						user = getUserService().getUserId(userId);
						if (user == null) {
							//Create user
							user = new User();
							user.setUse_id(userLDAP.getCn());
							user.setUse_name(userLDAP.getName());
							user.setUse_surname1((userLDAP.getDisplayName() == null ? "" : userLDAP.getDisplayName()));
							user.setUse_direction(userLDAP.getRegisteredAddress());
							user.setUse_email(userLDAP.getMail());
							user.setUse_phone(userLDAP.getTelephoneNumber());
							user.setUse_password(Constant.CONS_PASSLDAP);
							user.setUse_start_last_connection(new Date());
							user.setUse_end_last_connection(new Date());
							user.setUse_datmod(new Date());
							user.setUse_usemod(userId);
							getUserService().createUser(user);
						} else {
							//Update user
							user.setUse_password(password);
							user.setUse_datmod(new Date());
							user.setUse_usemod(userId);
							getUserService().updateUser(user);
						}
						//Check group LDAP in BD
						groupUser = getGroupUserService().getGroupUserCn(groupUserLDAP.getCn());
						if (groupUser == null) {
							//Create groupUser
							groupUser = new GroupUser();
							groupUser.setGus_cn(groupUserLDAP.getCn());
							groupUser.setGus_description(groupUserLDAP.getDescription());
							groupUser.setGus_name(groupUserLDAP.getName());
							groupUser.setGus_datmod(new Date());
							groupUser.setGus_usemod(userId);
							getGroupUserService().createGroupUser(groupUser);
						}
						List<UserGroup> userGroup = getUserService().getAllGroupUser(user);
						for (int i=0; i<userGroup.size(); i++) {
							if (userGroup.get(i).getUserGroupPK()
									.getGroup().getGus_cn().equals(groupUserLDAP.getCn())) {
								exisGroup = true;
							}
						}
						if (!exisGroup) {
							getUserService().addGroupUser(user, groupUser);
						}
					}
				} else { 
					//Authetication for BD
					user = getUserService().getUserId(userId);
					List<UserGroup> userGroup = getUserService().getAllGroupUser(user);
					for (int i=0; i<userGroup.size(); i++) {
						System.out.println(userGroup.get(i).getUserGroupPK().getGroup().getGus_cn() + userGroup.get(i).getUserGroupPK().getGroup().getGus_cn().indexOf(Constant.CONS_ADMIN));
						if (userGroup.get(i).getUserGroupPK().getGroup().getGus_cn().indexOf(Constant.CONS_ADMIN) > -1) {
							group = true;
							groupUser = userGroup.get(i).getUserGroupPK().getGroup();
							
						}
					}
				}
				//If group administrator and authentication is BD or CLIENT and replyLDAP is true add/modify user in LDAP SAMBA
				if (group && props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)
						&& (props.getProperty(Constant.LOAD_AUTHENTICATION).equals(Constant.CONS_CLIENT) || Constant.LOAD_AUTHENTICATION.equals(Constant.CONS_DB))) {
					Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
					BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
					userLdapDao = (IUserLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERDAO);
					UserLDAP userLDAP = userLdapDao.getUserCn(user.getUse_id());
					if (userLDAP == null) {
						userLDAP = new UserLDAP();
						userLDAP.setCn(user.getUse_id());
						userLDAP.setSAMAccountName(user.getUse_id());
						userLDAP.setDescription(user.getUse_name() + " " +
								user.getUse_surname1() + " " +
								user.getUse_surname2());
						userLDAP.setName(user.getUse_name());
						userLDAP.setDisplayName(user.getUse_surname1());
						userLDAP.setRegisteredAddress((user.getUse_direction().equals("") ? Constant.STRING_SINESPECIFICAR : user.getUse_direction()));
						userLDAP.setMail(user.getUse_email());
						userLDAP.setTelephoneNumber((user.getUse_phone().equals("") ? Constant.NUMBER_CERO : user.getUse_phone()));
						userLDAP.setUnicodePwd(user.getUse_password());
						userLdapDao.createUser(userLDAP);
						userLdapDao.setPasswordUser(userLDAP);
					}
				}
			}
			if (log) {
				if (group) {
					setLoggedIn(true);
					strRespuesta = Constant.WEB_PAGE_HOME + Constant.WEB_FACES_REDIRECT;
					context.addCallbackParam(Constant.ARGS_LOGGEDIN, loggedIn);
					context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
					setUsername(user.getUse_name() + " " + user.getUse_surname1());
				} else {
					msg = new FacesMessage(FacesMessage.SEVERITY_ERROR,lang.getMessage("log_sinpermisos"),"");
					FacesContext.getCurrentInstance().addMessage(null, msg);
					strRespuesta = Constant.WEB_PAGE_LOGIN;
					context.addCallbackParam(Constant.ARGS_LOGGEDIN, loggedIn);
					context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
				}
				
			} else {
				msg = new FacesMessage(FacesMessage.SEVERITY_ERROR,lang.getMessage("log_error"),"");
				FacesContext.getCurrentInstance().addMessage(null, msg);
				strRespuesta = Constant.WEB_PAGE_LOGIN;
				context.addCallbackParam(Constant.ARGS_LOGGEDIN, loggedIn);
				context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
			}
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println("ERROR EN LOGIN");
    		msg = new FacesMessage(FacesMessage.SEVERITY_FATAL,lang.getMessage("log_fatal"),"");
    		FacesContext.getCurrentInstance().addMessage(null, msg);
    		log = false;
		}
		
		
	}

	@Override
	public void doLogout() {
		// TODO Auto-generated method stub
		String strRespuesta = "";
		FacesMessage msg = null; 
		LanguageUtils lang = new LanguageUtils();
		msg = new FacesMessage(FacesMessage.SEVERITY_INFO,lang.getMessage("log_logout"),"");
		FacesContext.getCurrentInstance().addMessage(null, msg);
		HttpSession session = (HttpSession) FacesContext.getCurrentInstance()
				.getExternalContext().getSession(false);
		session.removeAttribute("use_detId");
		session.removeAttribute("app_detId");
		session.removeAttribute("ser_detId");
		session.invalidate();
		setLoggedIn(false);
		RequestContext context = RequestContext.getCurrentInstance();
		strRespuesta = Constant.WEB_PAGE_LOGIN + Constant.WEB_FACES_REDIRECT;
		context.addCallbackParam(Constant.ARGS_CORRECT, true);
		context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
		
	}

	
	
	
	
	
	
	/* Getters and Setters */
	/**
	 * @return the userId
	 */
	public String getUserId() {
		return userId;
	}

	/**
	 * @param userId the userId to set
	 */
	public void setUserId(String userId) {
		this.userId = userId;
	}

	/**
	 * @return the password
	 */
	public String getPassword() {
		return password;
	}

	/**
	 * @param password the password to set
	 */
	public void setPassword(String password) {
		this.password = password;
	}

	/**
	 * @return the loggedIn
	 */
	public boolean isLoggedIn() {
		return loggedIn;
	}

	/**
	 * @param loggedIn the loggedIn to set
	 */
	public void setLoggedIn(boolean loggedIn) {
		this.loggedIn = loggedIn;
	}

	/**
	 * @return the logonBean
	 */
	public ILogonBean getLogonBean() {
		return logonBean;
	}

	/**
	 * @param logonBean the logonBean to set
	 */
	public void setLogonBean(ILogonBean logonBean) {
		this.logonBean = logonBean;
	}

	/**
	 * @return the username
	 */
	public String getUsername() {
		return username;
	}

	/**
	 * @param username the username to set
	 */
	public void setUsername(String username) {
		this.username = username;
	}

	/**
	 * @return the userService
	 */
	public IUserService getUserService() {
		return userService;
	}

	/**
	 * @param userService the userService to set
	 */
	public void setUserService(IUserService userService) {
		this.userService = userService;
	}

	/**
	 * @return the groupUserService
	 */
	public IGroupUserService getGroupUserService() {
		return groupUserService;
	}

	/**
	 * @param groupUserService the groupUserService to set
	 */
	public void setGroupUserService(IGroupUserService groupUserService) {
		this.groupUserService = groupUserService;
	}

	
}
