package com.librework.console.managed.impl;

import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.ViewScoped;

import org.primefaces.context.RequestContext;

import com.librework.console.general.Constant;
import com.librework.console.managed.INotificationManaged;
import com.librework.console.model.Notification;
import com.librework.console.modelWEB.NotificationWEB;
import com.librework.console.service.INotificationService;
import com.librework.console.utils.LanguageUtils;

@ManagedBean(name="notificationBean")
@ViewScoped
public class NotificationManagedImpl implements INotificationManaged, Serializable {

	private static final long serialVersionUID = 1L;
	
	@ManagedProperty(value="#{NotificationService}")
	private INotificationService notificationService;
	
	private int intPulsa;
	private List<NotificationWEB> tableAllNotification;
	
	public NotificationManagedImpl () {
		tableAllNotification = new ArrayList<NotificationWEB>();
	}
	@PostConstruct
	public void init() {
		try {
			System.err.println("CONSTURYE NOTIFICATIONBEAN");
			setIntPulsa(1);
			getAllNotification();
		} catch (Exception e) {
			System.out.println(e.toString());
		}
	}
	
	@Override
	public void getAllNotification() {
		// TODO Auto-generated method stub
		RequestContext context = RequestContext.getCurrentInstance();
		//GenericApplicationContext appContext = AppUtils.getContext();
		//appContext.refresh();
		//AppUtils.setApplicationContext(appContext);
		//System.out.println("getAllNotification" + intPulsa);
		SimpleDateFormat sdf = new SimpleDateFormat(Constant.MASK_DATE_WEB);
		Date datTemporal = null;
		String strtypeEvent = null;
		String strtextEvent = null;
		String striconEvent = null;
		LanguageUtils lang = new LanguageUtils();
		List<Notification> listNotification = getNotificationService().getAllNotification(intPulsa);
		if (listNotification!=null) {
			
			if (!listNotification.isEmpty()) {
				tableAllNotification = new ArrayList<NotificationWEB>();
				for (int i=0; i < listNotification.size(); i++) {
					NotificationWEB notificationWEB = new NotificationWEB();
					datTemporal = listNotification.get(i).getNot_datmod();
					notificationWEB.setDateTime(sdf.format(datTemporal));
					switch(listNotification.get(i).getTypeEvent().getTev_id()) {
					case Constant.NOT_INFORMATION:
						striconEvent = Constant.NOT_ICON_INFORMATION;
						strtypeEvent = lang.getMessage(Constant.NOT_TXT_INFORMATION);
						strtextEvent = lang.getMessage(listNotification.get(i).getNot_description()) + " --> " +
									   lang.getMessage(Constant.I18N_GEN_USER) + ": " + listNotification.get(i).getNot_adic_data1() + " - " +
									   lang.getMessage(Constant.I18N_GEN_SERVER) + ": " + listNotification.get(i).getNot_adic_data2() + " - " +
									   lang.getMessage(Constant.I18N_GEN_DISK) + ": " + listNotification.get(i).getNot_adic_data3() + " - " +
									   lang.getMessage(Constant.I18N_GEN_APPLICATION) + ": " + listNotification.get(i).getNot_adic_data4();
						break;
					case Constant.NOT_WARNING:
						striconEvent = Constant.NOT_ICON_WARNING;
						strtypeEvent = lang.getMessage(Constant.NOT_TXT_WARNING);
						strtextEvent = lang.getMessage(listNotification.get(i).getNot_description()) + " --> " +
									   lang.getMessage(Constant.I18N_GEN_USER) + ": " + listNotification.get(i).getNot_adic_data1() + " - " +
									   lang.getMessage(Constant.I18N_GEN_SERVER) + ": " + listNotification.get(i).getNot_adic_data2() + " - " +
									   lang.getMessage(Constant.I18N_GEN_DISK) + ": " + listNotification.get(i).getNot_adic_data3() + " - " +
									   lang.getMessage(Constant.I18N_GEN_APPLICATION) + ": " + listNotification.get(i).getNot_adic_data4();
						break;
					case Constant.NOT_CRITICAL:
						striconEvent = Constant.NOT_ICON_ERROR;
						strtypeEvent = lang.getMessage(Constant.NOT_TXT_ERROR);
						strtextEvent = lang.getMessage(listNotification.get(i).getNot_description()) + " --> " +
									   lang.getMessage(Constant.I18N_GEN_USER) + ": " + listNotification.get(i).getNot_adic_data1() + " - " +
									   lang.getMessage(Constant.I18N_GEN_SERVER) + ": " + listNotification.get(i).getNot_adic_data2() + " - " +
									   lang.getMessage(Constant.I18N_GEN_DISK) + ": " + listNotification.get(i).getNot_adic_data3() + " - " +
									   lang.getMessage(Constant.I18N_GEN_APPLICATION) + ": " + listNotification.get(i).getNot_adic_data4();
						break;
					
					}
					notificationWEB.setIconEvent(striconEvent);
					notificationWEB.setTypeEvent(strtypeEvent);
					notificationWEB.setTextEvent(strtextEvent);
					
					
					tableAllNotification.add(notificationWEB);
				}
			}
		}
	}


	/**
	 * @return the notificationService
	 */
	public INotificationService getNotificationService() {
		return notificationService;
	}


	/**
	 * @param notificationService the notificationService to set
	 */
	public void setNotificationService(INotificationService notificationService) {
		this.notificationService = notificationService;
	}


	/**
	 * @return the intPulsa
	 */
	public int getIntPulsa() {
		return intPulsa;
	}

	/**
	 * @param intPulsa the intPulsa to set
	 */
	public void setIntPulsa(int intPulsa) {
		this.intPulsa = intPulsa;
	}

	/**
	 * @return the tableAllNotification
	 */
	public List<NotificationWEB> getTableAllNotification() {
		return tableAllNotification;
	}


	/**
	 * @param tableAllNotification the tableAllNotification to set
	 */
	public void setTableAllNotification(List<NotificationWEB> tableAllNotification) {
		this.tableAllNotification = tableAllNotification;
	}

	@Override
	public void getMoreNotification() {
		// TODO Auto-generated method stub
		setIntPulsa(this.intPulsa + 1);
		//System.out.println(this.intPulsa);
		getAllNotification();
	}

}
