package com.librework.console.managed.impl;

import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.ViewScoped;
import javax.faces.context.FacesContext;
import javax.servlet.http.HttpSession;

import org.primefaces.context.RequestContext;
import org.primefaces.event.DragDropEvent;
import org.primefaces.model.chart.PieChartModel;
import org.springframework.beans.factory.BeanFactory;
import org.springframework.beans.factory.xml.XmlBeanFactory;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.Resource;

import com.librework.console.daoLDAP.IAppServerLDAPDao;
import com.librework.console.daoLDAP.IApplicationLDAPDao;
import com.librework.console.daoLDAP.IGroupLDAPDao;
import com.librework.console.daoLDAP.IServerGroupLDAPDao;
import com.librework.console.daoLDAP.IServerLDAPDao;
import com.librework.console.daoLDAP.IUserGroupLDAPDao;
import com.librework.console.daoLDAP.IUserLDAPDao;
import com.librework.console.general.Constant;
import com.librework.console.managed.IServerManaged;
import com.librework.console.model.AppGroup;
import com.librework.console.model.AppServer;
import com.librework.console.model.Applications;
import com.librework.console.model.Events;
import com.librework.console.model.GroupApp;
import com.librework.console.model.GroupServer;
import com.librework.console.model.Server;
import com.librework.console.model.ServerGroup;
import com.librework.console.model.SystemOperating;
import com.librework.console.model.User;
import com.librework.console.model.UserApp;
import com.librework.console.modelLDAP.AppServerLDAP;
import com.librework.console.modelLDAP.ApplicationLDAP;
import com.librework.console.modelLDAP.GroupUserLDAP;
import com.librework.console.modelLDAP.ServerGroupLDAP;
import com.librework.console.modelLDAP.ServerLDAP;
import com.librework.console.modelLDAP.UserGroupLDAP;
import com.librework.console.modelLDAP.UserLDAP;
import com.librework.console.modelWEB.AppWEB;
import com.librework.console.modelWEB.EventsWEB;
import com.librework.console.modelWEB.ServerWEB;
import com.librework.console.modelWEB.UserAppWEB;
import com.librework.console.service.IApplicationsService;
import com.librework.console.service.IEventsService;
import com.librework.console.service.IGroupServerService;
import com.librework.console.service.IServerService;
import com.librework.console.service.ISystemOperatingService;
import com.librework.console.service.IUserService;
import com.librework.console.utils.FacesUtils;
import com.librework.console.utils.LanguageUtils;
import com.librework.console.utils.PropertiesUtils;

@ManagedBean(name="serverBean")
@ViewScoped
public class ServerManagedImpl implements IServerManaged, Serializable {

	private static final long serialVersionUID = 1L;
	
	@ManagedProperty(value="#{logon}")
	private LogonManagedImpl logon;
	
	@ManagedProperty(value="#{ServerService}")
	private IServerService serverService;
	
	@ManagedProperty(value="#{SystemOperatingService}")
	private ISystemOperatingService syoService;
	
	@ManagedProperty(value="#{GroupServerService}")
	private IGroupServerService groupServerService;
	
	@ManagedProperty(value="#{ApplicationsService}")
	private IApplicationsService appService;
	
	@ManagedProperty(value="#{EventsService}")
	private IEventsService eventsService;
	
	@ManagedProperty(value="#{UserService}")
	private IUserService userService;
	
	//Servers
	private List<ServerWEB> tableServerMain = new ArrayList<ServerWEB>();
	private List<ServerWEB> filteredtableServerMain = new ArrayList<ServerWEB>();
	private ServerWEB selectedServer;
	private Server selectedSer;
	private List<SystemOperating> tableSyo;

	//GroupServers
	private List<GroupServer> tableGroupServerAct;
	private List<GroupServer> filteredtableGroupServerAct;
	private GroupServer selectedGroupServerAct;
	private List<GroupServer> tableGroupServerDis;
	private List<GroupServer> filteredtableGroupServerDis;
	private GroupServer selectedGroupServerDis;
	
	//Applications server
	private List<AppWEB> tableAppAct;
	private List<AppWEB> filteredtableAppAct;
	private AppWEB selectedAppAct;
	private List<AppWEB> tableAppDis;
	private List<AppWEB> filteredtableAppDis;
	private AppWEB selectedAppDis;
	
	//Events server
	private List<EventsWEB> tableAllEvents;
	private int intPulsa;
	
	//UsersApp active
	private List<UserAppWEB> tableUserAppAct;
	private List<UserAppWEB> filteredtableUserAppAct;
	private UserAppWEB selectedUserAppAct;
		
	//Server data
	private String ser_id;
	private String ser_description;
	private String ser_host;
	private SystemOperating syo;
	private long syo_id;
	private boolean serCreated;
	private String ser_detId;
	
	//Imagenes detalle
	private PieChartModel cpuServer;
	private PieChartModel memServer;
	
	//General
	private FacesUtils faces;
	
	public ServerManagedImpl() {
		tableServerMain = new ArrayList<ServerWEB>();
		filteredtableServerMain = new ArrayList<ServerWEB>();
		selectedServer = new ServerWEB();
		selectedSer = new Server();
		tableGroupServerAct = new ArrayList<GroupServer>();
		filteredtableGroupServerAct = new ArrayList<GroupServer>();
		selectedGroupServerAct = new GroupServer();
		tableGroupServerDis = new ArrayList<GroupServer>();
		filteredtableGroupServerDis = new ArrayList<GroupServer>();
		selectedGroupServerDis = new GroupServer();
		tableAppAct = new ArrayList<AppWEB>();
		filteredtableAppAct = new ArrayList<AppWEB>();
		selectedAppAct = new AppWEB();
		tableAppDis = new ArrayList<AppWEB>();
		filteredtableAppDis = new ArrayList<AppWEB>();
		selectedAppDis = new AppWEB();
		tableAllEvents = new ArrayList<EventsWEB>();
		intPulsa = 1;
		ser_id = "";
		ser_description = "";
		ser_host = "";
		syo = new SystemOperating();
		syo_id = 0;
		serCreated = false;
		ser_detId = "";
		faces = new FacesUtils();
		getImaServer();
		
	}
	@PostConstruct
	public void init() {
		try {
			getServerMain();
			getAllSyo();
			HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);   
			ser_detId = (String) session.getAttribute("ser_detId");
			session.removeAttribute("use_detId");
			session.removeAttribute("app_detId");
			if (ser_detId != null) {
				selectedSer = getServerService().getServerId(ser_detId);
				float fCalculo;
				int iPorcentaje;
				ServerWEB serverWeb = new ServerWEB();
				serverWeb.setSer_id(selectedSer.getSer_id());
				serverWeb.setSer_host(selectedSer.getSer_host());
				serverWeb.setSer_description(selectedSer.getSer_description());
				serverWeb.setSer_syo(selectedSer.getFk_ser_syo_id().getSyo_description());
				serverWeb.setSer_memtot(Float.toString(selectedSer.getSer_mentot()));
				serverWeb.setSer_memuse(Float.toString(selectedSer.getSer_menuse()));
				fCalculo = selectedSer.getSer_menuse() * 100 / selectedSer.getSer_mentot();
				iPorcentaje = Math.round(fCalculo);
				serverWeb.setSer_pormemory(Integer.toString(iPorcentaje));
				iPorcentaje = Math.round(selectedSer.getSer_cpuuse());
				serverWeb.setSer_cpuuse(Integer.toString(iPorcentaje));
				serverWeb.setSer_porcpu(Integer.toString(iPorcentaje));
				iPorcentaje = Math.round(selectedSer.getSer_reduse());
				serverWeb.setSer_reduse(Integer.toString(iPorcentaje));
				serverWeb.setSer_porred(Integer.toString(iPorcentaje));
				selectedServer = serverWeb;
				getAllServerEvents();
				getTableGroup();
				getTableApp();
				getActiveUserApp();
				getImaServer();
			}
		} catch (Exception e) {
			System.out.println("SERVERBEAN:" + e.toString());
		}
	}
	
	@Override
	public void getImaServer() {
		float fltResta;
		float fltMemLib;
		LanguageUtils lang = new LanguageUtils();
		cpuServer  = new PieChartModel();
		memServer = new PieChartModel();
		if (selectedServer.getSer_cpuuse() != null) {
			fltResta = 100 - Float.valueOf(selectedServer.getSer_cpuuse());
			
			cpuServer.set(lang.getMessage("ser_porocu"), Float.valueOf(selectedServer.getSer_cpuuse()));
			cpuServer.set(lang.getMessage("ser_porlib"), fltResta);
			fltMemLib = 100 - Float.valueOf(selectedServer.getSer_pormemory());
			
			memServer.set(lang.getMessage("ser_memocu"), Float.valueOf(selectedServer.getSer_pormemory()));
			memServer.set(lang.getMessage("ser_memlib"), fltMemLib);
		}
	}
	
	@Override
	public void getServerMain() {
		// TODO Auto-generated method stub
		float fCalculo;
		int iPorcentaje;
		List<ServerWEB> listServerWeb = new ArrayList<ServerWEB>();
		//GenericApplicationContext appContext = AppUtils.getContext();
		//appContext.refresh();
		//AppUtils.setApplicationContext(appContext);
		List<Server> listServer = getServerService().getAllServer();
		if (listServer != null) {
			if (!listServer.isEmpty()) {
				for (int i = 0; i < listServer.size(); i++) {
					ServerWEB serverWeb = new ServerWEB();
					serverWeb.setSer_id(listServer.get(i).getSer_id());
					serverWeb.setSer_host(listServer.get(i).getSer_host());
					serverWeb.setSer_syo(listServer.get(i).getFk_ser_syo_id().getSyo_description());
					serverWeb.setSer_memtot(Float.toString(listServer.get(i).getSer_mentot()));
					serverWeb.setSer_memuse(Float.toString(listServer.get(i).getSer_menuse()));
					fCalculo = listServer.get(i).getSer_menuse() * 100 / listServer.get(i).getSer_mentot();
					iPorcentaje = Math.round(fCalculo);
					serverWeb.setSer_pormemory(Integer.toString(iPorcentaje));
					iPorcentaje = Math.round(listServer.get(i).getSer_cpuuse());
					serverWeb.setSer_cpuuse(Integer.toString(iPorcentaje));
					serverWeb.setSer_porcpu(Integer.toString(iPorcentaje));
					iPorcentaje = Math.round(listServer.get(i).getSer_reduse());
					serverWeb.setSer_reduse(Integer.toString(iPorcentaje));
					serverWeb.setSer_porred(Integer.toString(iPorcentaje));
					listServerWeb.add(serverWeb);
				}
			}
		}
		setTableServerMain(listServerWeb);
	}
	
	@Override 
	public void getAllSyo() {
		tableSyo = getSyoService().getAllSystemOperating();
	}
	
	@Override
	public void createServer() {
		// TODO Auto-generated method stub
		if (lfCheckData()) {
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			Server server = new Server();
			server.setSer_id(ser_id);
			server.setSer_description(ser_description);
			server.setSer_host(ser_host);
			server.setFk_ser_syo_id(syo);
			server.setSer_cpuuse(0);
			server.setSer_mentot(0);
			server.setSer_menuse(0);
			server.setSer_reduse(0);
			server.setSer_datmod(new Date());
			server.setSer_usemod(logon.getUserId());
			getServerService().createServer(server);
			//Reply to LDAP SAMBA
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IServerLDAPDao serverLdapDao =(IServerLDAPDao)factorySAMBA.getBean(Constant.BEAN_SERVERDAO);
				ServerLDAP serverLDAP = serverLdapDao.getServerCn(server.getSer_id());
				if (serverLDAP == null) {
					serverLDAP = new ServerLDAP();
					serverLDAP.setCn(server.getSer_id());
					serverLDAP.setName(server.getSer_id());
					serverLDAP.setDescription(server.getSer_description());
					serverLDAP.setHost(server.getSer_host());
					serverLDAP.setOperatingSystem(server.getFk_ser_syo_id().getSyo_description());
					serverLDAP.setServerGroup(Constant.STRING_SINESPECIFICAR);
					serverLdapDao.createServer(serverLDAP);
				}
			}
			serCreated = true;
			//Set the newServer in serDet session variable for go to detail
			HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);
			session.setAttribute("ser_detId", server.getSer_id());
			RequestContext.getCurrentInstance().execute(Constant.WEB_CLOSE_MSG_NEWSERVER);
			RequestContext context = RequestContext.getCurrentInstance();
			String strRespuesta = Constant.WEB_PAGE_DETSERVER + Constant.WEB_FACES_REDIRECT;
			context.addCallbackParam(Constant.ARGS_CORRECT, serCreated);
			context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
		} else {
			RequestContext context = RequestContext.getCurrentInstance();
			String strRespuesta = Constant.WEB_PAGE_DETSERVER + Constant.WEB_FACES_REDIRECT;
			context.addCallbackParam(Constant.ARGS_CORRECT, serCreated);
			context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
		}
	}
	@Override
	public void dialogNewServer() {
		// TODO Auto-generated method stub
		ser_id = "";
		ser_description = "";
		ser_host = "";
		syo = new SystemOperating();
		RequestContext.getCurrentInstance().execute(Constant.WEB_MSG_NEWSERVER);
	}
	
	private boolean lfCheckData() {
		FacesMessage msg = null;
		LanguageUtils lang = new LanguageUtils();
		boolean blnCorrect = true;
		
		if (getSer_host().equals("")) {
			msg = new FacesMessage(FacesMessage.SEVERITY_INFO,lang.getMessage("gen_id"),
					lang.getMessage("gen_requiered"));
			FacesContext.getCurrentInstance().addMessage(null, msg);
			blnCorrect = false;
		}
		
		if (getSer_description().equals("")) {
			msg = new FacesMessage(FacesMessage.SEVERITY_INFO,lang.getMessage("gen_description"),
					lang.getMessage("gen_requiered"));
			FacesContext.getCurrentInstance().addMessage(null, msg);
			blnCorrect = false;
		}
		
		if (getSyo().getSyo_description().equals("")) {
			msg = new FacesMessage(FacesMessage.SEVERITY_INFO,lang.getMessage("gen_syo"),
					lang.getMessage("gen_requiered"));
			FacesContext.getCurrentInstance().addMessage(null, msg);
			blnCorrect = false;
		}
		
		return blnCorrect;
	}
	
	@Override
	public void getAllServerEvents() {
		// TODO Auto-generated method stub
		//RequestContext context = RequestContext.getCurrentInstance();
		//GenericApplicationContext appContext = AppUtils.getContext();
		//appContext.refresh();
		//AppUtils.setApplicationContext(appContext);
		//System.out.println("getAllEvents");
		SimpleDateFormat sdf = new SimpleDateFormat(Constant.MASK_DATE_WEB);
		Date datTemporal = null;
		String strtypeEvent = null;
		String strtextEvent = null;
		String striconEvent = null;
		LanguageUtils lang = new LanguageUtils();
		//Applications app = getAppService().getApplicationsId(selectedApp.getApp_id());
		List<Events> listEvents = getEventsService().getServerEvents(selectedSer, intPulsa);
		if (listEvents != null) {
			tableAllEvents = new ArrayList<EventsWEB>();
			for (int i=0; i < listEvents.size(); i++) {
				EventsWEB eventsWEB = new EventsWEB();
				datTemporal = listEvents.get(i).getEve_datetime();
				eventsWEB.setDateTime(sdf.format(datTemporal));
				switch(listEvents.get(i).getTypeEvent().getTev_id()) {
				case Constant.EVE_START_SESSION:
					striconEvent = Constant.EVE_ICON_USER_EVENT;
					strtypeEvent = lang.getMessage(Constant.EVE_TXT_STAR_SESSION);
					strtextEvent = lang.getMessage(Constant.I18N_EVE_TXT_USER) + " " +
							       listEvents.get(i).getEve_adic_data_1() + " " +
							       lang.getMessage(Constant.I18N_EVE_TXT_STARTED_SESSION);
					break;
				case Constant.EVE_END_SESSION:
					striconEvent = Constant.EVE_ICON_USER_EVENT;
					strtypeEvent = lang.getMessage(Constant.EVE_TXT_END_SESSION);
					strtextEvent = lang.getMessage(Constant.I18N_EVE_TXT_USER) + " " +
							       listEvents.get(i).getEve_adic_data_1() + " " +
							       lang.getMessage(Constant.I18N_EVE_TXT_ENDED_SESSION);
					break;
				case Constant.EVE_STAR_APPLICATION:
					striconEvent = Constant.EVE_ICON_APP_EVENT;
					strtypeEvent = lang.getMessage(Constant.EVE_TXT_STAR_APPLICATION);
					strtextEvent = lang.getMessage(Constant.I18N_EVE_TXT_USER) + " " +
							       listEvents.get(i).getEve_adic_data_1() + " " +
							       lang.getMessage(Constant.I18N_EVE_TXT_STARTED_APPLICATION) + " " +
							       listEvents.get(i).getEve_adic_data_2() + " " +
							       lang.getMessage(Constant.I18N_EVE_TXT_SERVER) + " " +
							       listEvents.get(i).getEve_adic_data_3();
					break;
				case Constant.EVE_END_APPLICATION:
					striconEvent = Constant.EVE_ICON_APP_EVENT;
					strtypeEvent = lang.getMessage(Constant.EVE_TXT_END_APPLICATION);
					strtextEvent = lang.getMessage(Constant.I18N_EVE_TXT_USER) + " " +
						       listEvents.get(i).getEve_adic_data_1() + " " +
						       lang.getMessage(Constant.I18N_EVE_TXT_ENDED_APPLICATION) + " " +
						       listEvents.get(i).getEve_adic_data_2() + " " +
						       lang.getMessage(Constant.I18N_EVE_TXT_SERVER) + " " +
						       listEvents.get(i).getEve_adic_data_3();
					break;
				}
				eventsWEB.setIconEvent(striconEvent);
				eventsWEB.setTypeEvent(strtypeEvent);
				eventsWEB.setTextEvent(strtextEvent);
				User user = getUserService().getUserId(listEvents.get(i).getEve_adic_data_1());
				eventsWEB.setUserName(user.getUse_name() + user.getUse_surname1());
				tableAllEvents.add(eventsWEB);
			}
		}
	}
	
	@Override
	public void getMoreServerEvents() {
		// TODO Auto-generated method stub
		setIntPulsa(this.intPulsa + 1);
		//System.out.println(this.intPulsa);
		getAllServerEvents();
	}
	
	@Override
	public void getTableGroup() {
		List<GroupServer> lstTemp = new ArrayList<GroupServer>();
		List<GroupServer> lstTempGroupServer = new ArrayList<GroupServer>();
		if (selectedSer.getSer_id() != null) {
			lstTempGroupServer = getGroupServerService().getAllGroupServer();
			List<ServerGroup> serverGroups = getServerService().getAllGroupServer(selectedSer);
			if (serverGroups != null) {
				for (int i=0; i < serverGroups.size(); i++) {
					lstTemp.add(serverGroups.get(i).getServerGroupPK().getGroupServer());
					lstTempGroupServer.remove(serverGroups.get(i).getServerGroupPK().getGroupServer());
				}
				setTableGroupServerAct(lstTemp);
				setTableGroupServerDis(lstTempGroupServer);
			}
			setTableGroupServerAct(lstTemp);
			setTableGroupServerDis(lstTempGroupServer);
		}
	}
	
	@Override
	public void getActiveUserApp() {
		List<UserApp> lstUserApp = new ArrayList<UserApp>();
		List<UserAppWEB> lstUserAppWeb = new ArrayList<UserAppWEB>();
		try {
			lstUserApp = getServerService().getActiveUserApp(selectedSer);
			if (lstUserApp != null) {
				for (int i = 0; i < lstUserApp.size(); i++) {
					UserAppWEB userAppWeb = new UserAppWEB();
					User user = getUserService().getUserId(lstUserApp.get(i).getFk_uap_use_id());
					Applications app = getAppService().getApplicationsId(lstUserApp.get(i).getFk_uap_app_id());
					Server server = getServerService().getServerId(lstUserApp.get(i).getFk_uap_ser_id().getSer_id());
					userAppWeb.setUse_id(user.getUse_id());
					userAppWeb.setUse_name(user.getUse_name() + " " + user.getUse_surname1());
					userAppWeb.setApp_id(app.getApp_id());
					userAppWeb.setApp_description(app.getApp_description());
					userAppWeb.setSer_id(server.getSer_id());
					userAppWeb.setSer_host(server.getSer_host());
					userAppWeb.setSer_description(server.getSer_description());
					userAppWeb.setUap_start_date_process(lstUserApp.get(i).getUap_start_date_process());
					userAppWeb.setUap_end_date_process(lstUserApp.get(i).getUap_end_date_process());
					userAppWeb.setUap_id_process(lstUserApp.get(i).getUap_id_process());
					userAppWeb.setUap_cpuuse(lstUserApp.get(i).getUap_cpuuse());
					userAppWeb.setUap_memuse(lstUserApp.get(i).getUap_memuse());
					lstUserAppWeb.add(userAppWeb);
				}
			}
			setTableUserAppAct(lstUserAppWeb);
			
		} catch (Exception e) {
			System.err.println("GETACTIVEUSER");
			e.printStackTrace();
		}
	}
	
	@Override
	public void getTableApp() {
		List<AppWEB> lstTemp = new ArrayList<AppWEB>();
		List<AppWEB> lstTempApp = new ArrayList<AppWEB>();
		List<Applications> listApp = getAppService().getAllApplications();
		if (selectedSer.getSer_id() != null) {
			if (!listApp.isEmpty()) {
				List<AppServer> serverApps = getServerService().getAllApplications(selectedSer);
				if (serverApps != null) {
					for (int i = 0; i < serverApps.size(); i++) {
						AppWEB appWEB = new AppWEB();
						appWEB.setApp_id(serverApps.get(i).getAppServerPK().getApp().getApp_id());
						appWEB.setApp_name(serverApps.get(i).getAppServerPK().getApp().getApp_name());
						appWEB.setApp_description(serverApps.get(i).getAppServerPK().getApp().getApp_description());
						appWEB.setApp_display_name(serverApps.get(i).getAppServerPK().getApp().getApp_display_name());
						appWEB.setApp_path_exe(serverApps.get(i).getAppServerPK().getApp().getApp_path_exe());
						appWEB.setApp_syo(serverApps.get(i).getAppServerPK().getApp().getFk_app_syo_id().getSyo_description());
						appWEB.setApp_usemod(serverApps.get(i).getAppServerPK().getApp().getApp_usemod());
						appWEB.setApp_datmod(serverApps.get(i).getAppServerPK().getApp().getApp_datmod());
						lstTemp.add(appWEB);
					}
				}
				for (int i = 0; i < listApp.size(); i++) {
					AppWEB appWEB = new AppWEB();
					appWEB.setApp_id(listApp.get(i).getApp_id());
					appWEB.setApp_name(listApp.get(i).getApp_name());
					appWEB.setApp_description(listApp.get(i).getApp_description());
					appWEB.setApp_display_name(listApp.get(i).getApp_display_name());
					appWEB.setApp_path_exe(listApp.get(i).getApp_path_exe());
					appWEB.setApp_syo(listApp.get(i).getFk_app_syo_id().getSyo_description());
					appWEB.setApp_usemod(listApp.get(i).getApp_usemod());
					appWEB.setApp_datmod(listApp.get(i).getApp_datmod());
					boolean blnExiste = false;
					for (int iContaAct = 0; iContaAct < lstTemp.size(); iContaAct ++) {
						if (lstTemp.get(iContaAct).getApp_id() == appWEB.getApp_id()) {
							blnExiste = true;
						}
					}
					if (!blnExiste) {
						lstTempApp.add(appWEB);
					}
				}
			
			
			}
			setTableAppAct(lstTemp);
			setTableAppDis(lstTempApp);
		}
	}
	
	@Override
	public void gotoDetApp() {
		HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);  
		session.setAttribute("app_detId", selectedUserAppAct.getApp_id());  
		RequestContext context = RequestContext.getCurrentInstance();
		String strRespuesta = Constant.WEB_PAGE_DETAPP + Constant.WEB_FACES_REDIRECT;
		context.addCallbackParam(Constant.ARGS_CORRECT, true);
		context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
	}
	
	@Override
	public void gotoDetUse() {
		HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);  
		session.setAttribute("use_detId", selectedUserAppAct.getUse_id());  
		RequestContext context = RequestContext.getCurrentInstance();
		String strRespuesta = Constant.WEB_PAGE_DETUSER + Constant.WEB_FACES_REDIRECT;
		context.addCallbackParam(Constant.ARGS_CORRECT, true);
		context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
	}
	
	@Override
	public void dialogUpServer() {
		RequestContext.getCurrentInstance().execute(Constant.WEB_MSG_UPSERVER);
	}
	
	@Override
	public void updateServer() {
		// TODO Auto-generated method stub
		FacesMessage msg = null;
		LanguageUtils lang = new LanguageUtils();
		ser_id = selectedSer.getSer_id();
		ser_description = selectedSer.getSer_description();
		ser_host = selectedServer.getSer_host();
		//app_path_exe = selectedApplication.getApp_path_exe();
		syo = selectedSer.getFk_ser_syo_id();
		if (lfCheckData()) {
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			selectedSer.setSer_datmod(new Date());
			selectedSer.setSer_usemod(logon.getUserId());
			getServerService().updateServer(selectedSer);
			//Reply to LDAP SAMBA
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IServerLDAPDao serverLdapDao = (IServerLDAPDao)factorySAMBA.getBean(Constant.BEAN_SERVERDAO);
				ServerLDAP serverLDAP = serverLdapDao.getServerCn(selectedSer.getSer_id());
				if (serverLDAP == null) {
					serverLDAP = new ServerLDAP();
					serverLDAP.setCn(selectedSer.getSer_id());
					serverLDAP.setName(selectedSer.getSer_id());
					serverLDAP.setDescription(selectedSer.getSer_description());
					serverLDAP.setHost(selectedSer.getSer_host());
					serverLDAP.setOperatingSystem(selectedSer.getFk_ser_syo_id().getSyo_description());
					serverLDAP.setServerGroup(Constant.STRING_SINESPECIFICAR);
					serverLdapDao.createServer(serverLDAP);
				} else {
					serverLDAP.setCn(selectedSer.getSer_id());
					serverLDAP.setName(selectedSer.getSer_id());
					serverLDAP.setDescription(selectedSer.getSer_description());
					serverLDAP.setHost(selectedSer.getSer_host());
					serverLDAP.setOperatingSystem(selectedSer.getFk_ser_syo_id().getSyo_description());
					serverLDAP.setServerGroup(Constant.STRING_SINESPECIFICAR);
					serverLdapDao.updateServer(serverLDAP);
				}
			}
			//Set the newApp in appDet session variable for go to detail
			serCreated = true;
			//Set session variable for show app detail
			HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);
			session.setAttribute("ser_detId", selectedSer.getSer_id());
			RequestContext.getCurrentInstance().execute(Constant.WEB_CLOSE_MSG_UPSERVER);
			RequestContext context = RequestContext.getCurrentInstance();
			String strRespuesta = Constant.WEB_PAGE_DETSERVER + Constant.WEB_FACES_REDIRECT;
			context.addCallbackParam(Constant.ARGS_CORRECT, serCreated);
			context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
			msg = new FacesMessage(FacesMessage.SEVERITY_INFO, lang.getMessage("gen_correct"),
					lang.getMessage("gen_save_ok"));
			FacesContext.getCurrentInstance().addMessage(null, msg);
		} else {
			RequestContext context = RequestContext.getCurrentInstance();
			String strRespuesta = Constant.WEB_PAGE_DETSERVER + Constant.WEB_FACES_REDIRECT;
			context.addCallbackParam(Constant.ARGS_CORRECT, serCreated);
			context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
			msg = new FacesMessage(FacesMessage.SEVERITY_FATAL, lang.getMessage("gen_error"),
					lang.getMessage("gen_save_ko"));
			FacesContext.getCurrentInstance().addMessage(null, msg);
		}
	}
	@Override
	public void deleteServer() {
		// TODO Auto-generated method stub
		PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
		getServerService().deleteServer(selectedSer);
		//Reply to LDAP SAMBA
		if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)){
			Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
			BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
			IServerLDAPDao serverLdapDao = (IServerLDAPDao)factorySAMBA.getBean(Constant.BEAN_SERVERDAO);
			ServerLDAP serverLDAP = serverLdapDao.getServerCn(selectedSer.getSer_id());
			serverLdapDao.deleteServer(serverLDAP);
		}
		//Set the newUser in useDet session varible for detail
		serCreated = false;
		//Srt session variable for show user detail
		HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);
		session.removeAttribute("ser_detId");
		RequestContext context = RequestContext.getCurrentInstance();
		String strRespuesta = Constant.WEB_PAGE_HOMESERVER + Constant.WEB_FACES_REDIRECT;
		context.addCallbackParam(Constant.ARGS_CORRECT, true);
		context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
		faces.sendMessage("gen_correct",
				"gen_remove_ok", Constant.MSG_INFORMATION);
	}
	@Override
	public void removeServerApp() {
		// TODO Auto-generated method stub
		try {
			AppWEB appWeb = selectedAppAct;
			Applications app = getAppService().getApplicationsId(appWeb.getApp_id());
			
			boolean blnResult = getAppService().removeAppServer(app, selectedSer);
			//Reply to SAMBA
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				boolean blnExisServerApp = false;
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IAppServerLDAPDao appServerLdapDao = (IAppServerLDAPDao)factorySAMBA.getBean(Constant.BEAN_APPSERVERDAO);
				List resultAS = appServerLdapDao.getAppServer(app.getApp_name());
				for (int i = 0; i < resultAS.size(); i++) {
					AppServerLDAP resultServer = (AppServerLDAP) resultAS.get(i);
					String[] servers = resultServer.getServersApp();
					if (servers != null) {
						for (int a = 0; a < servers.length; a++) {
							if (servers[a].equals(selectedSer.getSer_host())) {
								blnExisServerApp = true;
							}
						}
					}
				}
				if (blnExisServerApp) {
					AppServerLDAP newAppServer = new AppServerLDAP();
					newAppServer.setCnApplication(app.getApp_name());
					newAppServer.setCnServer(selectedSer.getSer_host());
					appServerLdapDao.removeAppServer(newAppServer);
				}
			}
			//End reply SAMBA
			if (blnResult) {
				tableAppAct.remove(appWeb);
				tableAppDis.add(appWeb);
				faces.sendMessage(Constant.TXT_GEN_CORRECT, Constant.TXT_GEN_REMOVE_OK,
						Constant.MSG_INFORMATION);
			} else {
				faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_REMOVE_KO,
						Constant.MSG_CRITICAL);
			}
			
		} catch (Exception e) {
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_OK,
					Constant.MSG_CRITICAL);
			e.printStackTrace();
		}
	}
	@Override
	public void addServerApp() {
		// TODO Auto-generated method stub
		try {
			AppWEB appWeb = selectedAppDis;
			Applications app = getAppService().getApplicationsId(appWeb.getApp_id());
			
			boolean blnResult = getAppService().addAppServer(app, selectedSer, logon.getUserId());
			//Reply to SAMBA
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				boolean blnExisServerApp = false;
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IAppServerLDAPDao appServerLdapDao = (IAppServerLDAPDao)factorySAMBA.getBean(Constant.BEAN_APPSERVERDAO);
				List resultAS = appServerLdapDao.getAppServer(app.getApp_name());
				for (int i = 0; i < resultAS.size(); i++) {
					AppServerLDAP resultServer = (AppServerLDAP) resultAS.get(i);
					String[] servers = resultServer.getServersApp();
					if (servers != null) {
						for (int a = 0; a < servers.length; a++) {
							if (servers[a].equals(selectedSer.getSer_host())) {
								blnExisServerApp = true;
							}
						}
					}
				}
				if (!blnExisServerApp) {
					AppServerLDAP newAppServer = new AppServerLDAP();
					newAppServer.setCnApplication(app.getApp_name());
					newAppServer.setCnServer(selectedSer.getSer_host());
					appServerLdapDao.createAppServer(newAppServer);
				}
			}
			//End reply SAMBA
			if (blnResult) {
				tableAppAct.add(appWeb);
				tableAppDis.remove(appWeb);
				faces.sendMessage(Constant.TXT_GEN_CORRECT, Constant.TXT_GEN_SAVE_OK,
						Constant.MSG_INFORMATION);
			} else {
				faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_OK,
						Constant.MSG_CRITICAL);
			}
			
		} catch (Exception e) {
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_OK,
					Constant.MSG_CRITICAL);
			e.printStackTrace();
		}
	}
	@Override
	public void onAppDrop(DragDropEvent ddEvent) {
		// TODO Auto-generated method stub
		try {
			AppWEB appWeb = ((AppWEB) ddEvent.getData());
			Applications app = getAppService().getApplicationsId(appWeb.getApp_id());
			
			boolean blnResult = getAppService().addAppServer(app, selectedSer, logon.getUserId());
			//Reply to SAMBA
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				boolean blnExisServerApp = false;
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IAppServerLDAPDao appServerLdapDao = (IAppServerLDAPDao)factorySAMBA.getBean(Constant.BEAN_APPSERVERDAO);
				List resultAS = appServerLdapDao.getAppServer(app.getApp_name());
				for (int i = 0; i < resultAS.size(); i++) {
					AppServerLDAP resultServer = (AppServerLDAP) resultAS.get(i);
					String[] servers = resultServer.getServersApp();
					if (servers != null) {
						for (int a = 0; a < servers.length; a++) {
							if (servers[a].equals(selectedSer.getSer_host())) {
								blnExisServerApp = true;
							}
						}
					}
				}
				if (!blnExisServerApp) {
					AppServerLDAP newAppServer = new AppServerLDAP();
					newAppServer.setCnApplication(app.getApp_name());
					newAppServer.setCnServer(selectedSer.getSer_host());
					appServerLdapDao.createAppServer(newAppServer);
				}
			}
			//End reply SAMBA
			if (blnResult) {
				tableAppAct.add(appWeb);
				tableAppDis.remove(appWeb);
				faces.sendMessage(Constant.TXT_GEN_CORRECT, Constant.TXT_GEN_SAVE_OK,
						Constant.MSG_INFORMATION);
			} else {
				faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_OK,
						Constant.MSG_CRITICAL);
			}
			
		} catch (Exception e) {
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_OK,
					Constant.MSG_CRITICAL);
			e.printStackTrace();
		}
	}
	
	@Override
	public void removeServerGroup() {
		// TODO Auto-generated method stub
		try {
			boolean blnResult = getServerService().removeGroupServer(selectedSer, selectedGroupServerAct);
			//Reply to LDAP SAMBA
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				boolean blnExisServerGroup = false;
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IServerGroupLDAPDao serverGroupLdapDao = (IServerGroupLDAPDao)factorySAMBA.getBean(Constant.BEAN_SERVERGROUPDAO);
				List resultSG = serverGroupLdapDao.getGroupsServer(selectedSer.getSer_id());
				for (int i = 0; i < resultSG.size(); i++) {
					ServerGroupLDAP resultGroups = (ServerGroupLDAP) resultSG.get(i);
					String[] groups = resultGroups.getGroupsServer();
					if (groups != null) {
						for (int g = 0; g < groups.length; g++) {
							if (groups[g].equals(selectedGroupServerAct.getGrs_description())) {
								blnExisServerGroup = true;
							}
						}
					}
				}
				if (blnExisServerGroup) {
					ServerGroupLDAP newServerGroupLdap = new ServerGroupLDAP();
					newServerGroupLdap.setCnGroup(selectedGroupServerAct.getGrs_description());
					newServerGroupLdap.setCnServer(selectedSer.getSer_id());
					serverGroupLdapDao.deleteServerGroup(newServerGroupLdap);
				}
			}
			//End reply SAMBA
			if (blnResult) {
				tableGroupServerAct.remove(selectedGroupServerAct);
				tableGroupServerDis.add(selectedGroupServerAct);
				faces.sendMessage(Constant.TXT_GEN_CORRECT, Constant.TXT_GEN_REMOVE_OK,
						Constant.MSG_INFORMATION);
			} else {
				faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_REMOVE_KO,
						Constant.MSG_CRITICAL);
			}
			
		} catch (Exception e) {
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_REMOVE_KO,
					Constant.MSG_CRITICAL);
			e.printStackTrace();
		}
	}
	@Override
	public void addServerGroup() {
		// TODO Auto-generated method stub
		try {
			boolean blnResult = getServerService().addGroupServer(selectedSer, selectedGroupServerDis, logon.getUserId());
			//Reply to LDAP SAMBA
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				boolean blnExisServerGroup = false;
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IServerGroupLDAPDao serverGroupLdapDao = (IServerGroupLDAPDao)factorySAMBA.getBean(Constant.BEAN_SERVERGROUPDAO);
				List resultSG = serverGroupLdapDao.getGroupsServer(selectedSer.getSer_id());
				for (int i = 0; i < resultSG.size(); i++) {
					ServerGroupLDAP resultGroups = (ServerGroupLDAP) resultSG.get(i);
					String[] groups = resultGroups.getGroupsServer();
					if (groups != null) {
						for (int g = 0; g < groups.length; g++) {
							if (groups[g].equals(selectedGroupServerDis.getGrs_description())) {
								blnExisServerGroup = true;
							}
						}
					}
				}
				if (! blnExisServerGroup) {
					ServerGroupLDAP newServerGroupLdap = new ServerGroupLDAP();
					newServerGroupLdap.setCnGroup(selectedGroupServerDis.getGrs_description());
					newServerGroupLdap.setCnServer(selectedSer.getSer_id());
					serverGroupLdapDao.createServerGroup(newServerGroupLdap);
				}
			}
			//End reply SAMBA
			if (blnResult) {
				tableGroupServerAct.add(selectedGroupServerDis);
				tableGroupServerDis.remove(selectedGroupServerDis);
				faces.sendMessage(Constant.TXT_GEN_CORRECT, Constant.TXT_GEN_SAVE_OK,
						Constant.MSG_INFORMATION);
			} else {
				faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_KO,
						Constant.MSG_CRITICAL);
			}
			
		} catch (Exception e) {
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_KO,
					Constant.MSG_CRITICAL);
			e.printStackTrace();
		}
	}
	@Override
	public void onServerDrop(DragDropEvent ddEvent) {
		// TODO Auto-generated method stub
		try {
			GroupServer groupServer = ((GroupServer) ddEvent.getData());
			boolean blnResult = getServerService().addGroupServer(selectedSer, groupServer, logon.getUserId());
			//Reply to LDAP SAMBA
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				boolean blnExisServerGroup = false;
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IServerGroupLDAPDao serverGroupLdapDao = (IServerGroupLDAPDao)factorySAMBA.getBean(Constant.BEAN_SERVERGROUPDAO);
				List resultSG = serverGroupLdapDao.getGroupsServer(selectedSer.getSer_id());
				for (int i = 0; i < resultSG.size(); i++) {
					ServerGroupLDAP resultGroups = (ServerGroupLDAP) resultSG.get(i);
					String[] groups = resultGroups.getGroupsServer();
					if (groups != null) {
						for (int g = 0; g < groups.length; g++) {
							if (groups[g].equals(groupServer.getGrs_description())) {
								blnExisServerGroup = true;
							}
						}
					}
				}
				if (! blnExisServerGroup) {
					ServerGroupLDAP newServerGroupLdap = new ServerGroupLDAP();
					newServerGroupLdap.setCnGroup(groupServer.getGrs_description());
					newServerGroupLdap.setCnServer(selectedSer.getSer_id());
					serverGroupLdapDao.createServerGroup(newServerGroupLdap);
				}
			}
			//End reply SAMBA
			if (blnResult) {
				tableGroupServerAct.add(groupServer);
				tableGroupServerDis.remove(groupServer);
				faces.sendMessage(Constant.TXT_GEN_CORRECT, Constant.TXT_GEN_SAVE_OK,
						Constant.MSG_INFORMATION);
			} else {
				faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_KO,
						Constant.MSG_CRITICAL);
			}
			
		} catch (Exception e) {
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_KO,
					Constant.MSG_CRITICAL);
			e.printStackTrace();
		}
	}
	
	
	
	
	
	
	
	
	
	
	
	//** Getters and setters **//
	/**
	 * @return the serverService
	 */
	public IServerService getServerService() {
		return serverService;
	}

	/**
	 * @param serverService the serverService to set
	 */
	public void setServerService(IServerService serverService) {
		this.serverService = serverService;
	}

	/**
	 * @return the tableServerMain
	 */
	public List<ServerWEB> getTableServerMain() {
		return tableServerMain;
	}

	/**
	 * @param tableServerMain the tableServerMain to set
	 */
	public void setTableServerMain(List<ServerWEB> tableServerMain) {
		this.tableServerMain = tableServerMain;
	}

	/**
	 * @return the filteredtableServerMain
	 */
	public List<ServerWEB> getFilteredtableServerMain() {
		return filteredtableServerMain;
	}

	/**
	 * @param filteredtableServerMain the filteredtableServerMain to set
	 */
	public void setFilteredtableServerMain(List<ServerWEB> filteredtableServerMain) {
		this.filteredtableServerMain = filteredtableServerMain;
	}

	/**
	 * @return the selectedServer
	 */
	public ServerWEB getSelectedServer() {
		return selectedServer;
	}

	/**
	 * @param selectedServer the selectedServer to set
	 */
	public void setSelectedServer(ServerWEB selectedServer) {
		this.selectedServer = selectedServer;
		//Set session variable for show app detail
		HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);
		session.setAttribute("ser_detId", selectedServer.getSer_id());
	}
	/**
	 * @return the ser_id
	 */
	public String getSer_id() {
		return ser_id;
	}
	/**
	 * @param ser_id the ser_id to set
	 */
	public void setSer_id(String ser_id) {
		this.ser_id = ser_id;
	}
	/**
	 * @return the ser_description
	 */
	public String getSer_description() {
		return ser_description;
	}
	/**
	 * @param ser_description the ser_description to set
	 */
	public void setSer_description(String ser_description) {
		this.ser_description = ser_description;
	}
	/**
	 * @return the ser_host
	 */
	public String getSer_host() {
		return ser_host;
	}
	/**
	 * @param ser_host the ser_host to set
	 */
	public void setSer_host(String ser_host) {
		this.ser_host = ser_host;
	}
	
	/**
	 * @return the syo
	 */
	public SystemOperating getSyo() {
		return syo;
	}
	/**
	 * @param syo the syo to set
	 */
	public void setSyo(SystemOperating syo) {
		this.syo = syo;
	}
	/**
	 * @return the syo_id
	 */
	public long getSyo_id() {
		return syo_id;
	}
	/**
	 * @param syo_id the syo_id to set
	 */
	public void setSyo_id(long syo_id) {
		this.syo_id = syo_id;
		setSyo(getSyoService().getSystemOperatingId(syo_id));
	}
	/**
	 * @return the serCreated
	 */
	public boolean isSerCreated() {
		return serCreated;
	}
	/**
	 * @param serCreated the serCreated to set
	 */
	public void setSerCreated(boolean serCreated) {
		this.serCreated = serCreated;
	}
	/**
	 * @return the ser_detId
	 */
	public String getSer_detId() {
		return ser_detId;
	}
	/**
	 * @param ser_detId the ser_detId to set
	 */
	public void setSer_detId(String ser_detId) {
		this.ser_detId = ser_detId;
	}
	
	/**
	 * @return the syoService
	 */
	public ISystemOperatingService getSyoService() {
		return syoService;
	}
	/**
	 * @param syoService the syoService to set
	 */
	public void setSyoService(ISystemOperatingService syoService) {
		this.syoService = syoService;
	}
	/**
	 * @return the logon
	 */
	public LogonManagedImpl getLogon() {
		return logon;
	}
	/**
	 * @param logon the logon to set
	 */
	public void setLogon(LogonManagedImpl logon) {
		this.logon = logon;
	}
	/**
	 * @return the tableSyo
	 */
	public List<SystemOperating> getTableSyo() {
		return tableSyo;
	}
	/**
	 * @param tableSyo the tableSyo to set
	 */
	public void setTableSyo(List<SystemOperating> tableSyo) {
		this.tableSyo = tableSyo;
	}
	/**
	 * @return the groupServerService
	 */
	public IGroupServerService getGroupServerService() {
		return groupServerService;
	}
	/**
	 * @param groupServerService the groupServerService to set
	 */
	public void setGroupServerService(IGroupServerService groupServerService) {
		this.groupServerService = groupServerService;
	}
	/**
	 * @return the appService
	 */
	public IApplicationsService getAppService() {
		return appService;
	}
	/**
	 * @param appService the appService to set
	 */
	public void setAppService(IApplicationsService appService) {
		this.appService = appService;
	}
	/**
	 * @return the eventsService
	 */
	public IEventsService getEventsService() {
		return eventsService;
	}
	/**
	 * @param eventsService the eventsService to set
	 */
	public void setEventsService(IEventsService eventsService) {
		this.eventsService = eventsService;
	}
	/**
	 * @return the tableGroupServerAct
	 */
	public List<GroupServer> getTableGroupServerAct() {
		return tableGroupServerAct;
	}
	/**
	 * @param tableGroupServerAct the tableGroupServerAct to set
	 */
	public void setTableGroupServerAct(List<GroupServer> tableGroupServerAct) {
		this.tableGroupServerAct = tableGroupServerAct;
	}
	/**
	 * @return the filteredtableGroupServerAct
	 */
	public List<GroupServer> getFilteredtableGroupServerAct() {
		return filteredtableGroupServerAct;
	}
	/**
	 * @param filteredtableGroupServerAct the filteredtableGroupServerAct to set
	 */
	public void setFilteredtableGroupServerAct(
			List<GroupServer> filteredtableGroupServerAct) {
		this.filteredtableGroupServerAct = filteredtableGroupServerAct;
	}
	/**
	 * @return the selectedGroupServerAct
	 */
	public GroupServer getSelectedGroupServerAct() {
		return selectedGroupServerAct;
	}
	/**
	 * @param selectedGroupServerAct the selectedGroupServerAct to set
	 */
	public void setSelectedGroupServerAct(GroupServer selectedGroupServerAct) {
		this.selectedGroupServerAct = selectedGroupServerAct;
	}
	/**
	 * @return the tableGroupServerDis
	 */
	public List<GroupServer> getTableGroupServerDis() {
		return tableGroupServerDis;
	}
	/**
	 * @param tableGroupServerDis the tableGroupServerDis to set
	 */
	public void setTableGroupServerDis(List<GroupServer> tableGroupServerDis) {
		this.tableGroupServerDis = tableGroupServerDis;
	}
	/**
	 * @return the filteredtableGroupServerDis
	 */
	public List<GroupServer> getFilteredtableGroupServerDis() {
		return filteredtableGroupServerDis;
	}
	/**
	 * @param filteredtableGroupServerDis the filteredtableGroupServerDis to set
	 */
	public void setFilteredtableGroupServerDis(
			List<GroupServer> filteredtableGroupServerDis) {
		this.filteredtableGroupServerDis = filteredtableGroupServerDis;
	}
	/**
	 * @return the selectedGroupServerDis
	 */
	public GroupServer getSelectedGroupServerDis() {
		return selectedGroupServerDis;
	}
	/**
	 * @param selectedGroupServerDis the selectedGroupServerDis to set
	 */
	public void setSelectedGroupServerDis(GroupServer selectedGroupServerDis) {
		this.selectedGroupServerDis = selectedGroupServerDis;
	}
	/**
	 * @return the tableAppAct
	 */
	public List<AppWEB> getTableAppAct() {
		return tableAppAct;
	}
	/**
	 * @param tableAppAct the tableAppAct to set
	 */
	public void setTableAppAct(List<AppWEB> tableAppAct) {
		this.tableAppAct = tableAppAct;
	}
	/**
	 * @return the filteredtableAppAct
	 */
	public List<AppWEB> getFilteredtableAppAct() {
		return filteredtableAppAct;
	}
	/**
	 * @param filteredtableAppAct the filteredtableAppAct to set
	 */
	public void setFilteredtableAppAct(List<AppWEB> filteredtableAppAct) {
		this.filteredtableAppAct = filteredtableAppAct;
	}
	/**
	 * @return the selectedAppAct
	 */
	public AppWEB getSelectedAppAct() {
		return selectedAppAct;
	}
	/**
	 * @param selectedAppAct the selectedAppAct to set
	 */
	public void setSelectedAppAct(AppWEB selectedAppAct) {
		this.selectedAppAct = selectedAppAct;
	}
	/**
	 * @return the tableAppDis
	 */
	public List<AppWEB> getTableAppDis() {
		return tableAppDis;
	}
	/**
	 * @param tableAppDis the tableAppDis to set
	 */
	public void setTableAppDis(List<AppWEB> tableAppDis) {
		this.tableAppDis = tableAppDis;
	}
	/**
	 * @return the filteredtableAppDis
	 */
	public List<AppWEB> getFilteredtableAppDis() {
		return filteredtableAppDis;
	}
	/**
	 * @param filteredtableAppDis the filteredtableAppDis to set
	 */
	public void setFilteredtableAppDis(List<AppWEB> filteredtableAppDis) {
		this.filteredtableAppDis = filteredtableAppDis;
	}
	/**
	 * @return the selectedAppDis
	 */
	public AppWEB getSelectedAppDis() {
		return selectedAppDis;
	}
	/**
	 * @param selectedAppDis the selectedAppDis to set
	 */
	public void setSelectedAppDis(AppWEB selectedAppDis) {
		this.selectedAppDis = selectedAppDis;
	}
	/**
	 * @return the tableAllEvents
	 */
	public List<EventsWEB> getTableAllEvents() {
		return tableAllEvents;
	}
	/**
	 * @param tableAllEvents the tableAllEvents to set
	 */
	public void setTableAllEvents(List<EventsWEB> tableAllEvents) {
		this.tableAllEvents = tableAllEvents;
	}
	/**
	 * @return the intPulsa
	 */
	public int getIntPulsa() {
		return intPulsa;
	}
	/**
	 * @param intPulsa the intPulsa to set
	 */
	public void setIntPulsa(int intPulsa) {
		this.intPulsa = intPulsa;
	}
	/**
	 * @return the selectedSer
	 */
	public Server getSelectedSer() {
		return selectedSer;
	}
	/**
	 * @param selectedSer the selectedSer to set
	 */
	public void setSelectedSer(Server selectedSer) {
		this.selectedSer = selectedSer;
	}
	/**
	 * @return the userService
	 */
	public IUserService getUserService() {
		return userService;
	}
	/**
	 * @param userService the userService to set
	 */
	public void setUserService(IUserService userService) {
		this.userService = userService;
	}
	/**
	 * @return the tableUserAppAct
	 */
	public List<UserAppWEB> getTableUserAppAct() {
		return tableUserAppAct;
	}
	/**
	 * @param tableUserAppAct the tableUserAppAct to set
	 */
	public void setTableUserAppAct(List<UserAppWEB> tableUserAppAct) {
		this.tableUserAppAct = tableUserAppAct;
	}
	/**
	 * @return the filteredtableUserAppAct
	 */
	public List<UserAppWEB> getFilteredtableUserAppAct() {
		return filteredtableUserAppAct;
	}
	/**
	 * @param filteredtableUserAppAct the filteredtableUserAppAct to set
	 */
	public void setFilteredtableUserAppAct(List<UserAppWEB> filteredtableUserAppAct) {
		this.filteredtableUserAppAct = filteredtableUserAppAct;
	}
	/**
	 * @return the selectedUserAppAct
	 */
	public UserAppWEB getSelectedUserAppAct() {
		return selectedUserAppAct;
	}
	/**
	 * @param selectedUserAppAct the selectedUserAppAct to set
	 */
	public void setSelectedUserAppAct(UserAppWEB selectedUserAppAct) {
		this.selectedUserAppAct = selectedUserAppAct;
	}
	/**
	 * @return the cpuServer
	 */
	public PieChartModel getCpuServer() {
		return cpuServer;
	}
	
	/**
	 * @return the memServer
	 */
	public PieChartModel getMemServer() {
		return memServer;
	}
	
	
	
}
