package com.librework.console.managed.impl;

import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.ViewScoped;
import javax.faces.context.FacesContext;
import javax.servlet.http.HttpSession;

import org.primefaces.context.RequestContext;
import org.primefaces.event.DragDropEvent;
import org.springframework.beans.factory.BeanFactory;
import org.springframework.beans.factory.xml.XmlBeanFactory;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.Resource;


import com.librework.console.daoLDAP.IApplicationLDAPDao;
import com.librework.console.daoLDAP.IGroupLDAPDao;
import com.librework.console.daoLDAP.IUserAppLDAPDao;
import com.librework.console.daoLDAP.IUserGroupLDAPDao;
import com.librework.console.daoLDAP.IUserLDAPDao;
import com.librework.console.general.Constant;
import com.librework.console.managed.IUserManaged;
import com.librework.console.model.Applications;
import com.librework.console.model.Events;
import com.librework.console.model.GroupUser;
import com.librework.console.model.Server;
import com.librework.console.model.User;
import com.librework.console.model.UserApp;
import com.librework.console.model.UserGroup;
import com.librework.console.modelLDAP.ApplicationLDAP;
import com.librework.console.modelLDAP.GroupUserLDAP;
import com.librework.console.modelLDAP.UserAppLDAP;
import com.librework.console.modelLDAP.UserGroupLDAP;
import com.librework.console.modelLDAP.UserLDAP;
import com.librework.console.modelWEB.AppWEB;
import com.librework.console.modelWEB.EventsWEB;
import com.librework.console.modelWEB.UserAppWEB;
import com.librework.console.service.IApplicationsService;
import com.librework.console.service.IEventsService;
import com.librework.console.service.IGroupUserService;
import com.librework.console.service.IServerService;
import com.librework.console.service.IUserService;
import com.librework.console.utils.FacesUtils;
import com.librework.console.utils.LanguageUtils;
import com.librework.console.utils.PropertiesUtils;


@ManagedBean(name="userBean")
@ViewScoped
public class UserManagedImpl implements IUserManaged, Serializable  {

	private static final long serialVersionUID = 1L;
	@ManagedProperty(value="#{UserService}")
	private IUserService userService;
	
	@ManagedProperty(value="#{GroupUserService}")
	private IGroupUserService groupUserService;
	
	@ManagedProperty(value="#{ApplicationsService}")
	private IApplicationsService appService;
	
	@ManagedProperty(value="#{ServerService}")
	private IServerService serverService;

	@ManagedProperty(value="#{EventsService}")
	private IEventsService eventsService;
	
	@ManagedProperty(value="#{logon}")
	private LogonManagedImpl logon;
	
	//Users actived
	private List<User> tableActivatedUser;
	private List<User> filteredtableActivatedUser;
	//Users
	private List<User> tableUser;
	private List<User> filteredtableUser;
	//selected user
	private User selectedUser;
	private List<GroupUser> tableGroupUserAct;
	private List<GroupUser> filteredtableGroupUserAct;
	private GroupUser selectedGroupUserAct;
	private List<GroupUser> tableGroupUserDis;
	private List<GroupUser> filteredtableGroupUserDis;
	private GroupUser selectedGroupUserDis;
	private List<AppWEB> tableAppAct;
	private List<AppWEB> filteredtableAppAct;
	private AppWEB selectedAppAct;
	private List<AppWEB> tableAppDis;
	private List<AppWEB> filteredtableAppDis;
	private AppWEB selectedAppDis;
	
	private List<UserAppWEB> tableUserAppAct;
	private List<UserAppWEB> filteredtableUserAppAct;
	private UserAppWEB selectedUserAppAct;
	
	//User data
	private String use_id;
	private String use_name;
	private String use_surname1;
	private String use_surname2;
	private String use_direction;
	private String use_email;
	private String use_phone;
	private String use_password;
	private boolean userCreated;
	private boolean userUpdated;
	private String use_detId;
	private boolean userConected;
	//UserEvents
	private List<EventsWEB> tableAllEvents;
	private int intPulsa;
	private FacesUtils faces;
	
	public UserManagedImpl() {
		//System.err.println("Constructor VUSERBEAN");
		tableActivatedUser = new ArrayList<User>();
		filteredtableActivatedUser = new ArrayList<User>();
		tableUser = new ArrayList<User>();
		filteredtableUser = new ArrayList<User>();
		tableAllEvents = new ArrayList<EventsWEB>();
		selectedUser = new User();
		tableGroupUserAct = new ArrayList<GroupUser>();
		tableGroupUserDis = new ArrayList<GroupUser>();
		filteredtableGroupUserAct = new ArrayList<GroupUser>();
		filteredtableGroupUserDis = new ArrayList<GroupUser>();
		selectedGroupUserAct = new GroupUser();
		selectedGroupUserDis = new GroupUser();
		tableAppAct = new ArrayList<AppWEB>();
		filteredtableAppAct = new ArrayList<AppWEB>();
		selectedAppAct = new AppWEB();
		tableAppDis = new ArrayList<AppWEB>();
		filteredtableAppDis = new ArrayList<AppWEB>();
		selectedAppDis = new AppWEB();
		tableUserAppAct = new ArrayList<UserAppWEB>();
		filteredtableUserAppAct = new ArrayList<UserAppWEB>();
		selectedUserAppAct = new UserAppWEB();
		use_id = "";
		use_name = "";
		use_surname1 = "";
		use_surname2 = "";
		use_direction = "";
		use_email = "";
		use_phone = "";
		use_password = "";
		use_detId = "";
		userCreated = false;
		userUpdated = false;
		userConected=false;
		faces = new FacesUtils();
		//System.out.println(logon.getUserId() + " : " + logon.getUserDet());
	}
	
	@PostConstruct
	public void init() {
		try {
			getActivatedUser();
			getUser();
			intPulsa = 1;
			//Get session variable for show user detail
			HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);   
			use_detId = (String) session.getAttribute("use_detId");
			session.removeAttribute("app_detId");
			session.removeAttribute("ser_detId");
	        if (use_detId != null) {
	        	selectedUser = getUserService().getUserId(use_detId);
	        	if (selectedUser.getUse_end_last_connection() == null) {
	        		userConected = false;
	        	} else {
	        		userConected = true;
	        	}
	        	getAllUserEvents();
	        	getTableGroupUser();
	        	getTableAppUser();
	        	getActiveUserApp();
	        }
			//System.err.println("INIT VUSUARIOS");
		} catch (Exception e) {
			System.out.println("USERBEAN:" + e.toString());
		}	
	}

	@Override
	public void getActivatedUser() {
		// TODO Auto-generated method stub
		//GenericApplicationContext appContext = AppUtils.getContext();
		//appContext.refresh();
		//AppUtils.setApplicationContext(appContext);
		List<User> listUser = getUserService().getActiveUser();
		if (listUser != null) {
			setTableActivatedUser(listUser);
		}
		
	}

	@Override
	public void getUser() {
		//GenericApplicationContext appContext = AppUtils.getContext();
		//appContext.refresh();
		//AppUtils.setApplicationContext(appContext);
		List<User> listUser = getUserService().getAllUser();
		if (listUser != null) {
			setTableUser(listUser);
		}
	}

	@Override
	public void dialogNewUser() {
		// TODO Auto-generated method stub
		use_id = "";
		use_name = "";
		use_surname1 = "";
		use_surname2 = "";
		use_direction = "";
		use_email = "";
		use_phone = "";
		use_password = "";
		userCreated = false;
		PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
		props.getProperty(Constant.LOAD_AUTHENTICATION).equals(Constant.CONS_CLIENT);
		if (props.getProperty(Constant.LOAD_AUTHENTICATION).equals(Constant.CONS_CLIENT)) {
			RequestContext.getCurrentInstance().execute(Constant.WEB_MSG_NEWUSERDB);
		} else {
			RequestContext.getCurrentInstance().execute(Constant.WEB_MSG_NEWUSERDB);
		}
	}

	@Override
	public void createUserBD() {
		//System.out.println(getUse_id() + ":"+ use_id + ":" + userCreated + ":" + use_name);
		//Check requiered attributes
		if (lfCheckData()) {
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			User user = new User();
			user.setUse_id(use_id);
			user.setUse_name(use_name);
			user.setUse_surname1(use_surname1);
			user.setUse_surname2(use_surname2);
			user.setUse_direction(use_direction);
			user.setUse_email(use_email);
			user.setUse_phone(use_phone);
			user.setUse_password(use_password);
			user.setUse_start_last_connection(new Date());
			user.setUse_end_last_connection(new Date());
			user.setUse_datmod(new Date());
			user.setUse_usemod(logon.getUserId());
			getUserService().createUser(user);
			//Reply to LDAP SAMBA
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IUserLDAPDao userLdapDao = (IUserLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERDAO);
				UserLDAP userLDAP = userLdapDao.getUserCn(user.getUse_id());
				if (userLDAP == null) {
					userLDAP = new UserLDAP();
					userLDAP.setCn(user.getUse_id());
					userLDAP.setSAMAccountName(user.getUse_id());
					userLDAP.setDescription(user.getUse_name() + " " +
							user.getUse_surname1() + " " +
							user.getUse_surname2());
					userLDAP.setName(user.getUse_name());
					userLDAP.setDisplayName(user.getUse_surname1());
					userLDAP.setRegisteredAddress((user.getUse_direction().equals("") ? Constant.STRING_SINESPECIFICAR : user.getUse_direction()));
					userLDAP.setMail(user.getUse_email());
					userLDAP.setTelephoneNumber((user.getUse_phone().equals("") ? Constant.NUMBER_CERO : user.getUse_phone()));
					userLDAP.setUnicodePwd(user.getUse_password());
					userLdapDao.createUser(userLDAP);
					userLdapDao.setPasswordUser(userLDAP);
				}
			}
			//Set the newUser in userDet session variable for go to detail
			userCreated = true;
			//Set session variable for show user detail
			HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);  
			session.setAttribute("use_detId", user.getUse_id());  
			RequestContext.getCurrentInstance().execute(Constant.WEB_CLOSE_MSG_NEWUSERDB);
			RequestContext context = RequestContext.getCurrentInstance();
			String strRespuesta = Constant.WEB_PAGE_DETUSER + Constant.WEB_FACES_REDIRECT;
			context.addCallbackParam(Constant.ARGS_CORRECT, userCreated);
			context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
			
		} else {
			RequestContext context = RequestContext.getCurrentInstance();
			String strRespuesta = Constant.WEB_PAGE_DETUSER + Constant.WEB_FACES_REDIRECT;
			context.addCallbackParam(Constant.ARGS_CORRECT, userCreated);
			context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
		}
		
	}
	
	@Override
	public void createUserLDAP() {
		
	}
	
	@Override
	public void closeConnection() {
		/*
		 * 
		 * Pendiente de realizar la grabacin en lw_action
		 * 
		 */
		FacesMessage msg = null;
		LanguageUtils lang = new LanguageUtils();
		msg = new FacesMessage(FacesMessage.SEVERITY_INFO,lang.getMessage("gen_request"),
				lang.getMessage("gen_send_close_ok"));
		FacesContext.getCurrentInstance().addMessage(null, msg);
	}
	
	@Override
	public void dialogUpdUser() {
		// TODO Auto-generated method stub
		RequestContext.getCurrentInstance().execute(Constant.WEB_MSG_UPDUSER);
	}
	
	@Override
	public void updateUser() {
		LanguageUtils lang = new LanguageUtils();
		userUpdated = true;
		use_id = selectedUser.getUse_id();
		use_name = selectedUser.getUse_name();
		use_surname1 = selectedUser.getUse_surname1();
		use_surname2 = selectedUser.getUse_surname2();
		use_direction = selectedUser.getUse_direction();
		use_email = selectedUser.getUse_email();
		use_phone = selectedUser.getUse_phone();
		use_password = selectedUser.getUse_password();
		if (lfCheckData()) {
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			selectedUser.setUse_datmod(new Date());
			selectedUser.setUse_usemod(logon.getUserId());
			getUserService().updateUser(selectedUser);
			//Reply to LDAP SAMBA
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)){
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IUserLDAPDao userLdapDao = (IUserLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERDAO);
				UserLDAP userLDAP = userLdapDao.getUserCn(selectedUser.getUse_id());
				if (userLDAP == null) {
					userLDAP = new UserLDAP();
					userLDAP.setCn(selectedUser.getUse_id());
					userLDAP.setSAMAccountName(selectedUser.getUse_id());
					userLDAP.setDescription(selectedUser.getUse_name() + " " +
							selectedUser.getUse_surname1() + " " +
							selectedUser.getUse_surname2());
					userLDAP.setName(selectedUser.getUse_name());
					userLDAP.setDisplayName(selectedUser.getUse_surname1());
					userLDAP.setRegisteredAddress((selectedUser.getUse_direction().equals("") ? Constant.STRING_SINESPECIFICAR : selectedUser.getUse_direction()));
					userLDAP.setMail(selectedUser.getUse_email());
					userLDAP.setTelephoneNumber((selectedUser.getUse_phone().equals("") ? Constant.NUMBER_CERO : selectedUser.getUse_phone()));
					userLDAP.setUnicodePwd(selectedUser.getUse_password());
					userLdapDao.createUser(userLDAP);
					userLdapDao.setPasswordUser(userLDAP);
				} else {
					userLDAP.setCn(selectedUser.getUse_id());
					userLDAP.setSAMAccountName(selectedUser.getUse_id());
					userLDAP.setDescription(selectedUser.getUse_name() + " " +
							selectedUser.getUse_surname1() + " " +
							selectedUser.getUse_surname2());
					userLDAP.setName(selectedUser.getUse_name());
					userLDAP.setDisplayName(selectedUser.getUse_surname1());
					userLDAP.setRegisteredAddress((selectedUser.getUse_direction().equals("") ? Constant.STRING_SINESPECIFICAR : selectedUser.getUse_direction()));
					userLDAP.setMail(selectedUser.getUse_email());
					userLDAP.setTelephoneNumber((selectedUser.getUse_phone().equals("") ? Constant.NUMBER_CERO : selectedUser.getUse_phone()));
					userLDAP.setUnicodePwd(selectedUser.getUse_password());
					userLdapDao.updateUser(userLDAP);
					userLdapDao.setPasswordUser(userLDAP);
				}
			}
			//Set the newUser in useDet session varible for detail
			userCreated = true;
			//Srt session variable for show user detail
			HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);
			session.setAttribute("use_detId", selectedUser.getUse_id());
			RequestContext.getCurrentInstance().execute(Constant.WEB_CLOSE_MSG_UPDUSER);
			RequestContext context = RequestContext.getCurrentInstance();
			String strRespuesta = Constant.WEB_PAGE_DETUSER + Constant.WEB_FACES_REDIRECT;
			context.addCallbackParam(Constant.ARGS_CORRECT, userCreated);
			context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
			faces.sendMessage(lang.getMessage("gen_correct"),
					lang.getMessage("gen_save_ok"), Constant.MSG_INFORMATION);
		} else {
			RequestContext context = RequestContext.getCurrentInstance();
			String strRespuesta = Constant.WEB_PAGE_DETUSER + Constant.WEB_FACES_REDIRECT;
			context.addCallbackParam(Constant.ARGS_CORRECT, userCreated);
			context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_KO, Constant.MSG_CRITICAL);
			
		}
	}
	
	@Override
	public void deleteUser() {
		PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
		getUserService().deleteUser(selectedUser);
		//Reply to LDAP SAMBA
		if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)){
			Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
			BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
			IUserLDAPDao userLdapDao = (IUserLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERDAO);
			UserLDAP userLDAP = userLdapDao.getUserCn(selectedUser.getUse_id());
			userLdapDao.deleteUser(userLDAP);
		}
		//Set the newUser in useDet session varible for detail
		userCreated = false;
		//Srt session variable for show user detail
		HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);
		session.removeAttribute("use_detId");
		RequestContext context = RequestContext.getCurrentInstance();
		String strRespuesta = Constant.WEB_PAGE_HOMEUSER + Constant.WEB_FACES_REDIRECT;
		context.addCallbackParam(Constant.ARGS_CORRECT, true);
		context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
		faces.sendMessage("gen_correct",
				"gen_remove_ok", Constant.MSG_INFORMATION);
	
		
	}
	
	@Override
	public void gotoDetApp() {
		HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);  
		session.setAttribute("app_detId", selectedUserAppAct.getApp_id());  
		RequestContext context = RequestContext.getCurrentInstance();
		String strRespuesta = Constant.WEB_PAGE_DETAPP + Constant.WEB_FACES_REDIRECT;
		context.addCallbackParam(Constant.ARGS_CORRECT, true);
		context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
	}
	
	@Override
	public void gotoDetSer() {
		HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);  
		session.setAttribute("ser_detId", selectedUserAppAct.getSer_id());  
		RequestContext context = RequestContext.getCurrentInstance();
		String strRespuesta = Constant.WEB_PAGE_DETSERVER + Constant.WEB_FACES_REDIRECT;
		context.addCallbackParam(Constant.ARGS_CORRECT, true);
		context.addCallbackParam(Constant.ARGS_VIEW, strRespuesta);
	}
	
	private boolean lfCheckData() {
		FacesMessage msg = null;
		LanguageUtils lang = new LanguageUtils();
		boolean blnCorrect = true;
		if (getUse_id().equals("")) {
			msg = new FacesMessage(FacesMessage.SEVERITY_INFO,lang.getMessage("gen_id"),
					lang.getMessage("gen_requiered"));
			FacesContext.getCurrentInstance().addMessage(null, msg);
			blnCorrect = false;
		}
		if (getUse_name().equals("")) {
			msg = new FacesMessage(FacesMessage.SEVERITY_INFO,lang.getMessage("gen_name"),
					lang.getMessage("gen_requiered"));
			FacesContext.getCurrentInstance().addMessage(null, msg);
			blnCorrect = false;
		}
		if (getUse_surname1().equals("")) {
			msg = new FacesMessage(FacesMessage.SEVERITY_INFO,lang.getMessage("gen_surname1"),
					lang.getMessage("gen_requiered"));
			FacesContext.getCurrentInstance().addMessage(null, msg);
			blnCorrect = false;
		}
		if (getUse_email().equals("")) {
			msg = new FacesMessage(FacesMessage.SEVERITY_INFO,lang.getMessage("gen_email"),
					lang.getMessage("gen_requiered"));
			FacesContext.getCurrentInstance().addMessage(null, msg);
			blnCorrect = false;
		}
		if (getUse_password().equals("")) {
			msg = new FacesMessage(FacesMessage.SEVERITY_INFO,lang.getMessage("gen_password"),
					lang.getMessage("gen_requiered"));
			FacesContext.getCurrentInstance().addMessage(null, msg);
			blnCorrect = false;
		}
		if (! getUse_id().equals("") && ! userUpdated ) {
			User user = getUserService().getUserId(getUse_id());
			if (user != null) {
				msg = new FacesMessage(FacesMessage.SEVERITY_WARN,lang.getMessage("gen_error"),
						lang.getMessage("use_user_exis"));
				FacesContext.getCurrentInstance().addMessage(null, msg);
				blnCorrect = false;
			}
		}
		return blnCorrect;
	}
	
	@Override
	public void getAllUserEvents() {
		// TODO Auto-generated method stub
		//RequestContext context = RequestContext.getCurrentInstance();
		//GenericApplicationContext appContext = AppUtils.getContext();
		//appContext.refresh();
		//AppUtils.setApplicationContext(appContext);
		//System.out.println("getAllEvents");
		SimpleDateFormat sdf = new SimpleDateFormat(Constant.MASK_DATE_WEB);
		Date datTemporal = null;
		String strtypeEvent = null;
		String strtextEvent = null;
		String striconEvent = null;
		LanguageUtils lang = new LanguageUtils();
		List<Events> listEvents = getEventsService().getUserEvents(selectedUser, intPulsa);
		if (listEvents != null) {
			tableAllEvents = new ArrayList<EventsWEB>();
			for (int i=0; i < listEvents.size(); i++) {
				EventsWEB eventsWEB = new EventsWEB();
				datTemporal = listEvents.get(i).getEve_datetime();
				eventsWEB.setDateTime(sdf.format(datTemporal));
				switch(listEvents.get(i).getTypeEvent().getTev_id()) {
				case Constant.EVE_START_SESSION:
					striconEvent = Constant.EVE_ICON_USER_EVENT;
					strtypeEvent = lang.getMessage(Constant.EVE_TXT_STAR_SESSION);
					strtextEvent = lang.getMessage(Constant.I18N_EVE_TXT_USER) + " " +
							       listEvents.get(i).getEve_adic_data_1() + " " +
							       lang.getMessage(Constant.I18N_EVE_TXT_STARTED_SESSION);
					break;
				case Constant.EVE_END_SESSION:
					striconEvent = Constant.EVE_ICON_USER_EVENT;
					strtypeEvent = lang.getMessage(Constant.EVE_TXT_END_SESSION);
					strtextEvent = lang.getMessage(Constant.I18N_EVE_TXT_USER) + " " +
							       listEvents.get(i).getEve_adic_data_1() + " " +
							       lang.getMessage(Constant.I18N_EVE_TXT_ENDED_SESSION);
					break;
				case Constant.EVE_STAR_APPLICATION:
					striconEvent = Constant.EVE_ICON_APP_EVENT;
					strtypeEvent = lang.getMessage(Constant.EVE_TXT_STAR_APPLICATION);
					strtextEvent = lang.getMessage(Constant.I18N_EVE_TXT_USER) + " " +
							       listEvents.get(i).getEve_adic_data_1() + " " +
							       lang.getMessage(Constant.I18N_EVE_TXT_STARTED_APPLICATION) + " " +
							       listEvents.get(i).getEve_adic_data_2() + " " +
							       lang.getMessage(Constant.I18N_EVE_TXT_SERVER) + " " +
							       listEvents.get(i).getEve_adic_data_3();
					break;
				case Constant.EVE_END_APPLICATION:
					striconEvent = Constant.EVE_ICON_APP_EVENT;
					strtypeEvent = lang.getMessage(Constant.EVE_TXT_END_APPLICATION);
					strtextEvent = lang.getMessage(Constant.I18N_EVE_TXT_USER) + " " +
						       listEvents.get(i).getEve_adic_data_1() + " " +
						       lang.getMessage(Constant.I18N_EVE_TXT_ENDED_APPLICATION) + " " +
						       listEvents.get(i).getEve_adic_data_2() + " " +
						       lang.getMessage(Constant.I18N_EVE_TXT_SERVER) + " " +
						       listEvents.get(i).getEve_adic_data_3();
					break;
				}
				eventsWEB.setIconEvent(striconEvent);
				eventsWEB.setTypeEvent(strtypeEvent);
				eventsWEB.setTextEvent(strtextEvent);
				eventsWEB.setUserName(selectedUser.getUse_name() + selectedUser.getUse_surname1());
				tableAllEvents.add(eventsWEB);
			}
		}
	}

	@Override
	public void getMoreUserEvents() {
		// TODO Auto-generated method stub
		setIntPulsa(this.intPulsa + 1);
		//System.out.println(this.intPulsa);
		getAllUserEvents();
	}
	
	@Override
	public void getTableGroupUser() {
		List<GroupUser> lstTemp = new ArrayList<GroupUser>();
		List<GroupUser> lstTempGroupUser = new ArrayList<GroupUser>();
		if (selectedUser.getUse_id() != null) {
			lstTempGroupUser = getGroupUserService().getAllGroupUser();
			List<UserGroup> userGroups = getUserService().getAllGroupUser(selectedUser);
			if (userGroups != null) {
				for (int i=0; i < userGroups.size(); i++) {
					lstTemp.add(userGroups.get(i).getUserGroupPK().getGroup());
					lstTempGroupUser.remove(userGroups.get(i).getUserGroupPK().getGroup());
				}
				setTableGroupUserAct(lstTemp);
				setTableGroupUserDis(lstTempGroupUser);
			}
			setTableGroupUserAct(lstTemp);
			setTableGroupUserDis(lstTempGroupUser);
		}
	}
	
	@Override
	public void getTableAppUser() {
		List<AppWEB> lstTemp = new ArrayList<AppWEB>();
		List<AppWEB> lstTempApp = new ArrayList<AppWEB>();
		List<Applications> listApp = getAppService().getAllApplications();
		if (selectedUser.getUse_id() != null) {
			if (!listApp.isEmpty()) {
				List<UserApp> userApps = getUserService().getAllUserApp(selectedUser);
				if (userApps != null) {
					for (int i = 0; i < userApps.size(); i++) {
						AppWEB appWEB = new AppWEB();
						appWEB.setApp_id(userApps.get(i).getUserAppPK().getApplications().getApp_id());
						appWEB.setApp_name(userApps.get(i).getUserAppPK().getApplications().getApp_name());
						appWEB.setApp_description(userApps.get(i).getUserAppPK().getApplications().getApp_description());
						appWEB.setApp_display_name(userApps.get(i).getUserAppPK().getApplications().getApp_display_name());
						appWEB.setApp_path_exe(userApps.get(i).getUserAppPK().getApplications().getApp_path_exe());
						appWEB.setApp_syo(userApps.get(i).getUserAppPK().getApplications().getFk_app_syo_id().getSyo_description());
						appWEB.setApp_usemod(userApps.get(i).getUserAppPK().getApplications().getApp_usemod());
						appWEB.setApp_datmod(userApps.get(i).getUserAppPK().getApplications().getApp_datmod());
						lstTemp.add(appWEB);
					}
				}
				for (int i = 0; i < listApp.size(); i++) {
					AppWEB appWEB = new AppWEB();
					appWEB.setApp_id(listApp.get(i).getApp_id());
					appWEB.setApp_name(listApp.get(i).getApp_name());
					appWEB.setApp_description(listApp.get(i).getApp_description());
					appWEB.setApp_display_name(listApp.get(i).getApp_display_name());
					appWEB.setApp_path_exe(listApp.get(i).getApp_path_exe());
					appWEB.setApp_syo(listApp.get(i).getFk_app_syo_id().getSyo_description());
					appWEB.setApp_usemod(listApp.get(i).getApp_usemod());
					appWEB.setApp_datmod(listApp.get(i).getApp_datmod());
					boolean blnExiste = false;
					for (int iContaAct = 0; iContaAct < lstTemp.size(); iContaAct ++) {
						if (lstTemp.get(iContaAct).getApp_id() == appWEB.getApp_id()) {
							blnExiste = true;
						}
					}
					if (!blnExiste) {
						lstTempApp.add(appWEB);
					}
				}
			
			
			}
			setTableAppAct(lstTemp);
			setTableAppDis(lstTempApp);
		}
	}
	
	
	@Override
	public void onUserDrop(DragDropEvent ddEvent) {
		try {
			GroupUser groupUser =((GroupUser) ddEvent.getData());
			//Process db insert the new group user
			boolean blnResult = getUserService().addGroupUser(selectedUser, groupUser);
			//Reply to LDAP SAMBA
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				boolean blnExisUserGroup = false;
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IUserGroupLDAPDao userGroupLdapDao = (IUserGroupLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERGROUPDAO);
				List resultUG = userGroupLdapDao.getUserGroupByUser(selectedUser.getUse_id());
				for (int i = 0; i < resultUG.size(); i++) {
					UserGroupLDAP resultGroups = (UserGroupLDAP) resultUG.get(i);
					String[] groups = resultGroups.getUsersGroup();
					if (groups != null) {
						for (int g = 0; g < groups.length; g++) {
							if (groups[g].startsWith(Constant.KEY_STR_DNAME_CN_EQUAL + groupUser.getGus_cn())) {
								blnExisUserGroup = true;
							}
						}
					}
				}
				if (!blnExisUserGroup) {
					UserLDAP userLdap = new UserLDAP();
					IUserLDAPDao userLdapDao = (IUserLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERDAO);
					userLdap = userLdapDao.getUserCn(selectedUser.getUse_id());
					GroupUserLDAP groupUserLdap = new GroupUserLDAP();
					IGroupLDAPDao groupUserLdapDao = (IGroupLDAPDao)factorySAMBA.getBean(Constant.BEAN_GROUPDAO);
					groupUserLdap = groupUserLdapDao.getGroupCn(groupUser.getGus_cn());
					UserGroupLDAP newUserGroupLdap = new UserGroupLDAP();
					newUserGroupLdap.setCnGroup(groupUserLdap.getCn());
					newUserGroupLdap.setDnGroup(groupUserLdap.getDistinguishedName());
					newUserGroupLdap.setCnUser(userLdap.getCn());
					newUserGroupLdap.setDnUser(userLdap.getDistinguishedName());
					userGroupLdapDao.createUserGroup(newUserGroupLdap);
				}
			}
			//End reply SAMBA
			if (blnResult) {
				tableGroupUserAct.add(groupUser);
				tableGroupUserDis.remove(groupUser);
				faces.sendMessage(Constant.TXT_GEN_CORRECT, Constant.TXT_GEN_SAVE_OK,
						Constant.MSG_INFORMATION);
			} else {
				faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_OK,
						Constant.MSG_CRITICAL);
			}
			
		} catch (Exception e) {
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_OK,
					Constant.MSG_CRITICAL);
			e.printStackTrace();
		}
	}
	
	@Override
	public void addUserGroup() {
		try {
			boolean blnResult = getUserService().addGroupUser(selectedUser, selectedGroupUserDis);
			//Reply to LDAP SAMBA
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				boolean blnExisUserGroup = false;
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IUserGroupLDAPDao userGroupLdapDao = (IUserGroupLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERGROUPDAO);
				List resultUG = userGroupLdapDao.getUserGroupByUser(selectedUser.getUse_id());
				for (int i = 0; i < resultUG.size(); i++) {
					UserGroupLDAP resultGroups = (UserGroupLDAP) resultUG.get(i);
					String[] groups = resultGroups.getUsersGroup();
					if (groups != null) {
						for (int g = 0; g < groups.length; g++) {
							if (groups[g].startsWith(Constant.KEY_STR_DNAME_CN_EQUAL + selectedGroupUserDis.getGus_cn())) {
								blnExisUserGroup = true;
							}
						}
					}
				}
				if (!blnExisUserGroup) {
					UserLDAP userLdap = new UserLDAP();
					IUserLDAPDao userLdapDao = (IUserLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERDAO);
					userLdap = userLdapDao.getUserCn(selectedUser.getUse_id());
					GroupUserLDAP groupUserLdap = new GroupUserLDAP();
					IGroupLDAPDao groupUserLdapDao = (IGroupLDAPDao)factorySAMBA.getBean(Constant.BEAN_GROUPDAO);
					groupUserLdap = groupUserLdapDao.getGroupCn(selectedGroupUserDis.getGus_cn());
					UserGroupLDAP newUserGroupLdap = new UserGroupLDAP();
					newUserGroupLdap.setCnGroup(groupUserLdap.getCn());
					newUserGroupLdap.setDnGroup(groupUserLdap.getDistinguishedName());
					newUserGroupLdap.setCnUser(userLdap.getCn());
					newUserGroupLdap.setDnUser(userLdap.getDistinguishedName());
					userGroupLdapDao.createUserGroup(newUserGroupLdap);
				}
			}
			//End reply SAMBA
			if (blnResult) {
				tableGroupUserAct.add(selectedGroupUserDis);
				tableGroupUserDis.remove(selectedGroupUserDis);
				faces.sendMessage(Constant.TXT_GEN_CORRECT, Constant.TXT_GEN_SAVE_OK,
						Constant.MSG_INFORMATION);
			} else {
				faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_OK,
						Constant.MSG_CRITICAL);
			}
			
		} catch (Exception e) {
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_OK,
					Constant.MSG_CRITICAL);
			e.printStackTrace();
		}
	}
	
	@Override
	public void removeUserGroup() {
		try {
			boolean blnResult = getUserService().removeGroupUser(selectedUser, selectedGroupUserAct);
			//Reply to LDAP SAMBA
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				boolean blnExisUserGroup = false;
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IUserGroupLDAPDao userGroupLdapDao = (IUserGroupLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERGROUPDAO);
				List resultUG = userGroupLdapDao.getUserGroupByUser(selectedUser.getUse_id());
				for (int i = 0; i < resultUG.size(); i++) {
					UserGroupLDAP resultGroups = (UserGroupLDAP) resultUG.get(i);
					String[] groups = resultGroups.getUsersGroup();
					if (groups != null) {
						for (int g = 0; g < groups.length; g++) {
							if (groups[g].startsWith(Constant.KEY_STR_DNAME_CN_EQUAL + selectedGroupUserAct.getGus_cn())) {
								blnExisUserGroup = true;
							}
						}
					}
				}
				if (blnExisUserGroup) {
					UserLDAP userLdap = new UserLDAP();
					IUserLDAPDao userLdapDao = (IUserLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERDAO);
					userLdap = userLdapDao.getUserCn(selectedUser.getUse_id());
					GroupUserLDAP groupUserLdap = new GroupUserLDAP();
					IGroupLDAPDao groupUserLdapDao = (IGroupLDAPDao)factorySAMBA.getBean(Constant.BEAN_GROUPDAO);
					groupUserLdap = groupUserLdapDao.getGroupCn(selectedGroupUserAct.getGus_cn());
					UserGroupLDAP newUserGroupLdap = new UserGroupLDAP();
					newUserGroupLdap.setCnGroup(groupUserLdap.getCn());
					newUserGroupLdap.setDnGroup(groupUserLdap.getDistinguishedName());
					newUserGroupLdap.setCnUser(userLdap.getCn());
					newUserGroupLdap.setDnUser(userLdap.getDistinguishedName());
					userGroupLdapDao.removeUserGroup(newUserGroupLdap);
				}
			}
			//End reply SAMBA
			if (blnResult) {
				tableGroupUserAct.remove(selectedGroupUserAct);
				tableGroupUserDis.add(selectedGroupUserAct);
				faces.sendMessage(Constant.TXT_GEN_CORRECT, Constant.TXT_GEN_REMOVE_OK,
						Constant.MSG_INFORMATION);
			} else {
				faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_REMOVE_OK,
						Constant.MSG_CRITICAL);
			}
			
		} catch (Exception e) {
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_OK,
					Constant.MSG_CRITICAL);
			e.printStackTrace();
		}
	}
	
	@Override
	public void onAppDrop(DragDropEvent ddEvent) {
		try {
			AppWEB appWeb =((AppWEB) ddEvent.getData());
			Applications app = getAppService().getApplicationsId(appWeb.getApp_id());
			//Process db insert the new group user
			boolean blnResult = getUserService().addUserApp(selectedUser, app);
			//Reply to SAMBA
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				boolean blnExisUserApp = false;
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IUserAppLDAPDao userAppLdapDao = (IUserAppLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERAPPDAO);
				List resultUG = userAppLdapDao.getApplicationsUser(selectedUser.getUse_id());
				for (int i = 0; i < resultUG.size(); i++) {
					UserAppLDAP resultApp = (UserAppLDAP) resultUG.get(i);
					String[] apps = resultApp.getApplicationsUser();
					if (apps != null) {
						for (int g = 0; g < apps.length; g++) {
							if (apps[g].equals(app.getApp_name())) {
								blnExisUserApp = true;
							}
						}
					}
				}
				if (!blnExisUserApp) {
					UserLDAP userLdap = new UserLDAP();
					IUserLDAPDao userLdapDao = (IUserLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERDAO);
					userLdap = userLdapDao.getUserCn(selectedUser.getUse_id());
					ApplicationLDAP appLdap = new ApplicationLDAP();
					IApplicationLDAPDao appLdapDao = (IApplicationLDAPDao)factorySAMBA.getBean(Constant.BEAN_APPDAO);
					appLdap = appLdapDao.getApplicationCn(app.getApp_name());
					UserAppLDAP newUserAppLdap = new UserAppLDAP();
					newUserAppLdap.setCnApplication(appLdap.getCn());
					newUserAppLdap.setDnApplication(appLdap.getDistinguishedName());
					newUserAppLdap.setCnUser(userLdap.getCn());
					newUserAppLdap.setDnUser(userLdap.getDistinguishedName());
					userAppLdapDao.createUserApp(newUserAppLdap);
				}
			}
			//End reply SAMBA
			if (blnResult) {
				tableAppAct.add(appWeb);
				tableAppDis.remove(appWeb);
				faces.sendMessage(Constant.TXT_GEN_CORRECT, Constant.TXT_GEN_SAVE_OK,
						Constant.MSG_INFORMATION);
			} else {
				faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_KO,
						Constant.MSG_CRITICAL);
			}
			
		} catch (Exception e) {
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_KO,
					Constant.MSG_CRITICAL);
			e.printStackTrace();
		}
	}
	
	@Override
	public void addUserApp() {
		try {
			Applications app = getAppService().getApplicationsId(selectedAppDis.getApp_id());
			//Process db insert the new group user
			boolean blnResult = getUserService().addUserApp(selectedUser, app);
			//Reply to SAMBA
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				boolean blnExisUserApp = false;
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IUserAppLDAPDao userAppLdapDao = (IUserAppLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERAPPDAO);
				List resultUG = userAppLdapDao.getApplicationsUser(selectedUser.getUse_id());
				for (int i = 0; i < resultUG.size(); i++) {
					UserAppLDAP resultApp = (UserAppLDAP) resultUG.get(i);
					String[] apps = resultApp.getApplicationsUser();
					if (apps != null) {
						for (int g = 0; g < apps.length; g++) {
							if (apps[g].equals(app.getApp_name())) {
								blnExisUserApp = true;
							}
						}
					}
				}
				if (!blnExisUserApp) {
					UserLDAP userLdap = new UserLDAP();
					IUserLDAPDao userLdapDao = (IUserLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERDAO);
					userLdap = userLdapDao.getUserCn(selectedUser.getUse_id());
					ApplicationLDAP appLdap = new ApplicationLDAP();
					IApplicationLDAPDao appLdapDao = (IApplicationLDAPDao)factorySAMBA.getBean(Constant.BEAN_APPDAO);
					appLdap = appLdapDao.getApplicationCn(app.getApp_name());
					UserAppLDAP newUserAppLdap = new UserAppLDAP();
					newUserAppLdap.setCnApplication(appLdap.getCn());
					newUserAppLdap.setDnApplication(appLdap.getDistinguishedName());
					newUserAppLdap.setCnUser(userLdap.getCn());
					newUserAppLdap.setDnUser(userLdap.getDistinguishedName());
					userAppLdapDao.createUserApp(newUserAppLdap);
				}
			}
			//End reply SAMBA
			if (blnResult) {
				tableAppAct.add(selectedAppDis);
				tableAppDis.remove(selectedAppDis);
				faces.sendMessage(Constant.TXT_GEN_CORRECT, Constant.TXT_GEN_SAVE_OK,
						Constant.MSG_INFORMATION);
			} else {
				faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_KO,
						Constant.MSG_CRITICAL);
			}
			
		} catch (Exception e) {
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_SAVE_KO,
					Constant.MSG_CRITICAL);
			e.printStackTrace();
		}
	}
	
	@Override
	public void removeUserApp() {
		try {
			Applications app = getAppService().getApplicationsId(selectedAppAct.getApp_id());
			//Process db insert the new group user
			boolean blnResult = getUserService().removeUserApp(selectedUser, app);
			//Reply to SAMBA
			PropertiesUtils props = new PropertiesUtils(Constant.CONFIG_FILE_LIBREWORK);
			if (props.getProperty(Constant.LOAD_REPSAMBA).equals(Constant.CONS_Y)) {
				boolean blnExisUserApp = false;
				Resource resourceSAMBA = new ClassPathResource(Constant.CONFIG_FILE_LDAP);
				BeanFactory factorySAMBA = new XmlBeanFactory(resourceSAMBA);
				IUserAppLDAPDao userAppLdapDao = (IUserAppLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERAPPDAO);
				List resultUG = userAppLdapDao.getApplicationsUser(selectedUser.getUse_id());
				for (int i = 0; i < resultUG.size(); i++) {
					UserAppLDAP resultApp = (UserAppLDAP) resultUG.get(i);
					String[] apps = resultApp.getApplicationsUser();
					if (apps != null) {
						for (int g = 0; g < apps.length; g++) {
							if (apps[g].equals(app.getApp_name())) {
								blnExisUserApp = true;
							}
						}
					}
				}
				if (!blnExisUserApp) {
					UserLDAP userLdap = new UserLDAP();
					IUserLDAPDao userLdapDao = (IUserLDAPDao)factorySAMBA.getBean(Constant.BEAN_USERDAO);
					userLdap = userLdapDao.getUserCn(selectedUser.getUse_id());
					ApplicationLDAP appLdap = new ApplicationLDAP();
					IApplicationLDAPDao appLdapDao = (IApplicationLDAPDao)factorySAMBA.getBean(Constant.BEAN_APPDAO);
					appLdap = appLdapDao.getApplicationCn(app.getApp_name());
					UserAppLDAP newUserAppLdap = new UserAppLDAP();
					newUserAppLdap.setCnApplication(appLdap.getCn());
					newUserAppLdap.setDnApplication(appLdap.getDistinguishedName());
					newUserAppLdap.setCnUser(userLdap.getCn());
					newUserAppLdap.setDnUser(userLdap.getDistinguishedName());
					userAppLdapDao.deleteUserApp(newUserAppLdap);
				}
			}
			//End reply SAMBA
			if (blnResult) {
				tableAppAct.remove(selectedAppAct);
				tableAppDis.add(selectedAppAct);
				faces.sendMessage(Constant.TXT_GEN_CORRECT, Constant.TXT_GEN_REMOVE_OK,
						Constant.MSG_INFORMATION);
			} else {
				faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_REMOVE_KO,
						Constant.MSG_CRITICAL);
			}
			 
		} catch (Exception e) {
			faces.sendMessage(Constant.TXT_GEN_ERROR, Constant.TXT_GEN_REMOVE_KO,
					Constant.MSG_CRITICAL);
			e.printStackTrace();
		}
	}
	
	@Override
	public void getActiveUserApp() {
		List<UserApp> lstUserApp = new ArrayList<UserApp>();
		List<UserAppWEB> lstUserAppWeb = new ArrayList<UserAppWEB>();
		try {
			lstUserApp = getUserService().getUserAppActive(selectedUser);
			if (lstUserApp != null) {
				for (int i = 0; i < lstUserApp.size(); i++) {
					UserAppWEB userAppWeb = new UserAppWEB();
					User user = getUserService().getUserId(lstUserApp.get(i).getFk_uap_use_id());
					Applications app = getAppService().getApplicationsId(lstUserApp.get(i).getFk_uap_app_id());
					Server server = getServerService().getServerId(lstUserApp.get(i).getFk_uap_ser_id().getSer_id());
					userAppWeb.setUse_id(user.getUse_id());
					userAppWeb.setUse_name(user.getUse_name() + user.getUse_surname1());
					userAppWeb.setApp_id(app.getApp_id());
					userAppWeb.setApp_description(app.getApp_description());
					userAppWeb.setSer_id(server.getSer_id());
					userAppWeb.setSer_host(server.getSer_host());
					userAppWeb.setSer_description(server.getSer_description());
					userAppWeb.setUap_start_date_process(lstUserApp.get(i).getUap_start_date_process());
					userAppWeb.setUap_end_date_process(lstUserApp.get(i).getUap_end_date_process());
					userAppWeb.setUap_id_process(lstUserApp.get(i).getUap_id_process());
					userAppWeb.setUap_cpuuse(lstUserApp.get(i).getUap_cpuuse());
					userAppWeb.setUap_memuse(lstUserApp.get(i).getUap_memuse());
					lstUserAppWeb.add(userAppWeb);
				}
			}
			setTableUserAppAct(lstUserAppWeb);
			
		} catch (Exception e) {
			System.err.println("GETACTIVEUSER");
			e.printStackTrace();
		}
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	//** Getters and setters **//
	/**
	 * @return the userService
	 */
	public IUserService getUserService() {
		return userService;
	}

	/**
	 * @param userService the userService to set
	 */
	public void setUserService(IUserService userService) {
		this.userService = userService;
	}

	/**
	 * @return the tableActivatedUser
	 */
	public List<User> getTableActivatedUser() {
		return tableActivatedUser;
	}

	/**
	 * @param tableActivatedUser the tableActivatedUser to set
	 */
	public void setTableActivatedUser(List<User> tableActivatedUser) {
		this.tableActivatedUser = tableActivatedUser;
	}

	/**
	 * @return the filteredtableActivatedUser
	 */
	public List<User> getFilteredtableActivatedUser() {
		return filteredtableActivatedUser;
	}

	/**
	 * @param filteredtableActivatedUser the filteredtableActivatedUser to set
	 */
	public void setFilteredtableActivatedUser(List<User> filteredtableActivatedUser) {
		this.filteredtableActivatedUser = filteredtableActivatedUser;
	}

	
	/**
	 * @return the selectedUser
	 */
	public User getSelectedUser() {
		return selectedUser;
	}

	/**
	 * @param selectedUser the selectedUser to set
	 */
	public void setSelectedUser(User selectedUser) {
		this.selectedUser = selectedUser;
		//Set session variable for show user detail
		HttpSession session = (HttpSession)FacesContext.getCurrentInstance().getExternalContext().getSession(true);  
		session.setAttribute("use_detId", selectedUser.getUse_id()); 
		//System.out.println(logon.getUserId() + " : " + logon.getUserDet());
	}

	/**
	 * @return the tableUser
	 */
	public List<User> getTableUser() {
		return tableUser;
	}

	/**
	 * @param tableUser the tableUser to set
	 */
	public void setTableUser(List<User> tableUser) {
		this.tableUser = tableUser;
	}

	/**
	 * @return the filteredtableUser
	 */
	public List<User> getFilteredtableUser() {
		return filteredtableUser;
	}

	/**
	 * @param filteredtableUser the filteredtableUser to set
	 */
	public void setFilteredtableUser(List<User> filteredtableUser) {
		this.filteredtableUser = filteredtableUser;
	}

	/**
	 * @return the use_id
	 */
	public String getUse_id() {
		return use_id;
	}


	/**
	 * @param use_id the use_id to set
	 */
	public void setUse_id(String use_id) {
		this.use_id = use_id;
	}


	/**
	 * @return the use_name
	 */
	public String getUse_name() {
		return use_name;
	}


	/**
	 * @param use_name the use_name to set
	 */
	public void setUse_name(String use_name) {
		this.use_name = use_name;
	}


	/**
	 * @return the use_surname1
	 */
	public String getUse_surname1() {
		return use_surname1;
	}


	/**
	 * @param use_surname1 the use_surname1 to set
	 */
	public void setUse_surname1(String use_surname1) {
		this.use_surname1 = use_surname1;
	}


	/**
	 * @return the use_surname2
	 */
	public String getUse_surname2() {
		return use_surname2;
	}


	/**
	 * @param use_surname2 the use_surname2 to set
	 */
	public void setUse_surname2(String use_surname2) {
		this.use_surname2 = use_surname2;
	}


	/**
	 * @return the use_direction
	 */
	public String getUse_direction() {
		return use_direction;
	}


	/**
	 * @param use_direction the use_direction to set
	 */
	public void setUse_direction(String use_direction) {
		this.use_direction = use_direction;
	}


	/**
	 * @return the use_email
	 */
	public String getUse_email() {
		return use_email;
	}


	/**
	 * @param use_email the use_email to set
	 */
	public void setUse_email(String use_email) {
		this.use_email = use_email;
	}


	/**
	 * @return the use_phone
	 */
	public String getUse_phone() {
		return use_phone;
	}


	/**
	 * @param use_phone the use_phone to set
	 */
	public void setUse_phone(String use_phone) {
		this.use_phone = use_phone;
	}


	/**
	 * @return the use_password
	 */
	public String getUse_password() {
		return use_password;
	}


	/**
	 * @param use_password the use_password to set
	 */
	public void setUse_password(String use_password) {
		this.use_password = use_password;
	}


	/**
	 * @return the userCreated
	 */
	public boolean isUserCreated() {
		return userCreated;
	}


	/**
	 * @param userCreated the userCreated to set
	 */
	public void setUserCreated(boolean userCreated) {
		this.userCreated = userCreated;
	}

	/**
	 * @return the logon
	 */
	public LogonManagedImpl getLogon() {
		return logon;
	}

	/**
	 * @param logon the logon to set
	 */
	public void setLogon(LogonManagedImpl logon) {
		this.logon = logon;
	}

	/**
	 * @return the use_detId
	 */
	public String getUse_detId() {
		return use_detId;
	}

	/**
	 * @param use_detId the use_detId to set
	 */
	public void setUse_detId(String use_detId) {
		this.use_detId = use_detId;
	}

	/**
	 * @return the userConected
	 */
	public boolean isUserConected() {
		return userConected;
	}

	/**
	 * @param userConected the userConected to set
	 */
	public void setUserConected(boolean userConected) {
		this.userConected = userConected;
	}

	/**
	 * @return the eventsService
	 */
	public IEventsService getEventsService() {
		return eventsService;
	}

	/**
	 * @param eventsService the eventsService to set
	 */
	public void setEventsService(IEventsService eventsService) {
		this.eventsService = eventsService;
	}

	/**
	 * @return the tableAllEvents
	 */
	public List<EventsWEB> getTableAllEvents() {
		return tableAllEvents;
	}

	/**
	 * @param tableAllEvents the tableAllEvents to set
	 */
	public void setTableAllEvents(List<EventsWEB> tableAllEvents) {
		this.tableAllEvents = tableAllEvents;
	}

	/**
	 * @return the intPulsa
	 */
	public int getIntPulsa() {
		return intPulsa;
	}

	/**
	 * @param intPulsa the intPulsa to set
	 */
	public void setIntPulsa(int intPulsa) {
		this.intPulsa = intPulsa;
	}

	/**
	 * @return the tableGroupUserAct
	 */
	public List<GroupUser> getTableGroupUserAct() {
		return tableGroupUserAct;
	}

	/**
	 * @param tableGroupUserAct the tableGroupUserAct to set
	 */
	public void setTableGroupUserAct(List<GroupUser> tableGroupUserAct) {
		this.tableGroupUserAct = tableGroupUserAct;
	}

	/**
	 * @return the tableGroupUserDis
	 */
	public List<GroupUser> getTableGroupUserDis() {
		return tableGroupUserDis;
	}

	/**
	 * @param tableGroupUserDis the tableGroupUserDis to set
	 */
	public void setTableGroupUserDis(List<GroupUser> tableGroupUserDis) {
		this.tableGroupUserDis = tableGroupUserDis;
	}

	/**
	 * @return the groupUserService
	 */
	public IGroupUserService getGroupUserService() {
		return groupUserService;
	}

	/**
	 * @param groupUserService the groupUserService to set
	 */
	public void setGroupUserService(IGroupUserService groupUserService) {
		this.groupUserService = groupUserService;
	}

	/**
	 * @return the appService
	 */
	public IApplicationsService getAppService() {
		return appService;
	}

	/**
	 * @param appService the appService to set
	 */
	public void setAppService(IApplicationsService appService) {
		this.appService = appService;
	}

	/**
	 * @return the tableAppAct
	 */
	public List<AppWEB> getTableAppAct() {
		return tableAppAct;
	}

	/**
	 * @param tableAppAct the tableAppAct to set
	 */
	public void setTableAppAct(List<AppWEB> tableAppAct) {
		this.tableAppAct = tableAppAct;
	}

	/**
	 * @return the tableAppDis
	 */
	public List<AppWEB> getTableAppDis() {
		return tableAppDis;
	}

	/**
	 * @param tableAppDis the tableAppDis to set
	 */
	public void setTableAppDis(List<AppWEB> tableAppDis) {
		this.tableAppDis = tableAppDis;
	}

	/**
	 * @return the filteredtableGroupUserAct
	 */
	public List<GroupUser> getFilteredtableGroupUserAct() {
		return filteredtableGroupUserAct;
	}

	/**
	 * @param filteredtableGroupUserAct the filteredtableGroupUserAct to set
	 */
	public void setFilteredtableGroupUserAct(
			List<GroupUser> filteredtableGroupUserAct) {
		this.filteredtableGroupUserAct = filteredtableGroupUserAct;
	}

	/**
	 * @return the selectedGroupUserAct
	 */
	public GroupUser getSelectedGroupUserAct() {
		return selectedGroupUserAct;
	}

	/**
	 * @param selectedGroupUserAct the selectedGroupUserAct to set
	 */
	public void setSelectedGroupUserAct(GroupUser selectedGroupUserAct) {
		this.selectedGroupUserAct = selectedGroupUserAct;
	}

	/**
	 * @return the filteredtableGroupUserDis
	 */
	public List<GroupUser> getFilteredtableGroupUserDis() {
		return filteredtableGroupUserDis;
	}

	/**
	 * @param filteredtableGroupUserDis the filteredtableGroupUserDis to set
	 */
	public void setFilteredtableGroupUserDis(
			List<GroupUser> filteredtableGroupUserDis) {
		this.filteredtableGroupUserDis = filteredtableGroupUserDis;
	}

	/**
	 * @return the selectedGroupUserDis
	 */
	public GroupUser getSelectedGroupUserDis() {
		return selectedGroupUserDis;
	}

	/**
	 * @param selectedGroupUserDis the selectedGroupUserDis to set
	 */
	public void setSelectedGroupUserDis(GroupUser selectedGroupUserDis) {
		this.selectedGroupUserDis = selectedGroupUserDis;
	}

	/**
	 * @return the filteredtableAppAct
	 */
	public List<AppWEB> getFilteredtableAppAct() {
		return filteredtableAppAct;
	}

	/**
	 * @param filteredtableAppAct the filteredtableAppAct to set
	 */
	public void setFilteredtableAppAct(List<AppWEB> filteredtableAppAct) {
		this.filteredtableAppAct = filteredtableAppAct;
	}

	/**
	 * @return the selectedAppAct
	 */
	public AppWEB getSelectedAppAct() {
		return selectedAppAct;
	}

	/**
	 * @param selectedAppAct the selectedAppAct to set
	 */
	public void setSelectedAppAct(AppWEB selectedAppAct) {
		this.selectedAppAct = selectedAppAct;
	}

	/**
	 * @return the filteredtableAppDis
	 */
	public List<AppWEB> getFilteredtableAppDis() {
		return filteredtableAppDis;
	}

	/**
	 * @param filteredtableAppDis the filteredtableAppDis to set
	 */
	public void setFilteredtableAppDis(List<AppWEB> filteredtableAppDis) {
		this.filteredtableAppDis = filteredtableAppDis;
	}

	/**
	 * @return the selectedAppDis
	 */
	public AppWEB getSelectedAppDis() {
		return selectedAppDis;
	}

	/**
	 * @param selectedAppDis the selectedAppDis to set
	 */
	public void setSelectedAppDis(AppWEB selectedAppDis) {
		this.selectedAppDis = selectedAppDis;
	}

	/**
	 * @return the tableUserAppAct
	 */
	public List<UserAppWEB> getTableUserAppAct() {
		return tableUserAppAct;
	}

	/**
	 * @param tableUserAppAct the tableUserAppAct to set
	 */
	public void setTableUserAppAct(List<UserAppWEB> tableUserAppAct) {
		this.tableUserAppAct = tableUserAppAct;
	}

	/**
	 * @return the filteredtableUserAppAct
	 */
	public List<UserAppWEB> getFilteredtableUserAppAct() {
		return filteredtableUserAppAct;
	}

	/**
	 * @param filteredtableUserAppAct the filteredtableUserAppAct to set
	 */
	public void setFilteredtableUserAppAct(List<UserAppWEB> filteredtableUserAppAct) {
		this.filteredtableUserAppAct = filteredtableUserAppAct;
	}


	/**
	 * @return the serverService
	 */
	public IServerService getServerService() {
		return serverService;
	}

	/**
	 * @param serverService the serverService to set
	 */
	public void setServerService(IServerService serverService) {
		this.serverService = serverService;
	}

	/**
	 * @return the selectedUserAppAct
	 */
	public UserAppWEB getSelectedUserAppAct() {
		return selectedUserAppAct;
	}

	/**
	 * @param selectedUserAppAct the selectedUserAppAct to set
	 */
	public void setSelectedUserAppAct(UserAppWEB selectedUserAppAct) {
		this.selectedUserAppAct = selectedUserAppAct;
	}

	/**
	 * @return the userUpdated
	 */
	public boolean isUserUpdated() {
		return userUpdated;
	}

	/**
	 * @param userUpdated the userUpdated to set
	 */
	public void setUserUpdated(boolean userUpdated) {
		this.userUpdated = userUpdated;
	}
	
	
}
