package com.librework.console.model;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.AssociationOverride;
import javax.persistence.AssociationOverrides;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@Table(name="lw_app_group")
@AssociationOverrides({
	@AssociationOverride(name="fk_agr_gap_id",
			joinColumns = @JoinColumn(name = "AGR_GAP_ID", referencedColumnName = "GAP_ID", insertable = false, updatable = false)),
	@AssociationOverride(name="fk_agr_app_id",
			joinColumns = @JoinColumn(name = "AGR_APP_ID", referencedColumnName = "APP_ID", insertable = false, updatable = false))
})
public class AppGroup implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	private AppGroupPK appGroupPK = new AppGroupPK();
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name="AGR_DATMOD")
	private Date agr_datmod;
	
	@Column(name="AGR_USEMOD")
	private String agr_usemod;
	
	//Bidirectional relation with lw_group_app lw_applications
	@SuppressWarnings("unused")
	@Column(name="AGR_GAP_ID", nullable=false, updatable=false, insertable=false)
	private Long fk_agr_gap_id;
	
	@SuppressWarnings("unused")
	@Column(name="AGR_APP_ID", nullable=false, updatable=false, insertable=false)
	private Long fk_agr_app_id;

	public AppGroup(AppGroupPK appGroupPK, Date agr_datmod, String agr_usemod,
			Long fk_agr_gap_id, Long fk_agr_app_id) {
		super();
		this.appGroupPK = appGroupPK;
		this.agr_datmod = agr_datmod;
		this.agr_usemod = agr_usemod;
		this.fk_agr_gap_id = fk_agr_gap_id;
		this.fk_agr_app_id = fk_agr_app_id;
	}

	public AppGroup() {
		
	}

	/**
	 * @return the appGroupPK
	 */
	public AppGroupPK getAppGroupPK() {
		return appGroupPK;
	}

	/**
	 * @param appGroupPK the appGroupPK to set
	 */
	public void setAppGroupPK(AppGroupPK appGroupPK) {
		this.appGroupPK = appGroupPK;
	}

	/**
	 * @return the agr_datmod
	 */
	public Date getAgr_datmod() {
		return agr_datmod;
	}

	/**
	 * @param agr_datmod the agr_datmod to set
	 */
	public void setAgr_datmod(Date agr_datmod) {
		this.agr_datmod = agr_datmod;
	}

	/**
	 * @return the agr_usemod
	 */
	public String getAgr_usemod() {
		return agr_usemod;
	}

	/**
	 * @param agr_usemod the agr_usemod to set
	 */
	public void setAgr_usemod(String agr_usemod) {
		this.agr_usemod = agr_usemod;
	}

	/**
	 * @return the fk_agr_gap_id
	 */
	public Long getFk_agr_gap_id() {
		return fk_agr_gap_id;
	}

	/**
	 * @param fk_agr_gap_id the fk_agr_gap_id to set
	 */
	public void setFk_agr_gap_id(Long fk_agr_gap_id) {
		this.fk_agr_gap_id = fk_agr_gap_id;
	}

	/**
	 * @return the fk_agr_app_id
	 */
	public Long getFk_agr_app_id() {
		return fk_agr_app_id;
	}

	/**
	 * @param fk_agr_app_id the fk_agr_app_id to set
	 */
	public void setFk_agr_app_id(Long fk_agr_app_id) {
		this.fk_agr_app_id = fk_agr_app_id;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((appGroupPK == null) ? 0 : appGroupPK.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		AppGroup other = (AppGroup) obj;
		if (appGroupPK == null) {
			if (other.appGroupPK != null)
				return false;
		} else if (!appGroupPK.equals(other.appGroupPK))
			return false;
		return true;
	}

	
}
