package com.librework.console.model;

import java.io.Serializable;

import javax.persistence.Embeddable;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;

@Embeddable
public class AppGroupPK implements Serializable {

	private static final long serialVersionUID = 1L;
	
	@ManyToOne(fetch=FetchType.EAGER)
	@JoinColumns( {@JoinColumn(name="AGR_GAP_ID", referencedColumnName="GAP_ID") } )
	protected GroupApp group;
	@ManyToOne(fetch=FetchType.EAGER)
	@JoinColumns( { @JoinColumn(name="AGR_APP_ID", referencedColumnName="APP_ID") } )
	protected Applications app;
	
	public AppGroupPK() {
		
	}

	public AppGroupPK(GroupApp group, Applications app) {
		super();
		this.group = group;
		this.app = app;
	}

	/**
	 * @return the group
	 */
	public GroupApp getGroup() {
		return group;
	}

	/**
	 * @param group the group to set
	 */
	public void setGroup(GroupApp group) {
		this.group = group;
	}

	/**
	 * @return the app
	 */
	public Applications getApp() {
		return app;
	}

	/**
	 * @param app the app to set
	 */
	public void setApp(Applications app) {
		this.app = app;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = ((app == null) ? 0 : app.hashCode());
		result = prime * result + ((group == null) ? 0 : group.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		AppGroupPK other = (AppGroupPK) obj;
		if (app == null) {
			if (other.app != null)
				return false;
		} else if (!app.equals(other.app))
			return false;
		if (group == null) {
			if (other.group != null)
				return false;
		} else if (!group.equals(other.group))
			return false;
		return true;
	}
	
	

	
	

}
