package com.librework.console.model;

import java.io.Serializable;

import javax.persistence.Embeddable;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;

@Embeddable
public class AppServerPK implements Serializable {

	private static final long serialVersionUID = 1L;

	@ManyToOne(fetch=FetchType.EAGER)
	@JoinColumns( { @JoinColumn(name="ASE_APP_ID", referencedColumnName="APP_ID") })
	protected Applications app;
	
	@ManyToOne(fetch=FetchType.EAGER)
	@JoinColumns( { @JoinColumn(name="ASE_SER_ID", referencedColumnName="SER_ID") } )
	protected Server server;

	public AppServerPK(Applications app, Server server) {
		super();
		this.app = app;
		this.server = server;
	}

	public AppServerPK() {
		
	}

	/**
	 * @return the app
	 */
	public Applications getApp() {
		return app;
	}

	/**
	 * @param app the app to set
	 */
	public void setApp(Applications app) {
		this.app = app;
	}

	/**
	 * @return the server
	 */
	public Server getServer() {
		return server;
	}

	/**
	 * @param server the server to set
	 */
	public void setServer(Server server) {
		this.server = server;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = ((app == null) ? 0 : app.hashCode());
		result = prime * result + ((server == null) ? 0 : server.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		AppServerPK other = (AppServerPK) obj;
		if (app == null) {
			if (other.app != null)
				return false;
		} else if (!app.equals(other.app))
			return false;
		if (server == null) {
			if (other.server != null)
				return false;
		} else if (!server.equals(other.server))
			return false;
		return true;
	}
	
	

}
