package com.librework.console.model;

import static javax.persistence.GenerationType.IDENTITY;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@Table(name="lw_events")
public class Events implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=IDENTITY)
	@Column(name="EVE_ID", unique=true, nullable= false)
	private long eve_id;
	
	@ManyToOne(fetch=FetchType.EAGER)
	@JoinColumns( { @JoinColumn(name = "EVE_TEV_ID", referencedColumnName = "TEV_ID") }) 
	private TypeEvent typeEvent;

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name="EVE_DATETIME", nullable=false)
	private Date eve_datetime;

	@Column(name="EVE_DATA")
	private String eve_data;

	@Column(name="EVE_ADIC_DATA_1")
	private String eve_adic_data_1;
	
	@Column(name="EVE_ADIC_DATA_2")
	private String eve_adic_data_2;
	
	@Column(name="EVE_ADIC_DATA_3")
	private String eve_adic_data_3;
	
	@Column(name="EVE_ADIC_DATA_4")
	private String eve_adic_data_4;
	
	@Column(name="EVE_ADIC_DATA_5")
	private String eve_adic_data_5;

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name="EVE_DATMOD", nullable=false)
	private Date eve_datmod;

	@Column(name="EVE_USEMOD", nullable=false)
	private String eve_usemod;
	
	public Events() {}

	public Events(long eve_id, TypeEvent typeEvent, Date eve_datetime,
			String eve_data, String eve_adic_data_1, String eve_adic_data_2,
			String eve_adic_data_3, String eve_adic_data_4,
			String eve_adic_data_5, Date eve_datmod, String eve_usemod) {
		super();
		this.eve_id = eve_id;
		this.typeEvent = typeEvent;
		this.eve_datetime = eve_datetime;
		this.eve_data = eve_data;
		this.eve_adic_data_1 = eve_adic_data_1;
		this.eve_adic_data_2 = eve_adic_data_2;
		this.eve_adic_data_3 = eve_adic_data_3;
		this.eve_adic_data_4 = eve_adic_data_4;
		this.eve_adic_data_5 = eve_adic_data_5;
		this.eve_datmod = eve_datmod;
		this.eve_usemod = eve_usemod;
	}

	/**
	 * @return the eve_id
	 */
	public long getEve_id() {
		return eve_id;
	}

	/**
	 * @param eve_id the eve_id to set
	 */
	public void setEve_id(long eve_id) {
		this.eve_id = eve_id;
	}

	/**
	 * @return the typeEvent
	 */
	public TypeEvent getTypeEvent() {
		return typeEvent;
	}

	/**
	 * @param typeEvent the typeEvent to set
	 */
	public void setTypeEvent(TypeEvent typeEvent) {
		this.typeEvent = typeEvent;
	}

	/**
	 * @return the eve_datetime
	 */
	public Date getEve_datetime() {
		return eve_datetime;
	}

	/**
	 * @param eve_datetime the eve_datetime to set
	 */
	public void setEve_datetime(Date eve_datetime) {
		this.eve_datetime = eve_datetime;
	}

	/**
	 * @return the eve_data
	 */
	public String getEve_data() {
		return eve_data;
	}

	/**
	 * @param eve_data the eve_data to set
	 */
	public void setEve_data(String eve_data) {
		this.eve_data = eve_data;
	}

	/**
	 * @return the eve_adic_data_1
	 */
	public String getEve_adic_data_1() {
		return eve_adic_data_1;
	}

	/**
	 * @param eve_adic_data_1 the eve_adic_data_1 to set
	 */
	public void setEve_adic_data_1(String eve_adic_data_1) {
		this.eve_adic_data_1 = eve_adic_data_1;
	}

	/**
	 * @return the eve_adic_data_2
	 */
	public String getEve_adic_data_2() {
		return eve_adic_data_2;
	}

	/**
	 * @param eve_adic_data_2 the eve_adic_data_2 to set
	 */
	public void setEve_adic_data_2(String eve_adic_data_2) {
		this.eve_adic_data_2 = eve_adic_data_2;
	}

	/**
	 * @return the eve_adic_data_3
	 */
	public String getEve_adic_data_3() {
		return eve_adic_data_3;
	}

	/**
	 * @param eve_adic_data_3 the eve_adic_data_3 to set
	 */
	public void setEve_adic_data_3(String eve_adic_data_3) {
		this.eve_adic_data_3 = eve_adic_data_3;
	}

	/**
	 * @return the eve_adic_data_4
	 */
	public String getEve_adic_data_4() {
		return eve_adic_data_4;
	}

	/**
	 * @param eve_adic_data_4 the eve_adic_data_4 to set
	 */
	public void setEve_adic_data_4(String eve_adic_data_4) {
		this.eve_adic_data_4 = eve_adic_data_4;
	}

	/**
	 * @return the eve_adic_data_5
	 */
	public String getEve_adic_data_5() {
		return eve_adic_data_5;
	}

	/**
	 * @param eve_adic_data_5 the eve_adic_data_5 to set
	 */
	public void setEve_adic_data_5(String eve_adic_data_5) {
		this.eve_adic_data_5 = eve_adic_data_5;
	}

	/**
	 * @return the eve_datmod
	 */
	public Date getEve_datmod() {
		return eve_datmod;
	}

	/**
	 * @param eve_datmod the eve_datmod to set
	 */
	public void setEve_datmod(Date eve_datmod) {
		this.eve_datmod = eve_datmod;
	}

	/**
	 * @return the eve_usemod
	 */
	public String getEve_usemod() {
		return eve_usemod;
	}

	/**
	 * @param eve_usemod the eve_usemod to set
	 */
	public void setEve_usemod(String eve_usemod) {
		this.eve_usemod = eve_usemod;
	}


	
}
