package com.librework.console.model;

import static javax.persistence.GenerationType.IDENTITY;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.annotations.LazyCollection;
import org.hibernate.annotations.LazyCollectionOption;

@Entity
@Table(name="lw_group_app")
public class GroupApp implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=IDENTITY)
	@Column(name="GAP_ID", unique=true, nullable= false)
	private long gap_id;

	@Column(name="GAP_DESCRIPTION", nullable=false)
	private String gap_description;

	@Temporal(TemporalType.DATE)
	@Column(name="GAP_DATMOD")
	private Date gap_datmod;

	@Column(name="GAP_USEMOD")
	private String gap_usemod;
	
	@OneToMany(cascade=CascadeType.ALL, mappedBy="fk_agr_gap_id", orphanRemoval=true)
	@LazyCollection(LazyCollectionOption.TRUE)
	List<AppGroup> appGroups = new ArrayList<AppGroup>();

	public GroupApp(long gap_id, String gap_description, Date gap_datmod,
			String gap_usemod, List<AppGroup> appGroups) {
		super();
		this.gap_id = gap_id;
		this.gap_description = gap_description;
		this.gap_datmod = gap_datmod;
		this.gap_usemod = gap_usemod;
		this.appGroups = appGroups;
	}

	public GroupApp() {
		
	}

	/**
	 * @return the gap_id
	 */
	public long getGap_id() {
		return gap_id;
	}

	/**
	 * @param gap_id the gap_id to set
	 */
	public void setGap_id(long gap_id) {
		this.gap_id = gap_id;
	}

	/**
	 * @return the gap_description
	 */
	public String getGap_description() {
		return gap_description;
	}

	/**
	 * @param gap_description the gap_description to set
	 */
	public void setGap_description(String gap_description) {
		this.gap_description = gap_description;
	}

	/**
	 * @return the gap_datmod
	 */
	public Date getGap_datmod() {
		return gap_datmod;
	}

	/**
	 * @param gap_datmod the gap_datmod to set
	 */
	public void setGap_datmod(Date gap_datmod) {
		this.gap_datmod = gap_datmod;
	}

	/**
	 * @return the gap_usemod
	 */
	public String getGap_usemod() {
		return gap_usemod;
	}

	/**
	 * @param gap_usemod the gap_usemod to set
	 */
	public void setGap_usemod(String gap_usemod) {
		this.gap_usemod = gap_usemod;
	}

	/**
	 * @return the appGroups
	 */
	public List<AppGroup> getAppGroups() {
		return appGroups;
	}

	/**
	 * @param appGroups the appGroups to set
	 */
	public void setAppGroups(List<AppGroup> appGroups) {
		this.appGroups = appGroups;
	}
	
	
	
}
