package com.librework.console.model;

import static javax.persistence.GenerationType.IDENTITY;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.annotations.LazyCollection;
import org.hibernate.annotations.LazyCollectionOption;

@Entity
@Table(name="lw_group_server")
public class GroupServer implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=IDENTITY)
	@Column(name="GRS_ID", unique=true, nullable= false)
	private long grs_id;

	@Column(name="GRS_DESCRIPTION", nullable=false)
	private String grs_description;

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name="GRS_DATMOD")
	private Date grs_datmod;

	@Column(name="GRS_USEMOD")
	private String grs_usemod;
	
	@OneToMany(cascade=CascadeType.ALL, mappedBy="fk_seg_grs_id", orphanRemoval=true)
	@LazyCollection(LazyCollectionOption.TRUE)
	List<ServerGroup> serverGroups = new ArrayList<ServerGroup>();

	public GroupServer(long grs_id, String grs_description, Date grs_datmod,
			String grs_usemod, List<ServerGroup> serverGroups) {
		super();
		this.grs_id = grs_id;
		this.grs_description = grs_description;
		this.grs_datmod = grs_datmod;
		this.grs_usemod = grs_usemod;
		this.serverGroups = serverGroups;
	}

	public GroupServer() {

	}

	/**
	 * @return the grs_id
	 */
	public long getGrs_id() {
		return grs_id;
	}

	/**
	 * @param grs_id the grs_id to set
	 */
	public void setGrs_id(long grs_id) {
		this.grs_id = grs_id;
	}

	/**
	 * @return the grs_description
	 */
	public String getGrs_description() {
		return grs_description;
	}

	/**
	 * @param grs_description the grs_description to set
	 */
	public void setGrs_description(String grs_description) {
		this.grs_description = grs_description;
	}

	/**
	 * @return the grs_datmod
	 */
	public Date getGrs_datmod() {
		return grs_datmod;
	}

	/**
	 * @param grs_datmod the grs_datmod to set
	 */
	public void setGrs_datmod(Date grs_datmod) {
		this.grs_datmod = grs_datmod;
	}

	/**
	 * @return the grs_usemod
	 */
	public String getGrs_usemod() {
		return grs_usemod;
	}

	/**
	 * @param grs_usemod the grs_usemod to set
	 */
	public void setGrs_usemod(String grs_usemod) {
		this.grs_usemod = grs_usemod;
	}

	/**
	 * @return the serverGroups
	 */
	public List<ServerGroup> getServerGroups() {
		return serverGroups;
	}

	/**
	 * @param serverGroups the serverGroups to set
	 */
	public void setServerGroups(List<ServerGroup> serverGroups) {
		this.serverGroups = serverGroups;
	}
	
	
}
