package com.librework.console.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import static javax.persistence.GenerationType.IDENTITY;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.annotations.LazyCollection;
import org.hibernate.annotations.LazyCollectionOption;

@Entity
@Table(name="lw_group_user")
public class GroupUser implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=IDENTITY)
	@Column(name="GUS_ID", unique=true, nullable= false)
	private long gus_id;

	@Column(name="GUS_CN", nullable=false)
	private String gus_cn;

	@Column(name="GUS_NAME", nullable=false)
	private String gus_name;

	@Column(name="GUS_DESCRIPTION", nullable=false)
	private String gus_description;

	@Temporal(TemporalType.DATE)
	@Column(name="GUS_DATMOD", nullable=false)
	private Date gus_datmod;

	@Column(name="GUS_USEMOD", nullable=false)
	private String gus_usemod;
	

	@OneToMany(cascade=CascadeType.ALL, mappedBy="fk_ugr_gus_id", orphanRemoval=true)
	@LazyCollection(LazyCollectionOption.TRUE)
	private List<UserGroup> userGroups = new ArrayList<UserGroup>();
	
	@OneToMany(cascade=CascadeType.ALL, mappedBy="fk_gua_app_id", orphanRemoval=true)
	@LazyCollection(LazyCollectionOption.TRUE)
	private List<GroupUserApp> groupUserApps = new ArrayList<GroupUserApp>();
	
	public GroupUser() {}

	public GroupUser(String gus_cn, String gus_name,
			String gus_description, Date gus_datmod, String gus_usemod,
			List<UserGroup> userGroups) {
		super();
		this.gus_cn = gus_cn;
		this.gus_name = gus_name;
		this.gus_description = gus_description;
		this.gus_datmod = gus_datmod;
		this.gus_usemod = gus_usemod;
		this.userGroups = userGroups;
	}

	public long getGus_id() {
		return gus_id;
	}

	public void setGus_id(long gus_id) {
		this.gus_id = gus_id;
	}

	public String getGus_cn() {
		return gus_cn;
	}

	public void setGus_cn(String gus_cn) {
		this.gus_cn = gus_cn;
	}

	public String getGus_name() {
		return gus_name;
	}

	public void setGus_name(String gus_name) {
		this.gus_name = gus_name;
	}

	public String getGus_description() {
		return gus_description;
	}

	public void setGus_description(String gus_description) {
		this.gus_description = gus_description;
	}

	public Date getGus_datmod() {
		return gus_datmod;
	}

	public void setGus_datmod(Date gus_datmod) {
		this.gus_datmod = gus_datmod;
	}

	public String getGus_usemod() {
		return gus_usemod;
	}

	public void setGus_usemod(String gus_usemod) {
		this.gus_usemod = gus_usemod;
	}

	
	public List<UserGroup> getUserGroups() {
		return userGroups;
	}

	
	public void setUserGroups(List<UserGroup> userGroups) {
		this.userGroups = userGroups;
	}

	/**
	 * @return the groupUserApps
	 */
	public List<GroupUserApp> getGroupUserApps() {
		return groupUserApps;
	}

	/**
	 * @param groupUserApps the groupUserApps to set
	 */
	public void setGroupUserApps(List<GroupUserApp> groupUserApps) {
		this.groupUserApps = groupUserApps;
	}

	
	
}
