package com.librework.console.model;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.AssociationOverride;
import javax.persistence.AssociationOverrides;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@Table(name="lw_group_user_app")
@AssociationOverrides({
	@AssociationOverride(name="fk_gua_gus_id",
			joinColumns = @JoinColumn(name="GUA_GUS_ID", referencedColumnName="GUS_ID", insertable=false, updatable=false)),
	@AssociationOverride(name="fk_gua_app_id",
			joinColumns = @JoinColumn(name="GUA_APP_ID", referencedColumnName="APP_ID", insertable=false, updatable=false))
})
public class GroupUserApp implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	private GroupUserAppPK groupUserAppPK = new GroupUserAppPK();
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name="GUA_DATMOD")
	private Date gua_datmod;

	@Column(name="GUA_USEMOD")
	private String gua_usemod;
	
	@SuppressWarnings("unused")
	@Column(name="GUA_GUS_ID", nullable=false, updatable=false, insertable=false)
	private Long fk_gua_gus_id;
	
	@SuppressWarnings("unused")
	@Column(name="GUA_APP_ID", nullable=false, updatable=false, insertable=false)
	private Long fk_gua_app_id;

	public GroupUserApp(GroupUserAppPK groupUserAppPK, Date gua_datmod,
			String gua_usemod, Long fk_gua_gus_id, Long fk_gua_app_id) {
		super();
		this.groupUserAppPK = groupUserAppPK;
		this.gua_datmod = gua_datmod;
		this.gua_usemod = gua_usemod;
		this.fk_gua_gus_id = fk_gua_gus_id;
		this.fk_gua_app_id = fk_gua_app_id;
	}

	public GroupUserApp() {
		super();
	}

	/**
	 * @return the groupUserAppPK
	 */
	public GroupUserAppPK getGroupUserAppPK() {
		return groupUserAppPK;
	}

	/**
	 * @param groupUserAppPK the groupUserAppPK to set
	 */
	public void setGroupUserAppPK(GroupUserAppPK groupUserAppPK) {
		this.groupUserAppPK = groupUserAppPK;
	}

	/**
	 * @return the gua_datmod
	 */
	public Date getGua_datmod() {
		return gua_datmod;
	}

	/**
	 * @param gua_datmod the gua_datmod to set
	 */
	public void setGua_datmod(Date gua_datmod) {
		this.gua_datmod = gua_datmod;
	}

	/**
	 * @return the gua_usemod
	 */
	public String getGua_usemod() {
		return gua_usemod;
	}

	/**
	 * @param gua_usemod the gua_usemod to set
	 */
	public void setGua_usemod(String gua_usemod) {
		this.gua_usemod = gua_usemod;
	}

	/**
	 * @return the fk_gua_gus_id
	 */
	public Long getFk_gua_gus_id() {
		return fk_gua_gus_id;
	}

	/**
	 * @param fk_gua_gus_id the fk_gua_gus_id to set
	 */
	public void setFk_gua_gus_id(Long fk_gua_gus_id) {
		this.fk_gua_gus_id = fk_gua_gus_id;
	}

	/**
	 * @return the fk_gua_app_id
	 */
	public Long getFk_gua_app_id() {
		return fk_gua_app_id;
	}

	/**
	 * @param fk_gua_app_id the fk_gua_app_id to set
	 */
	public void setFk_gua_app_id(Long fk_gua_app_id) {
		this.fk_gua_app_id = fk_gua_app_id;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((groupUserAppPK == null) ? 0 : groupUserAppPK.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		GroupUserApp other = (GroupUserApp) obj;
		if (groupUserAppPK == null) {
			if (other.groupUserAppPK != null)
				return false;
		} else if (!groupUserAppPK.equals(other.groupUserAppPK))
			return false;
		return true;
	}

	
}
