package com.librework.console.model;

import static javax.persistence.GenerationType.IDENTITY;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@Table(name="lw_notification")
public class Notification implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=IDENTITY)
	@Column(name="NOT_ID", unique=true, nullable=false)
	private long not_id;
	
	@ManyToOne(fetch=FetchType.EAGER)
	@JoinColumns( { @JoinColumn(name="NOT_TEV_ID", referencedColumnName="TEV_ID")})
	private TypeEvent typeEvent;
	
	@Column(name="NOT_DESCRIPTION")
	private String not_description;
	
	@Column(name="NOT_ADIC_DATA1")
	private String not_adic_data1;
	
	@Column(name="NOT_ADIC_DATA2")
	private String not_adic_data2;
	
	@Column(name="NOT_ADIC_DATA3")
	private String not_adic_data3;
	
	@Column(name="NOT_ADIC_DATA4")
	private String not_adic_data4;
	
	@Column(name="NOT_ADIC_DATA5")
	private String not_adic_data5;
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name="NOT_DATMOD")
	private Date not_datmod;
	
	@Column(name="NOT_USEMOD")
	private String not_usemod;

	public Notification(long not_id, TypeEvent typeEvent,
			String not_description, String not_adic_data1,
			String not_adic_data2, String not_adic_data3,
			String not_adic_data4, String not_adic_data5, Date not_datmod,
			String not_usemod) {
		super();
		this.not_id = not_id;
		this.typeEvent = typeEvent;
		this.not_description = not_description;
		this.not_adic_data1 = not_adic_data1;
		this.not_adic_data2 = not_adic_data2;
		this.not_adic_data3 = not_adic_data3;
		this.not_adic_data4 = not_adic_data4;
		this.not_adic_data5 = not_adic_data5;
		this.not_datmod = not_datmod;
		this.not_usemod = not_usemod;
	}

	public Notification() {
		super();
	}

	/**
	 * @return the not_id
	 */
	public long getNot_id() {
		return not_id;
	}

	/**
	 * @param not_id the not_id to set
	 */
	public void setNot_id(long not_id) {
		this.not_id = not_id;
	}

	/**
	 * @return the typeEvent
	 */
	public TypeEvent getTypeEvent() {
		return typeEvent;
	}

	/**
	 * @param typeEvent the typeEvent to set
	 */
	public void setTypeEvent(TypeEvent typeEvent) {
		this.typeEvent = typeEvent;
	}

	/**
	 * @return the not_description
	 */
	public String getNot_description() {
		return not_description;
	}

	/**
	 * @param not_description the not_description to set
	 */
	public void setNot_description(String not_description) {
		this.not_description = not_description;
	}

	/**
	 * @return the not_adic_data1
	 */
	public String getNot_adic_data1() {
		return not_adic_data1;
	}

	/**
	 * @param not_adic_data1 the not_adic_data1 to set
	 */
	public void setNot_adic_data1(String not_adic_data1) {
		this.not_adic_data1 = not_adic_data1;
	}

	/**
	 * @return the not_adic_data2
	 */
	public String getNot_adic_data2() {
		return not_adic_data2;
	}

	/**
	 * @param not_adic_data2 the not_adic_data2 to set
	 */
	public void setNot_adic_data2(String not_adic_data2) {
		this.not_adic_data2 = not_adic_data2;
	}

	/**
	 * @return the not_adic_data3
	 */
	public String getNot_adic_data3() {
		return not_adic_data3;
	}

	/**
	 * @param not_adic_data3 the not_adic_data3 to set
	 */
	public void setNot_adic_data3(String not_adic_data3) {
		this.not_adic_data3 = not_adic_data3;
	}

	/**
	 * @return the not_adic_data4
	 */
	public String getNot_adic_data4() {
		return not_adic_data4;
	}

	/**
	 * @param not_adic_data4 the not_adic_data4 to set
	 */
	public void setNot_adic_data4(String not_adic_data4) {
		this.not_adic_data4 = not_adic_data4;
	}

	/**
	 * @return the not_adic_data5
	 */
	public String getNot_adic_data5() {
		return not_adic_data5;
	}

	/**
	 * @param not_adic_data5 the not_adic_data5 to set
	 */
	public void setNot_adic_data5(String not_adic_data5) {
		this.not_adic_data5 = not_adic_data5;
	}

	/**
	 * @return the not_datmod
	 */
	public Date getNot_datmod() {
		return not_datmod;
	}

	/**
	 * @param not_datmod the not_datmod to set
	 */
	public void setNot_datmod(Date not_datmod) {
		this.not_datmod = not_datmod;
	}

	/**
	 * @return the not_usemod
	 */
	public String getNot_usemod() {
		return not_usemod;
	}

	/**
	 * @param not_usemod the not_usemod to set
	 */
	public void setNot_usemod(String not_usemod) {
		this.not_usemod = not_usemod;
	}
	
	
	
}
