package com.librework.console.model;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.AssociationOverride;
import javax.persistence.AssociationOverrides;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@Table(name="lw_server_group")
@AssociationOverrides({
	@AssociationOverride(name="fk_seg_ser_id",
			joinColumns = @JoinColumn(name="SEG_SER_ID", referencedColumnName="SER_ID", insertable=false, updatable=false)),
	@AssociationOverride(name="fk_seg_grs_id",
			joinColumns = @JoinColumn(name="SEG_GRS_ID", referencedColumnName="GRS_ID", insertable=false, updatable=false))
})
public class ServerGroup implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	private ServerGroupPK serverGroupPK = new ServerGroupPK();
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name="SEG_DATMOD")
	private Date seg_datmod;

	@Column(name="SEG_USEMOD")
	private String seg_usemod;
	
	@SuppressWarnings("unused")
	@Column(name="SEG_SER_ID", nullable=false, insertable=false, updatable=false)
	private String fk_seg_ser_id;
	
	@SuppressWarnings("unused")
	@Column(name="SEG_GRS_ID", nullable=false, insertable=false, updatable=false)
	private Long fk_seg_grs_id;

	public ServerGroup(ServerGroupPK serverGroupPK, Date seg_datmod,
			String seg_usemod, String fk_seg_ser_id, Long fk_seg_grs_id) {
		super();
		this.serverGroupPK = serverGroupPK;
		this.seg_datmod = seg_datmod;
		this.seg_usemod = seg_usemod;
		this.fk_seg_ser_id = fk_seg_ser_id;
		this.fk_seg_grs_id = fk_seg_grs_id;
	}

	public ServerGroup() {

	}

	/**
	 * @return the serverGroupPK
	 */
	public ServerGroupPK getServerGroupPK() {
		return serverGroupPK;
	}

	/**
	 * @param serverGroupPK the serverGroupPK to set
	 */
	public void setServerGroupPK(ServerGroupPK serverGroupPK) {
		this.serverGroupPK = serverGroupPK;
	}

	/**
	 * @return the seg_datmod
	 */
	public Date getSeg_datmod() {
		return seg_datmod;
	}

	/**
	 * @param seg_datmod the seg_datmod to set
	 */
	public void setSeg_datmod(Date seg_datmod) {
		this.seg_datmod = seg_datmod;
	}

	/**
	 * @return the seg_usemod
	 */
	public String getSeg_usemod() {
		return seg_usemod;
	}

	/**
	 * @param seg_usemod the seg_usemod to set
	 */
	public void setSeg_usemod(String seg_usemod) {
		this.seg_usemod = seg_usemod;
	}

	/**
	 * @return the fk_seg_ser_id
	 */
	public String getFk_seg_ser_id() {
		return fk_seg_ser_id;
	}

	/**
	 * @param fk_seg_ser_id the fk_seg_ser_id to set
	 */
	public void setFk_seg_ser_id(String fk_seg_ser_id) {
		this.fk_seg_ser_id = fk_seg_ser_id;
	}

	/**
	 * @return the fk_seg_grs_id
	 */
	public Long getFk_seg_grs_id() {
		return fk_seg_grs_id;
	}

	/**
	 * @param fk_seg_grs_id the fk_seg_grs_id to set
	 */
	public void setFk_seg_grs_id(Long fk_seg_grs_id) {
		this.fk_seg_grs_id = fk_seg_grs_id;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((serverGroupPK == null) ? 0 : serverGroupPK.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ServerGroup other = (ServerGroup) obj;
		if (serverGroupPK == null) {
			if (other.serverGroupPK != null)
				return false;
		} else if (!serverGroupPK.equals(other.serverGroupPK))
			return false;
		return true;
	}

	
}
