package com.librework.console.model;

import java.io.Serializable;

import javax.persistence.Embeddable;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;

@Embeddable
public class ServerGroupPK implements Serializable {

	private static final long serialVersionUID = 1L;
	
	@ManyToOne(fetch=FetchType.EAGER)
	@JoinColumns( { @JoinColumn(name="SEG_SER_ID", referencedColumnName="SER_ID") })
	protected Server server;
	
	@ManyToOne(fetch=FetchType.EAGER)
	@JoinColumns( { @JoinColumn(name="SEG_GRS_ID", referencedColumnName="GRS_ID") })
	protected GroupServer groupServer;

	public ServerGroupPK(Server server, GroupServer groupServer) {
		super();
		this.server = server;
		this.groupServer = groupServer;
	}

	public ServerGroupPK() {
		
	}

	/**
	 * @return the server
	 */
	public Server getServer() {
		return server;
	}

	/**
	 * @param server the server to set
	 */
	public void setServer(Server server) {
		this.server = server;
	}

	/**
	 * @return the groupServer
	 */
	public GroupServer getGroupServer() {
		return groupServer;
	}

	/**
	 * @param groupServer the groupServer to set
	 */
	public void setGroupServer(GroupServer groupServer) {
		this.groupServer = groupServer;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = ((groupServer == null) ? 0 : groupServer.hashCode());
		result = prime * result + ((server == null) ? 0 : server.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ServerGroupPK other = (ServerGroupPK) obj;
		if (groupServer == null) {
			if (other.groupServer != null)
				return false;
		} else if (!groupServer.equals(other.groupServer))
			return false;
		if (server == null) {
			if (other.server != null)
				return false;
		} else if (!server.equals(other.server))
			return false;
		return true;
	}
	
	
	

}
