package com.librework.console.model;

import static javax.persistence.GenerationType.IDENTITY;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@Table(name="lw_server_hdd")
public class ServerHDD implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=IDENTITY)
	@Column(name="SHD_ID", unique=true, nullable= false)
	private long shd_id;

	@Column(name="SHD_DESCRIPTION")
	private String shd_description;
	
	@ManyToOne(fetch=FetchType.EAGER)
	@JoinColumns( { @JoinColumn(name = "SHD_SER_ID", referencedColumnName = "SER_ID") }) 
	private Server fk_shd_ser_id;

	@Column(name="SHD_HDDTOT")
	private float shd_hhdtot;

	@Column(name="SHD_HDDUSE")
	private float shd_hhduse;

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name="SHD_DATMOD")
	private Date shd_datmod;

	@Column(name="SHD_USEMOD")
	private String shd_usemod;

	public ServerHDD(long shd_id, Server fk_shd_ser_id, float shd_hhdtot,
			float shd_hhduse, Date shd_datmod, String shd_usemod) {
		super();
		this.shd_id = shd_id;
		this.fk_shd_ser_id = fk_shd_ser_id;
		this.shd_hhdtot = shd_hhdtot;
		this.shd_hhduse = shd_hhduse;
		this.shd_datmod = shd_datmod;
		this.shd_usemod = shd_usemod;
	}

	public ServerHDD() {

	}

	/**
	 * @return the shd_id
	 */
	public long getShd_id() {
		return shd_id;
	}

	/**
	 * @param shd_id the shd_id to set
	 */
	public void setShd_id(long shd_id) {
		this.shd_id = shd_id;
	}

	
	/**
	 * @return the shd_description
	 */
	public String getShd_description() {
		return shd_description;
	}

	/**
	 * @param shd_description the shd_description to set
	 */
	public void setShd_description(String shd_description) {
		this.shd_description = shd_description;
	}

	/**
	 * @return the fk_shd_ser_id
	 */
	public Server getFk_shd_ser_id() {
		return fk_shd_ser_id;
	}

	/**
	 * @param fk_shd_ser_id the fk_shd_ser_id to set
	 */
	public void setFk_shd_ser_id(Server fk_shd_ser_id) {
		this.fk_shd_ser_id = fk_shd_ser_id;
	}

	/**
	 * @return the shd_hhdtot
	 */
	public float getShd_hhdtot() {
		return shd_hhdtot;
	}

	/**
	 * @param shd_hhdtot the shd_hhdtot to set
	 */
	public void setShd_hhdtot(float shd_hhdtot) {
		this.shd_hhdtot = shd_hhdtot;
	}

	/**
	 * @return the shd_hhduse
	 */
	public float getShd_hhduse() {
		return shd_hhduse;
	}

	/**
	 * @param shd_hhduse the shd_hhduse to set
	 */
	public void setShd_hhduse(float shd_hhduse) {
		this.shd_hhduse = shd_hhduse;
	}

	/**
	 * @return the shd_datmod
	 */
	public Date getShd_datmod() {
		return shd_datmod;
	}

	/**
	 * @param shd_datmod the shd_datmod to set
	 */
	public void setShd_datmod(Date shd_datmod) {
		this.shd_datmod = shd_datmod;
	}

	/**
	 * @return the shd_usemod
	 */
	public String getShd_usemod() {
		return shd_usemod;
	}

	/**
	 * @param shd_usemod the shd_usemod to set
	 */
	public void setShd_usemod(String shd_usemod) {
		this.shd_usemod = shd_usemod;
	}

	
}
