package com.librework.console.model;

import static javax.persistence.GenerationType.IDENTITY;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Table;

@Entity
@Table(name="lw_server_hist")
public class ServerHist implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=IDENTITY)
	@Column(name="SEH_ID")
	private long seh_id;

	@Column(name="SEH_SER_ID")
	private String seh_ser_id;

	@Column(name="SEH_SER_DESCRIPTION")
	private String seh_ser_description;

	@Column(name="SEH_SER_MEMTOT")
	private float seh_ser_memtot;

	@Column(name="SEH_SER_MEMUSE")
	private float seh_ser_memuse;

	@Column(name="SEH_SER_CPUUSE")
	private float seh_ser_cpuuse;

	@Column(name="SEH_SER_REDUSE")
	private float seh_ser_reduse;

	@Column(name="SEH_SER_DATMOD")
	private Date seh_ser_datmod;

	@Column(name="SEH_SER_USEMOD")
	private String seh_ser_usemod;
	
	public ServerHist() {}

	public ServerHist(long seh_id, String seh_ser_id,
			String seh_ser_description, float seh_ser_memtot,
			float seh_ser_memuse, float seh_ser_cpuuse, float seh_ser_reduse,
			Date seh_ser_datmod, String seh_ser_usemod) {
		super();
		this.seh_id = seh_id;
		this.seh_ser_id = seh_ser_id;
		this.seh_ser_description = seh_ser_description;
		this.seh_ser_memtot = seh_ser_memtot;
		this.seh_ser_memuse = seh_ser_memuse;
		this.seh_ser_cpuuse = seh_ser_cpuuse;
		this.seh_ser_reduse = seh_ser_reduse;
		this.seh_ser_datmod = seh_ser_datmod;
		this.seh_ser_usemod = seh_ser_usemod;
	}

	public long getSeh_id() {
		return seh_id;
	}

	public void setSeh_id(long seh_id) {
		this.seh_id = seh_id;
	}

	public String getSeh_ser_id() {
		return seh_ser_id;
	}

	public void setSeh_ser_id(String seh_ser_id) {
		this.seh_ser_id = seh_ser_id;
	}

	public String getSeh_ser_description() {
		return seh_ser_description;
	}

	public void setSeh_ser_description(String seh_ser_description) {
		this.seh_ser_description = seh_ser_description;
	}

	public float getSeh_ser_memtot() {
		return seh_ser_memtot;
	}

	public void setSeh_ser_memtot(float seh_ser_memtot) {
		this.seh_ser_memtot = seh_ser_memtot;
	}

	public float getSeh_ser_memuse() {
		return seh_ser_memuse;
	}

	public void setSeh_ser_memuse(float seh_ser_memuse) {
		this.seh_ser_memuse = seh_ser_memuse;
	}

	public float getSeh_ser_cpuuse() {
		return seh_ser_cpuuse;
	}

	public void setSeh_ser_cpuuse(float seh_ser_cpuuse) {
		this.seh_ser_cpuuse = seh_ser_cpuuse;
	}

	public float getSeh_ser_reduse() {
		return seh_ser_reduse;
	}

	public void setSeh_ser_reduse(float seh_ser_reduse) {
		this.seh_ser_reduse = seh_ser_reduse;
	}

	public Date getSeh_ser_datmod() {
		return seh_ser_datmod;
	}

	public void setSeh_ser_datmod(Date seh_ser_datmod) {
		this.seh_ser_datmod = seh_ser_datmod;
	}

	public String getSeh_ser_usemod() {
		return seh_ser_usemod;
	}

	public void setSeh_ser_usemod(String seh_ser_usemod) {
		this.seh_ser_usemod = seh_ser_usemod;
	}
	
	

}
