package com.librework.console.model;

import static javax.persistence.GenerationType.IDENTITY;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.Lob;
import javax.persistence.OneToMany;
import javax.persistence.Table;

import org.hibernate.annotations.LazyCollection;
import org.hibernate.annotations.LazyCollectionOption;

@Entity
@Table(name="lw_site")
public class Site implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@GeneratedValue(strategy=IDENTITY)
	@Column(name="SIT_ID")
	private long sit_id;

	@Column(name="SIT_DESCRIPTION")
	private String sit_description;

	@Lob
	@Column(name="SIT_LOGO")
	private byte[] sit_logo;

	@Column(name="SIT_LDAP_IP")
	private String sit_ldap_ip;

	@Column(name="SIT_LDAP_IP_CLIENT")
	private String sit_ldap_ip_client;

	@Column(name="SIT_LDAP_DC1")
	private String sit_ldap_dc1;

	@Column(name="SIT_LDAP_DC1_CLIENT")
	private String sit_ldap_dc1_client;

	@Column(name="SIT_LDAP_DC2")
	private String sit_ldap_dc2;

	@Column(name="SIT_LDAP_DC2_CLIENT")
	private String sit_ldap_dc2_client;

	@Column(name="SIT_LDAP_USER")
	private String sit_ldap_user;

	@Column(name="SIT_LDAP_USER_CLIENT")
	private String sit_ldap_user_client;

	@Column(name="SIT_LDAP_PASS")
	private String sit_ldap_pass;

	@Column(name="SIT_LDAP_PASS_CLIENT")
	private String sit_ldap_pass_client;

	@Column(name="SIT_IP_BD")
	private String sit_ip_bd;

	@Column(name="SIT_USER_BD")
	private String sit_user_bd;

	@Column(name="SIT_PASS_BD")
	private String sit_pass_bd;

	@Column(name="SIT_URL")
	private String sit_url;

	@Column(name="SIT_DATMOD")
	private Date sit_datmod;

	@Column(name="SIT_USEMOD")
	private String sit_usemod;
	
	//Bidierectional asociation with UserSite
	@OneToMany(cascade=CascadeType.ALL, mappedBy="fk_usi_use_id", orphanRemoval=true)
	@LazyCollection(LazyCollectionOption.TRUE)
	private List<UserSite> userSites = new ArrayList<UserSite>();

	public Site(long sit_id, String sit_description, byte[] sit_logo,
			String sit_ldap_ip, String sit_ldap_ip_client, String sit_ldap_dc1,
			String sit_ldap_dc1_client, String sit_ldap_dc2,
			String sit_ldap_dc2_client, String sit_ldap_user,
			String sit_ldap_user_client, String sit_ldap_pass,
			String sit_ldap_pass_client, String sit_ip_bd, String sit_user_bd,
			String sit_pass_bd, String sit_url, Date sit_datmod,
			String sit_usemod, List<UserSite> userSites) {
		super();
		this.sit_id = sit_id;
		this.sit_description = sit_description;
		this.sit_logo = sit_logo;
		this.sit_ldap_ip = sit_ldap_ip;
		this.sit_ldap_ip_client = sit_ldap_ip_client;
		this.sit_ldap_dc1 = sit_ldap_dc1;
		this.sit_ldap_dc1_client = sit_ldap_dc1_client;
		this.sit_ldap_dc2 = sit_ldap_dc2;
		this.sit_ldap_dc2_client = sit_ldap_dc2_client;
		this.sit_ldap_user = sit_ldap_user;
		this.sit_ldap_user_client = sit_ldap_user_client;
		this.sit_ldap_pass = sit_ldap_pass;
		this.sit_ldap_pass_client = sit_ldap_pass_client;
		this.sit_ip_bd = sit_ip_bd;
		this.sit_user_bd = sit_user_bd;
		this.sit_pass_bd = sit_pass_bd;
		this.sit_url = sit_url;
		this.sit_datmod = sit_datmod;
		this.sit_usemod = sit_usemod;
		this.userSites = userSites;
	}

	public Site() {
		
	}

	/**
	 * @return the sit_id
	 */
	public long getSit_id() {
		return sit_id;
	}

	/**
	 * @param sit_id the sit_id to set
	 */
	public void setSit_id(long sit_id) {
		this.sit_id = sit_id;
	}

	/**
	 * @return the sit_description
	 */
	public String getSit_description() {
		return sit_description;
	}

	/**
	 * @param sit_description the sit_description to set
	 */
	public void setSit_description(String sit_description) {
		this.sit_description = sit_description;
	}

	/**
	 * @return the sit_logo
	 */
	public byte[] getSit_logo() {
		return sit_logo;
	}

	/**
	 * @param sit_logo the sit_logo to set
	 */
	public void setSit_logo(byte[] sit_logo) {
		this.sit_logo = sit_logo;
	}

	/**
	 * @return the sit_ldap_ip
	 */
	public String getSit_ldap_ip() {
		return sit_ldap_ip;
	}

	/**
	 * @param sit_ldap_ip the sit_ldap_ip to set
	 */
	public void setSit_ldap_ip(String sit_ldap_ip) {
		this.sit_ldap_ip = sit_ldap_ip;
	}

	/**
	 * @return the sit_ldap_ip_client
	 */
	public String getSit_ldap_ip_client() {
		return sit_ldap_ip_client;
	}

	/**
	 * @param sit_ldap_ip_client the sit_ldap_ip_client to set
	 */
	public void setSit_ldap_ip_client(String sit_ldap_ip_client) {
		this.sit_ldap_ip_client = sit_ldap_ip_client;
	}

	/**
	 * @return the sit_ldap_dc1
	 */
	public String getSit_ldap_dc1() {
		return sit_ldap_dc1;
	}

	/**
	 * @param sit_ldap_dc1 the sit_ldap_dc1 to set
	 */
	public void setSit_ldap_dc1(String sit_ldap_dc1) {
		this.sit_ldap_dc1 = sit_ldap_dc1;
	}

	/**
	 * @return the sit_ldap_dc1_client
	 */
	public String getSit_ldap_dc1_client() {
		return sit_ldap_dc1_client;
	}

	/**
	 * @param sit_ldap_dc1_client the sit_ldap_dc1_client to set
	 */
	public void setSit_ldap_dc1_client(String sit_ldap_dc1_client) {
		this.sit_ldap_dc1_client = sit_ldap_dc1_client;
	}

	/**
	 * @return the sit_ldap_dc2
	 */
	public String getSit_ldap_dc2() {
		return sit_ldap_dc2;
	}

	/**
	 * @param sit_ldap_dc2 the sit_ldap_dc2 to set
	 */
	public void setSit_ldap_dc2(String sit_ldap_dc2) {
		this.sit_ldap_dc2 = sit_ldap_dc2;
	}

	/**
	 * @return the sit_ldap_dc2_client
	 */
	public String getSit_ldap_dc2_client() {
		return sit_ldap_dc2_client;
	}

	/**
	 * @param sit_ldap_dc2_client the sit_ldap_dc2_client to set
	 */
	public void setSit_ldap_dc2_client(String sit_ldap_dc2_client) {
		this.sit_ldap_dc2_client = sit_ldap_dc2_client;
	}

	/**
	 * @return the sit_ldap_user
	 */
	public String getSit_ldap_user() {
		return sit_ldap_user;
	}

	/**
	 * @param sit_ldap_user the sit_ldap_user to set
	 */
	public void setSit_ldap_user(String sit_ldap_user) {
		this.sit_ldap_user = sit_ldap_user;
	}

	/**
	 * @return the sit_ldap_user_client
	 */
	public String getSit_ldap_user_client() {
		return sit_ldap_user_client;
	}

	/**
	 * @param sit_ldap_user_client the sit_ldap_user_client to set
	 */
	public void setSit_ldap_user_client(String sit_ldap_user_client) {
		this.sit_ldap_user_client = sit_ldap_user_client;
	}

	/**
	 * @return the sit_ldap_pass
	 */
	public String getSit_ldap_pass() {
		return sit_ldap_pass;
	}

	/**
	 * @param sit_ldap_pass the sit_ldap_pass to set
	 */
	public void setSit_ldap_pass(String sit_ldap_pass) {
		this.sit_ldap_pass = sit_ldap_pass;
	}

	/**
	 * @return the sit_ldap_pass_client
	 */
	public String getSit_ldap_pass_client() {
		return sit_ldap_pass_client;
	}

	/**
	 * @param sit_ldap_pass_client the sit_ldap_pass_client to set
	 */
	public void setSit_ldap_pass_client(String sit_ldap_pass_client) {
		this.sit_ldap_pass_client = sit_ldap_pass_client;
	}

	/**
	 * @return the sit_ip_bd
	 */
	public String getSit_ip_bd() {
		return sit_ip_bd;
	}

	/**
	 * @param sit_ip_bd the sit_ip_bd to set
	 */
	public void setSit_ip_bd(String sit_ip_bd) {
		this.sit_ip_bd = sit_ip_bd;
	}

	/**
	 * @return the sit_user_bd
	 */
	public String getSit_user_bd() {
		return sit_user_bd;
	}

	/**
	 * @param sit_user_bd the sit_user_bd to set
	 */
	public void setSit_user_bd(String sit_user_bd) {
		this.sit_user_bd = sit_user_bd;
	}

	/**
	 * @return the sit_pass_bd
	 */
	public String getSit_pass_bd() {
		return sit_pass_bd;
	}

	/**
	 * @param sit_pass_bd the sit_pass_bd to set
	 */
	public void setSit_pass_bd(String sit_pass_bd) {
		this.sit_pass_bd = sit_pass_bd;
	}

	/**
	 * @return the sit_url
	 */
	public String getSit_url() {
		return sit_url;
	}

	/**
	 * @param sit_url the sit_url to set
	 */
	public void setSit_url(String sit_url) {
		this.sit_url = sit_url;
	}

	/**
	 * @return the sit_datmod
	 */
	public Date getSit_datmod() {
		return sit_datmod;
	}

	/**
	 * @param sit_datmod the sit_datmod to set
	 */
	public void setSit_datmod(Date sit_datmod) {
		this.sit_datmod = sit_datmod;
	}

	/**
	 * @return the sit_usemod
	 */
	public String getSit_usemod() {
		return sit_usemod;
	}

	/**
	 * @param sit_usemod the sit_usemod to set
	 */
	public void setSit_usemod(String sit_usemod) {
		this.sit_usemod = sit_usemod;
	}

	/**
	 * @return the userSites
	 */
	public List<UserSite> getUserSites() {
		return userSites;
	}

	/**
	 * @param userSites the userSites to set
	 */
	public void setUserSites(List<UserSite> userSites) {
		this.userSites = userSites;
	}
	
	
}
