package com.librework.console.model;

import static javax.persistence.GenerationType.IDENTITY;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

import org.hibernate.annotations.LazyCollection;
import org.hibernate.annotations.LazyCollectionOption;

@Entity
@Table(name="lw_type_event")
public class TypeEvent implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	@Column(name="TEV_ID", unique=true, nullable= false)
	private int tev_id;

	@Column(name="TEV_DESCRIPTION", nullable=false)
	private String tev_description;

	@Temporal(TemporalType.DATE)
	@Column(name="TEV_DATMOD", nullable=false)
	private Date tev_datmod;

	@Column(name="TEV_USEMOD", nullable=false)
	private String tev_usemod;

	public TypeEvent(int tev_id, String tev_description, Date tev_datmod,
			String tev_usemod) {
		super();
		this.tev_id = tev_id;
		this.tev_description = tev_description;
		this.tev_datmod = tev_datmod;
		this.tev_usemod = tev_usemod;
	}

	public TypeEvent() {
		
	}

	/**
	 * @return the tev_id
	 */
	public int getTev_id() {
		return tev_id;
	}

	/**
	 * @param tev_id the tev_id to set
	 */
	public void setTev_id(int tev_id) {
		this.tev_id = tev_id;
	}

	/**
	 * @return the tev_description
	 */
	public String getTev_description() {
		return tev_description;
	}

	/**
	 * @param tev_description the tev_description to set
	 */
	public void setTev_description(String tev_description) {
		this.tev_description = tev_description;
	}

	/**
	 * @return the tev_datmod
	 */
	public Date getTev_datmod() {
		return tev_datmod;
	}

	/**
	 * @param tev_datmod the tev_datmod to set
	 */
	public void setTev_datmod(Date tev_datmod) {
		this.tev_datmod = tev_datmod;
	}

	/**
	 * @return the tev_usemod
	 */
	public String getTev_usemod() {
		return tev_usemod;
	}

	/**
	 * @param tev_usemod the tev_usemod to set
	 */
	public void setTev_usemod(String tev_usemod) {
		this.tev_usemod = tev_usemod;
	}
	
	
}
