package com.librework.console.model;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.AssociationOverride;
import javax.persistence.AssociationOverrides;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@Table(name="lw_user_app")
@AssociationOverrides({
	@AssociationOverride(name="fk_uap_use_id",
			joinColumns = @JoinColumn(name = "UAP_USE_ID", referencedColumnName = "USE_ID", insertable = false, updatable = false)),
	@AssociationOverride(name="fk_uap_app_id",
			joinColumns = @JoinColumn(name = "UAP_APP_ID", referencedColumnName = "APP_ID", insertable = false, updatable = false)),
	@AssociationOverride(name="fk_uap_ser_id",
			joinColumns = @JoinColumn(name = "UAP_SER_ID", referencedColumnName = "SER_ID", insertable = false, updatable = false))
})
public class UserApp implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	private UserAppPK userAppPK = new UserAppPK();
	
	@ManyToOne(fetch=FetchType.EAGER)
	@JoinColumns( { @JoinColumn(name = "UAP_SER_ID", referencedColumnName = "SER_ID") }) 
	private Server fk_uap_ser_id;

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name="UAP_START_DATE_PROCESS")
	private Date uap_start_date_process;

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name="UAP_END_DATE_PROCESS")
	private Date uap_end_date_process;

	@Column(name="UAP_ID_PROCESS")
	private String uap_id_process;

	@Column(name="UAP_CPUUSE")
	private float uap_cpuuse;

	@Column(name="UAP_MEMUSE")
	private float uap_memuse;

	@Column(name="UAP_HDDUSE")
	private float uap_hdduse;

	@Column(name="UAP_NETUSE")
	private float uap_netuse;

	@Temporal(TemporalType.TIMESTAMP)
	@Column(name="UAP_DATMOD")
	private Date uap_datmod;

	@Column(name="UAP_USEMOD")
	private String uap_usemod;
	
	@SuppressWarnings("unused")
	@Column(name="UAP_USE_ID", nullable=false, updatable=false, insertable=false)
	private String fk_uap_use_id;
	
	@SuppressWarnings("unused")
	@Column(name="UAP_APP_ID", nullable=false, updatable=false, insertable=false)
	private Long fk_uap_app_id;

	public UserApp(UserAppPK userAppPK, Server fk_uap_ser_id,
			Date uap_start_date_process, Date uap_end_date_process,
			String uap_id_process, float uap_cpuuse, float uap_memuse,
			float uap_hdduse, float uap_netuse, Date uap_datmod,
			String uap_usemod, String fk_uap_use_id, Long fk_uap_app_id) {
		super();
		this.userAppPK = userAppPK;
		this.fk_uap_ser_id = fk_uap_ser_id;
		this.uap_start_date_process = uap_start_date_process;
		this.uap_end_date_process = uap_end_date_process;
		this.uap_id_process = uap_id_process;
		this.uap_cpuuse = uap_cpuuse;
		this.uap_memuse = uap_memuse;
		this.uap_hdduse = uap_hdduse;
		this.uap_netuse = uap_netuse;
		this.uap_datmod = uap_datmod;
		this.uap_usemod = uap_usemod;
		this.fk_uap_use_id = fk_uap_use_id;
		this.fk_uap_app_id = fk_uap_app_id;
	}

	public UserApp() {
		
	}

	/**
	 * @return the userAppPK
	 */
	public UserAppPK getUserAppPK() {
		return userAppPK;
	}

	/**
	 * @param userAppPK the userAppPK to set
	 */
	public void setUserAppPK(UserAppPK userAppPK) {
		this.userAppPK = userAppPK;
	}

	/**
	 * @return the fk_uap_ser_id
	 */
	public Server getFk_uap_ser_id() {
		return fk_uap_ser_id;
	}

	/**
	 * @param fk_uap_ser_id the fk_uap_ser_id to set
	 */
	public void setFk_uap_ser_id(Server fk_uap_ser_id) {
		this.fk_uap_ser_id = fk_uap_ser_id;
	}

	/**
	 * @return the uap_start_date_process
	 */
	public Date getUap_start_date_process() {
		return uap_start_date_process;
	}

	/**
	 * @param uap_start_date_process the uap_start_date_process to set
	 */
	public void setUap_start_date_process(Date uap_start_date_process) {
		this.uap_start_date_process = uap_start_date_process;
	}

	/**
	 * @return the uap_end_date_process
	 */
	public Date getUap_end_date_process() {
		return uap_end_date_process;
	}

	/**
	 * @param uap_end_date_process the uap_end_date_process to set
	 */
	public void setUap_end_date_process(Date uap_end_date_process) {
		this.uap_end_date_process = uap_end_date_process;
	}

	/**
	 * @return the uap_id_process
	 */
	public String getUap_id_process() {
		return uap_id_process;
	}

	/**
	 * @param uap_id_process the uap_id_process to set
	 */
	public void setUap_id_process(String uap_id_process) {
		this.uap_id_process = uap_id_process;
	}

	/**
	 * @return the uap_cpuuse
	 */
	public float getUap_cpuuse() {
		return uap_cpuuse;
	}

	/**
	 * @param uap_cpuuse the uap_cpuuse to set
	 */
	public void setUap_cpuuse(float uap_cpuuse) {
		this.uap_cpuuse = uap_cpuuse;
	}

	/**
	 * @return the uap_memuse
	 */
	public float getUap_memuse() {
		return uap_memuse;
	}

	/**
	 * @param uap_memuse the uap_memuse to set
	 */
	public void setUap_memuse(float uap_memuse) {
		this.uap_memuse = uap_memuse;
	}

	/**
	 * @return the uap_hdduse
	 */
	public float getUap_hdduse() {
		return uap_hdduse;
	}

	/**
	 * @param uap_hdduse the uap_hdduse to set
	 */
	public void setUap_hdduse(float uap_hdduse) {
		this.uap_hdduse = uap_hdduse;
	}

	/**
	 * @return the uap_netuse
	 */
	public float getUap_netuse() {
		return uap_netuse;
	}

	/**
	 * @param uap_netuse the uap_netuse to set
	 */
	public void setUap_netuse(float uap_netuse) {
		this.uap_netuse = uap_netuse;
	}

	/**
	 * @return the uap_datmod
	 */
	public Date getUap_datmod() {
		return uap_datmod;
	}

	/**
	 * @param uap_datmod the uap_datmod to set
	 */
	public void setUap_datmod(Date uap_datmod) {
		this.uap_datmod = uap_datmod;
	}

	/**
	 * @return the uap_usemod
	 */
	public String getUap_usemod() {
		return uap_usemod;
	}

	/**
	 * @param uap_usemod the uap_usemod to set
	 */
	public void setUap_usemod(String uap_usemod) {
		this.uap_usemod = uap_usemod;
	}

	/**
	 * @return the fk_uap_use_id
	 */
	public String getFk_uap_use_id() {
		return fk_uap_use_id;
	}

	/**
	 * @param fk_uap_use_id the fk_uap_use_id to set
	 */
	public void setFk_uap_use_id(String fk_uap_use_id) {
		this.fk_uap_use_id = fk_uap_use_id;
	}

	/**
	 * @return the fk_uap_app_id
	 */
	public Long getFk_uap_app_id() {
		return fk_uap_app_id;
	}

	/**
	 * @param fk_uap_app_id the fk_uap_app_id to set
	 */
	public void setFk_uap_app_id(Long fk_uap_app_id) {
		this.fk_uap_app_id = fk_uap_app_id;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((userAppPK == null) ? 0 : userAppPK.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		UserApp other = (UserApp) obj;
		if (userAppPK == null) {
			if (other.userAppPK != null)
				return false;
		} else if (!userAppPK.equals(other.userAppPK))
			return false;
		return true;
	}

	
}
