package com.librework.console.model;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.AssociationOverride;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.AssociationOverrides;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.persistence.Transient;

@Entity
@Table(name="lw_user_group")
@AssociationOverrides({
	@AssociationOverride(name="fk_ugr_gus_id",
			joinColumns = @JoinColumn(name = "UGR_GUS_ID", referencedColumnName = "GUS_ID", insertable = false, updatable = false)),
	@AssociationOverride(name="fk_ugr_use_id",
			joinColumns = @JoinColumn(name = "UGR_USE_ID", referencedColumnName = "USE_ID", insertable = false, updatable = false))
})
public class UserGroup implements Serializable {

	private static final long serialVersionUID = 1L;
	
	@Id
	private UserGroupPK userGroupPK = new UserGroupPK();
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name="UGR_DATMOD")
	private Date ugr_datmod;
	
	@Column(name="UGR_USEMOD")
	private String ugr_usemod;
	
	//Bidirectional relation with lw_user, lw_group_user
	@SuppressWarnings("unused")
	@Column(name="UGR_GUS_ID", nullable=false, updatable=false, insertable=false)
	private Long fk_ugr_gus_id;
	
	@SuppressWarnings("unused")
	@Column(name="UGR_USE_ID", nullable=false, updatable=false, insertable=false)
	private String fk_ugr_use_id;
	
	public UserGroup() {}

	
	public UserGroupPK getUserGroupPK() {
		return userGroupPK;
	}

	public void setUserGroupPK(UserGroupPK userGroupPK) {
		this.userGroupPK = userGroupPK;
	}

	
	public Long getFk_ugr_gus_id() {
		return fk_ugr_gus_id;
	}
	
	public void setFk_ugr_gus_id(Long fk_ugr_gus_id) {
		this.fk_ugr_gus_id = fk_ugr_gus_id;
	}
	
	
	public String getFk_ugr_use_id() {
		return fk_ugr_use_id;
	}
		
	public void setFk_ugr_use_id(String fk_ugr_use_id) {
		this.fk_ugr_use_id = fk_ugr_use_id;
	}
	
	public Date getUgr_datmod() {
		return ugr_datmod;
	}

	public void setUgr_datmod(Date ugr_datmod) {
		this.ugr_datmod = ugr_datmod;
	}

	public String getUgr_usemod() {
		return ugr_usemod;
	}

	public void setUgr_usemod(String ugr_usemod) {
		this.ugr_usemod = ugr_usemod;
	}

	public int hashCode() {
		return (getUserGroupPK() != null ? getUserGroupPK().hashCode() : 0);
	}

	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		UserGroup other = (UserGroup) obj;
		if (userGroupPK == null) {
			if (other.userGroupPK != null)
				return false;
		} else if (!userGroupPK.equals(other.userGroupPK))
			return false;
		return true;
	}
	
	
	
}
