package com.librework.console.model;

import java.io.Serializable;

import javax.persistence.Embeddable;
import javax.persistence.FetchType;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;

@Embeddable
public class UserGroupPK implements Serializable {

	private static final long serialVersionUID = 1L;
	
	@ManyToOne(fetch=FetchType.EAGER)
	@JoinColumns( { @JoinColumn(name = "UGR_GUS_ID", referencedColumnName = "GUS_ID") }) 
	protected GroupUser group;
	@ManyToOne(fetch=FetchType.EAGER)
	@JoinColumns( { @JoinColumn(name = "UGR_USE_ID", referencedColumnName = "USE_ID") }) 
	protected User user;
	
	public UserGroupPK(User user, GroupUser groupUser) {
		// TODO Auto-generated constructor stub
		this.user = user;
		this.group = groupUser;
	}

	public UserGroupPK() {
		// TODO Auto-generated constructor stub
	}

	
	public User getUser() {
		return user;
	}

	public void setUser(User user) {
		this.user = user;
	}

	
	public GroupUser getGroup() {
		return group;
	}

	public void setGroup(GroupUser group) {
		this.group = group;
	}

	public int hashCode() {
		int result;
        result = (group != null ? group.hashCode() : 0);
        result = 31 * result + (user != null ? user.hashCode() : 0);
        return result;
	}

	public boolean equals(Object obj) {
		if (this == obj) return true;
        if (obj == null || getClass() != obj.getClass()) return false;
 
        UserGroupPK that = (UserGroupPK) obj;
 
        if (group != null ? !group.equals(that.group) : that.group != null) return false;
        if (user != null ? !user.equals(that.user) : that.user != null) return false;
 
        return true;
	}

	
	
}
