package com.librework.console.model;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.AssociationOverride;
import javax.persistence.AssociationOverrides;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

@Entity
@Table(name="lw_user_site")
@AssociationOverrides({
	@AssociationOverride(name="fk_usi_use_id",
			joinColumns = @JoinColumn(name = "USI_USE_ID", referencedColumnName = "USE_ID", insertable = false, updatable = false)),
	@AssociationOverride(name="fk_usi_sit_id",
			joinColumns = @JoinColumn(name = "USI_SIT_ID", referencedColumnName = "SIT_ID", insertable = false, updatable = false))
})
public class UserSite implements Serializable {

	private static final long serialVersionUID = 1L;

	@Id
	private UserSitePK userSitePK = new UserSitePK();
	
	@Temporal(TemporalType.TIMESTAMP)
	@Column(name="USI_DATMOD")
	private Date usi_datmod;

	@Column(name="USI_USEMOD")
	private String usi_usemod;
	
	@SuppressWarnings("unused")
	@Column(name="USI_USE_ID", nullable=false, updatable=false, insertable=false)
	private String fk_usi_use_id;
	
	@SuppressWarnings("unused")
	@Column(name="USI_SIT_ID", nullable=false, updatable=false, insertable=false)
	private Long fk_usi_sit_id;

	public UserSite(UserSitePK userSitePK, Date usi_datmod, String usi_usemod,
			String fk_usi_use_id, Long fk_usi_sit_id) {
		super();
		this.userSitePK = userSitePK;
		this.usi_datmod = usi_datmod;
		this.usi_usemod = usi_usemod;
		this.fk_usi_use_id = fk_usi_use_id;
		this.fk_usi_sit_id = fk_usi_sit_id;
	}

	public UserSite() {
		
	}

	/**
	 * @return the userSitePK
	 */
	public UserSitePK getUserSitePK() {
		return userSitePK;
	}

	/**
	 * @param userSitePK the userSitePK to set
	 */
	public void setUserSitePK(UserSitePK userSitePK) {
		this.userSitePK = userSitePK;
	}

	/**
	 * @return the usi_datmod
	 */
	public Date getUsi_datmod() {
		return usi_datmod;
	}

	/**
	 * @param usi_datmod the usi_datmod to set
	 */
	public void setUsi_datmod(Date usi_datmod) {
		this.usi_datmod = usi_datmod;
	}

	/**
	 * @return the usi_usemod
	 */
	public String getUsi_usemod() {
		return usi_usemod;
	}

	/**
	 * @param usi_usemod the usi_usemod to set
	 */
	public void setUsi_usemod(String usi_usemod) {
		this.usi_usemod = usi_usemod;
	}

	/**
	 * @return the fk_usi_use_id
	 */
	public String getFk_usi_use_id() {
		return fk_usi_use_id;
	}

	/**
	 * @param fk_usi_use_id the fk_usi_use_id to set
	 */
	public void setFk_usi_use_id(String fk_usi_use_id) {
		this.fk_usi_use_id = fk_usi_use_id;
	}

	/**
	 * @return the fk_usi_sit_id
	 */
	public Long getFk_usi_sit_id() {
		return fk_usi_sit_id;
	}

	/**
	 * @param fk_usi_sit_id the fk_usi_sit_id to set
	 */
	public void setFk_usi_sit_id(Long fk_usi_sit_id) {
		this.fk_usi_sit_id = fk_usi_sit_id;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((userSitePK == null) ? 0 : userSitePK.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		UserSite other = (UserSite) obj;
		if (userSitePK == null) {
			if (other.userSitePK != null)
				return false;
		} else if (!userSitePK.equals(other.userSitePK))
			return false;
		return true;
	}

	
}
