package com.librework.console.service;

import java.util.List;

import com.librework.console.model.AppServer;
import com.librework.console.model.Applications;
import com.librework.console.model.GroupServer;
import com.librework.console.model.Server;
import com.librework.console.model.ServerGroup;
import com.librework.console.model.ServerHDD;
import com.librework.console.model.UserApp;

public interface IServerService {

boolean createServer(Server server);
	
	Server getServerId(String serverId);
	
	List<Server> getServerHost(String serverHost);
	
	List<Server> getServerDescription(String serverDescription);
	
	List<Server> getAllServer();
	
	boolean updateServer(Server server);
	
	boolean deleteServer(Server server);
	
	List<ServerHDD> getAllServerHDD(Server server);
	
	boolean addServerHDD (Server server, ServerHDD serverHDD);
	
	boolean removeServerHDD (Server server, ServerHDD serverHDD);
	
	ServerHDD getServerHDD (Server server, ServerHDD serverHDD);
	
	List<ServerGroup> getAllGroupServer(Server server);
	
	boolean addGroupServer (Server server, GroupServer groupServer, String userId);
	
	boolean removeGroupServer (Server server, GroupServer groupServer);
	
	GroupServer getGroupServer(Server server, GroupServer groupServer);
	
	List<AppServer> getAllApplications(Server server);
	
	boolean addApplications(Server server, Applications applications, String userId);
	
	boolean removeApplications(Server server, Applications applications);
	
	Applications getApplications(Server server, Applications applications);
	
	List<UserApp> getAllUserApp (Server server);
	
	List<UserApp> getActiveUserApp (Server server);
}
