package com.librework.console.service;

import java.util.List;

import com.librework.console.model.Applications;
import com.librework.console.model.GroupUser;
import com.librework.console.model.Site;
import com.librework.console.model.User;
import com.librework.console.model.UserApp;
import com.librework.console.model.UserGroup;
import com.librework.console.model.UserSite;

public interface IUserService {

	 boolean createUser(User user);
	
	 User getUserId(String userId);
	 
	 List<User> getUserName(String userName);
	 
	 List<User> getUserSurname1(String userSurname1);
	 
	 List<User> getUserEmail(String userEmail);
	
	 List<User> getAllUser();
	 
	 List<User> getActiveUser();
	 
	 List<User> getDeactivateUser();
	
	 boolean updateUser(User user);
	
	 boolean deleteUser(User user);
	
	 boolean authenticateUser(String userId, String password);
	 
	 List<UserGroup> getAllGroupUser(User user);
	 
	 boolean addGroupUser(User user, GroupUser groupUser);
	 
	 boolean removeGroupUser(User user, GroupUser groupUser);
	 
	 GroupUser getGroupUser(User user, GroupUser groupUser);
	 
	 List<UserApp> getAllUserApp(User user);
	 
	 List<UserApp> getUserAppActive(User user);
	 
	 boolean addUserApp(User user, Applications applications);
	 
	 boolean removeUserApp(User user, Applications applications);
	 
	 Applications getApplications(User user, Applications applications);
	 
	 List<UserSite> getAllUserSite(User user);
	 
	 boolean addUserSite(User user, Site site);
	 
	 boolean removeUserSite(User user, Site site);
	 
	 Site getSite(User user, Site site);
	
}
