package com.librework.console.service.impl;

import java.io.Serializable;
import java.util.List;

import org.springframework.transaction.annotation.Transactional;

import com.librework.console.dao.IApplicationsDao;
import com.librework.console.model.AppGroup;
import com.librework.console.model.AppServer;
import com.librework.console.model.Applications;
import com.librework.console.model.GroupApp;
import com.librework.console.model.GroupUser;
import com.librework.console.model.GroupUserApp;
import com.librework.console.model.Server;
import com.librework.console.model.User;
import com.librework.console.model.UserApp;
import com.librework.console.service.IApplicationsService;

@Transactional(readOnly=true)
public class ApplicationsService implements IApplicationsService, Serializable {

	private static final long serialVersionUID = 1L;
	
	IApplicationsDao applicationsDao;

	public IApplicationsDao getApplicationsDao() {
		return applicationsDao;
	}

	public void setApplicationsDao(IApplicationsDao applicationsDao) {
		this.applicationsDao = applicationsDao;
	}

	@Transactional(readOnly=false)
	@Override
	public boolean createApplications(Applications applications) {
		// TODO Auto-generated method stub
		return getApplicationsDao().createApplications(applications);
	}

	@Override
	public Applications getApplicationsId(long applicationsId) {
		// TODO Auto-generated method stub
		return getApplicationsDao().getApplicationsId(applicationsId);
	}

	@Override
	public List<Applications> getApplicationsName(String applicationsName) {
		// TODO Auto-generated method stub
		return getApplicationsDao().getApplicationsName(applicationsName);
	}

	@Override
	public List<Applications> getAllApplications() {
		// TODO Auto-generated method stub
		return getApplicationsDao().getAllApplications();
	}

	@Transactional(readOnly=false)
	@Override
	public boolean updateApplications(Applications applications) {
		// TODO Auto-generated method stub
		return getApplicationsDao().updateApplications(applications);
	}

	@Transactional(readOnly=false)
	@Override
	public boolean deleteApplications(Applications applications) {
		// TODO Auto-generated method stub
		return getApplicationsDao().deleteApplications(applications);
	}

	@Override
	public List<AppGroup> getAllGroupApp(Applications applications) {
		// TODO Auto-generated method stub
		return getApplicationsDao().getAllGroupApp(applications);
	}

	@Transactional(readOnly=false)
	@Override
	public boolean addGroupApp(Applications applications, GroupApp groupApp,
			String userId) {
		// TODO Auto-generated method stub
		return getApplicationsDao().addGroupApp(applications, groupApp, userId);
	}

	@Transactional(readOnly=false)
	@Override
	public boolean removeGroupApp(Applications applications, GroupApp groupApp) {
		// TODO Auto-generated method stub
		return getApplicationsDao().removeGroupApp(applications, groupApp);
	}

	@Override
	public GroupApp getGroupApp(Applications applications, GroupApp gropuApp) {
		// TODO Auto-generated method stub
		return getApplicationsDao().getGroupApp(applications, gropuApp);
	}

	@Override
	public List<UserApp> getAllAppUser(Applications applications) {
		// TODO Auto-generated method stub
		return getApplicationsDao().getAllAppUser(applications);
	}

	@Override
	public List<UserApp> getActiveAppUser(Applications applications) {
		return getApplicationsDao().getActiveAppUser(applications);
	}
	@Transactional(readOnly=false)
	@Override
	public boolean addUserApp(Applications applications, User user,
			String userId) {
		// TODO Auto-generated method stub
		return getApplicationsDao().addUserApp(applications, user, userId);
	}

	@Transactional(readOnly=false)
	@Override
	public boolean removeUserApp(Applications applications, User user) {
		// TODO Auto-generated method stub
		return getApplicationsDao().removeUserApp(applications, user);
	}

	@Override
	public User getUser(Applications applications, User user) {
		// TODO Auto-generated method stub
		return getApplicationsDao().getUser(applications, user);
	}

	@Override
	public List<AppServer> getAllAppServer(Applications applications) {
		// TODO Auto-generated method stub
		return getApplicationsDao().getAllAppServer(applications);
	}

	@Transactional(readOnly=false)
	@Override
	public boolean addAppServer(Applications applications, Server server,
			String userId) {
		// TODO Auto-generated method stub
		return getApplicationsDao().addAppServer(applications, server, userId);
	}

	@Transactional(readOnly=false)
	@Override
	public boolean removeAppServer(Applications applications, Server server) {
		// TODO Auto-generated method stub
		return getApplicationsDao().removeAppServer(applications, server);
	}

	@Override
	public Server getServer(Applications applications, Server server) {
		// TODO Auto-generated method stub
		return getApplicationsDao().getServer(applications, server);
	}

	@Override
	public List<GroupUserApp> getAllGroupUser(Applications applications) {
		// TODO Auto-generated method stub
		return getApplicationsDao().getAllGroupUser(applications);
	}

	@Transactional(readOnly=false)
	@Override
	public boolean addGroupUser(Applications applications, GroupUser groupUser,
			String userId) {
		// TODO Auto-generated method stub
		return getApplicationsDao().addGroupUser(applications, groupUser, userId);
	}

	@Transactional(readOnly=false)
	@Override
	public boolean removeGroupUser(Applications applications,
			GroupUser groupUser) {
		// TODO Auto-generated method stub
		return getApplicationsDao().removeGroupUser(applications, groupUser);
	}

	@Override
	public GroupUser getGroupUser(Applications applications, GroupUser groupUser) {
		// TODO Auto-generated method stub
		return getApplicationsDao().getGroupUser(applications, groupUser);
	}
	
	
}
