package com.librework.console.service.impl;

import java.io.Serializable;
import java.util.List;

import org.springframework.transaction.annotation.Transactional;

import com.librework.console.dao.IServerDao;
import com.librework.console.model.AppServer;
import com.librework.console.model.Applications;
import com.librework.console.model.GroupServer;
import com.librework.console.model.Server;
import com.librework.console.model.ServerGroup;
import com.librework.console.model.ServerHDD;
import com.librework.console.model.UserApp;
import com.librework.console.service.IServerService;

@Transactional(readOnly=true)
public class ServerService implements IServerService, Serializable {

	private static final long serialVersionUID = 1L;
	
	IServerDao serverDao;
	
	public IServerDao getServerDao() {
		return serverDao;
	}

	public void setServerDao(IServerDao serverDao) {
		this.serverDao = serverDao;
	}

	@Transactional(readOnly=false)
	@Override
	public boolean createServer(Server server) {
		// TODO Auto-generated method stub
		return getServerDao().createServer(server);
	}

	@Override
	public Server getServerId(String serverId) {
		// TODO Auto-generated method stub
		return getServerDao().getServerId(serverId);
	}

	@Override
	public List<Server> getServerHost(String serverHost) {
		// TODO Auto-generated method stub
		return getServerDao().getServerHost(serverHost);
	}

	@Override
	public List<Server> getServerDescription(String serverDescription) {
		// TODO Auto-generated method stub
		return getServerDao().getServerDescription(serverDescription);
	}

	@Override
	public List<Server> getAllServer() {
		// TODO Auto-generated method stub
		return getServerDao().getAllServer();
	}

	@Transactional(readOnly=false)
	@Override
	public boolean updateServer(Server server) {
		// TODO Auto-generated method stub
		return getServerDao().updateServer(server);
	}

	@Transactional(readOnly=false)
	@Override
	public boolean deleteServer(Server server) {
		// TODO Auto-generated method stub
		return getServerDao().deleteServer(server);
	}

	@Override
	public List<ServerHDD> getAllServerHDD(Server server) {
		// TODO Auto-generated method stub
		return getServerDao().getAllServerHDD(server);
	}

	@Transactional(readOnly=false)
	@Override
	public boolean addServerHDD(Server server, ServerHDD serverHDD) {
		// TODO Auto-generated method stub
		return getServerDao().addServerHDD(server, serverHDD);
	}

	@Transactional(readOnly=false)
	@Override
	public boolean removeServerHDD(Server server, ServerHDD serverHDD) {
		// TODO Auto-generated method stub
		return getServerDao().removeServerHDD(server, serverHDD);
	}

	@Override
	public ServerHDD getServerHDD(Server server, ServerHDD serverHDD) {
		// TODO Auto-generated method stub
		return getServerDao().getServerHDD(server, serverHDD);
	}

	@Override
	public List<ServerGroup> getAllGroupServer(Server server) {
		// TODO Auto-generated method stub
		return getServerDao().getAllGroupServer(server);
	}

	@Transactional(readOnly=false)
	@Override
	public boolean addGroupServer(Server server, GroupServer groupServer,
			String userId) {
		// TODO Auto-generated method stub
		return getServerDao().addGroupServer(server, groupServer, userId);
	}

	@Transactional(readOnly=false)
	@Override
	public boolean removeGroupServer(Server server, GroupServer groupServer) {
		// TODO Auto-generated method stub
		return getServerDao().removeGroupServer(server, groupServer);
	}

	@Override
	public GroupServer getGroupServer(Server server, GroupServer groupServer) {
		// TODO Auto-generated method stub
		return getServerDao().getGroupServer(server, groupServer);
	}

	@Override
	public List<AppServer> getAllApplications(Server server) {
		// TODO Auto-generated method stub
		return getServerDao().getAllApplications(server);
	}

	@Transactional(readOnly=false)
	@Override
	public boolean addApplications(Server server, Applications applications,
			String userId) {
		// TODO Auto-generated method stub
		return getServerDao().addApplications(server, applications, userId);
	}

	@Transactional(readOnly=false)
	@Override
	public boolean removeApplications(Server server, Applications applications) {
		// TODO Auto-generated method stub
		return getServerDao().removeApplications(server, applications);
	}

	@Override
	public Applications getApplications(Server server, Applications applications) {
		// TODO Auto-generated method stub
		return getServerDao().getApplications(server, applications);
	}

	@Override
	public List<UserApp> getAllUserApp(Server server) {
		// TODO Auto-generated method stub
		return getServerDao().getAllUserApp(server);
	}

	@Override
	public List<UserApp> getActiveUserApp(Server server) {
		// TODO Auto-generated method stub
		return getServerDao().getActiveUserApp(server);
	}

}
