package com.librework.console.service.impl;

import java.io.Serializable;
import java.util.List;

import org.springframework.transaction.annotation.Transactional;

import com.librework.console.dao.IUserDao;
import com.librework.console.model.Applications;
import com.librework.console.model.GroupUser;
import com.librework.console.model.Site;
import com.librework.console.model.User;
import com.librework.console.model.UserApp;
import com.librework.console.model.UserGroup;
import com.librework.console.model.UserSite;
import com.librework.console.service.IUserService;

@Transactional(readOnly = true)
public class UserService implements IUserService, Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	IUserDao userDao;
	
	public IUserDao getUserDao() {
		return userDao;
	}

	public void setUserDao(IUserDao userDao) {
		this.userDao = userDao;
	}
	
	@Transactional(readOnly = false)
	@Override
	public boolean createUser(User user) {
		// TODO Auto-generated method stub
		return getUserDao().createUser(user);
	}

	
	@Override
	public User getUserId(String userId) {
		// TODO Auto-generated method stub
		return getUserDao().getUserId(userId);
	}

	@Override
	public List<User> getAllUser() {
		// TODO Auto-generated method stub
		return getUserDao().getAllUser();
	}

	@Override
	public List<User> getActiveUser() {
		// TODO Auto-generated method stub
		return getUserDao().getActiveUser();
	}
	@Transactional(readOnly = false)
	@Override
	public boolean updateUser(User user) {
		// TODO Auto-generated method stub
		return getUserDao().updateUser(user);
	}

	@Transactional(readOnly = false)
	@Override
	public boolean deleteUser(User user) {
		// TODO Auto-generated method stub
		return getUserDao().deleteUser(user);
	}

	@Override
	public boolean authenticateUser(String userId, String password) {
		// TODO Auto-generated method stub
		return getUserDao().authenticateUser(userId, password);
	}

	@Override
	public List<UserGroup> getAllGroupUser(User user) {
		// TODO Auto-generated method stub
		return getUserDao().getAllGroupUser(user);
	}

	@Transactional(readOnly = false)
	@Override
	public boolean addGroupUser(User user, GroupUser groupUser) {
		// TODO Auto-generated method stub
		return getUserDao().addGroupUser(user, groupUser);
	}

	@Transactional(readOnly = false)
	@Override
	public boolean removeGroupUser(User user, GroupUser groupUser) {
		// TODO Auto-generated method stub
		return getUserDao().removeGroupUser(user, groupUser);
	}

	@Override
	public GroupUser getGroupUser(User user, GroupUser groupUser) {
		// TODO Auto-generated method stub
		return getUserDao().getGroupUser(user, groupUser);
	}

	@Override
	public List<User> getUserName(String userName) {
		// TODO Auto-generated method stub
		return getUserDao().getUserName(userName);
	}

	@Override
	public List<User> getUserSurname1(String userSurname1) {
		// TODO Auto-generated method stub
		return getUserDao().getUserSurname1(userSurname1);
	}

	@Override
	public List<User> getUserEmail(String userEmail) {
		// TODO Auto-generated method stub
		return getUserDao().getUserEmail(userEmail);
	}

	@Override
	public List<User> getDeactivateUser() {
		// TODO Auto-generated method stub
		return getUserDao().getDeactivateUser();
	}

	@Override
	public List<UserApp> getAllUserApp(User user) {
		// TODO Auto-generated method stub
		return getUserDao().getAllUserApp(user);
	}
	
	@Override
	public List<UserApp> getUserAppActive(User user) {
		return getUserDao().getUserAppActive(user);
	}

	@Override
	public boolean addUserApp(User user, Applications applications) {
		// TODO Auto-generated method stub
		return getUserDao().addUserApp(user, applications);
	}

	@Override
	public boolean removeUserApp(User user, Applications applications) {
		// TODO Auto-generated method stub
		return getUserDao().removeUserApp(user, applications);
	}

	@Override
	public Applications getApplications(User user, Applications applications) {
		// TODO Auto-generated method stub
		return getUserDao().getApplications(user, applications);
	}

	@Override
	public List<UserSite> getAllUserSite(User user) {
		// TODO Auto-generated method stub
		return getUserDao().getAllUserSite(user);
	}

	@Override
	public boolean addUserSite(User user, Site site) {
		// TODO Auto-generated method stub
		return getUserDao().addUserSite(user, site);
	}

	@Override
	public boolean removeUserSite(User user, Site site) {
		// TODO Auto-generated method stub
		return getUserDao().removeUserSite(user, site);
	}

	@Override
	public Site getSite(User user, Site site) {
		// TODO Auto-generated method stub
		return getUserDao().getSite(user, site);
	}
}
