package com.librework.console.utils;

import java.io.Serializable;

import org.apache.log4j.BasicConfigurator;
import org.springframework.beans.factory.xml.XmlBeanDefinitionReader;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.GenericApplicationContext;
import org.springframework.core.io.ClassPathResource;

public class AppUtils implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public static ApplicationContext applicationContext;
	
	public static ApplicationContext getApplicationContext(){
		return applicationContext;
	}
	
	public static void setApplicationContext(final ApplicationContext context) {
		applicationContext = context;
	}
	
	public static Object getBean(final String name) {
		if (applicationContext == null) {
			throw new IllegalArgumentException(
					"ApplicationContext is not initialized");
		}
		return applicationContext.getBean(name);
	}
	
	public static GenericApplicationContext getContext() {
		BasicConfigurator.configure();
	 	GenericApplicationContext appContext = new GenericApplicationContext();
	 	XmlBeanDefinitionReader xmlReader = new XmlBeanDefinitionReader(
			 	appContext);
		xmlReader.loadBeanDefinitions(new ClassPathResource(
			 "ldapContext.xml"));
		return appContext;
		
	}
		
}
