package com.librework.console.utils;

import java.io.Serializable;
import java.util.Locale;

import javax.faces.context.FacesContext;
import javax.servlet.http.HttpServletRequest;

import com.librework.console.general.Constant;

public class LanguageUtils implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private String loc = null;
	
	public LanguageUtils() {
		HttpServletRequest request = (HttpServletRequest) FacesContext.getCurrentInstance().getExternalContext().getRequest();
		setLoc(request.getLocale().toString());
		//System.out.println("Default Locale is : " + Locale.getDefault());
	}
	
	/**
	 * Retorna el mensaje en el idioma del locale mediante su fichero de propiedades
	 * 
	 * @param keyi18n
	 * @return
	 */
	public String getMessage(String keyi18n) {
		//System.out.println("Locale=" + this.loc + keyi18n);
		int last = this.loc.lastIndexOf("_");
		String lang = null;
		if (last > 0) {
			lang = this.loc.substring(0, last);
		} else {
			lang = this.loc;
		}
		PropertiesUtils utilidades = new PropertiesUtils(Constant.CONFIG_FILE_I18N + lang + Constant.EXTENSION_FILE_PROPERTIES);
		return utilidades.getProperty(keyi18n);
	}

	/**
	 * @return the loc
	 */
	public String getLoc() {
		return loc;
	}

	/**
	 * @param loc the loc to set
	 */
	public void setLoc(String loc) {
		this.loc = loc;
	}
	
	
}
