package beans;

import java.util.ArrayList;  
import java.util.List;  

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.context.FacesContext;  

import ldap.Ldap;
import model.User;

import org.primefaces.event.RowEditEvent;  

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.naming.NamingEnumeration;
import javax.naming.directory.Attributes;
import javax.naming.directory.SearchResult;

import java.util.Hashtable;

import javax.naming.Context;
import javax.naming.NamingEnumeration;
import javax.naming.NamingException;
import javax.naming.directory.Attribute;
import javax.naming.directory.Attributes;
import javax.naming.directory.BasicAttribute;
import javax.naming.directory.DirContext;
import javax.naming.directory.InitialDirContext;
import javax.naming.directory.SearchControls;
import javax.naming.directory.SearchResult;


@ManagedBean
public class TableBean {  
  
	
    private List<User> userList;  
    private NamingEnumeration<SearchResult> enumResult;
  
    
    
    public TableBean() throws NamingException {  
    	String prueba = "";
    	userList = new ArrayList<User>();
        String[] attrIDs ={"cn","displayName", "mail", "telephoneNumber", "registeredAddress"};
    	
    	enumResult = Ldap.SearchAttrib("cn=Users,dc=librework,dc=local","(&(objectCategory=person)(objectClass=user))", attrIDs);
        populateTable(userList);  
    }  
  
    
    
    

    
    
    private void populateTable(List<User> list) throws NamingException {  
    	
    	
    	while (enumResult.hasMore()) {
    		
    		SearchResult result = (SearchResult) enumResult.next();
            Attributes attribs = result.getAttributes();
            
            // UserID
            NamingEnumeration userIDvalue = ((BasicAttribute) attribs.get("cn")).getAll();
            
            //displayName
            String displayNamevalueString;
            if ((BasicAttribute) attribs.get("displayName")!=null){
            NamingEnumeration displayNamevalue = ((BasicAttribute) attribs.get("displayName")).getAll();
            displayNamevalueString = displayNamevalue.next().toString();
            }
            else{
            	displayNamevalueString = "";
            }
          
            //displayName
            String mailvalueString;
            if ((BasicAttribute) attribs.get("mail")!=null){
            NamingEnumeration mailvalue = ((BasicAttribute) attribs.get("mail")).getAll();
            mailvalueString = mailvalue.next().toString();
            }
            else{
            	mailvalueString = "";
            }

            //telephoneNumber
            String telephoneNumbervalueString;
            if ((BasicAttribute) attribs.get("telephoneNumber")!=null){
            NamingEnumeration telephoneNumbervalue = ((BasicAttribute) attribs.get("telephoneNumber")).getAll();
            telephoneNumbervalueString = telephoneNumbervalue.next().toString();
            }
            else{
            	telephoneNumbervalueString = "";
            }
    		
    		list.add(new User(userIDvalue.next().toString(),displayNamevalueString, mailvalueString, 
    				telephoneNumbervalueString, "calle del pez"));
    		
            
            
            
    	      
    	     
    	    }
    	
    
    }  
  
    
    
    
    
	public List<User> getUserList() {
		return userList;
	}

	public void setUserList(List<User> list) {
		this.userList = list;
	}
    
    
    
    
    
    public void onEdit(RowEditEvent event) {  
        FacesMessage msg = new FacesMessage("Usuario Editado", ((User) event.getObject()).getUserID());  
  
        FacesContext.getCurrentInstance().addMessage(null, msg);  
    }  
      
    public void onCancel(RowEditEvent event) {  
        FacesMessage msg = new FacesMessage("Car Cancelled", ((User) event.getObject()).getUserID());  
  
        FacesContext.getCurrentInstance().addMessage(null, msg);  
    }  
}  