package ldap;
import java.util.Hashtable;

import javax.naming.Context;
import javax.naming.NamingEnumeration;
import javax.naming.NamingException;
import javax.naming.directory.Attribute;
import javax.naming.directory.BasicAttribute;
import javax.naming.directory.DirContext;
import javax.naming.directory.InitialDirContext;
import javax.naming.directory.ModificationItem;
import javax.naming.directory.SearchControls;
import javax.naming.directory.SearchResult;
import javax.naming.ldap.InitialLdapContext;
import javax.naming.ldap.LdapContext;

public class Ldap {


	public static String INITCTX = "com.sun.jndi.ldap.LdapCtxFactory";

	  public static String MY_HOST = "ldap://192.168.1.100";

	  public static String MGR_DN = "cn=Administrator, cn=Users, dc=librework, dc=local";

	  public static String MGR_PW = "Dinsa.2013";

	  public static String MY_SEARCHBASE = "dc=librework, dc=local";
	
	
	  
	  
	  public static void modifyAttrib(String cn, String attrib, String value) throws Exception {
	  //modifyUser("cn=usuario, cn=Users, dc=librework, dc=local", attrib, value)	  
	
	    
		    Hashtable<String, String> env = new Hashtable<String, String>();

		    env.put(Context.INITIAL_CONTEXT_FACTORY, INITCTX);

		    env.put(Context.PROVIDER_URL, MY_HOST);
		    env.put(Context.SECURITY_AUTHENTICATION, "simple");
		    env.put(Context.SECURITY_PRINCIPAL, MGR_DN);
		    env.put(Context.SECURITY_CREDENTIALS, MGR_PW);

		    DirContext ctx = new InitialDirContext(env);

		    ModificationItem[] mods = new ModificationItem[1];
		    Attribute mod = new BasicAttribute(attrib, value);
		    mods[0] = new ModificationItem(DirContext.REPLACE_ATTRIBUTE, mod);
		    	
		    ctx.modifyAttributes(cn, mods);
		  
	  
	  }
	  
	  
	  public static NamingEnumeration<SearchResult> SearchAttrib(String dn, String cond, String[] attrib) {
		  	
		  	Hashtable<String, String> env = new Hashtable<String, String>();
		    env.put(Context.INITIAL_CONTEXT_FACTORY, INITCTX);
		    env.put(Context.PROVIDER_URL, MY_HOST);
		    env.put(Context.SECURITY_AUTHENTICATION, "simple");
		    env.put(Context.SECURITY_PRINCIPAL, MGR_DN);
		    env.put(Context.SECURITY_CREDENTIALS, MGR_PW);
		    
		    NamingEnumeration<SearchResult> enumResult = null;
		    
		    try
		    {
		    	DirContext ctx = new InitialDirContext(env);
		    
		    	SearchControls controls = new SearchControls();                     
		    	controls.setSearchScope(SearchControls.SUBTREE_SCOPE);
		    	controls.setReturningAttributes(attrib);
		    	//enumResult = ctx.search("","(&(objectCategory=person)(objectClass=user)(CN=*))", controls);                     
		    	enumResult = ctx.search(dn,cond, controls);                     

		    	if(enumResult != null)
		    	{
		    		//authentication successful                                 
		    	}       
		    
		    }
		    catch(Exception e){
		        System.out.println(e.getMessage());
		    }
			return enumResult;
	  }
	  
	  
	  
	  
	
}
