#!/bin/bash

VG=$1

function usage()
{
	echo "Usage: $0 <lvm volume group>"
	echo "Example: $0 vgxen"
	exit 1
}

if [ -z "$1" ] || [ -n "$2" ]
then
	usage
fi

VMS=`xe vm-list | grep -v "Control domain" | grep -B1 "name-label" | grep uuid | awk -F ': ' '{print $2}'`
for i in $VMS
do
	xe vm-destroy uuid=$i
done

PBD=`xe pbd-list | grep -B4 "device: /dev/${VG}" | grep "^uuid" | awk -F ': ' '{print $2}'`

for i in $PBD
do
	xe pbd-unplug uuid=$i 2>/dev/null
	xe pbd-unplug uuid=$i
	xe pbd-destroy uuid=$i
done

SR=`xe sr-list | grep -B5 "lvhd" | grep "^uuid" | awk -F ': ' '{print $2}'`
for i in $SR
do
	xe sr-destroy uuid=$i
	xe sr-forget uuid=$i
done

for i in /dev/$VG/*
do
	lvremove -f $i
done

vgremove $VG
