#include "proxyserver.h"

#include "proxyserverthread.h"

ProxyServer::ProxyServer(QString remoteAddress, int remotePort) : QTcpServer()
{
	this->remoteAddress = remoteAddress;
	this->remotePort = remotePort;
}

ProxyServer::~ProxyServer()
{
}

void ProxyServer::incomingConnection ( int socketDescriptor )
{
	qDebug("New proxy server thread");
	ProxyServerThread *thread = new ProxyServerThread(socketDescriptor, this, remoteAddress, remotePort);
	connect(thread, SIGNAL(finished()), thread, SLOT(deleteLater()));
	thread->start();
}

void ProxyServer::error(QAbstractSocket::SocketError err)
{
	qDebug()<<tr("Error: %1").arg(err);
}
