#ifndef CONSTANTS_H
#define CONSTANTS_H

#include <QObject>

#ifdef Q_OS_LINUX
#define SHAREDIR "/usr/share/librework-server/"
#define CONFIG_FILE "/etc/librework-server/librework-server.ini"
#endif

#ifdef Q_OS_WIN
#define PROGRAMFILES qgetenv("PROGRAMW6432")
#define SHAREDIR PROGRAMFILES + "\\Librework Server\\"
#define CONFIG_FILE SHAREDIR + "librework-server.ini"
#endif

#define DEFAULT_PORT 4445
#define DEFAULT_ADDRESS "0.0.0.0"
#define TOKEN_LENGTH 64
#define CREATE_USER_TIMEOUT 15000
#define PYTHONRUNTIMEOUT 3000
#define SOCKET_TIMEOUT 5000
#define MAX_MESSAGE_SIZE 2048
#define DOWNLOAD_DIR "/tmp/lwserver/"

#define EVENT_ERROR 0
#define EVENT_WARNING 1
#define EVENT_INFO 2

#define EVENT_START_SESSION 1
#define EVENT_END_SESSION 2
#define EVENT_START_APPLICATION 3
#define EVENT_END_APPLICATION 4
#define EVENT_SERVER_ERROR 5
#define EVENT_USER_ERROR 6
#define EVENT_AUTH_ERROR 7

#define SERVER_RUNNING QString("RUNNING")
#define SERVER_STOPPED QString("STOPPED")
#define SERVER_PAUSED QString("PAUSED")
#define SERVER_UNKNOWN QString("UNKNOWN")
#define SERVER_VIRT_FILES_SAVED_DIR QString("/var/lib/libvirt/save/")


#define _ERROR_(errorString) ("Error: " + errorString)
#define _SUCCESS_(successString) ("Success: " + successString)

#endif
