#ifndef SERVER_H
#define SERVER_H

#include <QObject>

#ifdef Q_OS_WIN
#include <WinSock2.h>
#include <WS2tcpip.h>
#include <Windows.h>
#endif
#ifdef Q_OS_LINUX
#include <sys/socket.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <pthread.h>
#include <semaphore.h>
#endif

#include <string>

using namespace std;

#include <QDebug>
#include <QString>
#include <QTcpSocket>
#include <QSettings>

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>

#include <signal.h>

#include "lwserverthread.h"
#include "lwservercommand.h"
#include "lwusercommand.h"
#include "constants.h"

#ifdef Q_OS_WIN
#define SHOWERROR WSAGetLastError()
#else
#define SHOWERROR strerror(errno)
#endif

struct connectionStruct
{
	int * sock;
	char * remoteAddress;
};

class LWServer : public QObject
{
	Q_OBJECT

	public:
		LWServer(QString adminuser = QString::null, QString password = QString::null);

		static void *connection_handler(void *);
		int listenConnections( char * address, int port );
		static void intHandler(int);
		int sendServerInformation(QString adminuser, QString password);
		QString sendMessage(QTcpSocket *tcpSocket, QString message);
		QString lastError() { return _lastError; };

	signals:
		void progress(int);
		void progressText(QString);

	private:
		QString adminuser;
		QString password;
		QString address;
		QString _lastError;
		bool principal;
};

#endif
