#ifndef LWSERVERCOMMAND_H
#define LWSERVERCOMMAND_H

#include <QFile>
#include <QFileInfo>
#include <QDir>
#include <QUrl>
#include <QString>
#include <QStringList>
#include <QDateTime>
#include <QHostAddress>
#include <QProcess>
#include <QTemporaryFile>
#include <QDateTime>
#include <QTimer>
#include <QHash>
#include <QPixmap>
#include <QBuffer>

#include "constants.h"
#include "mysqlinfo.h"
#include "pythonrun.h"
#include "lwusercommand.h"
#include "lwsystemcommand.h"
#include "lwprintercommand.h"
#include "lwapplicationcommand.h"
#include "lwstoragecommand.h"
#include "lwvirtcommand.h"

class LWServerCommand : public QObject
{
	Q_OBJECT

	public:
		LWServerCommand(MySqlInfo * mySqlInfo, QString username, QString password, QString serverAddress, bool isAdministrator);

		QString doResponse(QString question);
		QByteArray doResponseByteArray(QString question);
		QString activateUser(QString username);
		QString writeToken(QString username, QString token);
		static QString setServerToken(MySqlInfo *mySqlInfo, QString serverAddress, int port, QString token);
		static QString setServerInformation(MySqlInfo * mySqlInfo, QString token, QString serverType, QString status, QString clientAddress);

#ifdef Q_OS_LINUX
		QString libreworkGroup();
		QString libreworkConsoleGroup();
#endif
        /* Session logs */
		QString startSession();
		QString endSession();
		QString startApplication( long long applicationId, long processId );
		QString endApplication( long long applicationId, long processId );

		/* Logs */
		QString writeError(QString errorString);
		QString writeInfo(QString infoString);

	private:
		Application getApplication( long applicationId );
		QString fillEvent(long long typeId, long long appId, QString text);
		QByteArray downloadIcon(QString iconFile);

		QString username;
		QString password;
		QString serverAddress;
		MySqlInfo * mySqlInfo;
		QList<Application*> applications;
		bool isAdministrator;
};

#endif
