#ifndef LWSERVERTHREAD_H
#define LWSERVERTHREAD_H

#include <QString>
#include <QByteArray>
#include <QSettings>

using namespace std;

#include <string>

#ifdef Q_OS_LINUX
#include <security/pam_appl.h> 
#endif

#ifdef Q_OS_WIN
#pragma comment(lib, "advapi32.lib")
#include <Windows.h>
#endif

#include "lwservercommand.h"
#include "lwusercommand.h"
#include "mysqlinfo.h"

class LWServerThread
{
	public:
		LWServerThread(QString name, QString clientAddress);
		~LWServerThread();

		QByteArray dispatchByteArrayMessage( QByteArray question );
		string dispatchMessage( QByteArray question );

	private:
		bool validate( QString username, QString password );
#ifdef Q_OS_LINUX
		bool pamValidate( const char * username, const char * password);
#endif
#ifdef Q_OS_WIN
        bool winValidate( QString username, QString password);
#endif
        bool isAdministrator(QString username , QString adminGroup);

		MySqlInfo * mySqlInfo;
		QString username;
		QString password;
		QString clientAddress;
		bool mySqlAuthenticated;
		bool _isAdministrator;
};

#endif
