#include "lwstoragecommand.h"

QString LWStorageCommand::getRedirectDrives(QString serverAddress, QString username, MySqlInfo *mySqlInfo)
{
	// Redirections by server
	QStringList redirections = mySqlInfo->getValues("lw_server,lw_storageredirection",
							"CONCAT(lw_storageredirection.server_path,'=',lw_storageredirection.client_path)",
							"lw_server.id=lw_storageredirection.server_id AND lw_server.address='" + serverAddress + "'");

	// Redirections by user name
	redirections += mySqlInfo->getValues("lw_userstorageredirection",
							"CONCAT(server_path,'=',client_path)",
							"user_id='" + username +"'");

	// Redirections by group
	redirections += mySqlInfo->getValues("lw_usergroup_users,lw_groupstorageredirection",
							"CONCAT(lw_groupstorageredirection.server_path,'=',lw_groupstorageredirection.client_path)",
							"lw_usergroup_users.user_id='" + username + "' AND lw_usergroup_users.usergroup_id=lw_groupstorageredirection.group_id");

	return redirections.join(",");
}
