#ifndef LWSYSTEMCOMMAND_H
#define LWSYSTEMCOMMAND_H

#include <QFile>
#include <QFileInfo>
#include <QDir>
#include <QUrl>
#include <QString>
#include <QStringList>
#include <QDateTime>
#include <QHostAddress>
#include <QProcess>
#include <QTemporaryFile>
#include <QDateTime>
#include <QTimer>
#include <QHash>
#include <QPixmap>
#include <QBuffer>

#ifdef Q_OS_WIN
#pragma comment(lib, "netapi32.lib")
#include <Windows.h>
#include <LM.h>
#include <winternl.h>
#include <WinBase.h>
#include <stdint.h>
#include <WtsApi32.h>
#endif

#ifdef Q_OS_LINUX
#include <stdlib.h>
#include <unistd.h>
#include <sys/sysinfo.h>
#include <proc/sysinfo.h>
#endif

#include "constants.h"

class LWSystemCommand : public QObject
{
	Q_OBJECT

	public:
		static QString mountChroot(QString chrootHome, QString chrootMount, QString username, QString password, QString homePath, QString sambaServer);
		static QString umountChroot(QString username);
		static QString getSystemMemory();
		static QString getSystemDiskSpace();
		static QString getSystemLoad();
		static QString killSession(QString username);
		static QString getPreferredServer( QList<double> cpuUsage, QList<double> freeMemory, QStringList serverId, double cpuWeight );

	private:
#ifdef Q_OS_WIN
		static ULONG FileTimeToULong(const FILETIME & ft);
#endif
};

#endif
