#ifndef LWUSERCOMMAND_H
#define LWUSERCOMMAND_H

#include <QObject>
#include <QString>
#include <QStringList>
#include <QProcess>
#include <QTime>
#include <QDir>

#ifdef Q_OS_WIN
#pragma comment(lib, "netapi32.lib")
#include <Windows.h>
#include <LM.h>
#include <winternl.h>
#include <WinBase.h>
#include <stdint.h>
#include <WtsApi32.h>
#include <Iads.h>
#include <AdsHlp.h>
#include <atlbase.h>
#include <NtLdap.h>
#include <accctrl.h>
#include <aclapi.h>
#include <Mq.h>
#endif

#include "constants.h"
#include "pythonrun.h"

class LWUserCommand : public QObject
{
	Q_OBJECT

	public:
		static QStringList getGroups(QString username);
		static QString getGroups();
		static bool isUserInGroup(QString username, QString groupname);
		static QString createGroup(QString group);
		static QString removeGroup(QString group);
		static QString modifyUserPassword(QString username, QString oldPassword, QString newPassword);
		static QString getUserList(QString group);
		static QString createUser(QString username, QString password);
		static QString createUserFolder(QString username, QString basePath);
		static QString removeUserFolder(QString username, QString basePath);
		static QString removeUser(QString username);
		static QString enableUser(QString username, QString group);
		static QString disableUser(QString username, QString group);
		static QString generateToken();

	private:
#ifdef Q_OS_WIN
		static HRESULT getSid(LPCWSTR wszAccName, PSID * ppSid);
		static USER_INFO_4 getUserInfo4(QString username, QString password, QString homeDir, QString profileDir);
#endif
};

#endif
