#ifndef LWVIRTCOMMAND_H
#define LWVIRTCOMMAND_H

#include <QString>
#include <QStringList>

#ifdef Q_OS_LINUX
#include <libvirt/libvirt.h>
#endif

#include "constants.h"

class LWVirtCommand : public QObject
{
	Q_OBJECT

	public:
		static QString startServer(QString serverName);
		static QString pauseServer(QString serverName);
		static QString hardStopServer(QString serverName);
		static QString resumeServer(QString serverName);
		static QString hardRebootServer(QString serverName);
		static QString softStopServer(QString serverName);
		static QString softRebootServer(QString serverName);
		static QStringList serverList();
		static QString getServerStatus(QString serverName);

	private:
#ifdef Q_OS_LINUX
        static virConnectPtr createConnection();
        static QString getFilePath(QString serverName);

#endif
};

#endif
