CREATE DATABASE `librework` /*!40100 DEFAULT CHARACTER SET latin1 COLLATE latin1_spanish_ci */;

USE librework;

CREATE TABLE `lw_type_event` (
  `TEV_ID` bigint(20) NOT NULL,
  `TEV_DESCRIPTION` varchar(100) COLLATE latin1_spanish_ci NOT NULL,
  `TEV_DATMOD` datetime NOT NULL,
  `TEV_USEMOD` varchar(20) COLLATE latin1_spanish_ci NOT NULL,
  PRIMARY KEY (`TEV_ID`,`TEV_DESCRIPTION`),
  KEY `TEV_ID` (`TEV_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci;


CREATE TABLE `lw_systemoperating` (
  `SYO_ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `SYO_DESCRIPTION` varchar(50) COLLATE latin1_spanish_ci NOT NULL,
  `SYO_DATMOD` datetime NOT NULL,
  `SYO_USEMOD` varchar(20) COLLATE latin1_spanish_ci NOT NULL,
  PRIMARY KEY (`SYO_ID`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci;

CREATE TABLE `lw_group_app` (
  `GAP_ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `GAP_DESCRIPTION` varchar(100) COLLATE latin1_spanish_ci NOT NULL,
  `GAP_DATMOD` datetime NOT NULL,
  `GAP_USEMOD` varchar(20) COLLATE latin1_spanish_ci NOT NULL,
  PRIMARY KEY (`GAP_ID`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci;


CREATE TABLE `lw_group_server` (
  `GRS_ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `GRS_DESCRIPTION` varchar(100) COLLATE latin1_spanish_ci NOT NULL,
  `GRS_DATMOD` datetime NOT NULL,
  `GRS_USEMOD` varchar(20) COLLATE latin1_spanish_ci NOT NULL,
  PRIMARY KEY (`GRS_ID`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci;


CREATE TABLE `lw_group_user` (
  `GUS_ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `GUS_CN` varchar(50) NOT NULL,
  `GUS_NAME` varchar(100) NOT NULL,
  `GUS_DESCRIPTION` varchar(100) CHARACTER SET latin1 COLLATE latin1_spanish_ci NOT NULL,
  `GUS_DATMOD` datetime NOT NULL,
  `GUS_USEMOD` varchar(20) CHARACTER SET latin1 COLLATE latin1_spanish_ci NOT NULL,
  PRIMARY KEY (`GUS_ID`)
) ENGINE=InnoDB AUTO_INCREMENT=115 DEFAULT CHARSET=latin1;


CREATE TABLE `lw_site` (
  `SIT_ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `SIT_DESCRIPTION` varchar(100) CHARACTER SET latin1 COLLATE latin1_spanish_ci NOT NULL,
  `SIT_LOGO` blob,
  `SIT_LDAP_IP` varchar(50) CHARACTER SET latin1 COLLATE latin1_spanish_ci DEFAULT NULL,
  `SIT_LDAP_IP_CLIENT` varchar(50) DEFAULT NULL,
  `SIT_LDAP_DC1` varchar(50) CHARACTER SET latin1 COLLATE latin1_spanish_ci DEFAULT NULL,
  `SIT_LDAP_DC1_CLIENT` varchar(50) DEFAULT NULL,
  `SIT_LDAP_DC2` varchar(50) CHARACTER SET latin1 COLLATE latin1_spanish_ci DEFAULT NULL,
  `SIT_LDAP_DC2_CLIENT` varchar(50) DEFAULT NULL,
  `SIT_LDAP_USER` varchar(50) CHARACTER SET latin1 COLLATE latin1_spanish_ci DEFAULT NULL,
  `SIT_LDAP_USER_CLIENT` varchar(50) DEFAULT NULL,
  `SIT_LDAP_PASS` varchar(50) CHARACTER SET latin1 COLLATE latin1_spanish_ci DEFAULT NULL,
  `SIT_LDAP_PASS_CLIENT` varchar(50) DEFAULT NULL,
  `SIT_IP_BD` varchar(100) DEFAULT NULL,
  `SIT_USER_BD` varchar(20) DEFAULT NULL,
  `SIT_PASS_BD` varchar(20) DEFAULT NULL,
  `SIT_URL` varchar(100) CHARACTER SET latin1 COLLATE latin1_spanish_ci DEFAULT NULL,
  `SIT_DATMOD` datetime NOT NULL,
  `SIT_USEMOD` varchar(20) CHARACTER SET latin1 COLLATE latin1_spanish_ci NOT NULL,
  PRIMARY KEY (`SIT_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `lw_user` (
  `USE_ID` varchar(20) NOT NULL,
  `USE_NAME` varchar(100) NOT NULL,
  `USE_SURNAME1` varchar(100) NOT NULL,
  `USE_SURNAME2` varchar(100) DEFAULT NULL,
  `USE_DIRECTION` varchar(200) DEFAULT NULL,
  `USE_EMAIL` varchar(100) DEFAULT NULL,
  `USE_PHONE` varchar(12) DEFAULT NULL,
  `USE_PASSWORD` varchar(100) DEFAULT NULL,
  `USE_START_LAST_CONNECTION` datetime DEFAULT NULL,
  `USE_END_LAST_CONNECTION` datetime DEFAULT NULL,
  `USE_DATMOD` datetime NOT NULL,
  `USE_USEMOD` varchar(20) NOT NULL,
  PRIMARY KEY (`USE_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


CREATE TABLE `lw_applications` (
  `APP_ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `APP_NAME` varchar(100) COLLATE latin1_spanish_ci NOT NULL,
  `APP_DISPLAY_NAME` varchar(100) COLLATE latin1_spanish_ci NOT NULL,
  `APP_DESCRIPTION` varchar(100) COLLATE latin1_spanish_ci DEFAULT NULL,
  `APP_PATH_EXE` varchar(200) COLLATE latin1_spanish_ci DEFAULT NULL,
  `APP_ICON` blob,
  `APP_SYO_ID` bigint(20) DEFAULT NULL,
  `APP_DATMOD` datetime NOT NULL,
  `APP_USEMOD` varchar(20) COLLATE latin1_spanish_ci NOT NULL,
  PRIMARY KEY (`APP_ID`),
  KEY `FK_APP_SYO_ID_idx` (`APP_SYO_ID`),
  CONSTRAINT `FK_APP_SYO_ID` FOREIGN KEY (`APP_SYO_ID`) REFERENCES `lw_systemoperating` (`SYO_ID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=16 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci;

CREATE TABLE `lw_notification` (
  `NOT_ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `NOT_TEV_ID` bigint(20) DEFAULT NULL,
  `NOT_DESCRIPTION` varchar(200) COLLATE latin1_spanish_ci DEFAULT NULL,
  `NOT_ADIC_DATA1` varchar(50) COLLATE latin1_spanish_ci DEFAULT NULL,
  `NOT_ADIC_DATA2` varchar(50) COLLATE latin1_spanish_ci DEFAULT NULL,
  `NOT_ADIC_DATA3` varchar(50) COLLATE latin1_spanish_ci DEFAULT NULL,
  `NOT_ADIC_DATA4` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL,
  `NOT_ADIC_DATA5` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL,
  `NOT_DATMOD` datetime DEFAULT NULL,
  `NOT_USEMOD` varchar(45) COLLATE latin1_spanish_ci DEFAULT NULL,
  PRIMARY KEY (`NOT_ID`),
  KEY `FK_NOT_TEV_ID_idx` (`NOT_TEV_ID`),
  CONSTRAINT `FK_NOT_TEV_ID` FOREIGN KEY (`NOT_TEV_ID`) REFERENCES `lw_type_event` (`TEV_ID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci;

CREATE TABLE `lw_events` (
  `EVE_ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `EVE_TEV_ID` bigint(20) NOT NULL,
  `EVE_DATETIME` datetime NOT NULL,
  `EVE_DATA` varchar(100) COLLATE latin1_spanish_ci NOT NULL,
  `EVE_ADIC_DATA_1` varchar(100) COLLATE latin1_spanish_ci DEFAULT NULL,
  `EVE_ADIC_DATA_2` varchar(100) COLLATE latin1_spanish_ci DEFAULT NULL,
  `EVE_ADIC_DATA_3` varchar(100) COLLATE latin1_spanish_ci DEFAULT NULL,
  `EVE_ADIC_DATA_4` varchar(100) COLLATE latin1_spanish_ci DEFAULT NULL,
  `EVE_ADIC_DATA_5` varchar(100) COLLATE latin1_spanish_ci DEFAULT NULL,
  `EVE_DATMOD` datetime NOT NULL,
  `EVE_USEMOD` varchar(20) COLLATE latin1_spanish_ci NOT NULL,
  PRIMARY KEY (`EVE_ID`),
  KEY `FK_EVE_TEV_EVE` (`EVE_TEV_ID`),
  CONSTRAINT `FK_EVE_TEV_EVE` FOREIGN KEY (`EVE_TEV_ID`) REFERENCES `lw_type_event` (`TEV_ID`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=62 DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci;

CREATE TABLE `lw_action` (
  `ACT_ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `ACT_TEV_ID` bigint(20) NOT NULL,
  `ACT_USE_ID` varchar(20) COLLATE latin1_spanish_ci DEFAULT NULL,
  `ACT_APP_ID` bigint(20) DEFAULT NULL,
  `ACT_SER_ID` varchar(20) COLLATE latin1_spanish_ci DEFAULT NULL,
  `ACT_DTI_EXEC` datetime DEFAULT NULL,
  `ACT_DATA_ADIC` varchar(200) COLLATE latin1_spanish_ci DEFAULT NULL,
  `ACT_RESULT` varchar(2) COLLATE latin1_spanish_ci DEFAULT NULL,
  `ACT_DATMOD` datetime DEFAULT NULL,
  `ACT_USEMOD` varchar(20) COLLATE latin1_spanish_ci DEFAULT NULL,
  PRIMARY KEY (`ACT_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci;

CREATE TABLE `lw_server` (
  `SER_ID` varchar(20) CHARACTER SET latin1 COLLATE latin1_spanish_ci NOT NULL,
  `SER_DESCRIPTION` varchar(100) CHARACTER SET latin1 COLLATE latin1_spanish_ci NOT NULL,
  `SER_SYO_ID` bigint(20) NOT NULL,
  `SER_HOST` varchar(100) NOT NULL,
  `SER_MEMTOT` float DEFAULT NULL,
  `SER_MEMUSE` float DEFAULT NULL,
  `SER_CPUUSE` float DEFAULT NULL,
  `SER_REDUSE` float DEFAULT NULL,
  `SER_DATMOD` datetime NOT NULL,
  `SER_USEMOD` varchar(20) CHARACTER SET latin1 COLLATE latin1_spanish_ci DEFAULT NULL,
  PRIMARY KEY (`SER_ID`),
  KEY `FK_SER_SYO_ID` (`SER_SYO_ID`),
  CONSTRAINT `FK_SER_SYO_ID` FOREIGN KEY (`SER_SYO_ID`) REFERENCES `lw_systemoperating` (`SYO_ID`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1;




CREATE TABLE `lw_app_server` (
  `ASE_APP_ID` bigint(20) NOT NULL,
  `ASE_SER_ID` varchar(20) COLLATE latin1_spanish_ci NOT NULL,
  `ASE_DATMOD` datetime NOT NULL,
  `ASE_USEMOD` varchar(20) COLLATE latin1_spanish_ci NOT NULL,
  PRIMARY KEY (`ASE_APP_ID`,`ASE_SER_ID`),
  KEY `FK_ASE_SER_ID` (`ASE_SER_ID`),
  CONSTRAINT `FK_ASE_APP_ID` FOREIGN KEY (`ASE_APP_ID`) REFERENCES `lw_applications` (`APP_ID`) ON DELETE CASCADE ON UPDATE NO ACTION,
  CONSTRAINT `FK_ASE_SER_ID` FOREIGN KEY (`ASE_SER_ID`) REFERENCES `lw_server` (`SER_ID`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci;




CREATE TABLE `lw_group_user_app` (
  `GUA_GUS_ID` bigint(20) NOT NULL,
  `GUA_APP_ID` bigint(20) NOT NULL,
  `GUA_DATMOD` datetime NOT NULL,
  `GUA_USEMOD` varchar(20) COLLATE latin1_spanish_ci NOT NULL,
  PRIMARY KEY (`GUA_GUS_ID`,`GUA_APP_ID`),
  KEY `FK_GUA_APP_ID` (`GUA_APP_ID`),
  CONSTRAINT `FK_GUA_APP_ID` FOREIGN KEY (`GUA_APP_ID`) REFERENCES `lw_applications` (`APP_ID`) ON DELETE CASCADE ON UPDATE NO ACTION,
  CONSTRAINT `FK_GUA_GUS_ID` FOREIGN KEY (`GUA_GUS_ID`) REFERENCES `lw_group_user` (`GUS_ID`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci;



CREATE TABLE `lw_server_group` (
  `SEG_SER_ID` varchar(20) COLLATE latin1_spanish_ci NOT NULL,
  `SEG_GRS_ID` bigint(20) NOT NULL,
  `SEG_DATMOD` datetime NOT NULL,
  `SEG_USEMOD` varchar(20) COLLATE latin1_spanish_ci NOT NULL,
  PRIMARY KEY (`SEG_SER_ID`,`SEG_GRS_ID`),
  KEY `FK_SEG_GRS_ID` (`SEG_GRS_ID`),
  CONSTRAINT `FK_SEG_GRS_ID` FOREIGN KEY (`SEG_GRS_ID`) REFERENCES `lw_group_server` (`GRS_ID`) ON DELETE CASCADE ON UPDATE NO ACTION,
  CONSTRAINT `FK_SEG_SER_ID` FOREIGN KEY (`SEG_SER_ID`) REFERENCES `lw_server` (`SER_ID`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci;


CREATE TABLE `lw_server_hdd` (
  `SHD_ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `SHD_DESCRIPTION` varchar(45) COLLATE latin1_spanish_ci NOT NULL,
  `SHD_SER_ID` varchar(20) COLLATE latin1_spanish_ci NOT NULL,
  `SHD_HDDTOT` float DEFAULT NULL,
  `SHD_HDDUSE` float DEFAULT NULL,
  `SHD_USEMOD` varchar(20) COLLATE latin1_spanish_ci NOT NULL,
  `SHD_DATMOD` datetime NOT NULL,
  PRIMARY KEY (`SHD_ID`),
  KEY `FK_SHD_SER_ID` (`SHD_SER_ID`),
  CONSTRAINT `FK_SHD_SER_ID` FOREIGN KEY (`SHD_SER_ID`) REFERENCES `lw_server` (`SER_ID`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci;


CREATE TABLE `lw_server_hdd_hist` (
  `SHH_ID` bigint(20) NOT NULL,
  `SHH_SHD_ID` bigint(20) DEFAULT NULL,
  `SHH_SHD_DESCRIPTION` varchar(45) COLLATE latin1_spanish_ci NOT NULL,
  `SHH_SHD_SER_ID` varchar(20) COLLATE latin1_spanish_ci DEFAULT NULL,
  `SHH_SHD_HDDTOT` float DEFAULT NULL,
  `SHH_SHD_HDDUSE` float DEFAULT NULL,
  `SHH_SHD_DATMOD` datetime DEFAULT NULL,
  `SHH_SHD_USEMOD` varchar(20) COLLATE latin1_spanish_ci DEFAULT NULL,
  PRIMARY KEY (`SHH_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci;


CREATE TABLE `lw_server_hist` (
  `SEH_ID` bigint(20) NOT NULL AUTO_INCREMENT,
  `SEH_SER_ID` varchar(20) COLLATE latin1_spanish_ci NOT NULL,
  `SEH_SER_DESCRIPTION` varchar(100) COLLATE latin1_spanish_ci NOT NULL,
  `SEH_SER_MEMTOT` float DEFAULT NULL,
  `SEH_SER_MEMUSE` float DEFAULT NULL,
  `SEH_SER_CPUUSE` float DEFAULT NULL,
  `SEH_SER_REDUSE` float DEFAULT NULL,
  `SEH_SER_DATMOD` datetime NOT NULL,
  `SEH_SER_USEMOD` varchar(20) COLLATE latin1_spanish_ci DEFAULT NULL,
  PRIMARY KEY (`SEH_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci;


CREATE TABLE `lw_user_app` (
  `UAP_USE_ID` varchar(20) CHARACTER SET latin1 NOT NULL,
  `UAP_APP_ID` bigint(20) NOT NULL,
  `UAP_SER_ID` varchar(20) COLLATE latin1_spanish_ci DEFAULT NULL,
  `UAP_START_DATE_PROCESS` datetime DEFAULT NULL,
  `UAP_END_DATE_PROCESS` datetime DEFAULT NULL,
  `UAP_ID_PROCESS` varchar(100) COLLATE latin1_spanish_ci DEFAULT NULL,
  `UAP_CPUUSE` float DEFAULT NULL,
  `UAP_MEMUSE` float DEFAULT NULL,
  `UAP_HDDUSE` float DEFAULT NULL,
  `UAP_NETUSE` float DEFAULT NULL,
  `UAP_DATMOD` datetime NOT NULL,
  `UAP_USEMOD` varchar(20) COLLATE latin1_spanish_ci NOT NULL,
  PRIMARY KEY (`UAP_USE_ID`,`UAP_APP_ID`),
  KEY `FK_UAP_APP_ID` (`UAP_APP_ID`),
  KEY `FK_UAP_SER_ID` (`UAP_SER_ID`),
  CONSTRAINT `FK_UAP_APP_ID` FOREIGN KEY (`UAP_APP_ID`) REFERENCES `lw_applications` (`APP_ID`) ON DELETE CASCADE ON UPDATE NO ACTION,
  CONSTRAINT `FK_UAP_SER_ID` FOREIGN KEY (`UAP_SER_ID`) REFERENCES `lw_server` (`SER_ID`) ON DELETE CASCADE ON UPDATE NO ACTION,
  CONSTRAINT `FK_UAP_USE_ID` FOREIGN KEY (`UAP_USE_ID`) REFERENCES `lw_user` (`USE_ID`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci;


CREATE TABLE `lw_user_app_hist` (
  `UAH_ID` bigint(20) NOT NULL,
  `UAH_UAP_USE_ID` varchar(20) CHARACTER SET latin1 NOT NULL,
  `UAH_UAP_APP_ID` bigint(20) NOT NULL,
  `UAH_UAP_SER_ID` varchar(20) COLLATE latin1_spanish_ci DEFAULT NULL,
  `UAH_UAP_START_DATE_PROCESS` datetime DEFAULT NULL,
  `UAH_UAP_END_DATE_PROCESS` datetime DEFAULT NULL,
  `UAH_UAP_ID_PROCESS` varchar(100) COLLATE latin1_spanish_ci DEFAULT NULL,
  `UAH_UAP_CPUUSE` float DEFAULT NULL,
  `UAH_UAP_MEMUSE` float DEFAULT NULL,
  `UAH_UAP_HDDUSE` float DEFAULT NULL,
  `UAH_UAP_NETUSE` int(11) DEFAULT NULL,
  `UAH_UAP_DATMOD` datetime NOT NULL,
  `UAH_UAP_USEMOD` varchar(20) COLLATE latin1_spanish_ci NOT NULL,
  PRIMARY KEY (`UAH_ID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci;


CREATE TABLE `lw_user_group` (
  `UGR_GUS_ID` bigint(20) NOT NULL,
  `UGR_USE_ID` varchar(20) NOT NULL,
  `UGR_DATMOD` datetime NOT NULL,
  `UGR_USEMOD` varchar(20) NOT NULL,
  PRIMARY KEY (`UGR_GUS_ID`,`UGR_USE_ID`),
  KEY `FK_UGR_USE_ID` (`UGR_USE_ID`),
  CONSTRAINT `FK_UGR_GUS_ID` FOREIGN KEY (`UGR_GUS_ID`) REFERENCES `lw_group_user` (`GUS_ID`) ON DELETE CASCADE ON UPDATE NO ACTION,
  CONSTRAINT `FK_UGR_USE_ID` FOREIGN KEY (`UGR_USE_ID`) REFERENCES `lw_user` (`USE_ID`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1;


CREATE TABLE `lw_user_site` (
  `USI_USE_ID` varchar(20) NOT NULL,
  `USI_SIT_ID` bigint(20) NOT NULL,
  `USI_DATMOD` datetime NOT NULL,
  `USI_USEMOD` varchar(20) NOT NULL,
  PRIMARY KEY (`USI_USE_ID`,`USI_SIT_ID`),
  KEY `FK_USI_SIT_ID` (`USI_SIT_ID`),
  CONSTRAINT `FK_USI_SIT_ID` FOREIGN KEY (`USI_SIT_ID`) REFERENCES `lw_site` (`SIT_ID`) ON DELETE CASCADE ON UPDATE NO ACTION,
  CONSTRAINT `FK_USI_USE_ID` FOREIGN KEY (`USI_USE_ID`) REFERENCES `lw_user` (`USE_ID`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE TABLE `lw_app_group` (
  `AGR_GAP_ID` bigint(20) NOT NULL,
  `AGR_APP_ID` bigint(20) NOT NULL,
  `AGR_DATMOD` datetime NOT NULL,
  `AGR_USEMOD` varchar(20) COLLATE latin1_spanish_ci NOT NULL,
  PRIMARY KEY (`AGR_GAP_ID`,`AGR_APP_ID`),
  KEY `FK_AGR_APP_ID` (`AGR_APP_ID`),
  CONSTRAINT `FK_AGR_APP_ID` FOREIGN KEY (`AGR_APP_ID`) REFERENCES `lw_applications` (`APP_ID`) ON DELETE CASCADE ON UPDATE NO ACTION,
  CONSTRAINT `FK_AGR_GAP_ID` FOREIGN KEY (`AGR_GAP_ID`) REFERENCES `lw_group_app` (`GAP_ID`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_spanish_ci;

INSERT INTO `librework`.`lw_type_event` (`TEV_ID`, `TEV_DESCRIPTION`, `TEV_DATMOD`, `TEV_USEMOD`) VALUES ('1', 'START SESSION', '2014-01-20 10:30:43', 'PNIETO');

INSERT INTO `librework`.`lw_type_event` (`TEV_ID`, `TEV_DESCRIPTION`, `TEV_DATMOD`, `TEV_USEMOD`) VALUES ('2', 'END SESSION', '2014-01-20 10:30:43', 'PNIETO');

INSERT INTO `librework`.`lw_type_event` (`TEV_ID`, `TEV_DESCRIPTION`, `TEV_DATMOD`, `TEV_USEMOD`) VALUES ('3', 'START APLICATION', '2014-01-20 10:30:43', 'PNIETO');

INSERT INTO `librework`.`lw_type_event` (`TEV_ID`, `TEV_DESCRIPTION`, `TEV_DATMOD`, `TEV_USEMOD`) VALUES ('4', 'END APPLICATION', '2014-01-20 10:30:43', 'PNIETO');

INSERT INTO `librework`.`lw_type_event` (`TEV_ID`, `TEV_DESCRIPTION`, `TEV_DATMOD`, `TEV_USEMOD`) VALUES ('1000', 'WARNING', '2014-01-20 10:30:43', 'PNIETO');

INSERT INTO `librework`.`lw_type_event` (`TEV_ID`, `TEV_DESCRIPTION`, `TEV_DATMOD`, `TEV_USEMOD`) VALUES ('1001', 'CRITICAL', '2014-01-20 10:30:43', 'PNIETO');

INSERT INTO `librework`.`lw_type_event` (`TEV_ID`, `TEV_DESCRIPTION`, `TEV_DATMOD`, `TEV_USEMOD`) VALUES ('1002', 'INFORMATION', '2014-01-20 10:30:43', 'PNIETO');

INSERT INTO `librework`.`lw_type_event` (`TEV_ID`, `TEV_DESCRIPTION`, `TEV_DATMOD`, `TEV_USEMOD`) VALUES ('2000', 'CLOSE SESSION', '2014-01-20 10:30:43', 'PNIETO');

INSERT INTO `librework`.`lw_type_event` (`TEV_ID`, `TEV_DESCRIPTION`, `TEV_DATMOD`, `TEV_USEMOD`) VALUES ('2001', 'CLOSE APPLICATION', '2014-01-20 10:30:43', 'PNIETO');

INSERT INTO `librework`.`lw_systemoperating` (`SYO_ID`, `SYO_DESCRIPTION`, `SYO_DATMOD`, `SYO_USEMOD`) VALUES ('1', 'Windows', '2014-01-16 11:23:22', 'pnieto');

INSERT INTO `librework`.`lw_systemoperating` (`SYO_ID`, `SYO_DESCRIPTION`, `SYO_DATMOD`, `SYO_USEMOD`) VALUES ('2', 'Linux', '2014-01-16 11:23:22', 'pnieto');



