#include "mysqlinfo.h"

MySqlInfo::MySqlInfo(QString server, int port)
{
	this->server = server;
	this->port = port;
}

bool MySqlInfo::authenticate(QString username, QString password, QString connName)
{
	db = QSqlDatabase::addDatabase( "QMYSQL", connName );
	qDebug("Created database");
	db.setHostName( server );
	db.setDatabaseName( "librework" );
	//db.setUserName( username );
	//db.setPassword( password );
	//db.setConnectOptions("MYSQL_OPT_CONNECT_TIMEOUT=4");
	qDebug("Trying to open database...");
	bool res = db.open( username, password );
	qDebug("done.");
	return res;
}

QStringList MySqlInfo::getRecord( QString table, QString filter, QStringList fields)
{
	QSqlQuery query( "SELECT " + fields.join(",") + " FROM " + table + " WHERE " + filter, db);
	QStringList res;

	if (query.first())
	{
		for ( int i = 0; i < fields.count(); i++)
		{
			res += query.value( i ).toString();
		}
	}

	return res;
}

QList<QStringList> MySqlInfo::getQueryValues(QString queryString, QStringList fields)
{
	QSqlQuery query( queryString, db);
	int count = fields.count();

/*
	QList<int> index;

	for ( int i = 0; i < count; i++ )
	{
		index.append( query.record().indexOf( fields[i] ) );
	}
*/

	QList<QStringList> res;

	while (query.next())
	{
		QStringList list;
		for ( int i = 0; i < count; i++ )
		{
			list.append( query.value( i ).toString() );
		}
		res.append( list );
	}

	return res;
}

QStringList MySqlInfo::getValues(QString table, QString attribute, QString filter)
{
	QSqlQuery query( "SELECT " + attribute + " FROM " + table + " WHERE " + filter, db);
	QStringList res;

	while (query.next())
	{
		res += query.value( 0 ).toString();
	}

	return res;
}

QByteArray MySqlInfo::getIcon(QString table, QString filter, QString attribute)
{
	QSqlQuery query( "SELECT " + attribute + " FROM " + table + " WHERE " + filter, db);
	QStringList res;

	if (query.first())
	{
		return query.value( 0 ).toByteArray();
	} else {
		return QByteArray();
	}
}

bool MySqlInfo::setValue(QString table, QString filter, QString attribute, QString value)
{
	QSqlQuery query( db );
	QString queryString = "UPDATE " + table + " SET " + attribute + "='" + value + "' WHERE " + filter;
	return query.exec( queryString );
}

bool MySqlInfo::insertRecord( QString table, QStringList attributes, QList<QVariant> values )
{
	QStringList attributes2 = attributes;
	attributes2.replaceInStrings(QRegExp("^"), ":");

	QSqlQuery query( db );
	QString queryString = "INSERT INTO " + table + " (" + attributes.join(",") + ")";
	queryString += " VALUES(" + attributes2.join(",") + ")";

	query.prepare( queryString );

	int count = attributes.count();
	if ( count != values.count() )
		return false;

	for ( int i = 0; i < count; i++ )
		query.bindValue( attributes2[i], values[i] );

	bool res = query.exec();
	return res;
}

void MySqlInfo::close()
{
	db.close();
}
