#ifndef MYSQLINFO_H
#define MYSQLINFO_H

#include <QObject>
#include <QStringList>
#include <QSqlDatabase>
#include <QSqlQuery>
#include <QSqlRecord>
#include <QVariant>
#include <QByteArray>
#include <QDebug>

class MySqlInfo : public QObject
{
	Q_OBJECT

	public:
		MySqlInfo(QString server, int port = 3306);

		bool authenticate(QString username, QString password, QString connName);
		QStringList getValues(QString table, QString attribute, QString filter = QString("true"));
		QList<QStringList> getQueryValues(QString query, QStringList fields);
		QStringList getRecord( QString table, QString filter, QStringList fields);
		QByteArray getIcon(QString table, QString filter, QString attribute);
		bool setValue(QString table, QString filter, QString attribute, QString value);
		bool insertRecord( QString table, QStringList attributes, QList<QVariant> values );
		void close();

	private:
		QSqlDatabase db;
		QString server;
		int port;
		
};

#endif
