set VERSION=%1

set VSVERSION=14
set ARCH=64
set QTVERSION=5.7

set VSDIR=%programfiles(x86)%\Microsoft Visual Studio %VSVERSION%.0\VC
set VSBINDIR=%VSDIR%\Bin
set SDKBINDIR=%programfiles%\Microsoft SDKs\Windows\v7.1\Bin

if %VSVERSION% equ 14 set VSYEAR=2015

if %ARCH% equ 32 set QTBINDIR=c:\Qt\%QTVERSION%\msvc%VSYEAR%\bin
if %ARCH% equ 64 set QTBINDIR=c:\Qt\%QTVERSION%\msvc%VSYEAR%_64\bin

set PATH=%PATH%;%SDKBINDIR%;%VSBINDIR%;%QTBINDIR%

cd ..

call "%VSDIR%\vcvarsall.bat" amd64

call "%VSBINDIR%\nmake" distclean

call rmdir /q /s Release
call rmdir /q /s Debug

call "%QTBINDIR%\qmake"
call "%VSBINDIR%\nmake" Release

call "%QTBINDIR%\windeployqt" Release

del Release\*.obj
del Release\*.cpp

copy windeploy\librework.png Release\
copy windeploy\librework.ico Release\
copy windeploy\setupScript.iss Release\
copy windeploy\reginstall.bat Release\
copy windeploy\reguninstall.bat Release\
copy windeploy\lib%ARCH%\*.dll Release\
copy windeploy\libmysql.dll Release\
copy windeploy\nssm-2.24\win%ARCH%\nssm.exe Release\

cd Release
call ..\windeploy\InnoSetup\ISCC.exe /q setupScript.iss
cd ..

copy Release\Output\librework-server-setup.exe LibreWork-Server-Setup-v%VERSION%.exe

cd windeploy

pause
