; Script generated by the Inno Setup Script Wizard.
; SEE THE DOCUMENTATION FOR DETAILS ON CREATING INNO SETUP SCRIPT FILES!

[Setup]
; NOTE: The value of AppId uniquely identifies this application.
; Do not use the same AppId value in installers for other applications.
; (To generate a new GUID, click Tools | Generate GUID inside the IDE.)
;SignTool=byparam $qC:\Program Files\Microsoft SDKs\Windows\v7.1\Bin\signtool.exe$q sign /f $qc:\librework\client\windeploy\Comodo.pfx$q /t http://timestamp.comodoca.com/authenticode /p librework14 $f
;SignedUninstaller=yes
ArchitecturesInstallIn64BitMode=x64
AppId={{F4D13E14-CC03-4BB4-B982-DE28200855AA}
AppName=Librework Server
AppVersion=2.2
AppPublisher=LibreWork
AppPublisherURL=http://www.librework.com/
AppSupportURL=http://www.librework.com/
AppUpdatesURL=http://www.librework.com/
DefaultDirName={pf}\LibreWork Server
DisableDirPage=yes
DefaultGroupName=Librework Server
DisableProgramGroupPage=yes
OutputBaseFilename=librework-server-setup
SetupIconFile=librework.ico
Compression=lzma
SolidCompression=yes

[Languages]
Name: "english"; MessagesFile: "compiler:Default.isl"
Name: "spanish"; MessagesFile: "compiler:Languages\Spanish.isl"

[Files]
Source: "lwserver.exe"; DestDir: "{app}"; Flags: ignoreversion
Source: "reginstall.bat"; DestDir: "{app}"; Flags: ignoreversion
Source: "reguninstall.bat"; DestDir: "{app}"; Flags: ignoreversion
Source: "librework.png"; DestDir: "{app}"; Flags: ignoreversion
Source: "librework.ico"; DestDir: "{app}"; Flags: ignoreversion
;Source: "icudt53.dll"; DestDir: "{app}"; Flags: ignoreversion
;Source: "icuin53.dll"; DestDir: "{app}"; Flags: ignoreversion
;Source: "icuuc53.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "concrt140.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "msvcp140.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "vccorlib140.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "vcruntime140.dll"; DestDir: "{app}"; Flags: ignoreversion
;Source: "msvcp100.dll"; DestDir: "{app}"; Flags: ignoreversion
;Source: "msvcr100.dll"; DestDir: "{app}"; Flags: ignoreversion
;Source: "libmysql.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "platforms\qwindows.dll"; DestDir: "{app}\platforms\"; Flags: ignoreversion
Source: "Qt5Core.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "Qt5Gui.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "Qt5Widgets.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "Qt5Network.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "Qt5Sql.dll"; DestDir: "{app}"; Flags: ignoreversion
Source: "nssm.exe"; DestDir: "{app}"; Flags: ignoreversion

[Run]
;Filename: "{app}\lwserver.exe --init"; Flags: waituntilterminated

[UninstallRun]
Filename: "{app}\reguninstall.bat"; Flags: waituntilterminated

[Code]
var
  LibreworkServerLineEdit: TNewEdit;
  LibreworkServerPortLineEdit: TNewEdit;
  DomainCheckBox: TNewCheckBox;
  DesktopCheckBox: TNewCheckBox;
  ApplicationsCheckBox: TNewCheckBox;
  HomeStorageCheckBox: TNewCheckBox;
  StorageCheckBox: TNewCheckBox;
  UsernameEdit: TNewEdit;
  PasswordEdit: TPasswordEdit;
  ServerPortEdit: TNewEdit;
  CustomPage: TWizardPage;  

function CheckForm(Page: TWizardPage):Boolean;
begin
  if (LibreworkServerLineEdit.Text = '') then
  begin
    MsgBox('Librework principal server address must not be empty', mbError, MB_OK);
    Result := false
    exit
  end;
  if (LibreworkServerPortLineEdit.Text = '') then
  begin
    MsgBox('Librework principal server port must not be empty', mbError, MB_OK);
    Result := false
    exit
  end;
  if (DomainCheckBox.Checked = false) and (DesktopCheckBox.Checked = false) and (ApplicationsCheckBox.Checked = false) then
  begin
    MsgBox('You must select at least one server role', mbError, MB_OK);
    Result := false
    Exit
  end;
  if (UsernameEdit.Text = '') then
  begin
    MsgBox('The Domain Administrator user name for Librework service must not be empty', mbError, MB_OK);
    Result := false
    exit
  end;
  if (PasswordEdit.Text = '') then
  begin
    MsgBox('The Domain Administrator user password for Librework service must not be empty', mbError, MB_OK);
    Result := false
    exit
  end;
  if (ServerPortEdit.Text = '') then
  begin
    MsgBox('The server port must not be empty', mbError, MB_OK);
    Result := false
    exit
  end;
  Result := true;
end;

procedure CurPageChanged(CurPageID: Integer);
var
  ResultCode : Integer;
  IniFile : String;
  ServerToken: String;
  ResultCode: Integer;
  Domain: String;
  Username: String;
  SlashPos: Integer;
begin
  IniFile := ExpandConstant('{pf}') + '\Librework Server\librework-server.ini';
  if CurPageID = wpInstalling then
  begin
    CreateDir( ExpandConstant('{pf}') + '\Librework Server' );
    if (FileExists( ExpandConstant('{pf}') + '\Librework Server\reguninstall.bat' ) ) then
    begin
      Exec( ExpandConstant('{pf}') + '\Librework Server\reguninstall.bat', '', ExpandConstant('{pf}') + '\Librework Server', SW_SHOW,  ewWaitUntilTerminated, ResultCode );
    end;
    SetIniBool('Server', 'DomainServer', DomainCheckBox.Checked, IniFile);
    SetIniBool('Server', 'DesktopServer', DesktopCheckBox.Checked, IniFile);
    SetIniBool('Server', 'ApplicationsServer', ApplicationsCheckBox.Checked, IniFile);
    SetIniBool('Server', 'HomeStorageServer', HomeStorageCheckBox.Checked, IniFile);
    SetIniBool('Server', 'StorageServer', StorageCheckBox.Checked, IniFile);
    SetIniString('Server', 'LibreworkPrincipalServerAddress', LibreworkServerLineEdit.Text, IniFile);
    SetIniString('Server', 'LibreworkPrincipalServerPort', LibreworkServerPortLineEdit.Text, IniFile);
    SlashPos := Pos('\', UsernameEdit.Text);
    if SlashPos = 0 then
    begin
      Domain := Copy( UsernameEdit.Text, 1, SlashPos - 1 );
      UserName := Copy( UsernameEdit.Text, SlashPos + 1, Length(UsernameEdit.Text) - SlashPos );
      SetIniString('Server', 'ServiceUsername', AddBackslash( Domain ) + UserName, IniFile);
    end
    else
    begin
      SetIniString('Server', 'ServiceUsername', UsernameEdit.Text, IniFile);
    end;
    SetIniString('Server', 'ServerPort', ServerPortEdit.Text, IniFile);
  end;
  
  if CurPageID = wpFinished then
  begin
    ServerToken := GetIniString('Server', 'ServerToken', '', IniFile);    
    if Length(ServerToken) = 0 then
    begin
      Exec( ExpandConstant('{pf}') + '\Librework Server\lwserver.exe', '--init', '', SW_SHOW, ewWaitUntilTerminated, ResultCode );
    end;
    Exec( ExpandConstant('{pf}') + '\Librework Server\reginstall.bat', ServerPortEdit.Text + ' "' + UsernameEdit.Text + '" "' + PasswordEdit.Text + '"', ExpandConstant('{pf}') + '\Librework Server', SW_SHOW,  ewWaitUntilTerminated, ResultCode );
  end;
end;

procedure InitializeWizard;
var
  AddressLabel: TLabel;
  PortLabel: TLabel;
  CheckLabel: TLabel;
  UsernameLabel: TLabel;
  PasswordLabel: TLabel;
  ServerPortLabel: TLabel;
  separator: Cardinal;
  IniFile: String;
begin
  IniFile := ExpandConstant('{pf}') + '\Librework Server\librework-server.ini';
  separator := 5;
  CustomPage := CreateCustomPage(wpSelectDir, 'Server Configuration', 'Select configuration options for this server');

  AddressLabel := TLabel.Create(WizardForm);
  AddressLabel.Parent := CustomPage.Surface;
  AddressLabel.Left := 0;
  AddressLabel.Top := 0;
  AddressLabel.Caption := 'Select Librework principal server address:';

  LibreworkServerLineEdit := TNewEdit.Create(WizardForm);
  LibreworkServerLineEdit.Parent := CustomPage.Surface;
  LibreworkServerLineEdit.Left := AddressLabel.width + separator;
  LibreworkServerLineEdit.Top := 0;  
  LibreworkServerLineEdit.Text := GetIniString('Server', 'LibreworkPrincipalServerAddress', '127.0.0.1', IniFile);
  LibreworkServerLineEdit.Width := 150;

  PortLabel := TLabel.Create(WizardForm);
  PortLabel.Parent := CustomPage.Surface;
  PortLabel.Left := 0;
  PortLabel.Top := LibreworkServerLineEdit.Top + LibreworkServerLineEdit.Height + separator;
  PortLabel.Caption := 'Select Librework principal server port:';

  LibreworkServerPortLineEdit := TNewEdit.Create(WizardForm);
  LibreworkServerPortLineEdit.Parent := CustomPage.Surface;
  LibreworkServerPortLineEdit.Left := PortLabel.width + separator;
  LibreworkServerPortLineEdit.Top := LibreworkServerLineEdit.Top + LibreworkServerLineEdit.Height + separator;  
  LibreworkServerPortLineEdit.Text := GetIniString('Server', 'LibreworkPrincipalServerPort', '4445', IniFile);
  LibreworkServerPortLineEdit.Width := 120;

  CheckLabel := TLabel.Create(WizardForm);
  CheckLabel.Parent := CustomPage.Surface;
  CheckLabel.Left := 0;
  CheckLabel.Top := LibreworkServerPortLineEdit.Top + LibreworkServerPortLineEdit.Height + 2 * separator;
  CheckLabel.Caption := 'Select this server roles:';

  DomainCheckBox := TNewCheckBox.Create(WizardForm);
  DomainCheckBox.Parent := CustomPage.Surface;
  DomainCheckBox.Left := 0;
  DomainCheckBox.Top := CheckLabel.Top + CheckLabel.Height + separator;
  DomainCheckBox.Caption := 'Domain Server';
  DomainCheckBox.Width := 130;
  DomainCheckBox.Checked := GetIniBool('Server', 'DomainServer', false, IniFile);
   
  DesktopCheckBox := TNewCheckBox.Create(WizardForm);
  DesktopCheckBox.Parent := CustomPage.Surface;
  DesktopCheckBox.Left := DomainCheckBox.width + separator;
  DesktopCheckBox.Top := CheckLabel.Top + CheckLabel.Height + separator;
  DesktopCheckBox.Caption := 'Desktop Server';
  DesktopCheckBox.Width := 130;
  DesktopCheckBox.Checked := GetIniBool('Server', 'DesktopServer', false, IniFile);

  ApplicationsCheckBox := TNewCheckBox.Create(WizardForm);
  ApplicationsCheckBox.Parent := CustomPage.Surface;
  ApplicationsCheckBox.Left := DomainCheckBox.width + separator + DesktopCheckBox.width + separator;
  ApplicationsCheckBox.Top := CheckLabel.Top + CheckLabel.Height + separator;
  ApplicationsCheckBox.Caption := 'Applications Server';
  ApplicationsCheckBox.Width := 130;
  ApplicationsCheckBox.Checked := GetIniBool('Server', 'ApplicationsServer', false, IniFile);

  HomeStorageCheckBox := TNewCheckBox.Create(WizardForm);
  HomeStorageCheckBox.Parent := CustomPage.Surface;
  HomeStorageCheckBox.Left := 0;
  HomeStorageCheckBox.Top := ApplicationsCheckBox.Top + ApplicationsCheckBox.Height + separator;
  HomeStorageCheckBox.Caption := 'Homes/Profiles Server';
  HomeStorageCheckBox.Width := 130;
  HomeStorageCheckBox.Checked := GetIniBool('Server', 'HomeStorageServer', false, IniFile);

  StorageCheckBox := TNewCheckBox.Create(WizardForm);
  StorageCheckBox.Parent := CustomPage.Surface;
  StorageCheckBox.Left := HomeStorageCheckbox.width + separator;
  StorageCheckBox.Top := ApplicationsCheckBox.Top + ApplicationsCheckBox.Height + separator;
  StorageCheckBox.Caption := 'Storage Server';
  StorageCheckBox.Width := 130;
  StorageCheckBox.Checked := GetIniBool('Server', 'StorageServer', false, IniFile);

  UsernameLabel := TLabel.Create(WizardForm);
  UsernameLabel.Parent := CustomPage.Surface;
  UsernameLabel.Left := 0;
  UsernameLabel.Top := StorageCheckbox.Top + StorageCheckbox.Height + 2 * separator;
  UsernameLabel.Caption := 'Domain Admin service username:';

  UsernameEdit := TNewEdit.Create(WizardForm);
  UsernameEdit.Parent := CustomPage.Surface;
  UsernameEdit.Left := UsernameLabel.width + separator;
  UsernameEdit.Top := StorageCheckbox.Top + StorageCheckbox.Height + 2 * separator;
  UsernameEdit.Text := GetIniString('Server', 'ServiceUsername', AddBackslash( GetEnv('USERDOMAIN') ) + GetUserNameString, IniFile);
  UsernameEdit.Width := 250;

  PasswordLabel := TLabel.Create(WizardForm);
  PasswordLabel.Parent := CustomPage.Surface;
  PasswordLabel.Left := 0;
  PasswordLabel.Top := UsernameEdit.Top + UsernameEdit.Height + separator;
  PasswordLabel.Caption := 'Domain Admin service password:';

  PasswordEdit := TPasswordEdit.Create(WizardForm);
  PasswordEdit.Parent := CustomPage.Surface;
  PasswordEdit.Left := PasswordLabel.width + separator;
  PasswordEdit.Top := UsernameEdit.Top + UsernameEdit.Height + separator;
  PasswordEdit.Width := 250;

  ServerPortLabel := TLabel.Create(WizardForm);
  ServerPortLabel.Parent := CustomPage.Surface;
  ServerPortLabel.Left := 0;
  ServerPortLabel.Top := PasswordEdit.Top + PasswordEdit.Height + separator;
  ServerPortLabel.Caption := 'Server port:';

  ServerPortEdit := TNewEdit.Create(WizardForm);
  ServerPortEdit.Parent := CustomPage.Surface;
  ServerPortEdit.Left := PasswordLabel.width + separator;
  ServerPortEdit.Top := PasswordEdit.Top + PasswordEdit.Height + separator;
  ServerPortEdit.Width := 250;
  ServerPortEdit.Text := GetIniString('Server', 'ServerPort', '4445', IniFile);

  CustomPage.OnNextButtonClick := @CheckForm;
end;
